# PyGFNFF

[![Pypi version](https://img.shields.io/pypi/v/pygfnff)](https://pypi.org/project/pygfnff/)
[![PyPI Downloads](https://static.pepy.tech/badge/pygfnff)](https://pepy.tech/projects/pygfnff)

This is a Python version for [GFN-FF](https://github.com/pprcht/gfnff) based on F2PY.

---

## Usage

There is an `ase.Calculator` subclass termed `GFNFF` for non-PBC system. And a more low function called `gfnff` can be found in [the code](https://github.com/LiuGaoyong/PyGFNFF/blob/main/pygfnff/_pygfnff.py).

```python
from ase import Atoms
from ase.build import molecule
from ase.optimize import BFGS
from scipy.spatial.distance import pdist

from pygfnff import GFNFF

atoms = Atoms(molecule("CO"), calculator=GFNFF())
opt = BFGS(atoms, logfile="-", trajectory=None)
opt.run(fmax=0.03, steps=50)
print(f"Energy: {e:.3f}eV")
print(f"C=O Length: {bl:.3f}\u212b")

# Output:
#       Step     Time          Energy          fmax
# BFGS:    0 19:56:53       -9.188347        2.478131
# BFGS:    1 19:56:53       -9.050233        7.166941
# BFGS:    2 19:56:53       -9.215231        0.433918
# BFGS:    3 19:56:53       -9.215990        0.070653
# BFGS:    4 19:56:53       -9.216011        0.000889
# Energy: -9.216eV
# C=O Length: 1.129Å
```



### Reference

1. S.Spicher, S.Grimme. Robust Atomistic Modeling of Materials, Organometallic, and Biochemical Systems (2020), DOI: https://doi.org/10.1002/anie.202004239
2. A standalone library of the GFN-FF method. https://github.com/pprcht/gfnff/

!================================================================================!
! This file is part of gfnff.
!
! Copyright (C) 2023 Philipp Pracht
!
! gfnff is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfnff is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfnff. If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------!
!> The original (unmodified) source code can be found under the GNU LGPL 3.0 license
!> Copyright (C) 2019-2020 Sebastian Ehlert, Sebastian Spicher, Stefan Grimme
!> at https://github.com/grimme-lab/xtb
!================================================================================!
module gfnff_qm_setup
  use iso_fortran_env,only:wp => real64,sp => real64, stdout=>output_unit
  use gfnff_data_types,only:TGFFData,init,TGFFGenerator,TGFFTopology
  implicit none
  private
  public :: gfnffqmsolve

!========================================================================================!
!========================================================================================!
contains  !> MODULE PROCEDURES START HERE
!========================================================================================!
!========================================================================================!

! solve QM Hamiltonian A in overlap basis S (if ovlp=.true., ZDO otherwise)
! and return density matrix in A (and energy weighted density in S if ovlp=.true.)
! ndim is the dimension of the problem for nel electrons with nopen more alpha than beta
  subroutine gfnffqmsolve(pr,A,S,ovlp,et,ndim,nopen,nel,eel,focc,e,io)
    implicit none
    character(len=*),parameter :: source = 'gfnffqmsolve()'
    integer :: ndim      ! # basis
    integer :: nopen     ! # of open shells
    integer :: nel       ! # of electrons
    logical :: ovlp      ! in overlap basis?
    logical :: pr        !
    real(wp) :: et       ! electronic temp Fermi smear
    real(wp) :: eel      ! electronic energy = sum_occ nocc*eps
    real(wp) :: focc(ndim)! occupations
    real(wp) :: e(ndim)  ! eigenvalues
    real(wp) :: A(ndim,ndim)
    real(wp) :: S(ndim,ndim)
    integer,intent(out) :: io ! output status
    integer  :: ihomoa,ihomob,i,liwork,info,lwork
    real(wp) :: ga,gb,efa,efb,nfoda,nfodb
    real(wp),allocatable :: X(:,:)
    real(wp),allocatable :: focca(:),foccb(:),aux(:)
    integer,allocatable  :: iwork(:),ifail(:)
    !> LAPACK
    external :: dsyev,dsygvd

    io = 0

    allocate (focca(ndim),foccb(ndim))

! ZDO case
    if (.not.ovlp) then

      lwork = 1+6*ndim+2*ndim**2
!     allocate(aux4(lwork),e4(ndim),A4(ndim,ndim))
!     A4 = A
!     call ssyev ('V','U',ndim,A4,ndim,e4,aux4,lwork,info)
!     A = A4
!     e = e4
!     deallocate(aux4,A4,e4)
      allocate (aux(lwork))
      call dsyev('V','U',ndim,A,ndim,e,aux,lwork,info)

    else
! with overlap case

      allocate (aux(1),iwork(1),ifail(ndim))
      call DSYGVD(1,'V','U',ndim,A,ndim,S,ndim,e,aux, &  !workspace query
     &               -1,IWORK,LIWORK,INFO)
      lwork = int(aux(1))
      liwork = iwork(1)
      deallocate (aux,iwork)

      allocate (aux(lwork),iwork(liwork))              !do it
      call DSYGVD(1,'V','U',ndim,A,ndim,S,ndim,e,aux, &
     &            LWORK,IWORK,LIWORK,INFO)

    end if
! DONE

! scale energy  so that gaps a roughly ok (in eV)

    e = e*0.1_wp*27.2113957_wp

    if (info .ne. 0) then
      write (stdout,*) 'diag error in ',source
      io = info 
    end if

    if (et .gt. 1.d-3) then
! Fermi smearing, convert restricted occ first to alpha/beta
      call occu(ndim,nel,nopen,ihomoa,ihomob,focca,foccb)
      if (ihomoa .le. ndim.and.ihomoa .gt. 0) then
        call fermismear(.false.,ndim,ihomoa,et,e,focca,nfoda,efa,ga)
      else
        focca = 0
      end if
      if (ihomob .le. ndim.and.ihomob .gt. 0) then
        call fermismear(.false.,ndim,ihomob,et,e,foccb,nfodb,efb,gb)
      else
        foccb = 0
      end if
      focc = focca+foccb
      if (ihomoa+1 .le. ndim) then
        if (abs(focc(ihomoa)-focc(ihomoa+1)) .lt. 1.d-4) then ! a perfect birad is anit-aromatic
          focc = 0                                        ! and hence we break the sym
          do i = 1,nel/2
            focc(i) = 2.0d0
          end do
          if(pr)then
          write (stdout,*) 'perfect biradical detected at FT-HMO level. Breaking the symmetry'
          write (stdout,*) 'because its assumed to be an anit-aromatic system like COT or CB.'
          endif
        end if
      end if
    else
      focc = 0
      do i = 1,nel/2
        focc(i) = 2.0d0
      end do
      if (2*(nel/2) .ne. nel) focc(nel/2+1) = 1.0
    end if

    focca = focc*e
    eel = sum(focca)
! density matrix
    S = A
    call dmat(ndim,focc,S,A)

    if (ovlp) then
      allocate (X(ndim,ndim))
! energy weighted density on S
      call dmat(ndim,focca,S,X)
      S = X
    end if

    deallocate (focca,foccb)

  end subroutine gfnffqmsolve
!========================================================================================!

  subroutine fermismear(prt,norbs,nel,t,eig,occ,fod,e_fermi,s)
    integer,intent(in)  :: norbs
    integer,intent(in)  :: nel
    real(wp),intent(in)  :: eig(norbs)
    real(wp),intent(out) :: occ(norbs)
    real(wp),intent(in)  :: t
    real(wp),intent(out) :: fod
    real(wp),intent(out) :: e_fermi
    logical,intent(in)  :: prt

    real(wp) :: bkt,occt,total_number
    real(wp) :: total_dfermi,dfermifunct,fermifunct,s,change_fermi

    real(wp),parameter :: autoev = 27.21138505_wp
    real(wp),parameter :: kB = 3.166808578545117e-06_wp
    real(wp),parameter :: boltz = kB*autoev
    real(wp),parameter :: thr = 1.d-9
    integer :: ncycle,i,j,m,k,i1,i2

    bkt = boltz*t

    e_fermi = 0.5*(eig(nel)+eig(nel+1))
    occt = nel

    do ncycle = 1,200
      total_number = 0.0
      total_dfermi = 0.0
      do i = 1,norbs
        fermifunct = 0.0
        if ((eig(i)-e_fermi)/bkt .lt. 50) then
          fermifunct = 1.0/(exp((eig(i)-e_fermi)/bkt)+1.0)
          dfermifunct = exp((eig(i)-e_fermi)/bkt)/ &
          &       (bkt*(exp((eig(i)-e_fermi)/bkt)+1.0)**2)
        else
          dfermifunct = 0.0
        end if
        occ(i) = fermifunct
        total_number = total_number+fermifunct
        total_dfermi = total_dfermi+dfermifunct
      end do
      change_fermi = (occt-total_number)/total_dfermi
      e_fermi = e_fermi+change_fermi
      if (abs(occt-total_number) .le. thr) exit
    end do

    fod = 0
    s = 0
    do i = 1,norbs
      if (occ(i) .gt. thr.and.1.0d00-occ(i) .gt. thr) &
      &   s = s+occ(i)*log(occ(i))+(1.0d0-occ(i))*log(1.0d00-occ(i))
      if (eig(i) .lt. e_fermi) then
        fod = fod+1.0d0-occ(i)
      else
        fod = fod+occ(i)
      end if
    end do
    s = s*kB*t

    if (prt) then
      write (*,'('' t,e(fermi),nfod : '',2f10.3,f10.6)') t,e_fermi,fod
    end if

  end subroutine fermismear
!========================================================================================!
  subroutine occu(ndim,nel,nopen,ihomoa,ihomob,focca,foccb)
    integer  :: nel
    integer  :: nopen
    integer  :: ndim
    integer  :: ihomoa
    integer  :: ihomob
    real(wp) :: focca(ndim)
    real(wp) :: foccb(ndim)
    integer  :: focc(ndim)
    integer  :: i,na,nb,ihomo

    focc = 0
    focca = 0
    foccb = 0
!>--- even nel
    if (mod(nel,2) .eq. 0) then
      ihomo = nel/2
      do i = 1,ihomo
        focc(i) = 2
      end do
      if (2*ihomo .ne. nel) then
        ihomo = ihomo+1
        focc(ihomo) = 1
        if (nopen .eq. 0) nopen = 1
      end if
      if (nopen .gt. 1) then
        do i = 1,nopen/2
          focc(ihomo-i+1) = focc(ihomo-i+1)-1
          focc(ihomo+i) = focc(ihomo+i)+1
        end do
      end if
!>--- odd nel
    else
      na = nel/2+(nopen-1)/2+1
      nb = nel/2-(nopen-1)/2
      do i = 1,na
        focc(i) = focc(i)+1
      end do
      do i = 1,nb
        focc(i) = focc(i)+1
      end do
    end if

    do i = 1,ndim
      if (focc(i) .eq. 2) then
        focca(i) = 1.0d0
        foccb(i) = 1.0d0
      end if
      if (focc(i) .eq. 1) focca(i) = 1.0d0
    end do

    ihomoa = 0
    ihomob = 0
    do i = 1,ndim
      if (focca(i) .gt. 0.99) ihomoa = i
      if (foccb(i) .gt. 0.99) ihomob = i
    end do

  end subroutine occu
!========================================================================================!
  subroutine dmat(ndim,focc,C,P)
    !> density matrix
    !> C: MO coefficient
    !> P  dmat
    use gfnff_math_wrapper,only:gemm
    integer,intent(in)  :: ndim
    real(wp),intent(in)  :: focc(:)
    real(wp),intent(in)  :: C(:,:)
    real(wp),intent(out) :: P(:,:)
    integer :: i,m
    real(wp),allocatable :: Ptmp(:,:)

    allocate (Ptmp(ndim,ndim))
    Ptmp = 0.0_wp

    do m = 1,ndim
      do i = 1,ndim
        Ptmp(i,m) = C(i,m)*focc(m)
      end do
    end do
    call gemm(C,Ptmp,P,transb='t')

    deallocate (Ptmp)
  end subroutine dmat

!========================================================================================!
end module gfnff_qm_setup

!================================================================================!
! This file is part of gfnff.
!
! Copyright (C) 2023 Philipp Pracht
!
! gfnff is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfnff is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfnff. If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------!
!> The original (unmodified) source code can be found under the GNU LGPL 3.0 license
!> Copyright (C) 2019-2020 Sebastian Ehlert, Sebastian Spicher, Stefan Grimme
!> at https://github.com/grimme-lab/xtb
!================================================================================!
module gfnff_gdisp0
   use iso_fortran_env, only: wp=>real64,stdout=>output_unit
   use gfnff_data_types, only: TDispersionData,initgffdispersion
   use gfnff_helpers, only: lin
   implicit none
   public :: d3_gradient,newD3Model
   private


!========================================================================================!
!========================================================================================!
contains  !> MODULE PROCEDURES START HERE
!========================================================================================!
!========================================================================================!

subroutine newD3Model(dispm,nat,at)
   use disp_dftd3param
   use dftd4param
   implicit none
   type(TDispersionData), intent(out) :: dispm

   integer, intent(in)  :: nat
   integer, intent(in)  :: at(nat)

   integer  :: i,ia,is,icn,j,ja,ii,jj,ij
   integer  :: cncount(0:18)
   real(wp) :: alpha(23),c6

   intrinsic :: nint

!   call init(dispm, maxElem=maxval(at))
   call initGFFDispersion(dispm)

   dispm%atoms = 0
   dispm%nref = 0.0_wp

   !> set up ncount und alpha, also obtain the dimension of the dispmat
   do i = 1, nat
      ia = at(i)
      if (dispm%atoms(ia).eq.0) then
         dispm%nref(ia) = refn(ia)
         do j = 1, dispm%nref(ia)
            is = refsys(j,ia)
            alpha = sscale(is)*secaiw(:,is)
            dispm%cn(j,ia) = refcn(j,ia)
            dispm%alpha(:,j,ia) = max(ascale(j,ia)*(alphaiw(:,j,ia) &
               &                - hcount(j,ia)*alpha), 0.0_wp)
         enddo
      endif
      dispm%atoms(ia) = dispm%atoms(ia)+1
   enddo

   ! integrate C6 coefficients
   do i = 1, maxval(at)
      do j = 1, i
         if (dispm%atoms(i) > 0 .and. dispm%atoms(j) > 0) then
            do ii = 1, dispm%nref(i)
               do jj = 1, dispm%nref(j)
                  alpha = dispm%alpha(:,ii,i)*dispm%alpha(:,jj,j)
                  c6 = thopi * trapzd(alpha)
                  dispm%c6(ii,jj,i,j) = c6
                  dispm%c6(jj,ii,j,i) = c6
               enddo
            enddo
         endif
      enddo
   enddo

end subroutine newD3Model

!> Calculate the weights of the reference system and the derivatives w.r.t.
!  coordination number for later use.
subroutine weight_references(nat, atoms, wf, cn, gwvec, gwdcn)
   use disp_dftd3param
   !> Nr. of atoms (without periodic images)
   integer, intent(in) :: nat
   !> Atomic numbers of every atom.
   integer, intent(in) :: atoms(:)
   !> Exponent for the Gaussian weighting.
   real(wp), intent(in) :: wf
   !> Coordination number of every atom.
   real(wp), intent(in) :: cn(:)
   !> weighting for the atomic reference systems
   real(wp), intent(out) :: gwvec(:, :)
   !> derivative of the weighting function w.r.t. the coordination number
   real(wp), intent(out) :: gwdcn(:, :)

   integer :: iat, ati, iref, icount
   real(wp) :: norm, dnorm, gw, expw, expd, gwk, dgwk

   gwvec = 0.0_wp
   gwdcn = 0.0_wp

   do iat = 1, nat
      ati = atoms(iat)
      norm = 0.0_wp
      dnorm = 0.0_wp
      do iref = 1, number_of_references(ati)
         gw = weight_cn(wf, cn(iat), reference_cn(iref, ati))
         norm = norm + gw
         dnorm = dnorm + 2*wf*(reference_cn(iref, ati) - cn(iat)) * gw
      end do
      norm = 1.0_wp / norm
      do iref = 1, number_of_references(ati)
         expw = weight_cn(wf, cn(iat), reference_cn(iref, ati))
         expd = 2*wf*(reference_cn(iref, ati) - cn(iat)) * expw

         gwk = expw * norm
         if (gwk /= gwk) then
            if (maxval(reference_cn(:number_of_references(ati), ati)) &
               & == reference_cn(iref, ati)) then
               gwk = 1.0_wp
            else
               gwk = 0.0_wp
            endif
         endif
         gwvec(iref, iat) = gwk

         dgwk = expd*norm-expw*dnorm*norm**2
         if (dgwk /= dgwk) then
            dgwk = 0.0_wp
         endif
         gwdcn(iref, iat) = dgwk

      end do
   end do

end subroutine weight_references
!========================================================================================!

!> Calculate the weights of the reference system and the derivatives w.r.t.
!  coordination number for later use.
subroutine weight_references_d4(dispm, nat, atoms, wf, cn, gwvec, gwdcn)
   type(TDispersionData), intent(in) :: dispm
   !> Nr. of atoms (without periodic images)
   integer, intent(in) :: nat
   !> Atomic numbers of every atom.
   integer, intent(in) :: atoms(:)
   !> Exponent for the Gaussian weighting.
   real(wp), intent(in) :: wf
   !> Coordination number of every atom.
   real(wp), intent(in) :: cn(:)
   !> weighting for the atomic reference systems
   real(wp), intent(out) :: gwvec(:, :)
   !> derivative of the weighting function w.r.t. the coordination number
   real(wp), intent(out) :: gwdcn(:, :)

   integer :: iat, ati, iref, icount
   real(wp) :: norm, dnorm, gw, expw, expd, gwk, dgwk

   gwvec = 0.0_wp
   gwdcn = 0.0_wp

   do iat = 1, nat
      ati = atoms(iat)
      norm = 0.0_wp
      dnorm = 0.0_wp
      do iref = 1, dispm%nref(ati)
         gw = weight_cn(wf, cn(iat), dispm%cn(iref, ati))
         norm = norm + gw
         dnorm = dnorm + 2*wf*(dispm%cn(iref, ati) - cn(iat)) * gw
      end do
      norm = 1.0_wp / norm
      do iref = 1, dispm%nref(ati)
         expw = weight_cn(wf, cn(iat), dispm%cn(iref, ati))
         expd = 2*wf*(dispm%cn(iref, ati) - cn(iat)) * expw

         gwk = expw * norm
         if (gwk /= gwk) then
            if (maxval(dispm%cn(:dispm%nref(ati), ati)) &
               & == dispm%cn(iref, ati)) then
               gwk = 1.0_wp
            else
               gwk = 0.0_wp
            endif
         endif
         gwvec(iref, iat) = gwk

         dgwk = expd*norm-expw*dnorm*norm**2
         if (dgwk /= dgwk) then
            dgwk = 0.0_wp
         endif
         gwdcn(iref, iat) = dgwk

      end do
   end do

end subroutine weight_references_d4
!========================================================================================!

!> calculate atomic dispersion coefficients and their derivatives w.r.t.
!  the coordination number.
subroutine get_atomic_c6(nat, atoms, gwvec, gwdcn, c6, dc6dcn)
   use disp_dftd3param
   !> Nr. of atoms (without periodic images)
   integer, intent(in) :: nat
   !> numbers of every atom.
   integer, intent(in) :: atoms(:)
   !> weighting function for the atomic reference systems
   real(wp), intent(in) :: gwvec(:, :)
   !> derivative of the weighting function w.r.t. the coordination number
   real(wp), intent(in) :: gwdcn(:, :)
   !> C6 coefficients for all atom pairs.
   real(wp), intent(out) :: c6(:, :)
   !> derivative of the C6 w.r.t. the coordination number
   real(wp), intent(out) :: dc6dcn(:, :)

   integer :: iat, jat, ati, atj, iref, jref
   real(wp) :: refc6, dc6, dc6dcni, dc6dcnj

   c6 = 0.0_wp
   dc6dcn = 0.0_wp

   do iat = 1, nat
      ati = atoms(iat)
      do jat = 1, iat
         atj = atoms(jat)
         dc6 = 0.0_wp
         dc6dcni = 0.0_wp
         dc6dcnj = 0.0_wp
         do iref = 1, number_of_references(ati)
            do jref = 1, number_of_references(atj)
               refc6 = get_c6(iref, jref, ati, atj)
               dc6 = dc6 + gwvec(iref, iat) * gwvec(jref, jat) * refc6
               dc6dcni = dc6dcni + gwdcn(iref, iat) * gwvec(jref, jat) * refc6
               dc6dcnj = dc6dcnj + gwvec(iref, iat) * gwdcn(jref, jat) * refc6
            end do
         end do
         c6(iat, jat) = dc6
         c6(jat, iat) = dc6
         dc6dcn(iat, jat) = dc6dcni
         dc6dcn(jat, iat) = dc6dcnj
      end do
   end do
end subroutine get_atomic_c6
!========================================================================================!

!> calculate atomic dispersion coefficients and their derivatives w.r.t.
!  the coordination number.
subroutine get_atomic_c6_d4(dispm, nat, atoms, gwvec, gwdcn, c6, dc6dcn)
   use disp_dftd3param, only : get_c6
   type(TDispersionData), intent(in) :: dispm
   !> Nr. of atoms (without periodic images)
   integer, intent(in) :: nat
   !> numbers of every atom.
   integer, intent(in) :: atoms(:)
   !> weighting function for the atomic reference systems
   real(wp), intent(in) :: gwvec(:, :)
   !> derivative of the weighting function w.r.t. the coordination number
   real(wp), intent(in) :: gwdcn(:, :)
   !> C6 coefficients for all atom pairs.
   real(wp), intent(out) :: c6(:, :)
   !> derivative of the C6 w.r.t. the coordination number
   real(wp), intent(out) :: dc6dcn(:, :)

   integer :: iat, jat, ati, atj, iref, jref
   real(wp) :: refc6, dc6, dc6dcni, dc6dcnj

   c6 = 0.0_wp
   dc6dcn = 0.0_wp

   do iat = 1, nat
      ati = atoms(iat)
      do jat = 1, iat
         atj = atoms(jat)
         dc6 = 0.0_wp
         dc6dcni = 0.0_wp
         dc6dcnj = 0.0_wp
         do iref = 1, dispm%nref(ati)
            do jref = 1, dispm%nref(atj)
               refc6 = dispm%c6(iref, jref, ati, atj)
               dc6 = dc6 + gwvec(iref, iat) * gwvec(jref, jat) * refc6
               dc6dcni = dc6dcni + gwdcn(iref, iat) * gwvec(jref, jat) * refc6
               dc6dcnj = dc6dcnj + gwvec(iref, iat) * gwdcn(jref, jat) * refc6
            end do
         end do
         c6(iat, jat) = dc6
         c6(jat, iat) = dc6
         dc6dcn(iat, jat) = dc6dcni
         dc6dcn(jat, iat) = dc6dcnj
      end do
   end do
end subroutine get_atomic_c6_d4
!========================================================================================!

subroutine d3_gradient(dispm, nat, at, xyz, npair, pairlist, zeta_scale, radii, &
      & r4r2, weighting_factor, dispscale, cn, dcndr, energy, gradient)
   use disp_dftd3param
   type(TDispersionData), intent(in) :: dispm
   integer, intent(in) :: nat
   integer, intent(in) :: at(:)
   real(wp), intent(in) :: xyz(:, :)
   integer, intent(in) :: npair
   integer, intent(in) :: pairlist(:, :)
   real(wp), intent(in) :: zeta_scale(:)
   real(wp), intent(in) :: r4r2(:)
   real(wp), intent(in) :: radii(:)

   real(wp), intent(in) :: dispscale
   real(wp), intent(in) :: weighting_factor
   real(wp), intent(in) :: cn(:)
   real(wp), intent(in) :: dcndr(:, :, :)

   real(wp), intent(inout) :: energy
   real(wp), intent(inout) :: gradient(:, :)
   real(wp) :: sigma(3, 3)

   integer :: max_ref
   integer :: iat, jat, ati, atj, ij, img

   real(wp) :: r4r2ij, r0, rij(3), r2, t6, t8, t10, d6, d8, d10
   real(wp) :: dE, dG(3), dS(3, 3), disp, ddisp

   real(wp), allocatable :: gw(:, :), dgwdcn(:, :)
   real(wp), allocatable :: c6(:, :), dc6dcn(:, :)
   real(wp), allocatable :: energies(:), dEdcn(:)

   max_ref = maxval(dispm%nref(at))
   allocate(gw(max_ref, nat), dgwdcn(max_ref, nat), c6(nat, nat), &
      &     dc6dcn(nat, nat), energies(nat), dEdcn(nat), source=0.0_wp)

   call weight_references_d4(dispm, nat, at, weighting_factor, cn, gw, dgwdcn)

   !gw = gw*zeta_scale
   !dgwdcn = dgwdcn*zeta_scale
   call get_atomic_c6_d4(dispm, nat, at, gw, dgwdcn, c6, dc6dcn)

   !$omp parallel do default(none) schedule(runtime) &
   !$omp reduction(+:energies, gradient, sigma, dEdcn) &
   !$omp shared(at, xyz, npair, pairlist, zeta_scale, dispscale, radii, r4r2, c6, &
   !$omp&       dc6dcn) &
   !$omp private(ij, img, iat, jat, ati, atj, r2, rij, r4r2ij, r0, t6, t8, t10, &
   !$omp&        d6, d8, d10, disp, ddisp, dE, dG, dS)
   do img = 1, npair
      iat = pairlist(1, img)
      jat = pairlist(2, img)
      ij = jat + iat*(iat-1)/2
      ati = at(iat)
      atj = at(jat)
      rij = xyz(:, iat) - xyz(:, jat)
      r2 = sum(rij**2)

      r4r2ij = 3*r4r2(ati)*r4r2(atj)
      r0 = radii(lin(ati, atj))

      t6 = 1._wp/(r2**3+r0**3)
      t8 = 1._wp/(r2**4+r0**4)

      d6 = -6*r2**2*t6**2
      d8 = -8*r2**3*t8**2

      disp = (t6 + 2*r4r2ij*t8) * zeta_scale(ij)*dispscale
      ddisp= (d6 + 2*r4r2ij*d8) * zeta_scale(ij)*dispscale

      dE = -c6(iat, jat)*disp * 0.5_wp
      dG = -c6(iat, jat)*ddisp*rij
      dS = spread(dG, 1, 3) * spread(rij, 2, 3) * 0.5_wp

      energies(iat) = energies(iat) + dE
      dEdcn(iat) = dEdcn(iat) - dc6dcn(iat, jat) * disp
      sigma = sigma + dS
      if (iat /= jat) then
         energies(jat) = energies(jat) + dE
         dEdcn(jat) = dEdcn(jat) - dc6dcn(jat, iat) * disp
         gradient(:, iat) = gradient(:, iat) + dG
         gradient(:, jat) = gradient(:, jat) - dG
         sigma = sigma + dS
      endif

   enddo
   !$omp end parallel do

   call dgemv('n', 3*nat, nat, 1.0_wp, dcndr, 3*nat, dEdcn, 1, 1.0_wp, gradient, 1)
   !call dgemv('n', 9, nat, 1.0_wp, dcndL, 9, dEdcn, 1, 1.0_wp, sigma, 1)

   energy = sum(energies)

end subroutine d3_gradient

real(wp) pure elemental function weight_cn(wf,cn,cnref) result(cngw)
   real(wp),intent(in) :: wf, cn, cnref
   intrinsic :: exp
   cngw = exp ( -wf * ( cn - cnref )**2 )
end function weight_cn

real(wp) pure elemental function pair_scale(iat, jat) result(scale)
   integer, intent(in) :: iat, jat
   if (iat == jat) then
      scale = 0.5_wp
   else
      scale = 1.0_wp
   endif
end function pair_scale

pure function trapzd(pol)
   real(wp),intent(in) :: pol(23)
   real(wp)            :: trapzd

   real(wp)            :: tmp1, tmp2
   real(wp),parameter  :: freq(23) = (/ &
&   0.000001_wp,0.050000_wp,0.100000_wp, &
&   0.200000_wp,0.300000_wp,0.400000_wp, &
&   0.500000_wp,0.600000_wp,0.700000_wp, &
&   0.800000_wp,0.900000_wp,1.000000_wp, &
&   1.200000_wp,1.400000_wp,1.600000_wp, &
&   1.800000_wp,2.000000_wp,2.500000_wp, &
&   3.000000_wp,4.000000_wp,5.000000_wp, &
&   7.500000_wp,10.00000_wp /)
!  just precalculate all weights and get the job done
   real(wp),parameter :: weights(23) = 0.5_wp * (/ &
&  ( freq (2) - freq (1) ),  &
&  ( freq (2) - freq (1) ) + ( freq (3) - freq (2) ),  &
&  ( freq (3) - freq (2) ) + ( freq (4) - freq (3) ),  &
&  ( freq (4) - freq (3) ) + ( freq (5) - freq (4) ),  &
&  ( freq (5) - freq (4) ) + ( freq (6) - freq (5) ),  &
&  ( freq (6) - freq (5) ) + ( freq (7) - freq (6) ),  &
&  ( freq (7) - freq (6) ) + ( freq (8) - freq (7) ),  &
&  ( freq (8) - freq (7) ) + ( freq (9) - freq (8) ),  &
&  ( freq (9) - freq (8) ) + ( freq(10) - freq (9) ),  &
&  ( freq(10) - freq (9) ) + ( freq(11) - freq(10) ),  &
&  ( freq(11) - freq(10) ) + ( freq(12) - freq(11) ),  &
&  ( freq(12) - freq(11) ) + ( freq(13) - freq(12) ),  &
&  ( freq(13) - freq(12) ) + ( freq(14) - freq(13) ),  &
&  ( freq(14) - freq(13) ) + ( freq(15) - freq(14) ),  &
&  ( freq(15) - freq(14) ) + ( freq(16) - freq(15) ),  &
&  ( freq(16) - freq(15) ) + ( freq(17) - freq(16) ),  &
&  ( freq(17) - freq(16) ) + ( freq(18) - freq(17) ),  &
&  ( freq(18) - freq(17) ) + ( freq(19) - freq(18) ),  &
&  ( freq(19) - freq(18) ) + ( freq(20) - freq(19) ),  &
&  ( freq(20) - freq(19) ) + ( freq(21) - freq(20) ),  &
&  ( freq(21) - freq(20) ) + ( freq(22) - freq(21) ),  &
&  ( freq(22) - freq(21) ) + ( freq(23) - freq(22) ),  &
&  ( freq(23) - freq(22) ) /)

   trapzd = sum(pol*weights)

end function trapzd



!========================================================================================!
end module gfnff_gdisp0

!================================================================================!
! This file is part of gfnff.
!
! Copyright (C) 2023 Philipp Pracht
!
! gfnff is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfnff is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfnff. If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------!
!> The original (unmodified) source code can be found under the GNU LGPL 3.0 license
!> Copyright (C) 2019-2020 Sebastian Ehlert, Sebastian Spicher, Stefan Grimme
!> at https://github.com/grimme-lab/xtb
!================================================================================!
!> Topological data for force field type calculations and neighbor lists
module gfnff_data_types
  use iso_fortran_env, only: wp => real64, sp=>real32
  implicit none
  private

  !> public types and routines
  public :: TGFFTopology
  public :: TGFFNeighbourList,new
  public :: TGFFData,init
  public :: TDispersionData,initgffdispersion
  public :: TGFFGenerator

!========================================================================================!

  !> Data for the dispersion contribution
  type :: TDispersionData

    !> Damping parameters
    real(wp) :: s6 = 1.0_wp
    real(wp) :: s8 = 0.0_wp
    real(wp) :: s10 = 0.0_wp
    real(wp) :: a1 = 0.0_wp
    real(wp) :: a2 = 0.0_wp
    real(wp) :: s9 = 0.0_wp
    integer  :: alp = 16

    !> Weighting factor for Gaussian interpolation
    real(wp) :: wf

    !> Charge steepness
    real(wp) :: g_a

    !> Charge height
    real(wp) :: g_c

    !> Reference data for the dispersion
    integer,allocatable :: atoms(:)
    integer,allocatable :: nref(:)
    integer,allocatable :: ncount(:,:)
    real(wp),allocatable :: cn(:,:)
    real(wp),allocatable :: q(:,:)
    real(wp),allocatable :: alpha(:,:,:)
    real(wp),allocatable :: c6(:,:,:,:)

  end type TDispersionData
!========================================================================================!

  !> Topology information for a given system
  type :: TGFFTopology

    !> some reference files
    character(len=:),allocatable :: filename
    character(len=:),allocatable :: refcharges

    !> number of terms
    integer  :: nbond
    integer  :: nangl
    integer  :: ntors
    integer  :: nathbH
    integer  :: nathbAB
    integer  :: natxbAB
    integer  :: nbatm
    integer  :: nfrag
    integer  :: maxsystem   !> max. number of fragmentsfor hessian
    integer  :: bond_hb_nr  !> number of unique AH...B HB/bond terms
    integer  :: b_max       !> number of B atoms per unique AH bond

    !> numbers that are rewritten, so must be stored for allocation
    integer  :: nbond_blist
    integer  :: nbond_vbond
    integer  :: nangl_alloc
    integer  :: ntors_alloc

    !> file type read
    integer  :: read_file_type

    !> lists
    integer,allocatable ::     nb(:,:)   ! neighbors nb(20,i) is the # neigbors
    integer,allocatable ::      hyb(:)   ! hybridization of every atom
    integer,allocatable ::    bpair(:)   ! # of cov. between atoms
    integer,allocatable ::  blist(:,:)   ! bonded atoms
    integer,allocatable ::  alist(:,:)   ! angles
    integer,allocatable ::  tlist(:,:)   ! torsions
    integer,allocatable :: b3list(:,:)   ! bond atm
    integer,allocatable :: sTorsl(:,:)   ! triple bonded carbon potential
    real(wp),allocatable::      pbo(:)   ! bond order from Hückel
    !-----------------------------------------------
    integer,allocatable :: nr_hb(:)        ! Nr. of H bonds per O-H or N-H bond
    integer,allocatable :: bond_hb_AH(:,:) ! A, H atoms in bonds that are also part of HBs
    integer,allocatable :: bond_hb_B(:,:)  ! B atoms in bonds that are also part of HBs
    integer,allocatable :: bond_hb_Bn(:)   ! Nr. of B atoms for one AH bond pair
    !-----------------------------------------------
    integer,allocatable :: hbatABl(:,:) ! AB atoms for HB
    integer,allocatable :: xbatABl(:,:) ! AB atoms for XB
    integer,allocatable :: hbatHl(:)    ! H  atoms for HB
    integer,allocatable :: fraglist(:)  ! atoms in molecular fragments (for EEQ)
    integer,allocatable :: qpdb(:)      ! atomic charge in residues from PDB file

    !potential parameters used in energy-gradient routine
    real(wp),allocatable :: vbond(:,:) ! bonds
    real(wp),allocatable :: vangl(:,:) ! angles
    real(wp),allocatable :: vtors(:,:) ! torsions
    real(wp),allocatable :: chieeq(:)  ! atomic ENs for EEQ
    real(wp),allocatable :: gameeq(:)  ! atomic gamma for EEQ
    real(wp),allocatable :: alpeeq(:)  ! atomic alpha for EEQ, squared
    real(wp),allocatable :: alphanb(:) ! non-bonded exponent for atom pairs
    real(wp),allocatable :: qa(:)      ! estimated atomic charges (fixed and obtained from topology EEQ)
    real(wp),allocatable :: xyze0(:,:) ! atom xyz, starting geom. (for Efield energy)
    real(wp),allocatable :: zetac6(:)  ! D4 scaling factor product
    real(wp),allocatable :: qfrag(:)   ! fragment charge (for EEQ)
    real(wp),allocatable :: hbbas(:)   ! HB donor atom basicity
    real(wp),allocatable :: hbaci(:)   ! HB acceptor atom acidity

    integer,allocatable  :: ispinsyst(:,:)
    integer,allocatable  :: nspinsyst(:)
    integer              :: nsystem

    type(TDispersionData) :: dispm

  contains

    procedure :: zero

  end type TGFFTopology
!========================================================================================!

  !> Neighbourlist storage
  type :: TGFFNeighbourList
    logical :: initialized = .false.
    logical :: force_hbond_update = .false.
    integer :: nhb1
    integer :: nhb2
    integer :: nxb
    !> atomic charges (obtained from EEQ)
    real(wp),allocatable :: q(:)
    !> atom xyz, used to check for HB list update
    real(wp),allocatable :: hbrefgeo(:,:)
    !> HBs loose
    integer,allocatable :: hblist1(:,:)
    !> HBs bonded
    integer,allocatable :: hblist2(:,:)
    !> XBs
    integer,allocatable :: hblist3(:,:)
  end type TGFFNeighbourList

  interface new
    module procedure :: newGFFNeighbourList
  end interface
!========================================================================================!

  !> Parametrisation data for the force field
  type :: TGFFData

    !> repulsion scaling
    real(wp) :: repscaln
    real(wp) :: repscalb

    !> bend/tors angle damping
    real(wp) :: atcuta
    real(wp) :: atcutt

    !> bend/tors nci angle damping for HB term
    real(wp) :: atcuta_nci
    real(wp) :: atcutt_nci

    !> damping HB
    real(wp) :: hbacut
    real(wp) :: hbscut

    !> damping XB
    real(wp) :: xbacut
    real(wp) :: xbscut

    !> damping HB/XB
    real(wp) :: hbalp

    !> damping HB/XB
    real(wp) :: hblongcut
    real(wp) :: hblongcut_xb

    !> charge scaling HB/XB
    real(wp) :: hbst
    real(wp) :: hbsf
    real(wp) :: xbst
    real(wp) :: xbsf

    !> HB AH-B
    real(wp) :: xhaci_globabh

    !> HB AH-O=C
    real(wp) :: xhaci_coh

    !> acidity
    real(wp) :: xhaci_glob

    !> HB AH-B
    real(wp) :: hbabmix

    !> new parameter for neighbour angle
    real(wp) :: hbnbcut

    !> new parameter for HB NCI angle term
    real(wp) :: tors_hb

    !> new parameter for HB NCI torsion term
    real(wp) :: bend_hb

    !> new parameter for FC scaling of bonds in HB
    real(wp) :: vbond_scale

    !> max CN cut-off
    real(wp) :: cnmax

    !> D3 scaling
    real(wp) :: dispscale

    !> Constant data
    real(wp),allocatable :: en(:)
    real(wp),allocatable :: rad(:)
    real(wp),allocatable :: rcov(:)
    integer,allocatable :: metal(:)
    integer,allocatable :: group(:)
    integer,allocatable :: normcn(:)

    !> rep alpha bond
    real(wp),allocatable :: repa(:)
    real(wp),allocatable :: repan(:)

    !> prefactor (Zval), 3atm bond term
    real(wp),allocatable :: repz(:)
    real(wp),allocatable :: zb3atm(:)

    !> HB/XB
    real(wp),allocatable :: xhaci(:)
    real(wp),allocatable :: xhbas(:)
    real(wp),allocatable :: xbaci(:)

    !> EN dep. in EEQ.
    real(wp),allocatable :: chi(:)
    real(wp),allocatable :: gam(:)
    real(wp),allocatable :: cnf(:)
    real(wp),allocatable :: alp(:)

    !> Elem. bond param.
    real(wp),allocatable :: bond(:)

    !> Elem. angular param.
    real(wp),allocatable :: angl(:)

    !> Elem. angular param.
    real(wp),allocatable :: angl2(:)

    !> Elem. torsion param_alloc.
    real(wp),allocatable :: tors(:)

    !> Elem. torsion param.
    real(wp),allocatable :: tors2(:)

    !> BJ radii set in gnff_ini()
    real(wp),allocatable :: d3r0(:)

  end type TGFFData

  !> Initialize a new instance of the parametrisation data
  interface init
    module procedure :: initGFFData
  end interface init

!========================================================================================!


   !> Generator for the force field topology
   type TGFFGenerator

      !> when is an angle close to linear ? (GEODEP)
      !  for metals values closer to 170 (than to 160) are better
      real(wp) :: linthr

      !> skip torsion and bending if potential is small
      real(wp) :: fcthr

      !> R threshold in Angstroem for cov distance estimated used in apprx EEQ
      real(sp) :: tdist_thr

      !> important bond determination threshold, large values yield more 1.23
      real(wp) :: rthr

      !> decrease if a metal is present, larger values yield smaller CN
      real(wp) :: rthr2

      !> change of R0 for topo with charge qa
      !  larger values yield smaller CN for metals in particular
      real(wp) :: rqshrink

      !> H charge (qa) threshold for H in HB list 18
      real(wp) :: hqabthr

      !> AB charge (qa) threshold for AB in HB list
      !  - avoids HBs with positive atoms,
      !  - larger val. better for S30L but worse in PubChem RMSD checks
      real(wp) :: qabthr

      !> Parameter
      real(wp) :: srb1
      real(wp) :: srb2
      real(wp) :: srb3

      !> change of non-bonded rep. with q(topo)
      real(wp) :: qrepscal

      !> change of non-bonded rep. with CN
      real(wp) :: nrepscal

      !> HH repulsion
      real(wp) :: hhfac
      real(wp) :: hh13rep
      real(wp) :: hh14rep
      real(wp) :: bstren(9)

      !> bend FC change with polarity
      real(wp) :: qfacBEN

      !> torsion FC change with polarity
      real(wp) :: qfacTOR

      !> tors FC 3-ring
      real(wp) :: fr3

      !> tors FC 4-ring
      real(wp) :: fr4

      !> tors FC 5-ring
      real(wp) :: fr5

      !> tors FC 6-ring
      real(wp) :: fr6

      !> bonds
      real(wp) :: torsf(8)

      !> small bend corr.
      real(wp) :: fbs1

      !> bonded ATM scal
      real(wp) :: batmscal

      !> Shifts
      real(wp) :: mchishift

      !> gen shift
      real(wp) :: rabshift

      !> XH
      real(wp) :: rabshifth

      !> hypervalent
      real(wp) :: hyper_shift

      !> heavy
      real(wp) :: hshift3
      real(wp) :: hshift4
      real(wp) :: hshift5

      !> group 1+2 metals
      real(wp) :: metal1_shift

      !> TM
      real(wp) :: metal2_shift

      !> main group metals
      real(wp) :: metal3_shift

      !> eta bonded
      real(wp) :: eta_shift

      !> Charge Param
      real(wp) :: qfacbm(0:4)

      !> bond charge dependent
      real(wp) :: qfacbm0

      !> topo dist scaling
      real(wp) :: rfgoed1

      !> Hückel Param
      !  decrease Hueckel off-diag for triple bonds because they are less well conjugated 1.4
      real(wp) :: htriple

      !> increase pot depth depending on P
      real(wp) :: hueckelp2

      !> diagonal element change with qa
      real(wp) :: hueckelp3

      !> diagonal element relative to C
      real(wp) :: hdiag(17)

      !> Huckel off-diag constants
      real(wp) :: hoffdiag(17)

      !> iteration mixing
      real(wp) :: hiter

      !> diagonal qa dep.
      real(wp) :: hueckelp

      !> ref P value R shift
      real(wp) :: bzref

      !> ref P value k stretch
      real(wp) :: bzref2

      !> 2el diag shift
      real(wp) :: pilpf

      !> the Hückel iterations can diverge so take only a few steps
      real(wp) :: maxhiter

      !> D3 Param
      real(wp) :: d3a1

      !> D3
      real(wp) :: d3a2

      !> mixing of sp^n with sp^n-1
      real(wp) :: split0

      !> mixing of sp^n with sp^n-1
      real(wp) :: split1

      !> str ring size dep.
      real(wp) :: fringbo

      !> three coord. heavy eq. angle
      real(wp) :: aheavy3

      !> four coord. heavy eq. angle
      real(wp) :: aheavy4
      real(wp) :: bsmat(0:3,0:3)

      !> max CN cut-off
      real(wp) :: cnmax

   end type TGFFGenerator


!========================================================================================!
!========================================================================================!
contains  !> MODULE PROCEDURES START HERE
!========================================================================================!
!========================================================================================!

  subroutine zero(self)
    class(TGFFTopology),intent(inout) :: self

    self%nbond = 0
    self%nangl = 0
    self%ntors = 0
    self%nathbH = 0
    self%nathbAB = 0
    self%natxbAB = 0
    self%nbatm = 0
    self%nfrag = 0
    self%maxsystem = 0
    self%bond_hb_nr = 0
    self%b_max = 0

    self%nbond_blist = 0
    self%nbond_vbond = 0
    self%nangl_alloc = 0
    self%ntors_alloc = 0

    self%read_file_type = 0
  end subroutine zero
!========================================================================================!

  !> Initialize new instance for the neighbourlist
  subroutine newGFFNeighbourList(self,n,nhb1,nhb2,nxb)
    type(TGFFNeighbourList),intent(out) :: self
    integer,intent(in) :: n
    integer,intent(in) :: nhb1
    integer,intent(in) :: nhb2
    integer,intent(in) :: nxb
    self%initialized = .true.
    self%nhb1 = nhb1
    self%nhb2 = nhb2
    self%nxb = nxb
    allocate (self%q(n),source=0.0_wp)
    allocate (self%hbrefgeo(3,n),source=0.0_wp)
    allocate (self%hblist1(3,self%nhb1),source=0)
    allocate (self%hblist2(3,self%nhb2),source=0)
    allocate (self%hblist3(3,self%nxb),source=0)
  end subroutine newGFFNeighbourList
!========================================================================================!

  !> Initialize a new instance of the parametrisation data
  subroutine initGFFData(self,ndim)

    !> Instance of the parametrisation data
    type(TGFFData),intent(out) :: self

    !> Dimension for allocating space
    integer,intent(in) :: ndim

    allocate (self%en(ndim))
    allocate (self%rad(ndim))
    allocate (self%metal(ndim))
    allocate (self%group(ndim))
    allocate (self%normcn(ndim))
    allocate (self%rcov(ndim))

    allocate (self%repa(ndim))
    allocate (self%repan(ndim))

    allocate (self%repz(ndim))
    allocate (self%zb3atm(ndim))

    allocate (self%xhaci(ndim))
    allocate (self%xhbas(ndim))
    allocate (self%xbaci(ndim))

    allocate (self%chi(ndim))
    allocate (self%gam(ndim))
    allocate (self%cnf(ndim))
    allocate (self%alp(ndim))

    allocate (self%bond(ndim))

    allocate (self%angl(ndim))

    allocate (self%angl2(ndim))

    allocate (self%tors(ndim))

    allocate (self%tors2(ndim))

    allocate (self%d3r0(ndim*(1+ndim)/2))

  end subroutine initGFFData

!========================================================================================!
  subroutine initGFFDispersion(self)
    type(TDispersionData),intent(out) :: self
    integer :: elem,ref,freq

    elem = 118
    ref = 7
    freq = 23

    allocate (self%atoms(elem),source=0)
    allocate (self%nref(elem),source=0)
    allocate (self%ncount(ref,elem),source=0)
    allocate (self%cn(ref,elem),source=0.0_wp)
    allocate (self%q(ref,elem),source=0.0_wp)
    allocate (self%alpha(freq,ref,elem),source=0.0_wp)
    allocate (self%c6(ref,ref,elem,elem),source=0.0_wp)

    self%g_a = 3.0_wp
    self%g_c = 2.0_wp
    self%wf = 6.0_wp

    self%a1 = 0.8000000_wp
    self%a2 = 4.6000000_wp
    self%s8 = 2.8500000_wp

  end subroutine initGFFDispersion

!========================================================================================!
end module gfnff_data_types

!================================================================================!
! This file is part of gfnff.
!
! Copyright (C) 2025 Philipp Pracht
!
! gfnff is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfnff is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfnff. If not, see <https://www.gnu.org/licenses/>.
!================================================================================!

!> c bindings for gfnff

module gfnff_interface_c
  use iso_c_binding
  use iso_fortran_env,only:wp => real64,stdout => output_unit,stderr => error_unit
  use gfnff_interface
  implicit none
  private

  !> Public C-compatible interface
  public :: c_gfnff_calculator
  public :: c_gfnff_calculator_init
  public :: c_gfnff_calculator_deallocate
  public :: c_gfnff_calculator_singlepoint
  public :: c_gfnff_calculator_results

  !> C-compatible type containing a pointer to the original Fortran type
  type,bind(C) :: c_gfnff_calculator
    !> C will understand fortran types as pointers
    type(c_ptr) :: ptr
  end type c_gfnff_calculator

!========================================================================================!
!========================================================================================!
contains  !> MODULE PROCEDURES START HERE
!========================================================================================!
!========================================================================================!

!>--- C-compatible initialization function
  function c_gfnff_calculator_init(c_nat,c_at,c_xyz,c_ichrg,c_printlevel,  &
    &                              c_solvent) &
    &                                  result(calculator) &
    &                                  bind(C,name="c_gfnff_calculator_init")
    implicit none
    type(c_gfnff_calculator) :: calculator
    integer(c_int),value,intent(in) :: c_nat
    integer(c_int),target,intent(in) :: c_at(*)
    !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<!
    !> WARNING: row-first vs column-first difference  in Fortran and C!
    real(c_double),target,intent(in) :: c_xyz(3,*)
    !> We assume here that a 3-by-x elements are passed, which in C corresponds
    !> to a vector of length nat for x, y and z coordinates respectively
    !> when xyz[3][nat] was defined.
    !> Hence, it should be defined as xyz[nat][3] in C in order for Fortran
    !> to handle everything correctly in the following!
    !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<!
    !character(kind=c_char,len=1),intent(in) :: c_model(*)
    integer(c_int),value,intent(in) :: c_ichrg
    !integer(c_int),value,intent(in) :: c_iunit
    integer(c_int),value,intent(in) :: c_printlevel
    character(kind=c_char),intent(in) :: c_solvent(*)
    type(gfnff_data),pointer :: calc

    integer :: nat
    integer,pointer :: at(:)
    real(wp),pointer :: xyz(:,:)
    character(len=:),allocatable :: solvent
    logical :: verbose,pr
    integer :: iunit,printlevel,iostatus
    integer :: i,ichrg

    !> Convert C arguments to Fortran types
    nat = c_nat
    call c_f_pointer(c_loc(c_at),at, [nat])
    call c_f_pointer(c_loc(c_xyz),xyz, [3,nat]) !> assumes xyz[nat][3] in C
    ichrg = c_ichrg
    pr = .false.
    verbose = .false.
    iunit = stdout !> use a default here.
    printlevel = c_printlevel
    if (printlevel > 0) pr = .true.
    if (printlevel > 1) verbose = .true.
    solvent = c_string_to_fortran(c_solvent)
    if (len_trim(solvent) == 0) deallocate (solvent)

    !> Allocate and initialize the Fortran calculator
    allocate (calc)
    call calc%init(nat,at,xyz,ichrg=ichrg, &
    &              print=pr,verbose=verbose,iunit=iunit,iostat=iostatus,&
    &              solvent=solvent)
    if (iostatus == 0) then
      !> Store the pointer in the C-compatible structure
      calculator%ptr = c_loc(calc)
    else
      write (stderr,'(a,i0)') 'Error initializing GFN-FF calculator. code ',iostatus
      calculator%ptr = c_null_ptr
      deallocate (calc)
    end if
  end function c_gfnff_calculator_init

!========================================================================================!

  subroutine c_gfnff_calculator_deallocate(calculator) &
    &     bind(C,name="c_gfnff_calculator_deallocate")
    type(c_gfnff_calculator),intent(inout) :: calculator
    type(gfnff_data),pointer :: calc_ptr

    !> Convert the C pointer to a Fortran pointer
    call c_f_pointer(calculator%ptr,calc_ptr)

    !> Deallocate the Fortran object
    if (associated(calc_ptr)) then
      call calc_ptr%deallocate()
      deallocate (calc_ptr)
    end if

    !> Nullify the C pointer
    calculator%ptr = c_null_ptr
  end subroutine c_gfnff_calculator_deallocate

!========================================================================================!

  subroutine c_gfnff_calculator_singlepoint(c_calculator,c_nat,c_at,c_xyz, &
    &                                           c_energy,c_gradient,c_iostat) &
    &                        bind(C,name="c_gfnff_calculator_singlepoint")
    implicit none
    !> Input arguments from C
    type(c_gfnff_calculator),intent(inout) :: c_calculator
    integer(c_int),value,intent(in) :: c_nat
    integer(c_int),target,intent(in) :: c_at(*)
    real(c_double),target,intent(in) :: c_xyz(3,*) !> NOTE Fortran/C matrix orders

    !> Output arguments to C
    real(c_double),intent(out) :: c_energy
    real(c_double),target,intent(out) :: c_gradient(3,*) !> NOTE Fortran/C matrix orders
    integer(c_int),intent(out) :: c_iostat

    !> Local Fortran variables
    type(gfnff_data),pointer :: calc_ptr
    integer :: nat
    integer,pointer :: at(:)
    real(wp),pointer :: xyz(:,:)
    real(wp),pointer :: grad(:,:)
    real(wp) :: energy
    integer :: iostat,i,j

    !> Convert C pointers to Fortran pointers
    call c_f_pointer(c_calculator%ptr,calc_ptr)
    call c_f_pointer(c_loc(c_at),at, [c_nat])
    call c_f_pointer(c_loc(c_xyz),xyz, [3,c_nat]) !> Assumes xyz[nat][3] in C
    call c_f_pointer(c_loc(c_gradient),grad, [3,c_nat])  !> Assumes grad[nat][3] in C

    !> Set the integer variable
    nat = c_nat

    !> Call the Fortran subroutine
    call calc_ptr%singlepoint(nat,at,xyz,energy,grad,iostat=iostat)

    !> Pass back the results to C variables
    c_energy = energy
    c_gradient(1:3,1:nat) = grad(1:3,1:nat)
    c_iostat = iostat

  end subroutine c_gfnff_calculator_singlepoint

!========================================================================================!

  subroutine c_gfnff_calculator_results(c_calculator,c_iunit) &
    &   bind(C,name="c_gfnff_calculator_results")
    implicit none
    !> Input arguments from C
    type(c_gfnff_calculator),intent(in) :: c_calculator
    integer(c_int),value,intent(in) :: c_iunit
    !> Local Fortran variables
    type(gfnff_data),pointer :: calc_ptr
    integer :: myunit
    !> Convert C pointer to Fortran pointer
    call c_f_pointer(c_calculator%ptr,calc_ptr)
    myunit = c_iunit
    !> Call the Fortran subroutine
    call calc_ptr%resultprint(myunit)
  end subroutine c_gfnff_calculator_results

!========================================================================================!

  function c_string_to_fortran(c_str) result(f_str)
    use iso_c_binding
    implicit none
    character(kind=c_char),intent(in) :: c_str(*)   !> C null-terminated string
    character(len=:),allocatable :: f_str           !> Fortran allocatable string
    integer :: i
    !> Find the null terminator dynamically
    i = 1
    do while (c_str(i) /= c_null_char)
      i = i+1
    end do
    i = i-1  !> Exclude null terminator
    !> Allocate Fortran string with exact length
    allocate (character(len=i) :: f_str)
    !> Copy contents from C string to Fortran string
    f_str = transfer(c_str(1:i),f_str)
  end function c_string_to_fortran

!========================================================================================!
!========================================================================================!
end module gfnff_interface_c

!================================================================================!
! This file is part of gfnff.
!
! Copyright (C) 2023 Philipp Pracht
!
! gfnff is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfnff is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfnff. If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------!
!> The original (unmodified) source code can be found under the GNU LGPL 3.0 license
!> Copyright (C) 2019-2020 Sebastian Ehlert, Sebastian Spicher, Stefan Grimme
!> at https://github.com/grimme-lab/xtb
!================================================================================!
module gfnff_ini2
  use iso_fortran_env,only:wp => real64,sp => real32,stdout=>output_unit

  use gfnff_data_types,only:TGFFData,TGFFNeighbourList,TGFFTopology
  use gfnff_helpers, only: lin,bangl
  implicit none
  private

  public :: gfnff_neigh,getnb,nbondmat
  public :: pairsbond,pilist,nofs,xatom,ctype,amide,amideH,alphaCO
  public :: ringsatom,ringsbond,ringsbend,ringstors,ringstorl
  public :: chktors,hbonds,goedeckera,qheavy
  public :: gfnff_hbset,gfnff_hbset0,bond_hbset,bond_hbset0
  public :: bond_hb_AHB_set,bond_hb_AHB_set1,bond_hb_AHB_set0

!========================================================================================!
!========================================================================================!
contains  !> MODULE PROCEDURES START HERE
!========================================================================================!
!========================================================================================!

  subroutine gfnff_neigh(makeneighbor,natoms,at,xyz,rab,fq,f_in,f2_in,lintr,mchar,hyb,itag,nbm,nbf,param,topo,myunit,pr)
    use gfnff_param
    use gfnff_rab
    implicit none
    character(len=*),parameter :: source = 'gfnff_ini2_neigh'
    type(TGFFData),intent(in) :: param
    type(TGFFTopology),intent(inout) :: topo
    integer,intent(in) :: myunit
    logical,intent(in) :: pr 
    logical :: makeneighbor
    integer :: at(natoms),natoms
    integer :: hyb(natoms)
    integer :: itag(natoms)
    integer :: nbm(20,natoms)                 ! needed for ring assignment (done without metals)
    integer :: nbf(20,natoms)                 ! full needed for fragment assignment
    real(wp) :: rab(natoms*(natoms+1)/2)
    real(wp) :: xyz(3,natoms)
    real(wp) :: mchar(natoms)
    real(wp) :: fq
    real(wp) :: f_in,f2_in               ! radius scaling for atoms/metal atoms recpectively
    real(wp) :: lintr                    ! threshold for linearity

    logical :: etacoord,da,strange_iat,metal_iat
    integer,allocatable :: nbdum(:,:)
    real(wp),allocatable :: cn(:),rtmp(:)
    integer :: iat,i,j,k,ni,ii,jj,kk,ll,ati,nb20i,nbdiff,hc_crit,nbmdiff,nnf,nni,nh,nm
    integer :: ai,aj,nn,im,ncm,l,no
    real(wp) r,pi,a1,f,f1,phi,f2,rco,fat(86)
    data pi/3.1415926535897932384626433832795029d0/
    data fat/86*1.0d0/

!     special hacks
    fat(1) = 1.02
    fat(4) = 1.03
    fat(5) = 1.02
    fat(8) = 1.02
    fat(9) = 1.05
    fat(10) = 1.10
    fat(11) = 1.01
    fat(12) = 1.02
    fat(15) = 0.97
    fat(18) = 1.10
    fat(19) = 1.02
    fat(20) = 1.02
    fat(38) = 1.02
    fat(34) = 0.99
    fat(50) = 1.01
    fat(51) = 0.99
    fat(52) = 0.95
    fat(53) = 0.98
    fat(56) = 1.02
    fat(76) = 1.02
    fat(82) = 1.06
    fat(83) = 0.95

    allocate (cn(natoms),rtmp(natoms*(natoms+1)/2),nbdum(20,natoms))

! determine the neighbor list
    if (makeneighbor) then

      topo%nb = 0  ! without highly coordinates atoms
      nbm = 0  ! without any metal
      nbf = 0  ! full

      do i = 1,natoms
        cn(i) = dble(param%normcn(at(i)))
      end do
      call gfnffrab(natoms,at,cn,rtmp) ! guess RAB based on "normal" CN
      do i = 1,natoms
        ai = at(i)
        f1 = fq
        if (param%metal(ai) > 0) f1 = f1*2.0d0
        do j = 1,i-1
          f2 = fq
          aj = at(j)
          if (param%metal(aj) > 0) f2 = f2*2.0d0
          k = lin(j,i)
          rco = rtmp(k)
          rtmp(k) = rtmp(k)-topo%qa(i)*f1-topo%qa(j)*f2 ! change radius of atom i and j with charge
!             element specials
          rtmp(k) = rtmp(k)*fat(ai)*fat(aj)
        end do
      end do

      call getnb(natoms,at,rtmp,rab,mchar,1,f_in,f2_in,nbdum,nbf,param) ! full
      call getnb(natoms,at,rtmp,rab,mchar,2,f_in,f2_in,nbf,topo%nb,param) ! no highly coordinates atoms
      call getnb(natoms,at,rtmp,rab,mchar,3,f_in,f2_in,nbf,nbm,param) ! no metals and unusually coordinated stuff

! take the input
    else

      nbf = topo%nb
      nbm = topo%nb

    end if
! done

    itag = 0 ! save special hyb info

! tag atoms in nb(19,i) if they belong to a cluster (which avoids the ring search)
    do i = 1,natoms
      if (nbf(20,i) .eq. 0.and.param%group(at(i)) .ne. 8 .and.pr) then
        write (myunit,'(''!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'')')
        write (myunit,'(''  warning: no bond partners for atom'',i4)') i
        write (myunit,'(''!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'')')
      end if
      if (at(i) .lt. 11.and.nbf(20,i) .gt. 2) then
        do k = 1,nbf(20,i)
          kk = nbf(k,i)
          if (param%metal(at(kk)) .ne. 0.or.topo%nb(20,kk) .gt. 4) then
            topo%nb(19,i) = 1
            nbf(19,i) = 1
            nbm(19,i) = 1
          end if
        end do
      end if
!        write(myunit,*) i,(topo%nb(j,i),j=1,topo%nb(20,i))
    end do

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! hybridization states
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    do i = 1,natoms
      ati = at(i)
!        important: determine cases where atom is pi bonded to a metal and thus
!        the hyb must be obtained from the reduced (wo metals) neighbor list
      etacoord = .false.
      if (ati .le. 10) then
        if (ati .eq. 6.and.nbf(20,i) .ge. 4.and.nbm(20,i) .eq. 3) etacoord = .true.  ! CP case
        if (ati .eq. 6.and.nbf(20,i) .eq. 3.and.nbm(20,i) .eq. 2) etacoord = .true.  ! alkyne case
        nm = 0
        do k = 1,nbf(20,i)  ! how many metals ? and which
          kk = nbf(k,i)
          if (param%metal(at(kk)) .ne. 0) then
            nm = nm+1
            im = kk
          end if
        end do
        if (nm .eq. 0) then
          etacoord = .false.  ! etacoord makes no sense without metals!
        elseif (nm .eq. 1) then  ! distinguish M-CR2-R i.e. not an eta coord.
          ncm = 0
          do k = 1,nbf(20,i)  !
            if (nbf(k,i) .ne. im) then ! all neighbors that are not the metal im
              kk = nbf(k,i)
              do l = 1,nbf(20,kk)
                if (nbf(l,kk) .eq. im) ncm = ncm+1 ! ncm=1 is alkyne, =2 is cp
              end do
            end if
          end do
          if (ncm .eq. 0) etacoord = .false.
        end if
      end if
      if (etacoord) then
        itag(i) = -1
        nbdum(1:20,i) = nbm(1:20,i)
      else
        nbdum(1:20,i) = nbf(1:20,i) ! take full set of neighbors by default
      end if
    end do

    do i = 1,natoms
      ati = at(i)
      hyb(i) = 0    ! don't know it
      nbdiff = nbf(20,i)-topo%nb(20,i)
      nbmdiff = nbf(20,i)-nbm(20,i)
      nb20i = nbdum(20,i)
      nh = 0
      no = 0
      do j = 1,nb20i
        if (at(nbdum(j,i)) .eq. 1) nh = nh+1
        if (at(nbdum(j,i)) .eq. 8) no = no+1
      end do
! H
      if (param%group(ati) .eq. 1) then
        if (nb20i .eq. 2) hyb(i) = 1 ! bridging H
        if (nb20i .gt. 2) hyb(i) = 3 ! M+ tetra coord
        if (nb20i .gt. 4) hyb(i) = 0 ! M+ HC
      end if
! Be
      if (param%group(ati) .eq. 2) then
        if (nb20i .eq. 2) hyb(i) = 1 ! bridging M
        if (nb20i .gt. 2) hyb(i) = 3 ! M+ tetra coord
        if (nb20i .gt. 4) hyb(i) = 0 !
      end if
! B
      if (param%group(ati) .eq. 3) then
        if (nb20i .gt. 4) hyb(i) = 3
        if (nb20i .gt. 4.and.ati .gt. 10.and.nbdiff .eq. 0) hyb(i) = 5
        if (nb20i .eq. 4) hyb(i) = 3
        if (nb20i .eq. 3) hyb(i) = 2
        if (nb20i .eq. 2) hyb(i) = 1
      end if
! C
      if (param%group(ati) .eq. 4) then
        if (nb20i .ge. 4) hyb(i) = 3
        if (nb20i .gt. 4.and.ati .gt. 10.and.nbdiff .eq. 0) hyb(i) = 5
        if (nb20i .eq. 3) hyb(i) = 2
        if (nb20i .eq. 2) then
          call bangl(xyz,nbdum(1,i),i,nbdum(2,i),phi)
          if (phi*180./pi .lt. 150.0) then                         ! geometry dep. setup! GEODEP
            hyb(i) = 2  ! otherwise, carbenes will not be recognized
            itag(i) = 1  ! tag for Hueckel and HB routines
          else
            hyb(i) = 1  ! linear triple bond etc
          end if
          if (topo%qa(i) .lt. -0.4) then
            hyb(i) = 2
            itag(i) = 0  ! tag for Hueckel and HB routines
          end if
        end if
        if (nb20i .eq. 1) hyb(i) = 1  ! CO
      end if
! N
      if (param%group(ati) .eq. 5) then
        if (nb20i .ge. 4) hyb(i) = 3
        if (nb20i .gt. 4.and.ati .gt. 10.and.nbdiff .eq. 0) hyb(i) = 5
        if (nb20i .eq. 3) hyb(i) = 3
        if (nb20i .eq. 3.and.ati .eq. 7) then
          kk = 0
          ll = 0
          nn = 0
          do j = 1,3
            jj = nbdum(j,i)
            if (at(jj) .eq. 8.and.topo%nb(20,jj) .eq. 1) kk = kk+1 ! check for NO2 or R2-N=O
            if (at(jj) .eq. 5.and.topo%nb(20,jj) .eq. 4) ll = ll+1 ! check for B-N, if the CN(B)=4 the N is loosely bound and sp2
            if (at(jj) .eq. 16.and.topo%nb(20,jj) .eq. 4) nn = nn+1 ! check for N-SO2-
          end do
          if (nn .eq. 1.and.ll .eq. 0.and.kk .eq. 0) hyb(i) = 3
          if (ll .eq. 1.and.nn .eq. 0) hyb(i) = 2
          if (kk .ge. 1) then
            hyb(i) = 2
            itag(i) = 1  ! tag for Hueckel with no el. for the N in NO2
          end if
          if (nbmdiff .gt. 0.and.nn .eq. 0) hyb(i) = 2  ! pyridin N coord. to heavy atom
        end if
        if (nb20i .eq. 2) then
          hyb(i) = 2
          call bangl(xyz,nbdum(1,i),i,nbdum(2,i),phi)
          jj = nbdum(1,i)
          kk = nbdum(2,i)
          if (nbdum(20,jj) .eq. 1.and.at(jj) .eq. 6) hyb(i) = 1  ! R-N=C
          if (nbdum(20,kk) .eq. 1.and.at(kk) .eq. 6) hyb(i) = 1  ! R-N=C
          if (nbdum(20,jj) .eq. 1.and.at(jj) .eq. 7) hyb(i) = 1  ! R-N=N in e.g. diazomethane
          if (nbdum(20,kk) .eq. 1.and.at(kk) .eq. 7) hyb(i) = 1  ! R-N=N in e.g. diazomethane
          if (nbdum(1,i) .gt. 0.and.param%metal(at(nbdum(1,i))) .gt. 0) hyb(i) = 1 ! M-NC-R in e.g. nitriles
          if (nbdum(2,i) .gt. 0.and.param%metal(at(nbdum(2,i))) .gt. 0) hyb(i) = 1 ! M-NC-R in e.g. nitriles
          if (at(jj) .eq. 7.and.at(kk) .eq. 7.and. &
&          nbdum(20,jj) .le. 2.and.nbdum(20,kk) .le. 2) hyb(i) = 1  ! N=N=N
          if (phi*180./pi .gt. lintr) hyb(i) = 1  ! geometry dep. setup! GEODEP
        end if
        if (nb20i .eq. 1) hyb(i) = 1
      end if
! O
      if (param%group(ati) .eq. 6) then
        if (nb20i .ge. 3) hyb(i) = 3
        if (nb20i .gt. 3.and.ati .gt. 10.and.nbdiff .eq. 0) hyb(i) = 5
        if (nb20i .eq. 2) hyb(i) = 3
        if (nb20i .eq. 2.and.nbmdiff .gt. 0) then
          call nn_nearest_noM(i,natoms,at,topo%nb,rab,j,param) ! CN of closest non-M atom
          if (j .eq. 3) hyb(i) = 2 ! M-O-X konj
          if (j .eq. 4) hyb(i) = 3 ! M-O-X non
        end if
        if (nb20i .eq. 1) hyb(i) = 2
        if (nb20i .eq. 1.and.nbdiff .eq. 0) then
          if (topo%nb(20,topo%nb(1,i)) .eq. 1) hyb(i) = 1 ! CO
        end if
      end if
! F
      if (param%group(ati) .eq. 7) then
        if (nb20i .eq. 2) hyb(i) = 1
        if (nb20i .gt. 2.and.ati .gt. 10) hyb(i) = 5
      end if
! Ne
      if (param%group(ati) .eq. 8) then
        hyb(i) = 0
        if (nb20i .gt. 0.and.ati .gt. 2) hyb(i) = 5
      end if
! done with main groups
      if (param%group(ati) .le. 0) then ! TMs
        nni = nb20i
        if (nh .ne. 0.and.nh .ne. nni) nni = nni-nh ! don't count Hs
        if (nni .le. 2) hyb(i) = 1
        if (nni .le. 2.and.param%group(ati) .le. -6) hyb(i) = 2
        if (nni .eq. 3) hyb(i) = 2
        if (nni .eq. 4.and.param%group(ati) .gt. -7) hyb(i) = 3  ! early TM, tetrahedral
        if (nni .eq. 4.and.param%group(ati) .le. -7) hyb(i) = 3  ! late TM, square planar
        if (nni .eq. 5.and.param%group(ati) .eq. -3) hyb(i) = 3  ! Sc-La are tetrahedral CN=5
      end if
    end do

    topo%nb = nbdum ! list is complete but hyb determination is based only on reduced (without metals) list
    if(allocated(topo%hyb)) topo%hyb = hyb

    deallocate (nbdum)

    j = 0
    do i = 1,natoms
      if (topo%nb(20,i) .gt. 12) j = j+1
      do k = 1,topo%nb(20,i)
        kk = topo%nb(k,i)
        if (at(kk) .eq. 6.and.at(i) .eq. 6.and.itag(i) .eq. 1.and.itag(kk) .eq. 1) then ! check the very special situation of
          itag(i) = 0                                                          ! two carbene C bonded which is an arine
          itag(kk) = 0
        end if
      end do
    end do
    if (dble(j)/dble(natoms) .gt. 0.3 .and.pr) then
      write(myunit,*) 'too many atoms with extreme high CN',source
    end if

  end subroutine gfnff_neigh

!ccccccccccccccccccccccccccccccccccccccccccccccccc
! fill neighbor list
!ccccccccccccccccccccccccccccccccccccccccccccccccc

  subroutine getnb(n,at,rad,r,mchar,icase,f,f2,nbf,nb,param)
    implicit none
    type(TGFFData),intent(in) :: param
    integer n,at(n),nbf(20,n),nb(20,n)
    real(wp) rad(n*(n+1)/2),r(n*(n+1)/2),mchar(n),f,f2

    integer i,j,k,nn,icase,hc_crit,nnfi,nnfj
    integer tag(n*(n+1)/2)
    real(wp) rco,fm

    nb = 0 ! resulting array (nbf is full from first call)
    tag = 0
    do i = 1,n
      nnfi = nbf(20,i)                  ! full CN of i, only valid for icase > 1
      do j = 1,i-1
        nnfj = nbf(20,j)               ! full CN of i
        fm = 1.0d0
!           full case
        if (icase .eq. 1) then
          if (param%metal(at(i)) .eq. 2) fm = fm*f2 !change radius for metal atoms
          if (param%metal(at(j)) .eq. 2) fm = fm*f2
          if (param%metal(at(i)) .eq. 1) fm = fm*(f2+0.025)
          if (param%metal(at(j)) .eq. 1) fm = fm*(f2+0.025)
        end if
!           no HC atoms
        if (icase .eq. 2) then
          hc_crit = 6
          if (param%group(at(i)) .le. 2) hc_crit = 4
          if (nnfi .gt. hc_crit) cycle
          hc_crit = 6
          if (param%group(at(j)) .le. 2) hc_crit = 4
          if (nnfj .gt. hc_crit) cycle
        end if
!           no metals and unusually coordinated stuff
        if (icase .eq. 3) then
          if (mchar(i) .gt. 0.25.or.param%metal(at(i)) .gt. 0) cycle   ! metal case TMonly ?? TODO
          if (mchar(j) .gt. 0.25.or.param%metal(at(j)) .gt. 0) cycle   ! metal case
          if (nnfi .gt. param%normcn(at(i)).and.at(i) .gt. 10) cycle   ! HC case
          if (nnfj .gt. param%normcn(at(j)).and.at(j) .gt. 10) cycle   ! HC case
        end if
        k = lin(j,i)
        rco = rad(k) !(rad(i)+rad(j))/0.5291670d0
!               R         est. R0
        if (r(k) .lt. fm*f*rco) tag(k) = 1
      end do
    end do

    do i = 1,n
      nn = 0
      do j = 1,n
        if (tag(lin(j,i)) .eq. 1.and.i .ne. j) then
          nn = nn+1
          nb(nn,i) = j
        end if
      end do
      nb(20,i) = nn
    end do

  end subroutine getnb

!ccccccccccccccccccccccccccccccccccccccccccccccccc
! find the CN of nearest non metal of atom i
!ccccccccccccccccccccccccccccccccccccccccccccccccc

  subroutine nn_nearest_noM(ii,n,at,nb,r,nn,param)
    implicit none
    type(TGFFData),intent(in) :: param
    integer ii,n,at(n),nn,nb(20,n)
    real(wp) r(n*(n+1)/2)

    integer jmin,j,jj
    real(wp) rmin

    nn = 0
    rmin = 1.d+42
    jmin = 0
    do j = 1,nb(20,ii)
      jj = nb(j,ii)
      if (param%metal(at(jj)) .ne. 0) cycle
      if (r(lin(jj,ii)) .lt. rmin) then
        rmin = r(lin(jj,ii))
        jmin = jj
      end if
    end do

    if (jmin .gt. 0) nn = nb(20,jmin)

  end subroutine nn_nearest_noM

!ccccccccccccccccccccccccccccccccccccccccccccccccc
! find smallest ring in which atom i is located
!ccccccccccccccccccccccccccccccccccccccccccccccccc

  subroutine ringsatom(n,i,c,s,rings)
    implicit none
    integer n,i,k,l,c(10,20,n),s(20,n),rings,rings1

    rings = 99
    do k = 1,s(20,i)    ! all rings of atom i
      if (s(k,i) .lt. rings) rings = s(k,i)
    end do

  end subroutine ringsatom

!ccccccccccccccccccccccccccccccccccccccccccccccccc
! find smallest ring in which bond i-j is located
!ccccccccccccccccccccccccccccccccccccccccccccccccc

  subroutine ringsbond(n,i,j,c,s,rings)
    implicit none
    integer,intent(in) :: n,i,j,c(10,20,n),s(20,n)
    integer,intent(out) :: rings
    integer :: k,l,rings1,rings2

    rings=0
    if(n==2) return
    rings1 = 99
    rings2 = 99
    do k = 1,s(20,i)    ! all rings of atom i
      do l = 1,s(k,i)  ! all atoms of ring k
        if (c(l,k,i) .eq. j.and.s(k,i) .lt. rings1) then
          rings1 = s(k,i)
        end if
      end do
    end do
    do k = 1,s(20,j)    ! all rings of atom i
      do l = 1,s(k,j)  ! all atoms of ring k
        if (c(l,k,j) .eq. i.and.s(k,j) .lt. rings2) then
          rings2 = s(k,j)
        end if
      end do
    end do
    continue
    rings = min(rings1,rings2)
    if (rings .eq. 99) rings = 0

  end subroutine ringsbond

!cccccccccccccccccccccccccccccccccccccccccccccccccccc
! find smallest ring in which angle i-j-k is located
!cccccccccccccccccccccccccccccccccccccccccccccccccccc

  subroutine ringsbend(n,i,j,k,c,s,rings)
    implicit none
    integer n,i,j,k,rings
    integer c(10,20,n),s(20,n)
    integer itest,rings1,rings2,rings3,m,l

    if (s(20,i) .eq. 0.or.s(20,j) .eq. 0.or.s(20,k) .eq. 0) then
      rings = 0
      return
    end if

    rings1 = 99
    rings2 = 99
    rings3 = 99

    do m = 1,s(20,i)    ! all rings of atom i
      itest = 0
      do l = 1,s(m,i)  ! all atoms of ring m
        if (c(l,m,i) .eq. j.or.c(l,m,i) .eq. k) itest = itest+1
      end do
      if (itest .eq. 2.and.s(m,i) .lt. rings1) rings1 = s(m,i)
    end do
    do m = 1,s(20,j)    ! all rings of atom j
      itest = 0
      do l = 1,s(m,j)  ! all atoms of ring m
        if (c(l,m,j) .eq. i.or.c(l,m,j) .eq. k) itest = itest+1
      end do
      if (itest .eq. 2.and.s(m,j) .lt. rings2) rings2 = s(m,j)
    end do
    do m = 1,s(20,k)    ! all rings of atom k
      itest = 0
      do l = 1,s(m,k)  ! all atoms of ring m
        if (c(l,m,k) .eq. i.or.c(l,m,k) .eq. j) itest = itest+1
      end do
      if (itest .eq. 2.and.s(m,j) .lt. rings3) rings3 = s(m,k)
    end do

    rings = min(rings1,rings2,rings3)
    if (rings .eq. 99) rings = 0

  end subroutine ringsbend

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! find smallest torsion in which angle i-j-k-l is located
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

  subroutine ringstors(n,i,j,k,l,c,s,rings)
    implicit none
    integer n,i,j,k,l,rings
    integer c(10,20,n),s(20,n)
    integer itest,rings1,rings2,rings3,rings4,m,a
!     integer ht1,ht2,ht3,ht4

    if (s(20,i) .eq. 0.or.s(20,j) .eq. 0.or.s(20,k) .eq. 0.or.s(20,l) .eq. 0) then
      rings = 0
      return
    end if

    rings1 = 99
    rings2 = 99
    rings3 = 99
    rings4 = 99

    do m = 1,s(20,i)    ! all rings of atom i
      itest = 0
      do a = 1,s(m,i)  ! all atoms of ring m
        if (c(a,m,i) .eq. j.or.c(a,m,i) .eq. k.or.c(a,m,i) .eq. l) itest = itest+1
      end do
      if (itest .eq. 3.and.s(m,i) .lt. rings1) then
        rings1 = s(m,i)
!           ht1=c(m,19,i)
      end if
    end do
    do m = 1,s(20,j)    ! all rings of atom j
      itest = 0
      do a = 1,s(m,j)  ! all atoms of ring m
        if (c(a,m,j) .eq. i.or.c(a,m,j) .eq. k.or.c(a,m,j) .eq. l) itest = itest+1
      end do
      if (itest .eq. 3.and.s(m,j) .lt. rings2) then
        rings2 = s(m,j)
!           ht2=c(m,19,j)
      end if
    end do
    do m = 1,s(20,k)    ! all rings of atom k
      itest = 0
      do a = 1,s(m,k)  ! all atoms of ring m
        if (c(a,m,k) .eq. i.or.c(a,m,k) .eq. j.or.c(a,m,k) .eq. l) itest = itest+1
      end do
      if (itest .eq. 3.and.s(m,k) .lt. rings3) then
        rings3 = s(m,k)
!           ht3=c(m,19,k)
      end if
    end do
    do m = 1,s(20,l)    ! all rings of atom k
      itest = 0
      do a = 1,s(m,l)  ! all atoms of ring m
        if (c(a,m,l) .eq. i.or.c(a,m,l) .eq. k.or.c(a,m,l) .eq. j) itest = itest+1
      end do
      if (itest .eq. 3.and.s(m,l) .lt. rings4) then
        rings4 = s(m,l)
!           ht4=c(m,19,l)
      end if
    end do

    rings = min(rings1,rings2,rings3,rings4)
    if (rings .eq. 99) then
      rings = 0
    end if

  end subroutine ringstors

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! find smallest torsion in which angle i-j-k-l is located
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

  subroutine ringstorl(n,i,j,k,l,c,s,ringl)
    implicit none
    integer n,i,j,k,l,ringl
    integer c(10,20,n),s(20,n)
    integer itest,rings1,rings2,rings3,rings4,m,a

    if (s(20,i) .eq. 0.or.s(20,j) .eq. 0.or.s(20,k) .eq. 0.or.s(20,l) .eq. 0) then
      ringl = 0
      return
    end if

    rings1 = -99
    rings2 = -99
    rings3 = -99
    rings4 = -99

    do m = 1,s(20,i)    ! all rings of atom i
      itest = 0
      do a = 1,s(m,i)  ! all atoms of ring m
        if (c(a,m,i) .eq. j.or.c(a,m,i) .eq. k.or.c(a,m,i) .eq. l) itest = itest+1
      end do
      if (itest .eq. 3.and.s(m,i) .gt. rings1) then
        rings1 = s(m,i)
      end if
    end do
    do m = 1,s(20,j)    ! all rings of atom j
      itest = 0
      do a = 1,s(m,j)  ! all atoms of ring m
        if (c(a,m,j) .eq. i.or.c(a,m,j) .eq. k.or.c(a,m,j) .eq. l) itest = itest+1
      end do
      if (itest .eq. 3.and.s(m,j) .gt. rings2) then
        rings2 = s(m,j)
      end if
    end do
    do m = 1,s(20,k)    ! all rings of atom k
      itest = 0
      do a = 1,s(m,k)  ! all atoms of ring m
        if (c(a,m,k) .eq. i.or.c(a,m,k) .eq. j.or.c(a,m,k) .eq. l) itest = itest+1
      end do
      if (itest .eq. 3.and.s(m,k) .gt. rings3) then
        rings3 = s(m,k)
      end if
    end do
    do m = 1,s(20,l)    ! all rings of atom k
      itest = 0
      do a = 1,s(m,l)  ! all atoms of ring m
        if (c(a,m,l) .eq. i.or.c(a,m,l) .eq. k.or.c(a,m,l) .eq. j) itest = itest+1
      end do
      if (itest .eq. 3.and.s(m,l) .gt. rings4) then
        rings4 = s(m,l)
      end if
    end do

    ringl = max(rings1,rings2,rings3,rings4)
    if (ringl .eq. -99) then
      ringl = 0
    end if

  end subroutine ringstorl

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

  logical function chktors(n,xyz,i,j,k,l)  ! true if dihedral angle is bad i.e. near 180
    implicit none
    integer n,i,j,k,l
    real(wp) xyz(3,n),phi

    chktors = .true.

    call bangl(xyz,j,i,k,phi)
!     write(stdout,*) phi*180./3.1415926d0
    if (phi*180./3.1415926d0 .gt. 170.0d0) return
    call bangl(xyz,i,j,l,phi)
!     write(stdout,*) phi*180./3.1415926d0
    if (phi*180./3.1415926d0 .gt. 170.0d0) return

    chktors = .false.

  end function chktors

!========================================================================================!

  subroutine gfnff_hbset(n,at,xyz,sqrab,topo,nlist,hbthr1,hbthr2)
    use gfnff_param
    implicit none
    type(TGFFTopology),intent(in) :: topo
    type(TGFFNeighbourList),intent(inout) :: nlist
    integer n
    integer at(n)
    real(wp) sqrab(n*(n+1)/2)
    real(wp) xyz(3,n)
    real(wp),intent(in) :: hbthr1,hbthr2

    integer i,j,k,nh,ia,ix,ij,inh,jnh
    real(wp) rab,rmsd
    logical ijnonbond

    rmsd = sqrt(sum((xyz-nlist%hbrefgeo)**2))/dble(n)

    if (rmsd .lt. 1.d-6.or.rmsd .gt. 0.3d0) then ! update list if first call or substantial move occured

      nlist%nhb1 = 0
      nlist%nhb2 = 0
      do ix = 1,topo%nathbAB
        i = topo%hbatABl(1,ix)
        j = topo%hbatABl(2,ix)
        ij = j+i*(i-1)/2
        rab = sqrab(ij)
        if (rab .gt. hbthr1) cycle
        ijnonbond = topo%bpair(ij) .ne. 1
        do k = 1,topo%nathbH
          nh = topo%hbatHl(k)
          inh = lin(i,nh)
          jnh = lin(j,nh)
          if (topo%bpair(inh) .eq. 1.and.ijnonbond) then ! exclude cases where A and B are bonded
            nlist%nhb2 = nlist%nhb2+1
            nlist%hblist2(1,nlist%nhb2) = i
            nlist%hblist2(2,nlist%nhb2) = j
            nlist%hblist2(3,nlist%nhb2) = nh
          elseif (topo%bpair(jnh) .eq. 1.and.ijnonbond) then ! exclude cases where A and B are bonded
            nlist%nhb2 = nlist%nhb2+1
            nlist%hblist2(1,nlist%nhb2) = j
            nlist%hblist2(2,nlist%nhb2) = i
            nlist%hblist2(3,nlist%nhb2) = nh
          elseif (rab+sqrab(inh)+sqrab(jnh) .lt. hbthr2) then
            nlist%nhb1 = nlist%nhb1+1
            nlist%hblist1(1,nlist%nhb1) = i
            nlist%hblist1(2,nlist%nhb1) = j
            nlist%hblist1(3,nlist%nhb1) = nh
          end if
        end do
      end do

      nlist%nxb = 0
      do ix = 1,topo%natxbAB
        i = topo%xbatABl(1,ix)
        j = topo%xbatABl(2,ix)
        ij = j+i*(i-1)/2
        rab = sqrab(ij)
        if (rab .gt. hbthr2) cycle
        nlist%nxb = nlist%nxb+1
        nlist%hblist3(1,nlist%nxb) = i
        nlist%hblist3(2,nlist%nxb) = j
        nlist%hblist3(3,nlist%nxb) = topo%xbatABl(3,ix)
      end do

      nlist%hbrefgeo = xyz

    end if  ! else do nothing

  end subroutine gfnff_hbset
!========================================================================================!

  subroutine bond_hbset(n,at,xyz,sqrab,bond_hbn,bond_hbl,topo,hbthr1,hbthr2)
    use gfnff_param
    implicit none
    type(TGFFTopology),intent(in) :: topo
    integer,intent(in) :: n
    integer,intent(in) :: at(n)
    integer,intent(in) :: bond_hbn
    integer,intent(out) :: bond_hbl(3,bond_hbn)
    real(wp),intent(in) :: sqrab(n*(n+1)/2)
    real(wp),intent(in) :: xyz(3,n)
    real(wp),intent(in) :: hbthr1,hbthr2

    integer i,j,k,nh,ia,ix,ij,inh,jnh
    integer bond_nr
    real(wp) rab
    logical ijnonbond

    bond_nr = 0
    bond_hbl = 0
    do ix = 1,topo%nathbAB
      i = topo%hbatABl(1,ix)
      j = topo%hbatABl(2,ix)
      ij = j+i*(i-1)/2
      rab = sqrab(ij)
      if (rab .gt. hbthr1) cycle
      ijnonbond = topo%bpair(ij) .ne. 1
      do k = 1,topo%nathbH
        nh = topo%hbatHl(k)
        inh = lin(i,nh)
        jnh = lin(j,nh)
        if (topo%bpair(inh) .eq. 1.and.ijnonbond) then ! exclude cases where A and B are bonded
          bond_nr = bond_nr+1
          bond_hbl(1,bond_nr) = i
          bond_hbl(2,bond_nr) = j
          bond_hbl(3,bond_nr) = nh
        elseif (topo%bpair(jnh) .eq. 1.and.ijnonbond) then ! exclude cases where A and B are bonded
          bond_nr = bond_nr+1
          bond_hbl(1,bond_nr) = j
          bond_hbl(2,bond_nr) = i
          bond_hbl(3,bond_nr) = nh
        end if
      end do
    end do

  end subroutine bond_hbset
!========================================================================================!

  subroutine bond_hbset0(n,at,xyz,sqrab,bond_hbn,topo,hbthr1,hbthr2)
    use gfnff_param
    implicit none
    type(TGFFTopology),intent(in) :: topo
    integer,intent(in) :: n
    integer,intent(in) :: at(n)
    integer,intent(out) :: bond_hbn
    real(wp),intent(in) :: sqrab(n*(n+1)/2)
    real(wp),intent(in) :: xyz(3,n)
    real(wp),intent(in) :: hbthr1,hbthr2

    integer i,j,k,nh,ia,ix,ij,inh,jnh
    real(wp) rab
    logical ijnonbond

    bond_hbn = 0
    do ix = 1,topo%nathbAB
      i = topo%hbatABl(1,ix)
      j = topo%hbatABl(2,ix)
      ij = j+i*(i-1)/2
      rab = sqrab(ij)
      if (rab .gt. hbthr1) cycle
      ijnonbond = topo%bpair(ij) .ne. 1
      do k = 1,topo%nathbH
        nh = topo%hbatHl(k)
        inh = lin(i,nh)
        jnh = lin(j,nh)
        if (topo%bpair(inh) .eq. 1.and.ijnonbond) then ! exclude cases where A and B are bonded
          bond_hbn = bond_hbn+1
        elseif (topo%bpair(jnh) .eq. 1.and.ijnonbond) then ! exclude cases where A and B are bonded
          bond_hbn = bond_hbn+1
        end if
      end do
    end do

  end subroutine bond_hbset0
!========================================================================================!

  subroutine bond_hb_AHB_set(n,at,numbond,bond_hbn,bond_hbl,tot_AHB_nr,lin_AHB,topo)
    use gfnff_param
    implicit none
    !Dummy
    type(TGFFTopology),intent(inout) :: topo
    integer,intent(in)  :: n
    integer,intent(in)  :: numbond
    integer,intent(in)  :: at(n)
    integer,intent(in)  :: bond_hbn
    integer,intent(in)  :: bond_hbl(3,bond_hbn)
    integer,intent(in)  :: tot_AHB_nr
    integer,intent(inout) :: lin_AHB(0:tot_AHB_nr)
    !Stack
    integer :: i,j
    integer :: ii,jj
    integer :: ia,ja
    integer :: hbH,hbA
    integer :: Hat,Aat
    integer :: Bat,atB
    integer :: tot_count
    integer :: AH_count
    integer :: B_count
    integer :: lin_diff

    tot_count = 0
    AH_count = 0
    B_count = 0
    lin_diff = 0

    do i = 1,numbond
      ii = topo%blist(1,i)
      jj = topo%blist(2,i)
      ia = at(ii)
      ja = at(jj)
      if (ia .eq. 1) then
        hbH = ii
        hbA = jj
      else if (ja .eq. 1) then
        hbH = jj
        hbA = ii
      else
        cycle
      end if
      if (at(hbA) .eq. 7.or.at(hbA) .eq. 8) then
        do j = 1,bond_hbn
          Bat = bond_hbl(2,j)
          atB = at(Bat)
          Aat = bond_hbl(1,j)
          Hat = bond_hbl(3,j)
          if (hbA .eq. Aat.and.hbH .eq. Hat) then
            if (atB .eq. 7.or.atB .eq. 8) then
              tot_count = tot_count+1
              lin_AHB(tot_count) = lin(hbA,hbH)
              lin_diff = lin_AHB(tot_count)-lin_AHB(tot_count-1)
              if (lin_diff .eq. 0) then
                B_count = B_count+1
              end if
              !Next AH pair
              if (lin_diff .ne. 0) then
                AH_count = AH_count+1
                topo%bond_hb_AH(1,AH_count) = hbA
                topo%bond_hb_AH(2,AH_count) = hbH
                !Reset B count
                B_count = 1
              end if
              topo%bond_hb_Bn(AH_count) = B_count
              topo%bond_hb_B(B_count,AH_count) = Bat
            end if
          else
            cycle
          end if
        end do
      end if
    end do

  end subroutine bond_hb_AHB_set
!========================================================================================!

  subroutine bond_hb_AHB_set1(n,at,numbond,bond_hbn,bond_hbl,tot_AHB_nr,lin_AHB,AH_count,bmax,topo)
    use gfnff_param
    implicit none
    !Dummy
    type(TGFFTopology),intent(inout) :: topo
    integer,intent(in)  :: n
    integer,intent(in)  :: numbond
    integer,intent(in)  :: at(n)
    integer,intent(in)  :: bond_hbn
    integer,intent(in)  :: bond_hbl(3,bond_hbn)
    integer,intent(in)  :: tot_AHB_nr
    integer,intent(inout) :: lin_AHB(0:tot_AHB_nr)
    integer,intent(out) :: AH_count
    integer,intent(out) :: bmax
    !Stack
    integer :: i,j
    integer :: ii,jj
    integer :: ia,ja
    integer :: hbH,hbA
    integer :: Hat,Aat
    integer :: Bat,atB
    integer :: tot_count
    integer :: B_count
    integer :: lin_diff

    tot_count = 0
    AH_count = 0
    B_count = 1
    bmax = 1
    lin_diff = 0

    do i = 1,numbond
      ii = topo%blist(1,i)
      jj = topo%blist(2,i)
      ia = at(ii)
      ja = at(jj)
      if (ia .eq. 1) then
        hbH = ii
        hbA = jj
      else if (ja .eq. 1) then
        hbH = jj
        hbA = ii
      else
        cycle
      end if
      if (at(hbA) .eq. 7.or.at(hbA) .eq. 8) then
        do j = 1,bond_hbn
          Bat = bond_hbl(2,j)
          atB = at(Bat)
          Aat = bond_hbl(1,j)
          Hat = bond_hbl(3,j)
          if (hbA .eq. Aat.and.hbH .eq. Hat) then
            if (atB .eq. 7.or.atB .eq. 8) then
              tot_count = tot_count+1
              lin_AHB(tot_count) = lin(hbA,hbH)
              lin_diff = lin_AHB(tot_count)-lin_AHB(tot_count-1)
              if (lin_diff .eq. 0) B_count = B_count+1
              if (lin_diff .ne. 0) then
                AH_count = AH_count+1
                B_count = 1
              end if
              if (B_count .gt. bmax) bmax = B_count
            end if
          else
            cycle
          end if
        end do
        topo%nr_hb(i) = B_count
      end if
    end do

  end subroutine bond_hb_AHB_set1
!========================================================================================!

  subroutine bond_hb_AHB_set0(n,at,numbond,bond_hbn,bond_hbl,tot_AHB_nr,topo)
    use gfnff_param
    implicit none
    !Dummy
    type(TGFFTopology),intent(in) :: topo
    integer,intent(in)  :: n
    integer,intent(in)  :: numbond
    integer,intent(in)  :: at(n)
    integer,intent(in)  :: bond_hbn
    integer,intent(in)  :: bond_hbl(3,bond_hbn)
    integer,intent(out) :: tot_AHB_nr
    !Stack
    integer :: i,j
    integer :: ii,jj
    integer :: ia,ja
    integer :: hbH,hbA
    integer :: Hat,Aat
    integer :: Bat,atB

    tot_AHB_nr = 0

    do i = 1,numbond
      ii = topo%blist(1,i)
      jj = topo%blist(2,i)
      ia = at(ii)
      ja = at(jj)
      if (ia .eq. 1) then
        hbH = ii
        hbA = jj
      else if (ja .eq. 1) then
        hbH = jj
        hbA = ii
      else
        cycle
      end if
      if (at(hbA) .eq. 7.or.at(hbA) .eq. 8) then
        do j = 1,bond_hbn
          Bat = bond_hbl(2,j)
          atB = at(Bat)
          Aat = bond_hbl(1,j)
          Hat = bond_hbl(3,j)
          if (hbA .eq. Aat.and.hbH .eq. Hat) then
            if (atB .eq. 7.or.atB .eq. 8) then
              tot_AHB_nr = tot_AHB_nr+1
            end if
          else
            cycle
          end if
        end do
      end if
    end do

  end subroutine bond_hb_AHB_set0
!========================================================================================!

  subroutine gfnff_hbset0(n,at,xyz,sqrab,topo,nhb1,nhb2,nxb,hbthr1,hbthr2)
    use gfnff_param
    implicit none
    type(TGFFTopology),intent(in) :: topo
    integer,intent(out) :: nhb1
    integer,intent(out) :: nhb2
    integer,intent(out) :: nxb
    integer n
    integer at(n)
    real(wp) sqrab(n*(n+1)/2)
    real(wp) xyz(3,n)
    real(wp),intent(in) :: hbthr1,hbthr2

    integer i,j,k,nh,ia,ix,ij,inh,jnh
    logical ijnonbond
    real(wp) rab

    nhb1 = 0
    nhb2 = 0
    do ix = 1,topo%nathbAB
      i = topo%hbatABl(1,ix)
      j = topo%hbatABl(2,ix)
      ij = j+i*(i-1)/2
      rab = sqrab(ij)
      if (rab .gt. hbthr1) cycle
      ijnonbond = topo%bpair(ij) .ne. 1
      do k = 1,topo%nathbH
        nh = topo%hbatHl(k)
        inh = lin(i,nh)
        jnh = lin(j,nh)
        if (topo%bpair(inh) .eq. 1.and.ijnonbond) then
          nhb2 = nhb2+1
        elseif (topo%bpair(jnh) .eq. 1.and.ijnonbond) then
          nhb2 = nhb2+1
        elseif (rab+sqrab(inh)+sqrab(jnh) .lt. hbthr2) then
          nhb1 = nhb1+1
        end if
      end do
    end do

    nxb = 0
    do ix = 1,topo%natxbAB
      i = topo%xbatABl(1,ix)
      j = topo%xbatABl(2,ix)
      ij = j+i*(i-1)/2
      rab = sqrab(ij)
      if (rab .gt. hbthr2) cycle
      nxb = nxb+1
    end do

  end subroutine gfnff_hbset0
!========================================================================================!

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! HB strength
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

  subroutine hbonds(i,j,ci,cj,param,topo)
    use gfnff_param
    implicit none
    type(TGFFTopology),intent(in) :: topo
    type(TGFFData),intent(in) :: param
    integer i,j
    integer ati,atj
    real(wp) ci(2),cj(2)
    ci(1) = topo%hbbas(i)
    cj(1) = topo%hbbas(j)
    ci(2) = topo%hbaci(i)
    cj(2) = topo%hbaci(j)
  end subroutine hbonds
!========================================================================================!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! neighbor only version of EEQ model
! included up to 1,4 interactions
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  subroutine goedeckera(n,at,nb,pair,q,es,topo,io)
    !use xtb_mctc_lapack,only:mctc_sytrf,mctc_sytrs
    use gfnff_math_wrapper, only: sytrf_wrap, sytrs_wrap
    implicit none
    character(len=*),parameter :: source = 'gfnff_ini2_goedeckera'
    !type(TEnvironment),intent(inout) :: env
    type(TGFFTopology),intent(in) :: topo
    integer,intent(in)  :: n          ! number of atoms
    integer,intent(in)  :: at(n)      ! ordinal numbers
    integer,intent(in)  :: nb(20,n)   ! neighbors
    real(wp),intent(in)  :: pair(n*(n+1)/2)
    real(wp),intent(out) :: q(n)       ! output charges
    real(wp),intent(out) :: es         ! ES energy
    integer,intent(out) :: io

!  local variables
    logical :: exitRun
    integer  :: m,i,j,k,l,ii,jj,kk
    integer  :: ij,lj
    integer,allocatable :: ipiv(:)

    integer :: info1, info2
    real(wp) :: gammij,sief1,sief2
    real(wp) :: r2,r0
    real(wp) :: rij
    real(wp) :: tsqrt2pi,bohr
    real(wp) :: tmp
    real(wp),allocatable :: A(:,:)
    real(wp),allocatable :: x(:)

!  parameter
    parameter(tsqrt2pi=0.797884560802866_wp)

    io = 0

    m = n+topo%nfrag ! # atoms frag constrain
    allocate (A(m,m),x(m),ipiv(m))

!  call prmati(6,pair,n,0,'pair')

    A = 0

!  setup RHS
    do i = 1,n
      x(i) = topo%chieeq(i) ! EN of atom
      A(i,i) = topo%gameeq(i)+tsqrt2pi/sqrt(topo%alpeeq(i))
    end do

!  setup A matrix
    do i = 1,n
      do j = 1,i-1
        ij = i*(i-1)/2+j
        rij = pair(ij)
        r2 = rij*rij
        gammij = 1.d0/sqrt(topo%alpeeq(i)+topo%alpeeq(j)) ! squared above
        tmp = erf(gammij*rij)/rij
        A(j,i) = tmp
        A(i,j) = tmp
      end do
    end do

!  fragment charge constrain
    do i = 1,topo%nfrag
      x(n+i) = topo%qfrag(i)
      do j = 1,n
        if (topo%fraglist(j) .eq. i) then
          A(n+i,j) = 1
          A(j,n+i) = 1
        end if
      end do
    end do
!  call prmat(6,A,m,m,'A ini')

    !call mctc_sytrf(env,a,ipiv)
    call sytrf_wrap(a,ipiv,info1)
    !call mctc_sytrs(env,a,x,ipiv)
    call sytrs_wrap( a, x, ipiv, info2)
    
    exitRun = (info1 /= 0) .or. (info2 /= 0)
    !call env%check(exitRun)
    if (exitRun) then
      !call env%error('Solving linear equations failed',source)
      write(stdout,'("Solving linear equations failed ",a)')source
      io = 1
      return
    end if

    q(1:n) = x(1:n)

    if (n .eq. 1) q(1) = topo%qfrag(1)

!  energy
    es = 0.0_wp
    do i = 1,n
      ii = i*(i-1)/2
      do j = 1,i-1
        ij = ii+j
        rij = pair(ij)
        gammij = 1.d0/sqrt(topo%alpeeq(i)+topo%alpeeq(j)) ! squared above
        tmp = erf(gammij*rij)/rij
        es = es+q(i)*q(j)*tmp/rij
      end do
      es = es-q(i)*topo%chieeq(i) &
     &        +q(i)*q(i)*0.5d0*(topo%gameeq(i)+tsqrt2pi/sqrt(topo%alpeeq(i)))
    end do

  end subroutine goedeckera
!========================================================================================!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! condense charges to heavy atoms based on topology
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  subroutine qheavy(n,at,nb,q)
    implicit none
    integer,intent(in)   ::  n,nb(20,n),at(n)
    real(wp),intent(inout) ::  q(n)

    integer i,j,k
    real(wp) qtmp(n)

    qtmp = q
    do i = 1,n
      if (at(i) .ne. 1) cycle
      qtmp(i) = 0
      do j = 1,nb(20,i)
        k = nb(j,i)
        qtmp(k) = qtmp(k)+q(i)/dble(nb(20,i))  ! could be a bridging H
      end do
    end do

    q = qtmp

  end subroutine qheavy
!========================================================================================!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! determine number of cov. bonds between atoms
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  subroutine nbondmat(n,nb,pair)
    implicit none
!     Dummy
    integer,intent(in)  :: n
    integer,intent(in)  :: nb(20,n)
    integer,intent(out) ::  pair(n*(n+1)/2)
!     Stack
    integer i,ni,newi,j,newatom,tag,d,i1,ni1,iii,ii,jj,k
    integer,allocatable :: list(:,:),nlist(:,:),nnn(:),nn(:)
    logical da

    allocate (nnn(n),nn(n),list(5*n,n),nlist(5*n,n))

    nn(1:n) = nb(20,1:n)

    pair = 0
    list = 0
    do i = 1,n
      ni = nn(i)
      list(1:ni,i) = nb(1:ni,i)
    end do

    nlist = list

    pair = 0
    do i = 1,n
      do j = 1,nb(20,i)
        k = nb(j,i)
        pair(lin(k,i)) = 1
      end do
    end do

!     one bond, tag=1
    tag = 1
!     call pairsbond(n,nn,list,pair,tag)

!     determine up to 3 bonds in between
    do d = 1,2

!     loop over atoms
      do i = 1,n
        ni = nn(i)
        newi = ni
!        all neighbors of i
        do ii = 1,ni
          i1 = list(ii,i)
          ni1 = nb(20,i1)
!           all neighbors of neighbors of i
          do iii = 1,ni1
            newatom = nb(iii,i1)
            da = .false.
            do j = 1,newi
              if (newatom .eq. list(j,i)) da = .true.
            end do
            if (.not.da) then
              newi = newi+1
              nlist(newi,i) = newatom
            end if
          end do
        end do
        nnn(i) = newi
      end do

      list = nlist
      nn = nnn

!     one bond more
      tag = tag+1
      call pairsbond(n,nn,list,pair,tag)

    end do
    do i = 1,n
      do j = 1,i
        if (i .ne. j.and.pair(lin(j,i)) .eq. 0) pair(lin(j,i)) = 5
      end do
    end do

  end subroutine nbondmat
!========================================================================================!

  subroutine pairsbond(n,nn,list,pair,tag)
    implicit none
    integer n,nn(n),list(5*n,n),tag
    integer i,j,k,ni,nj,ii,jj,ij
    integer pair(n*(n+1)/2)
    logical dai,daj

    do i = 1,n
      ni = nn(i)
      ij = i*(i-1)/2
      do j = 1,i-1
        k = ij+j
        nj = nn(j)
        dai = .false.
        daj = .false.
        do ii = 1,ni
          if (list(ii,i) .eq. j) daj = .true.
        end do
        do jj = 1,nj
          if (list(jj,j) .eq. i) dai = .true.
        end do
        if (dai.and.daj.and.pair(k) .eq. 0) then
          pair(k) = tag
        end if
      end do
    end do

  end subroutine pairsbond
!========================================================================================!

  logical function pilist(ati)
    integer ati
    pilist = .false.
!     if(ati.eq.5.or.ati.eq.6.or.ati.eq.7.or.ati.eq.8.or.ati.eq.9.or.ati.eq.16) pilist=.true.
    if (ati .eq. 5.or.ati .eq. 6.or.ati .eq. 7.or.ati .eq. 8.or.ati .eq. 9.or.ati .eq. 16.or.ati .eq. 17) pilist = .true.
  end function pilist

  logical function nofs(ati)
    integer ati
    nofs = .false.
!     if(ati.eq.7.or.ati.eq.8.or.ati.eq.9.or.ati.eq.16) nofs=.true.
    if (ati .eq. 7.or.ati .eq. 8.or.ati .eq. 9.or.ati .eq. 16.or.ati .eq. 17) nofs = .true.
  end function nofs

  logical function xatom(ati)
    integer ati
    xatom = .false.
    if (ati .eq. 17.or.ati .eq. 35.or.ati .eq. 53.or.&  ! X in A-X...B
   &   ati .eq. 16.or.ati .eq. 34.or.ati .eq. 52.or.&
   &   ati .eq. 15.or.ati .eq. 33.or.ati .eq. 51) xatom = .true.
  end function xatom
!========================================================================================!

  integer function ctype(n,at,nb,pi,a)
    integer n,a,at(n),nb(20,n),pi(n)
    integer i,no,j

    ctype = 0 ! don't know

    no = 0
    do i = 1,nb(20,a)
      j = nb(i,a)
      if (at(j) .eq. 8.and.pi(j) .ne. 0) no = no+1
    end do

    if (no .eq. 1.and.pi(a) .ne. 0) ctype = 1 ! a C=O carbon

  end function ctype
!========================================================================================!

  logical function alphaCO(n,at,hyb,nb,pi,a,b)
    integer n,a,b,at(n),hyb(n),nb(20,n),pi(n)
    integer i,j,no,nc

    alphaCO = .false.
    if (pi(a) .ne. 0.and.hyb(b) .eq. 3.and.at(a) .eq. 6.and.at(b) .eq. 6) then
      no = 0
      do i = 1,nb(20,a)
        j = nb(i,a)
        if (at(j) .eq. 8.and.pi(j) .ne. 0.and.nb(20,j) .eq. 1) no = no+1 ! a pi =O on the C?
      end do
      if (no .eq. 1) then
        alphaCO = .true.
        return
      end if
    end if
    if (pi(b) .ne. 0.and.hyb(a) .eq. 3.and.at(b) .eq. 6.and.at(a) .eq. 6) then
      no = 0
      do i = 1,nb(20,b)
        j = nb(i,b)
        if (at(j) .eq. 8.and.pi(j) .ne. 0.and.nb(20,j) .eq. 1) no = no+1 ! a pi =O on the C?
      end do
      if (no .eq. 1) then
        alphaCO = .true.
        return
      end if
    end if

  end function alphaCO
!========================================================================================!

  logical function amide(n,at,hyb,nb,pi,a)
    integer n,a,at(n),hyb(n),nb(20,n),pi(n)
    integer i,j,no,nc,ic

    amide = .false. ! don't know
    if (pi(a) .eq. 0.or.hyb(a) .ne. 3.or.at(a) .ne. 7) return

    nc = 0
    no = 0
    do i = 1,nb(20,a)
      j = nb(i,a)
      if (at(j) .eq. 6.and.pi(j) .ne. 0) then  ! a pi C on N?
        nc = nc+1
        ic = j
      end if
    end do

    if (nc .eq. 1) then
      do i = 1,nb(20,ic)
        j = nb(i,ic)
        if (at(j) .eq. 8.and.pi(j) .ne. 0.and.nb(20,j) .eq. 1) no = no+1 ! a pi =O on the C?
!           if(at(j).eq.16.and.pi(j).ne.0.and.nb(20,j).eq.1) no = no +1 ! a pi =S on the C?
      end do
    end if

    if (no .eq. 1) amide = .true.

  end function amide
!========================================================================================!

  logical function amideH(n,at,hyb,nb,pi,a)
    integer n,a,at(n),hyb(n),nb(20,n),pi(n)
    integer i,j,nc,nn
    !logical amide

    amideH = .false. ! don't know
    if (nb(20,a) .ne. 1) return
    nn = nb(1,a)       ! the N
    if (.not.amide(n,at,hyb,nb,pi,nn)) return

    nc = 0
    do i = 1,nb(20,nn)
      j = nb(i,nn)
      if (at(j) .eq. 6.and.hyb(j) .eq. 3) then  ! a sp3 C on N?
        nc = nc+1
      end if
    end do

    if (nc .eq. 1) amideH = .true.

  end function amideH

!========================================================================================!
end module gfnff_ini2

!================================================================================!
! This file is part of gfnff.
!
! Copyright (C) 2023 Philipp Pracht
!
! gfnff is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfnff is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfnff. If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------!
!> The original (unmodified) source code can be found under the GNU LGPL 3.0 license
!> Copyright (C) 2019-2020 Sebastian Ehlert, Sebastian Spicher, Stefan Grimme
!> at https://github.com/grimme-lab/xtb
!================================================================================!
module gfnff_restart
  use iso_fortran_env,only:wp => real64,stdout => output_unit
  use gfnff_data_types
  use gfnff_param
  implicit none
  private
  public :: write_restart_gff,read_restart_gff

  integer,parameter :: i8 = selected_int_kind(18)

!========================================================================================!
!========================================================================================!
contains  !> MODULE PROCEDURES START HERE
!========================================================================================!
!========================================================================================!

  subroutine write_restart_gff(fname,nat,version,topo)
    implicit none
    type(TGFFTopology),intent(in) :: topo
    character(len=*),intent(in) :: fname
    integer,intent(in)  :: nat
    integer,intent(in)  :: version
    integer :: ich ! file handle
    integer :: err

    open (file=fname,newunit=ich,action='write',form='unformatted',iostat=err)

!>--- Dimensions
    write (ich) int(version,i8),int(nat,i8)
    write (ich) topo%nbond,topo%nangl,topo%ntors,   &
             &  topo%nathbH,topo%nathbAB,topo%natxbAB,topo%nbatm, &
             &  topo%nfrag,topo%nsystem,topo%maxsystem
    write (ich) topo%nbond_blist,topo%nbond_vbond,topo%nangl_alloc, &
             &  topo%ntors_alloc,topo%bond_hb_nr,topo%b_max
!>--- Arrays Integers
    write (ich) topo%nb,topo%bpair,topo%blist,topo%alist, &
             &  topo%tlist,topo%b3list,topo%fraglist,topo%hbatHl,topo%hbatABl, &
             &  topo%xbatABl,topo%ispinsyst,topo%nspinsyst,topo%bond_hb_AH, &
             &  topo%bond_hb_B,topo%bond_hb_Bn,topo%nr_hb
!>--- Arrays Reals
    write (ich) topo%vbond,topo%vangl,topo%vtors,topo%chieeq, &
             &  topo%gameeq,topo%alpeeq,topo%alphanb,topo%qa,  &
             &  topo%xyze0,topo%zetac6, &
             &  topo%qfrag,topo%hbbas,topo%hbaci
    close (ich)
  end subroutine write_restart_gff
!========================================================================================!

  subroutine read_restart_gff(fname,n,version,success,verbose,topo)
    implicit none
    character(len=*),parameter :: source = 'restart_read_restart_gff'
    type(TGFFTopology),intent(inout) :: topo
    character(len=*),intent(in) :: fname
    integer,intent(in)  :: n
    integer,intent(in)  :: version
    logical,intent(out) :: success
    logical,intent(in)  :: verbose

    integer(i8) :: iver8,nat8

    integer :: ich ! file handle
    integer :: err
    logical :: exist

    success = .false.
    open (file=fname,newunit=ich,status='old',action='read', &
         & form='unformatted',iostat=err)
    if (ich .ne. -1) then
!>--- read the first byte, which identify the calculation specs
      read (ich,iostat=err) iver8,nat8
      if (err .eq. 0) then
        if (iver8 .ne. int(version,i8).and.verbose) &
           &  write (stdout,'("Version number missmatch in restart file.",a)') source
        if (nat8 .ne. n.and.verbose) then
          write (stdout,'("Atom number missmatch in restart file.",a)') source
          success = .false.
          close (ich)
          return
        else if (iver8 .eq. int(version)) then
          success = .true.
          read (ich) topo%nbond,topo%nangl,topo%ntors, &
                  &  topo%nathbH,topo%nathbAB,topo%natxbAB,topo%nbatm, &
                  &  topo%nfrag,topo%nsystem,topo%maxsystem
          read (ich) topo%nbond_blist,topo%nbond_vbond,topo%nangl_alloc, &
                  &  topo%ntors_alloc,topo%bond_hb_nr,topo%b_max
!>--- allocate some memory now
          call gfnff_param_alloc(topo,n)
          if (.not.allocated(topo%ispinsyst)) allocate (topo%ispinsyst(n,topo%maxsystem),source=0)
          if (.not.allocated(topo%nspinsyst)) allocate (topo%nspinsyst(topo%maxsystem),source=0)
          read (ich) topo%nb,topo%bpair,topo%blist,topo%alist, &
             & topo%tlist,topo%b3list,topo%fraglist,topo%hbatHl,topo%hbatABl, &
             & topo%xbatABl,topo%ispinsyst,topo%nspinsyst,topo%bond_hb_AH, &
             & topo%bond_hb_B,topo%bond_hb_Bn,topo%nr_hb
          read (ich) topo%vbond,topo%vangl,topo%vtors,topo%chieeq, &
             & topo%gameeq,topo%alpeeq,topo%alphanb,topo%qa, &
             & topo%xyze0,topo%zetac6,&
             & topo%qfrag,topo%hbbas,topo%hbaci
        else
          if (verbose) &
            write (stdout,'("Dimension missmatch in restart file.",a)') source
          success = .false.
        end if
      else
        if (verbose) &
          write (stdout,'("Dimension missmatch in restart file.",a)') source
        success = .false.
      end if
      close (ich)
    end if

  end subroutine read_restart_gff

!========================================================================================!
end module gfnff_restart

!================================================================================!
! This file is part of gfnff.
!
! Copyright (C) 2023 Philipp Pracht
!
! gfnff is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfnff is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfnff. If not, see <https://www.gnu.org/licenses/>.
!================================================================================!
module gfnff_interface
  use iso_fortran_env,only:wp => real64,stdout => output_unit
  use gfnff_data_types
  use gfnff_engrad_module
  use gfnff_gbsa
  use gfnff_param
  implicit none
  private

!> routines/datatypes that can be seen outside the module
  public :: gfnff_data,my_gfnff_data
  public :: gfnff_initialize
  public :: gfnff_singlepoint
  public :: print_gfnff_results
  public :: gfnff_get_fake_wbo

!> this type bundles together most of the
!> data required for a GFN-FF calculation
  type :: gfnff_data
    integer  :: ichrg = 0  !> total molecular charge
    real(wp) :: accuracy = 0.1_wp
    logical  :: make_chrg = .true.
    integer  :: version = gffVersion%angewChem2020_2
    logical  :: update = .true.
    logical  :: write_topo = .true.
    character(len=:),allocatable :: parametrisation
    character(len=:),allocatable :: solvent
    logical :: restart = .false.
    character(len=:),allocatable :: restartfile
    character(len=:),allocatable :: refgeo
    character(len=:),allocatable :: refcharges

    type(TGFFGenerator),allocatable     :: gen
    type(TGFFData),allocatable          :: param
    type(TGFFTopology),allocatable      :: topo
    type(TGFFNeighbourList),allocatable :: nlist
    type(TBorn),allocatable             :: solvation
    type(gfnff_results),allocatable     :: res
  contains
    procedure :: deallocate => gfnff_data_deallocate
    procedure :: type_reset => gfnff_data_reset_types
    procedure :: type_init => gfnff_data_make_types
    procedure :: singlepoint => gfnff_singlepoint_wrapper
    procedure :: init => gfnff_initialize_wrapper
    procedure :: resultprint => gfnff_print_results_wrapper
  end type gfnff_data

!> This is a semi-global placeholder for a single gfnff_data object.
!> It may be used as storage for running GFN-FF calculations,
!> but ONLY if there is ever a single instance running at the same time!
!> i.e., no parallelization shenanigans !!!
  type(gfnff_data),allocatable :: my_gfnff_data

!========================================================================================!
!========================================================================================!
contains  !> MODULE PROCEDURES START HERE
!========================================================================================!
!========================================================================================!

  subroutine gfnff_singlepoint(nat,at,xyz,dat,energy,gradient,verbose,iostat)
    implicit none
    !> INPUT
    integer,intent(in)  :: nat        !> number of atoms
    integer,intent(in)  :: at(nat)    !> atom types
    real(wp),intent(in) :: xyz(3,nat) !> Cartesian coordinates in Bohr
    logical,intent(in),optional    :: verbose  !> printout activation 
    type(gfnff_data),intent(inout) :: dat  !> collection of gfnff datatypes and settings
    !> OUTPUT
    real(wp),intent(out) :: energy
    real(wp),intent(out) :: gradient(3,nat)
    integer,intent(out),optional  :: iostat
    !> LOCAL
    integer :: io
    logical :: pr

    !> printout activation via verbosity
    if(present(verbose))then
      pr = verbose
    else
      pr =.false. !> (there is close to no printout anyways)
    endif

    energy = 0.0_wp
    gradient(:,:) = 0.0_wp
    io = 0

    call gfnff_eg(pr,nat,dat%ichrg,at,xyz,dat%make_chrg,gradient,energy,   &
    &             dat%res,dat%param,dat%topo,dat%nlist,dat%solvation, &
    &             dat%update,dat%version,dat%accuracy,io)

    if (present(iostat)) then
      iostat = io
    end if

  end subroutine gfnff_singlepoint

  subroutine gfnff_singlepoint_wrapper(self,nat,at,xyz,energy,gradient,verbose,iostat)
!******************************************************************
!* A wrapper to the singlepoint routine, allowing
!* the energy routine to be called with "call dat%singlepoint(...)"
!******************************************************************
    implicit none
    !> INPUT
    class(gfnff_data) :: self 
    integer,intent(in)  :: nat        !> number of atoms
    integer,intent(in)  :: at(nat)    !> atom types
    real(wp),intent(in) :: xyz(3,nat) !> Cartesian coordinates in Bohr
    logical,intent(in),optional    :: verbose  !> printout activation 
    !> OUTPUT
    real(wp),intent(out) :: energy
    real(wp),intent(out) :: gradient(3,nat)
    integer,intent(out),optional  :: iostat
    call gfnff_singlepoint(nat,at,xyz,self,energy,gradient,verbose=verbose,iostat=iostat)
  end subroutine gfnff_singlepoint_wrapper

!========================================================================================!

  subroutine print_gfnff_results(iunit,res_gff,lsolv)
    integer,intent(in) :: iunit ! file handle (usually output_unit=6)
    type(gfnff_results),intent(in) :: res_gff
    logical,intent(in) :: lsolv
    character(len=*),parameter :: outfmt = &
                                  '(2x,a,f23.12,1x,a)'
    write (iunit,outfmt) "total energy      ",res_gff%e_total,"Eh   "
    write (iunit,outfmt) "gradient norm     ",res_gff%gnorm,"Eh/a0"
    write (iunit,'(a)') repeat('-',50)
    write (iunit,outfmt) "bond energy       ",res_gff%e_bond,"Eh   "
    write (iunit,outfmt) "angle energy      ",res_gff%e_angl,"Eh   "
    write (iunit,outfmt) "torsion energy    ",res_gff%e_tors,"Eh   "
    write (iunit,outfmt) "repulsion energy  ",res_gff%e_rep,"Eh   "
    write (iunit,outfmt) "electrostat energy",res_gff%e_es,"Eh   "
    write (iunit,outfmt) "dispersion energy ",res_gff%e_disp,"Eh   "
    write (iunit,outfmt) "HB energy         ",res_gff%e_hb,"Eh   "
    write (iunit,outfmt) "XB energy         ",res_gff%e_xb,"Eh   "
    write (iunit,outfmt) "bonded atm energy ",res_gff%e_batm,"Eh   "
    write (iunit,outfmt) "external energy   ",res_gff%e_ext,"Eh   "
    if (lsolv) then
      write (iunit,'(2x,a)') repeat('-',44)
      write (iunit,outfmt) "-> Gsolv          ",res_gff%g_solv,"Eh   "
      write (iunit,outfmt) "   -> Gborn       ",res_gff%g_born,"Eh   "
      write (iunit,outfmt) "   -> Gsasa       ",res_gff%g_sasa,"Eh   "
      write (iunit,outfmt) "   -> Ghb         ",res_gff%g_hb,"Eh   "
      write (iunit,outfmt) "   -> Gshift      ",res_gff%g_shift,"Eh   "
    end if
    write (iunit,'(a)') repeat('-',50)
  end subroutine print_gfnff_results

  subroutine gfnff_print_results_wrapper(self,iunit)
    implicit none
    class(gfnff_data) :: self
    !> INPUT
    integer,intent(in),optional :: iunit
    !> LOCAL
    integer :: myunit 

    if(present(iunit))then
       myunit = iunit
    else
       myunit = stdout
    endif
    if(allocated(self%res))then
    call print_gfnff_results(myunit,self%res,allocated(self%solvation))
    endif
  end subroutine gfnff_print_results_wrapper
!========================================================================================!

  subroutine gfnff_initialize(nat,at,xyz,dat, &
  &                 print,verbose,iunit,version,iostat,ichrg)
    use gfnff_param
    use gfnff_setup_mod,only:gfnff_setup
    use gfnff_gdisp0,only:newD3Model
    use gfnff_gbsa
    character(len=*),parameter :: source = 'gfnff_initialize'
    !> INPUT
    integer,intent(in) :: nat
    integer,intent(in) :: at(nat)
    real(wp),intent(in) :: xyz(3,nat)
    logical,intent(in),optional  :: print
    logical,intent(in),optional  :: verbose
    integer,intent(in),optional  :: iunit
    integer,intent(in),optional  :: version
    integer,intent(out),optional :: iostat
    integer,intent(in),optional  :: ichrg 
    !> OUTPUT
    type(gfnff_data),intent(inout) :: dat
    !> LOCAL
    character(len=:),allocatable :: fname
    integer :: ich,io,myunit
    logical :: ex,okbas,pr,pr2
    logical :: exitRun
    logical :: restart

!> mapping of optional instuctions
    if(present(print))then
      pr = print
    else
      pr = .false.
    endif
    if(present(verbose))then
      pr2 = verbose
    else
      pr2 = .false.
    endif
    if(pr2) pr = pr2    
    if(present(iunit))then
      myunit = iunit
    else
      myunit = stdout
    endif

!> Reset datatypes
    call dat%type_init()
    if(present(ichrg))then
      dat%ichrg = ichrg
    endif
!> except restart-related options
    restart = dat%restart
    if(.not.allocated(dat%restartfile))then
      dat%topo%filename = 'gfnff_topo'
    else
      dat%topo%filename = dat%restartfile
    endif
    if(allocated(dat%refgeo)) restart = .false.
    if(allocated(dat%refcharges))then
      dat%topo%refcharges = dat%refcharges
    endif

!> Parametrisation version
    if (present(version)) then
      dat%version = version
    else
      dat%version = gffVersion%angewChem2020_2
    end if

    call dat%topo%zero
    dat%update = .true.
!> global accuracy factor similar to acc in xtb used in SCF
    dat%accuracy = 0.1_wp
    if (nat > 10000) then
      dat%accuracy = 2.0_wp
    end if

!> Obtain the parameter file or load internal
    if(allocated(dat%parametrisation))then
      fname=dat%parametrisation
    else
      fname='no file!'
    endif
    inquire (file=fname,exist=ex)
    if (ex) then
      open (newunit=ich,file=fname)
      call gfnff_read_param(ich,dat%param)
      close (ich)
    else !> no parameter file, try to load internal version
      call gfnff_load_param(dat%version,dat%param,ex)
      if (.not.ex.and.pr) then
        write (myunit,'("Parameter file ",a," not found!",a)') fname,source
        return
      end if
    end if

    call newD3Model(dat%topo%dispm,nat,at)

    call gfnff_setup(nat,at,xyz,dat%ichrg,pr,restart,dat%write_topo, &
    &        dat%gen,dat%param,dat%topo,dat%accuracy,dat%version,io, &
    &        verbose=verbose, iunit=myunit)

    !> Optional, ALPB solvation
    if (allocated(dat%solvent)) then
      if (.not. (allocated(dat%solvation))) allocate (dat%solvation)
      call gfnff_gbsa_init(nat,at,dat%solvent,dat%solvation)
      if (pr)then
        write(myunit,*)
        call gfnff_gbsa_print(dat%solvation,myunit)
      endif
    end if

    if ((io /= 0).and.pr) then
      write (myunit,'("Could not create force field calculator ",a)') source
    end if
    if (present(iostat)) then
      iostat = io
    end if
  end subroutine gfnff_initialize

  subroutine gfnff_initialize_wrapper(self,nat,at,xyz, &
     &                 print,verbose,iunit,version,iostat,ichrg,solvent)
!******************************************************************
!* A wrapper to the initialize routine, allowing
!* the energy routine to be called with "call dat%init(...)"
!******************************************************************
    implicit none
    class(gfnff_data) :: self
    !> INPUT
    integer,intent(in) :: nat
    integer,intent(in) :: at(nat)
    real(wp),intent(in) :: xyz(3,nat)
    logical,intent(in),optional  :: print
    logical,intent(in),optional  :: verbose
    integer,intent(in),optional  :: iunit
    integer,intent(in),optional  :: version
    integer,intent(out),optional :: iostat
    integer,intent(in),optional  :: ichrg
    character(len=*),intent(in),optional :: solvent

    if(present(solvent))then
      if(solvent.ne.'none'.and.len_trim(solvent)>0) self%solvent=solvent
    endif

    call  gfnff_initialize(nat,at,xyz,self, &
    &       print=print,verbose=verbose,iunit=iunit,&
    &       version=version,iostat=iostat,ichrg=ichrg)
  end subroutine gfnff_initialize_wrapper

!========================================================================================!
  subroutine gfnff_data_deallocate(self)
    implicit none
    class(gfnff_data) :: self
    self%ichrg = 0
    self%accuracy = 0.1_wp
    self%make_chrg = .true.
    self%version = 1
    self%update = .true.
    self%write_topo = .true.
    if (allocated(self%solvent)) deallocate (self%solvent)
    if (allocated(self%gen)) deallocate (self%gen)
    if (allocated(self%param)) deallocate (self%param)
    if (allocated(self%topo)) deallocate (self%topo)
    if (allocated(self%nlist)) deallocate (self%nlist)
    if (allocated(self%solvation)) deallocate (self%solvation)
    if (allocated(self%res)) deallocate (self%res)
  end subroutine gfnff_data_deallocate
  subroutine gfnff_data_reset_types(self)
    implicit none
    class(gfnff_data) :: self
    if (allocated(self%gen)) deallocate (self%gen)
    if (allocated(self%param)) deallocate (self%param)
    if (allocated(self%topo)) deallocate (self%topo)
    if (allocated(self%nlist)) deallocate (self%nlist)
    if (allocated(self%solvation)) deallocate (self%solvation)
    if (allocated(self%res)) deallocate (self%res)
  end subroutine gfnff_data_reset_types
  subroutine gfnff_data_make_types(self)
    implicit none
    class(gfnff_data) :: self
    call self%type_reset()
    allocate (self%gen)
    allocate (self%param)
    allocate (self%topo)
    allocate (self%nlist)
    allocate (self%res)
  end subroutine gfnff_data_make_types

!=========================================================================================!
  subroutine gfnff_get_fake_wbo(ff_dat,nat,wbo)
    implicit none
    type(gfnff_data),intent(in) :: ff_dat
    integer,intent(in) :: nat
    real(wp),intent(out) :: wbo(nat,nat)
    integer :: i,k,l
    wbo = 0.0_wp
    if(allocated(ff_dat%topo))then
      if(allocated(ff_dat%topo%blist))then
         do i =1,ff_dat%topo%nbond
            k = ff_dat%topo%blist(1,i)
            l = ff_dat%topo%blist(2,i)
            wbo(k,l) = 1.0_wp
            wbo(l,k) = wbo(k,l)
         enddo
      endif
    endif
  end subroutine gfnff_get_fake_wbo

!========================================================================================!
end module gfnff_interface

!================================================================================!
! This file is part of gfnff.
!
! Copyright (C) 2023 Philipp Pracht
!
! gfnff is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfnff is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfnff. If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------!
!> The original (unmodified) source code can be found under the GNU LGPL 3.0 license
!> Copyright (C) 2019-2020 Sebastian Ehlert, Sebastian Spicher, Stefan Grimme
!> at https://github.com/grimme-lab/xtb
!================================================================================!
module gfnff_ini_mod
  use iso_fortran_env,only:wp => real64,sp => real32, stdout=>output_unit
  use gfnff_helpers
  implicit none
  private

  public :: gfnff_ini

!========================================================================================!
!========================================================================================!
contains  !> MODULE PROCEDURES START HERE
!========================================================================================!
!========================================================================================!

  subroutine gfnff_ini(pr,makeneighbor,nat,at,xyz,ichrg,gen,param,topo,accuracy,io,verbose,iunit)
    use gfnff_param,only:efield,gfnff_thresholds,pse
    use gfnff_data_types,only:TGFFData,TGFFTopology,TGFFGenerator

    use gfnff_ini2
    use gfnff_cn,only:gfnff_dlogcoord
    use gfnff_qm_setup, only:gfnffqmsolve
    use gfnff_fraghess
    use gfnff_rab
    implicit none
    character(len=*),parameter :: source = 'gfnff_ini'
!--------------------------------------------------------------------------------------------------
    integer,intent(in) :: nat
    integer,intent(in) :: at( nat )
    real(wp),intent(in) :: xyz(3,nat) 

    type(TGFFTopology),intent(inout) :: topo
    type(TGFFGenerator),intent(in) :: gen
    type(TGFFData),intent(in) :: param
    real(wp),intent(in) :: accuracy

    integer,intent(in) :: ichrg         ! mol. charge
    logical,intent(in) :: pr            ! standard print flag
    logical,intent(in) :: makeneighbor  ! make a neigbor list or use existing one?
    integer,intent(out) :: io           ! return status 
    logical,intent(in),optional :: verbose  ! extended print flag
    integer,intent(in),optional :: iunit    ! printout unit
!--------------------------------------------------------------------------------------------------

    integer :: ati,atj,atk,i,j,k,l,nn,ii,jj,kk,ll,m,rings,ia,ja,ij,ix,nnn,idum,ip,ji,no
    integer :: ineig,jneig,nrot,bbtyp,ringtyp,nn1,nn2,hybi,hybj,pis,ka,nh,jdum,hcalc,nc
    integer :: ringsi,ringsj,ringsk,ringl,npi,nelpi,picount,npiall,maxtors,rings4,nheav
    integer :: nm,maxhb,ki,n13,current,ncarbo,mtyp1,mtyp2,nbi
    integer :: ind3(3),sr(20),cr(10,20),niel(86)
    integer :: qloop_count,nf,nsi,nmet,nhi,nhj,ifrag
    integer :: hbA,hbH,Bat,atB,Aat,Hat
    integer :: AHB_nr
    integer :: bond_hbn
    integer :: myunit

    real(wp) :: r0,ff,f1,f2,phi,ringf,fcn
    real(wp) :: shift,dum,dum1,dum2,dum4,qafac,fqq,feta
    real(wp) :: sumppi,fpi,fxh,fijk,fsrb2,ees
    real(wp) :: fheavy,fn,eold,fctot,fij
    real(wp) :: hbpi(2),hbpj(2),sdum3(3)
    real(wp) :: bstrength
    real(wp) :: xx(20)
    real(wp) :: fkl,qreps,fbsmall,bohr

    parameter(bohr=1.0_wp/0.52917726_wp)

    real(wp),parameter :: rabd_cutoff = 13.0_wp

    logical :: lring,picon,notpicon,bridge,sp3ij,ccij,success
    logical :: heavy,triple,piat,sp3kl,ex,cnij,frag_charges_known
    logical :: pr2

    integer,allocatable :: btyp(:),imetal(:),nbm(:,:),nbf(:,:)
    integer,allocatable :: hyb(:),itag(:)
    integer,allocatable :: piadr(:),piadr2(:),piadr3(:),piadr4(:)
    integer,allocatable :: itmp(:),sring(:,:),cring(:,:,:)
    integer,allocatable :: ipis(:),pimvec(:),nbpi(:,:),piel(:)
    integer,allocatable :: lin_AHB(:)
    integer,allocatable :: bond_hbl(:,:)

    real(wp),allocatable:: rab(:)
    real(wp),allocatable:: sqrab(:)
    real(wp),allocatable:: cn(:)
    real(wp),allocatable:: dcn(:,:,:)
    real(wp),allocatable:: dgam(:),dxi(:)
    real(wp),allocatable:: mchar(:)
    real(wp),allocatable:: rtmp(:)
    real(wp),allocatable:: pbo(:)
    real(wp),allocatable:: qtmp(:),dqa(:),qah(:)
    real(wp),allocatable:: Api(:,:),S(:,:),Pold(:,:),pibo(:),occ(:),eps(:)
    real(wp),allocatable:: pispop(:),pisea(:),pisip(:),apisave(:,:)
    real(sp),allocatable:: rabd(:,:)

    character(len=255) atmp
    integer  :: ich,err
    real(wp) :: dispthr,cnthr,repthr,hbthr1,hbthr2
    logical :: exitRun
  
    real(wp),parameter :: pi=3.1415926535897932385_wp

!> initialization
    io = 0
    exitRun = .false.
    if(present(iunit))then
      myunit = iunit
    else
      myunit = stdout
    endif
    if(present(verbose))then
      pr2 = verbose
    else
      pr2 =.false.
    endif


!> set thresholds
    call gfnff_thresholds(accuracy,dispthr,cnthr,repthr,hbthr1,hbthr2)

    if (pr2) then
      write (myunit,*)
      write (myunit,'(1x,"entering GFN-FF setup routine... ",i0)') nat
    end if

    if(pr)then
    write (myunit,*)
    write (myunit,'(1x,"==================== Thresholds ====================")')
    write (myunit,'(2x,"CN  :",f12.5)') cnthr
    write (myunit,'(2x,"rep :",f12.5)') repthr
    write (myunit,'(2x,"disp:",f12.5)') dispthr
    write (myunit,'(2x,"HB1 :",f12.5)') hbthr1
    write (myunit,'(2x,"HB2 :",f12.5)') hbthr2
    write (myunit,*)
    endif

    allocate (rab(nat*(nat+1)/2),source=0.0d0)
    allocate (cn(nat),source=0.0d0)
    allocate (sqrab(nat*(nat+1)/2),source=0.0d0)
    allocate (hyb(nat),source=0)
    allocate (topo%hyb(nat),source=0)
    allocate (topo%alphanb(nat*(nat+1)/2),source=0.0d0)
    allocate (rtmp(nat*(nat+1)/2),source=0.0d0)
    allocate (pbo(nat*(nat+1)/2),source=0.0d0)
    allocate (piadr(nat),source=0)
    allocate (piadr2(nat),source=0)
    allocate (topo%bpair(nat*(nat+1)/2),source=0)
    allocate (itmp(nat),source=0)
    allocate (itag(nat),source=0)
    allocate (sring(20,nat),source=0)
    allocate (cring(10,20,nat),source=0)
    allocate (piadr3(nat),source=0)
    allocate (piadr4(nat),source=0)
    allocate (qtmp(nat),source=0.0d0)
    allocate (dxi(nat),source=0.0d0)
    allocate (dgam(nat),source=0.0d0)
    allocate (topo%chieeq(nat),source=0.0d0)
    allocate (topo%gameeq(nat),source=0.0d0)
    allocate (topo%alpeeq(nat),source=0.0d0)
    allocate (topo%qa(nat),source=0.0d0)
    allocate (dqa(nat),source=0.0d0)
    allocate (qah(nat),source=0.0d0)
    allocate (nbm(20,nat),source=0)
    allocate (mchar(nat),source=0.0d0)
    allocate (imetal(nat),source=0)
    allocate (topo%zetac6(nat*(nat+1)/2),source=0.0d0)
    allocate (topo%xyze0(3,nat),source=0.0d0)
    allocate (nbf(20,nat),source=0)

    niel = 0
    do i = 1,nat
      niel(at(i)) = niel(at(i))+1
    end do

    if(pr)then
    write (myunit,'(2x,"Pauling EN used:")')
    do i = 1,86
      if (niel(i) .gt. 0) write (myunit,'(2x,"Z :",i2,"  EN :",f6.2)') i,param%en(i)
    end do

    dum = sqrt(sum(efield**2))
    write (myunit,'(2x,"electric field strengths (au):",f6.3)') dum

    write (myunit,*)
    write (myunit,'(1x," ------------------------------------------------- ")')
    write (myunit,'(1x,"|           Force Field Initialization            |")')
    write (myunit,'(1x," ------------------------------------------------- ")')
    write (myunit,*)
    endif

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! distances and bonds
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    topo%xyze0 = xyz ! initial geom

    if(pr) write (myunit,'(2x,"distances ...")')
    pbo = 0
    rab = 0
    sqrab = 0
    do i = 1,nat
      ati = at(i)
      kk = i*(i-1)/2
      do j = 1,i-1
        atj = at(j)
        k = kk+j
        sqrab(k) = (xyz(1,i)-xyz(1,j))**2+(xyz(2,i)-xyz(2,j))**2+(xyz(3,i)-xyz(3,j))**2
        rab(k) = sqrt(sqrab(k))
        if (rab(k) .lt. 1.d-3) then
          if(pr) write (myunit,*) i,j,ati,atj,rab(k)
          if(pr) write(myunit,'("Particular close distance present ",a)')source
          exitRun = .true.
          exit
        end if
      end do
    end do

    if (exitRun) then
      io = -1 
      return
    end if

!>-- Calculate CN and derivative
    allocate (dcn(3,nat,nat),source=0.0d0)
    call gfnff_dlogcoord(nat,at,xyz,rab,cn,dcn,cnthr,param) ! dcn needed
    do i = 1,nat
      dum2 = 0
      do j = 1,nat
        dum2 = dum2+sqrt(dcn(1,j,i)**2+dcn(2,j,i)**2+dcn(3,j,i)**2)
      end do
      mchar(i) = exp(-0.005d0*param%en(at(i))**8)*dum2/(cn(i)+1.0d0)     ! estimated metallic character as ratio of av. dCN and CN
      ! and an EN cut-off function, used in neigbor routinen and for BS estimate
    end do
    deallocate (dcn)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! neighbor list, hyb and ring info
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    topo%qa = 0
    qloop_count = 0

!111   continue
!  do the loop only if factor is significant
    do while (qloop_count .lt. 2.and.gen%rqshrink .gt. 1.d-3)

      if(pr)then
      write (myunit,'(2x,"----------------------------------------")')
      write (myunit,'(2x,"generating topology and atomic info file ...")')
      endif
      call gfnff_neigh(makeneighbor,nat,at,xyz,rab,gen%rqshrink, &
         & gen%rthr,gen%rthr2,gen%linthr,mchar,hyb,itag,nbm,nbf,param,topo,myunit,pr)

      do i = 1,nat
        imetal(i) = param%metal(at(i))
        if (topo%nb(20,i) .le. 4.and.param%group(at(i)) .gt. 3) imetal(i) = 0 ! Sn,Pb,Bi, with small CN are better described as non-metals
      end do

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! bonds (non bonded directly in EG)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      topo%bpair = 0
      do i = 1,nat
        do j = 1,topo%nb(20,i)
          k = topo%nb(j,i)
          topo%bpair(lin(k,i)) = 1
        end do
      end do
      topo%nbond = sum(topo%bpair)
      topo%nbond_blist = topo%nbond
      allocate (topo%blist(2,topo%nbond),source=0)
      allocate (btyp(topo%nbond),source=0)
      allocate (pibo(topo%nbond),source=0.0d0)

      pibo = -99.
      topo%nbond = 0
      do i = 1,nat
        kk = i*(i-1)/2
        do j = 1,i-1
          k = kk+j
          if (topo%bpair(k) .eq. 1) then  ! bonds
            topo%nbond = topo%nbond+1
            topo%blist(1,topo%nbond) = i
            topo%blist(2,topo%nbond) = j
          end if
        end do
      end do

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Hueckel setup for all first-row sp2 and sp atoms
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! setup list of all possible pi atoms
      k = 0
      piadr = 0
      piadr2 = 0
      do i = 1,nat ! setup loop
        piat = (hyb(i) .eq. 1.or.hyb(i) .eq. 2).and.pilist(at(i)) ! sp or sp2 and CNOFS
        kk = 0
        do j = 1,topo%nb(20,i)
          jj = topo%nb(j,i)
          if (at(i) .eq. 8.and.at(jj) .eq. 16.and.hyb(jj) .eq. 5) then
            piat = .false.
            cycle ! SO3   is not a pi
          end if
          if (hyb(jj) .eq. 1.or.hyb(jj) .eq. 2) kk = kk+1         ! attached to sp2 or sp
        end do
        picon = kk .gt. 0.and.nofs(at(i))                     ! an N,O,F (sp3) on sp2
        if (at(i) .eq. 7.and.topo%nb(20,i) .gt. 3) cycle           ! NR3-X is not a pi
        if (at(i) .eq. 16.and.hyb(i) .eq. 5) cycle           ! SO3   is not a pi
        if (picon.or.piat) then
          k = k+1
          piadr(k) = i
          piadr2(i) = k
        end if
      end do
      npiall = k
! make pi neighbor list
      allocate (nbpi(20,npiall),pimvec(npiall),source=0)
      nbpi = 0
      do i = 1,nat
        if (piadr2(i) .eq. 0) cycle
        ii = piadr2(i)
        nbpi(20,ii) = 0
        do j = 1,topo%nb(20,i)
          k = topo%nb(j,i)
          if (piadr2(k) .gt. 0) then
            nbpi(20,ii) = nbpi(20,ii)+1
            nbpi(nbpi(20,ii),ii) = piadr2(k)
          end if
        end do
      end do

! assign pi atoms to fragments
      call mrecgff(npiall,nbpi,picount,pimvec)
      deallocate (nbpi)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! setup xi correction for EEQ
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      dxi = 0 ! default none
      do i = 1,nat
        ati = at(i)
        nn = topo%nb(20,i)
        if (nn .eq. 0) cycle
        ip = piadr2(i)
        ji = topo%nb(1,i) ! first neighbor
        nh = 0
        nm = 0
        do j = 1,nn
          if (at(topo%nb(j,i)) .eq. 1) nh = nh+1
          if (imetal(topo%nb(j,i)) .ne. 0) nm = nm+1
        end do
!     hydrogen
!        if(ati.eq.1.and.nn.gt.1)                                                 dxi(i)=dxi(i)-nn*0.01
!     boron
        if (ati .eq. 5) dxi(i) = dxi(i)+nh*0.015
!     carbon
        if (ati .eq. 6.and.nn .eq. 2.and.itag(i) .eq. 1) dxi(i) = -0.15 ! make carbene more negative
!        if(ati.eq.6.and.nn.eq.2)then
!           ki=topo%nb(2,i)
!           if(at(ki).eq.8.and.at(ji).eq.8.and.topo%nb(20,ji).eq.1.and.topo%nb(20,ki).eq.1)then          ! free CO2
!                                                                                 dxi(ki)=0.19 ! lower EN for O
!                                                                                 dxi(ji)=0.19 !  "    "   "  "
!           endif
!        endif
        if (ati .eq. 6.and.nn .eq. 1.and.at(ji) .eq. 8.and.topo%nb(20,ji) .eq. 1) dxi(ji) = 0.15! free CO
!     nitrogen
!        if(ati.eq.7.and.nn.eq.1.and.at(ji).eq.6)                                 dxi(i)=0.00  !CN
!     oxygen / group 6
        if (ati .eq. 8.and.nn .eq. 1.and.ip .ne. 0.and.at(ji) .eq. 7.and.piadr2(ji) .ne. 0) dxi(i) = 0.05    ! nitro oxygen, otherwise NO2 HBs are too strong
        if (ati .eq. 8.and.nn .eq. 2.and.nh .eq. 2) dxi(i) = -0.02    ! H2O
        if (param%group(ati) .eq. 6.and.nn .gt. 2) dxi(i) = dxi(i)+nn*0.005! good effect
        if (ati .eq. 8.or.ati .eq. 16) dxi(i) = dxi(i)-nh*0.005
!    fluorine / group 7
        if (param%group(ati) .eq. 7.and.ati .gt. 9.and.nn .gt. 1) then ! polyvalent Cl,Br ...
          if (nm .eq. 0) then
            dxi(i) = dxi(i)-nn*0.021! good effect
          else
            dxi(i) = dxi(i)+nn*0.05 ! good effect for TMs
          end if
        end if
      end do

!> prepare EEQ xi ATOMIC parameter
!> at this point for the non-geom. dep. charges qa with CN = nb
      do i = 1,nat
        ati = at(i)
        dum = min(dble(topo%nb(20,i)),gen%cnmax)  ! limits it
!> base val  spec. corr.    CN dep.
        topo%chieeq(i) = -param%chi(ati)+dxi(i)+param%cnf(ati)*sqrt(dum)
        topo%gameeq(i) = param%gam(ati)
        if (imetal(i) .eq. 2) then 
!> the "true" charges for the TM metals are small (for various reasons)
!> so take for the non-geom. dep. ones less   electronegative metals yield more q+
!> which reflect better the true polarity used for guessing various
          topo%chieeq(i) = topo%chieeq(i)-gen%mchishift
        end if
!> potential terms. The positive effect of this is big.
        topo%alpeeq(i) = param%alp(ati)**2
      end do

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! topology based charges
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      if (pr) write (myunit,'(2x,"pair mat ...")')
!> get number of cov. bonds between atoms up to 4 bonds
      call nbondmat(nat,topo%nb,topo%bpair) 
      if (pr) write (myunit,'(2x,"computing topology distances matrix with Floyd-Warshall algo ...")')
      allocate (rabd(nat,nat),source=0.0e0_sp)
      rabd = rabd_cutoff
!> determine topology distances by Floyd-Warshall algo
!> they are used in the EEQ to determine qa (approximate topology charges)
      do i = 1,nat
        rabd(i,i) = 0.0
        do j = 1,topo%nb(20,i)
          k = topo%nb(j,i)
          rabd(k,i) = param%rad(at(i))+param%rad(at(k))
          rabd(i,k) = rabd(k,i)
        end do
      end do
      do k = 1,nat
        do i = 1,nat
          if (rabd(i,k) > gen%tdist_thr) cycle
          do j = 1,nat
            if (rabd(k,j) > gen%tdist_thr) cycle
            if (rabd(i,j) > (rabd(i,k)+rabd(k,j))) then
              rabd(i,j) = rabd(i,k)+rabd(k,j)
            end if
          end do
        end do
      end do

      do i = 1,nat
        do j = 1,i-1
          ij = lin(j,i)
          if (rabd(j,i) .gt. gen%tdist_thr) rabd(j,i) = rabd_cutoff ! values not properly considered
          rtmp(ij) = gen%rfgoed1*rabd(j,i)/0.52917726d0
        end do
      end do
      deallocate (rabd)

      frag_charges_known = .false.
      if(pr) write (myunit,'(2x,"making topology EEQ charges ...")')
      if (topo%nfrag .le. 1) then                           ! nothing is known
!> first check for fragments
        call mrecgff(nat,nbf,topo%nfrag,topo%fraglist)
        if(pr) write (myunit,'(2x,"#fragments for EEQ constrain: ",i0)') topo%nfrag
!> read QM info if it exists
        if(allocated(topo%refcharges))then
          inquire(file=trim(topo%refcharges),exist=ex)
          if(.not.ex)then
            write(*,*) 'reference charge file '//topo%refcharges//' allocated, but could not be found!'
            error stop 
          endif
        else
          ex=.false.
        endif
        if(ex)then
          if(pr) write(myunit,'(2x,a)') topo%refcharges//" file detected, attempting to read ..."
          open(newunit=ich,file=trim(topo%refcharges),action='read')
          qtmp = 0
          err = 0
          i = 0
          do while (err == 0)
            read (ich,*,iostat=err) dum
            if (err /= 0) exit
            if (i < nat) then
              i = i+1
              qtmp(topo%fraglist(i)) = qtmp(topo%fraglist(i))+dum
            else
              if(pr) write(myunit,'("More charges than atoms present, assuming missmatch ",a)') source
              exitRun=.true.
              err = 1
            end if
          end do
          if (is_iostat_end(err).and.i == nat) err = 0
          close(ich)
          if (err == 0) then
            if (i < nat.or.abs(sum(qtmp)-ichrg) > 1.0e-3_wp) then
              if(pr) write(myunit,'("Rejecting external charges input due to missmatch ",a)')source
              exitRun = .true.
            else
              topo%qfrag = dnint(qtmp)
              if(pr) write (myunit,'(2x,"fragment charges from <charges> :",10(1x,F7.3))') topo%qfrag(1:topo%nfrag)
            end if
          else
            if(pr) write(myunit,'("Could not initialize fragment charges from file ",a)')source 
            exitRun = .true.
          end if

          if (exitRun) then
            io = 1
            return
          end if
        end if
        if (nat .lt. 100 .and. &
        &   topo%nfrag .gt. 2 .and. &
        &   ichrg .ne. 0 .and. &
        &   sum(topo%qfrag(2:topo%nfrag)) .gt. 999) then
          itmp = 0
          do i = 1,nat
            itmp(topo%fraglist(i)) = itmp(topo%fraglist(i))+1
          end do
          do i = 1,topo%nfrag
            if(pr) write (myunit,*) i,itmp(i)
          end do
          if(pr)  write(myunit,'("fragment charge input required ",a)')source
          io = 1
          return
        end if
        if (nat .ge. 100.and.topo%nfrag .gt. 2.and.ichrg .ne. 0.and.sum(topo%qfrag(2:topo%nfrag)) .gt. 999) then
          topo%qfrag(1) = ichrg
          topo%qfrag(2:topo%nfrag) = 0
        end if
        if (topo%nfrag .eq. 2.and.ichrg .ne. 0.and.sum(topo%qfrag(2:topo%nfrag)) .gt. 999) then
          if(pr) write (myunit,*) 'trying auto detection of charge on 2 fragments:'
          topo%qfrag(1) = 0
          topo%qfrag(2) = dble(ichrg)
          call goedeckera(nat,at,topo%nb,rtmp,topo%qa,dum1,topo,io)
          if(io /= 0 ) exitRun = .true.
          if (exitRun) then
            if(pr) write(myunit,'("Failed to generate charges ",a)')source
            return
          end if
          topo%qfrag(2) = 0
          topo%qfrag(1) = dble(ichrg)
          call goedeckera(nat,at,topo%nb,rtmp,topo%qa,dum2,topo,io)
          if(io /= 0 ) exitRun = .true.
          if (exitRun) then
            if(pr) write(myunit,'("Failed to generate charges ",a)')source
            return
          end if
          if (dum1 .lt. dum2) then
            topo%qfrag(1) = 0
            topo%qfrag(2) = dble(ichrg)
          end if
          if(pr) write (myunit,*) 'dEes      :',dum1-dum2
          if(pr) write (myunit,*) 'charge 1/2:',topo%qfrag(1:2)
        end if
      !else if (allocated(mol%pdb)) then ! frag_charges_known
      !  write (myunit,'(2x,"#fragments for EEQ constrain from pdb file: ",i0)') topo%nfrag
      !  frag_charges_known = .true.
      end if

       if(pr) write (myunit,'(2x,"fragment charges :",10(1x,F7.3))') topo%qfrag(1:topo%nfrag)

!> make estimated, topology only EEQ charges from rabd values, including "right" fragment charge
      call goedeckera(nat,at,topo%nb,rtmp,topo%qa,ees,topo,io)
      if(io /= 0 ) exitRun = .true. 
      if (exitRun) then
        if(pr) write(myunit,'("Failed to generate charges ",a)')source
        return
      end if

!> estimate how much of the frag charge is on the pi sub systems
      if (picount .gt. 0.and.qloop_count .gt. 0) then
        allocate (ipis(picount),source=0)
        if (frag_charges_known) then                        ! PDB case
          ipis = 0
          do pis = 1,picount ! loop over pi systems
            do k = 1,npiall
              if (pimvec(k) .eq. pis) then
                ipis(pis) = ipis(pis)+topo%qpdb(piadr(k))
                topo%qpdb(piadr(k)) = 0
              end if
            end do
          end do
        else                                               ! general case
          qtmp = topo%qa ! save the "right" ones
          qah = topo%qa
          call qheavy(nat,at,topo%nb,qah) ! heavy atoms only ie H condensed to neighbor
          do pis = 1,picount ! loop over pi systems
            do k = 1,npiall
              if (pimvec(k) .eq. pis) then
                kk = piadr(k)
                ifrag = topo%fraglist(kk) !the pi atom of this pi fragment is in EEQ fragment ifrag
                exit
              end if
            end do
            dum2 = topo%qfrag(ifrag) ! save
            topo%qfrag(ifrag) = 0 ! make only this EEQ fragment neutral
            call goedeckera(nat,at,topo%nb,rtmp,topo%qa,ees,topo,io) ! for neutral
            if(io /= 0 ) exitRun = .true.
            if (exitRun) then
              if(pr) write(myunit,'("Failed to generate charges ",a)')source
              return
            end if
            topo%qfrag(ifrag) = dum2 ! back
            call qheavy(nat,at,topo%nb,topo%qa)
            dqa = qah-topo%qa ! difference charges upon ionization
            dum1 = 0
            dum = 0
            do k = 1,npiall
              if (pimvec(k) .eq. pis) dum = dum+dqa(piadr(k)) ! only pi atoms
            end do
            dum = dum*1.1 !charges tend to be slightly too small 1.1-1.2
            ipis(pis) = idnint(dum)
            dum1 = dum1+dum
          end do
          topo%qa = qtmp ! put "right" charges used in FF construction and for HB/XB in place
        end if
      end if

      if (qloop_count .eq. 0) itmp(1:nat) = topo%nb(20,1:nat)
      qloop_count = qloop_count+1
      if (qloop_count .lt. 2.and.gen%rqshrink .gt. 1.d-3) then  ! do the loop only if factor is significant
        deallocate (topo%blist,btyp,pibo,pimvec)
!         goto 111
      end if
    end do

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! change EEQ J with estimated q
! which is a kind of third-order term
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    do i = 1,nat
      ff = 0                           ! do nothing
      if (at(i) .eq. 1) ff = -0.08 ! H
      if (at(i) .eq. 5) ff = -0.05 ! B
      if (at(i) .eq. 6) then
        ff = -0.27 ! C
        if (hyb(i) .lt. 3) ff = -0.45 ! unsat
        if (hyb(i) .lt. 2) ff = -0.34 ! unsat
      end if
      if (at(i) .eq. 7) then
        ff = -0.13 ! N
        if (piadr(i) .ne. 0) ff = -0.14
        if (amide(nat,at,hyb,topo%nb,piadr,i)) ff = -0.16
      end if
      if (at(i) .eq. 8) then
        ff = -0.15 ! O
        if (hyb(i) .lt. 3) ff = -0.08 ! unsat
      end if
      if (at(i) .eq. 9) ff = 0.10 ! F
      if (at(i) .gt. 10) ff = -0.02 ! heavy
      if (at(i) .eq. 17) ff = -0.02 ! Cl
      if (at(i) .eq. 35) ff = -0.11 ! Br
      if (at(i) .eq. 53) ff = -0.07 ! I
      if (imetal(i) .eq. 1) ff = -0.08 ! M maing
      if (imetal(i) .eq. 2) ff = -0.9  ! M TM    ??? too large
      if (param%group(at(i)) .eq. 8) ff = 0.0  ! RG
      dgam(i) = topo%qa(i)*ff
    end do

!     prepare true EEQ parameter, they are ATOMIC not element specific!
    do i = 1,nat
!                   base val   spec. corr.
      topo%chieeq(i) = -param%chi(at(i))+dxi(i)
      topo%gameeq(i) = param%gam(at(i))+dgam(i)
      if (amideH(nat,at,hyb,topo%nb,piadr2,i)) topo%chieeq(i) = topo%chieeq(i)-0.02
      ff = 0
      if (at(i) .eq. 6) ff = 0.09
      if (at(i) .eq. 7) ff = -0.21
      if (param%group(at(i)) .eq. 6) ff = -0.03
      if (param%group(at(i)) .eq. 7) ff = 0.50
      if (imetal(i) .eq. 1) ff = 0.3
      if (imetal(i) .eq. 2) ff = -0.1
      topo%alpeeq(i) = (param%alp(at(i))+ff*topo%qa(i))**2
    end do
    deallocate (dgam,dxi)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! get ring info (smallest ring size)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    if(pr) write (myunit,'(2x,"rings ...")')
!$omp parallel default(none) private(i,cr,sr) shared(nat,at,nbm,cring,sring)
!$omp do
    do i = 1,nat
      call getring36(nat,at,nbm,i,cr,sr)
      cring(1:10,1:20,i) = cr(1:10,1:20)
      sring(1:20,i) = sr(1:20)
    end do
!$omp end do
!$omp end parallel
    deallocate (nbm)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! bonded atom triples not included in
! bend and tors
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    idum = 1000*nat
    allocate (topo%b3list(3,idum),source=0)
    topo%nbatm = 0
    do i = 1,nat
      do j = 1,i-1
        ij = lin(j,i)
        if (topo%bpair(ij) .eq. 3) then  ! 1,4 exclusion of back-pair makes it worse, 1,3 makes little effect
          do m = 1,topo%nb(20,j)
            k = topo%nb(m,j)
            topo%nbatm = topo%nbatm+1
            topo%b3list(1,topo%nbatm) = i
            topo%b3list(2,topo%nbatm) = j
            topo%b3list(3,topo%nbatm) = k
          end do
          do m = 1,topo%nb(20,i)
            k = topo%nb(m,i)
            topo%nbatm = topo%nbatm+1
            topo%b3list(1,topo%nbatm) = i
            topo%b3list(2,topo%nbatm) = j
            topo%b3list(3,topo%nbatm) = k
          end do
        end if
      end do
    end do
    if (topo%nbatm .gt. idum) then
      if(pr) write (myunit,*) idum,topo%nbatm
      if(pr) write(myunit,'("overflow in ini ",a)')source 
      io = 1
      return
    end if
    if(pr) write (myunit,'(2x,"# BATM",3x,i0)') topo%nbatm

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! non bonded pair exponents
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    do i = 1,nat
      ati = at(i)
      fn = 1.0d0+gen%nrepscal/(1.0d0+dble(topo%nb(20,i))**2)
      dum1 = param%repan(ati)*(1.d0+topo%qa(i)*gen%qrepscal)*fn ! a small but physically correct decrease of repulsion with q
      f1 = zeta(ati,topo%qa(i))
      do j = 1,i-1
        atj = at(j)
        fn = 1.0d0+gen%nrepscal/(1.0d0+dble(topo%nb(20,j))**2)
        dum2 = param%repan(atj)*(1.d0+topo%qa(j)*gen%qrepscal)*fn
        f2 = zeta(atj,topo%qa(j))
        ij = lin(j,i)
        ff = 1.0d0
        if (ati .eq. 1.and.atj .eq. 1) then
          ff = 1.0d0*gen%hhfac                     ! special H ... H case (for other pairs there is no good effect of this)
          if (topo%bpair(ij) .eq. 3) ff = ff*gen%hh14rep     ! 1,4 case important for right torsion pot.
          if (topo%bpair(ij) .eq. 2) ff = ff*gen%hh13rep     ! 1,3 case
        end if
        if ((ati .eq. 1.and.param%metal(atj) .gt. 0).or.(atj .eq. 1.and.param%metal(ati) .gt. 0)) ff = 0.85 ! M...H
        if ((ati .eq. 1.and.atj .eq. 6).or.(atj .eq. 1.and.ati .eq. 6)) ff = 0.91 ! C...H, good effect
        if ((ati .eq. 1.and.atj .eq. 8).or.(atj .eq. 1.and.ati .eq. 8)) ff = 1.04 ! O...H, good effect
        topo%alphanb(ij) = sqrt(dum1*dum2)*ff
        topo%zetac6(ij) = f1*f2  ! D4 zeta scaling using qref=0
      end do
    end do

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! make list of HB donor bascity
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    !atom specific (not element) basicity parameters
    allocate (topo%hbbas(nat),source=1.0d0)
    do i = 1,nat
      nn = topo%nb(20,i)
      ati = at(i)
      topo%hbbas(i) = param%xhbas(at(i))
      ! Carbene:
      if (ati .eq. 6.and.nn .eq. 2.and.itag(i) .eq. 1) topo%hbbas(i) = 1.46
      ! Carbonyl R-C=O
      if (ati .eq. 8.and.nn .eq. 1.and.at(topo%nb(nn,i)) .eq. 6) topo%hbbas(i) = 0.68
      ! Nitro R-N=O
      if (ati .eq. 8.and.nn .eq. 1.and.at(topo%nb(nn,i)) .eq. 7) topo%hbbas(i) = 0.47
    end do

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! make list of HB donor acidity
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!> atom specific (not element) basicity parameters
    allocate (topo%hbaci(nat),source=1.0d0)
    do i = 1,nat
      topo%hbaci(i) = param%xhaci(at(i))
    end do
    do i = 1,nat
      nn = topo%nb(1,i)
      topo%hbaci(i) = param%xhaci(at(i))
      ! AmideH:
      if (amideH(nat,at,hyb,topo%nb,piadr2,i)) topo%hbaci(nn) = topo%hbaci(nn)*0.80
    end do

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! make list of ABs for HAB
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    allocate (topo%hbatHl(nat),topo%hbatABl(2,nat*(nat+1)/2),source=0)

    topo%nathbH = 0
    do i = 1,nat
      if (at(i) .ne. 1) cycle
      if (hyb(i) .eq. 1) cycle      ! exclude bridging hydrogens from HB correction
      ff = gen%hqabthr
      j = topo%nb(1,i)
      if (j .le. 0) cycle
      if (at(j) .gt. 10) ff = ff-0.20                ! H on heavy atoms may be negatively charged
      if (at(j) .eq. 6.and.hyb(j) .eq. 3) ff = ff+0.05 ! H on sp3 C must be really positive 0.05
      if (topo%qa(i) .gt. ff) then                       ! make list of HB H atoms but only if they have a positive charge
        topo%nathbH = topo%nathbH+1
        topo%hbatHl(topo%nathbH) = i
      end if
    end do
    if(pr) write (myunit,'(2x,"# H in HB",3x,i0)') topo%nathbH

    topo%nathbAB = 0
    do i = 1,nat
      if (at(i) .eq. 6.and.piadr2(i) .eq. 0) cycle ! C sp or sp2 pi
      ff = gen%qabthr
      if (at(i) .gt. 10) ff = ff+0.2   ! heavy atoms may be positively charged
      if (topo%qa(i) .gt. ff) cycle
      do j = 1,i-1
        ff = gen%qabthr
        if (at(j) .gt. 10) ff = ff+0.2  ! heavy atoms may be positively charged
        if (topo%qa(j) .gt. ff) cycle
        call hbonds(i,j,hbpi,hbpj,param,topo)
        if (hbpi(1)*hbpj(2) .lt. 1.d-6.and.hbpi(2)*hbpj(1) .lt. 1.d-6) cycle
        if (at(j) .eq. 6.and.piadr2(j) .eq. 0) cycle ! C sp or sp2 pi
        topo%nathbAB = topo%nathbAB+1
        topo%hbatABl(1,topo%nathbAB) = i
        topo%hbatABl(2,topo%nathbAB) = j
      end do
    end do

!> make ABX list
    m = 0
    do i = 1,nat
      do ia = 1,topo%nb(20,i)
        ix = topo%nb(ia,i)
        if (xatom(at(ix))) then
          if (at(ix) .eq. 16.and.topo%nb(20,ix) .gt. 2) cycle ! no sulphoxide etc S
          do j = 1,nat
            if (i .eq. j.or.j .eq. ix) cycle
            if (topo%bpair(lin(j,ix)) .le. 3) cycle   ! must be A...B and not X-B i.e. A-X...B
            if (param%xhbas(at(j)) .lt. 1.d-6) cycle   ! B must be O,N,...
            if (param%group(at(j)) .eq. 4) then
              if (piadr2(j) .eq. 0.or.topo%qa(j) .gt. 0.05) cycle   ! must be a (pi)base
            end if
            m = m+1
          end do
        end if
      end do
    end do
    topo%natxbAB = m
    allocate (topo%xbatABl(3,topo%natxbAB),source=0)
    m = 0
    do i = 1,nat
      do ia = 1,topo%nb(20,i)
        ix = topo%nb(ia,i)
        if (xatom(at(ix))) then
          if (at(ix) .eq. 16.and.topo%nb(20,ix) .gt. 2) cycle ! no sulphoxide etc S
          do j = 1,nat
            if (i .eq. j.or.j .eq. ix) cycle
            if (topo%bpair(lin(j,ix)) .le. 3) cycle  ! must be A...B and not X-B i.e. A-X...B
            if (param%xhbas(at(j)) .lt. 1.d-6) cycle  ! B must be O,N,...
            if (param%group(at(j)) .eq. 4) then
              if (piadr2(j) .eq. 0.or.topo%qa(j) .gt. 0.05) cycle   ! must be a (pi)base
            end if
            m = m+1
            topo%xbatABl(1,m) = i
            topo%xbatABl(2,m) = j
            topo%xbatABl(3,m) = ix
          end do
        end if
      end do
    end do

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! do Hueckel
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    if (picount .gt. 0) then
      if(pr)then
      write (myunit,'(2x,"doing iterative Hueckel for ",i0," subsystem(s) ...")') picount
      endif
      allocate (pispop(picount),pisip(picount),pisea(picount),source=0.0d0)
      allocate (piel(nat),source=0)
      itmp = 0 ! save pi atom info
      hcalc = 0
      pisip = 0
      pisea = 0

      if (pr2) then
        write (myunit,'(2x,"iterative Hueckel run to get P ...")')
      end if
      do pis = 1,picount ! loop over pi systems
        npi = 0
        nelpi = 0
        piadr3 = 0
        piadr4 = 0
        piel = 0

        do k = 1,npiall
          if (pimvec(k) .eq. pis) then
            npi = npi+1
            ati = at(piadr(k))
            hybi = hyb(piadr(k))
            ii = nelpi
            if (ati .eq. 5.and.hybi .eq. 1) nelpi = nelpi+1  ! B in borine
            if (ati .eq. 6.and.itag(piadr(k)) .ne. 1) nelpi = nelpi+1  ! skip if its a carbene (tag itag=1)
            if (ati .eq. 7.and.hybi .eq. 2.and.itag(piadr(k)) .eq. 1) &
     &                                           nelpi = nelpi+1  ! the itag=1 avoids an odd el number for the nitro group (its 4)
            if (ati .eq. 7.and.hybi .le. 2) nelpi = nelpi+1
            if (ati .eq. 7.and.hybi .eq. 3) nelpi = nelpi+2
            if (ati .eq. 8.and.hybi .eq. 1) nelpi = nelpi+1
            if (ati .eq. 8.and.hybi .eq. 2) nelpi = nelpi+1
            if (ati .eq. 8.and.hybi .eq. 3) nelpi = nelpi+2
            if (ati .eq. 9.and.hybi .ne. 1) nelpi = nelpi+2
            if (ati .eq. 9.and.hybi .eq. 1) nelpi = nelpi+3 !??? otherwise fluor-furan+ is wrong
            if (ati .eq. 16.and.hybi .eq. 1) nelpi = nelpi+1
            if (ati .eq. 16.and.hybi .eq. 2) nelpi = nelpi+1
            if (ati .eq. 16.and.hybi .eq. 3) nelpi = nelpi+2
            if (ati .eq. 17.and.hybi .eq. 0) nelpi = nelpi+2
            if (ati .eq. 17.and.hybi .eq. 1) nelpi = nelpi+3
            piadr3(npi) = piadr(k) ! map to original, full atom set
            piadr4(piadr(k)) = npi
            piel(piadr(k)) = nelpi-ii
            if (piel(piadr(k)) .gt. 2) piel(piadr(k)) = 2
          end if
        end do
        nelpi = nelpi-ipis(pis)
        if (npi .lt. 2.or.nelpi .lt. 1) cycle
        allocate (Api(npi,npi),apisave(npi,npi),Pold(npi,npi),S(npi,npi),occ(npi),eps(npi)) ! S is just scratch here

        eold = 0
        Pold = 2.d0/3.d0
! iterative Hueckel loop, off-diag terms are reduced depending on P to avoid overdelocalization
        do nn = 1,nint(gen%maxhiter)      ! just some iterations
          Api = 0
          do i = 1,npi
            ii = piadr3(i)
            Api(i,i) = gen%hdiag(at(ii))+topo%qa(ii)*gen%hueckelp3-dble(piel(ii)-1)*gen%pilpf
          end do
!     loop over bonds for pair interactions
          do i = 1,topo%nbond
            ii = topo%blist(1,i)
            jj = topo%blist(2,i)
            ia = piadr4(ii)
            ja = piadr4(jj)
            if (ia .gt. 0.and.ja .gt. 0) then
              dum = 1.d-9*rab(lin(ii,jj))                                 ! distort so that Huckel for e.g. COT localizes to right bonds
              dum = sqrt(gen%hoffdiag(at(ii))*gen%hoffdiag(at(jj)))-dum           ! better than arithmetic
              dum2 = gen%hiter
              if (hyb(ii) .eq. 1) dum2 = dum2*gen%htriple        ! triple bond is different
              if (hyb(jj) .eq. 1) dum2 = dum2*gen%htriple        ! triple bond is different
              Api(ja,ia) = -dum*(1.0d0-dum2*(2.0d0/3.0d0-Pold(ja,ia))) ! Pmat scaling with benzene as reference
              Api(ia,ja) = Api(ja,ia)
            end if
          end do

          apisave = Api
!> diagonalize, 4000 better than 300
          call gfnffqmsolve(.false.,Api,S,.false.,4000.0d0,npi,0,nelpi,dum,occ,eps, io)
          if(io /= 0) return

          do i = 1,npi  ! save IP/EA
            if (occ(i) .gt. 0.5) then
              pisip(pis) = eps(i)   ! IP
              if (i+1 .lt. npi) pisea(pis) = eps(i+1) ! EA
            end if
          end do
          if (abs(dum-eold) .lt. 1.d-4) exit  ! end of iterations
          Pold = Api
          eold = dum
        end do
! end of iterative loop
        if (pr2) then
          write (myunit,'(''Hueckel system :'',i3,'' charge : '',i3,'' ndim/Nel :'',2i5, &
      &         3x, ''eps(HOMO/LUMO)'',2f12.6)') pis,ipis(pis),npi,nelpi,pisip(pis),pisea(pis)
          if (pisip(pis) .gt. 0.40) then
            write (myunit,*) 'WARNING: probably wrong pi occupation. Second attempt with Nel=Nel-1!'
            do i = 1,nat
              if (piadr4(i) .ne. 0) write (myunit,*) 'at,nb,hyb,Npiel:',i,pse(at(i)),topo%nb(20,i),hyb(i),piel(i)
            end do
            nelpi = nelpi-1
            Api = Apisave
            call gfnffqmsolve(.false.,Api,S,.false.,300.0d0,npi,0,nelpi,dum,occ,eps, io)  
            if(io /= 0) return
          end if
        end if
! save BO
        !if(.not.allocated(topo%pbo))allocate(topo%pbo(topo%nbond),source=1.0_wp)
        do i = 1,topo%nbond
          ii = topo%blist(1,i)
          jj = topo%blist(2,i)
          ia = piadr4(ii)
          ja = piadr4(jj)
          if (ia .gt. 0.and.ja .gt. 0) then
            pibo(i) = Api(ja,ia)
            pbo(lin(ii,jj)) = Api(ja,ia)
            !topo%pbo(i) = Api(ja,ia)
            itmp(ii) = 1
            itmp(jj) = 1
          end if
        end do
        deallocate (Api,apisave,Pold,S,occ,eps)
      end do
! end of pi system loop
      piadr = itmp  ! array used for identifying pi atoms in following codes
      deallocate (pispop,pisip,pisea,ipis,pimvec,piel)
    end if
!----------- end Hueckel

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! modify hyb due to pi assignment
! and output
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    do i = 1,nat
      if (hyb(i) .eq. 2.and.piadr(i) .eq. 0.and.topo%nb(20,i) .eq. 3.and.param%group(at(i)) .eq. 4) then ! C,Si,Ge... CN=3, no pi
        jj = topo%nb(1,i)
        kk = topo%nb(2,i)
        ll = topo%nb(3,i)
        phi = omega(nat,xyz,i,jj,kk,ll)  ! the shitty second geom. dep. term GEODEP
        if (abs(phi)*180.0_wp/pi .gt. 40.d0) hyb(i) = 3  ! change to sp^3
      end if
    end do

    if(pr)then
    write (myunit,*)
    write (myunit,'(2x,"atom   neighbors  erfCN metchar sp-hybrid imet pi  qest     coordinates")')
    do i = 1,nat
      j = hyb(i)
      if (amide(nat,at,hyb,topo%nb,piadr,i)) j = -hyb(i)
      if (at(i) .eq. 6.and.itag(i) .eq. 1) j = -hyb(i)
      write (myunit,'(i5,2x,a2,3x,i4,3x,f5.2,2x,f5.2,8x,i2,3x,i2,3x,i2,2x,f6.3,3f12.6)') &
  &             i,pse(at(i)),topo%nb(20,i),cn(i),mchar(i),j,imetal(i),piadr(i),topo%qa(i),xyz(1:3,i)
    end do
    endif

!     compute fragments and charges for output (check for CT)
!     call mrecgff(nat,topo%nb,nmol,piadr3)
!     write(myunit,*) 'Nmol',nmol
    if (pr2) then
      write (myunit,'(/,''molecular fragment  # atoms  topo charge'')')
      do i = 1,topo%nfrag
        dum = 0
        m = 0
        do k = 1,nat
          if (topo%fraglist(k) .eq. i) then
            m = m+1
            dum = dum+topo%qa(k)
          end if
        end do
        write (myunit,'(5x,i3,1x,i4,1x,f8.3)') i,m,dum
      end do
      write (myunit,*)
    end if

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!            bonds
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    call gfnffrab(nat,at,cn,rtmp)           ! guess RAB for output

    topo%nbond_vbond = topo%nbond
    allocate (topo%vbond(3,topo%nbond),source=0.0d0)

    if(pr)then
    write (myunit,*)
    write (myunit,'(1x,"#atoms   :",3x,i0)') nat
    write (myunit,'(1x,"#bonds   :",3x,i0)') topo%nbond
    endif
    if (pr2) then
      write (myunit,*)
      write (myunit,*) 'bond atoms        type  in ring    R      R0    piBO    fqq  kbond(tot)  alp'
    end if

    do i = 1,topo%nbond
      ii = topo%blist(1,i)
      jj = topo%blist(2,i)
      ij = lin(ii,jj)
      ia = at(ii)
      ja = at(jj)
      call ringsbond(nat,ii,jj,cring,sring,rings)
      shift = 0.d0
      fxh = 1.d0
      ringf = 1.d0
      fqq = 1.d0
      fpi = 1.d0
      fheavy = 1.d0
      fheavy = 1.d0
      fcn = 1.d0
      fsrb2 = gen%srb2
      bridge = .false.
      shift = 0.d0
! assign bond type
      btyp(i) = 1 ! single
      if (hyb(ii) .eq. 2.and.hyb(jj) .eq. 2) btyp(i) = 2 ! sp2-sp2 = pi
      if (hyb(ii) .eq. 3.and.hyb(jj) .eq. 2.and.ia .eq. 7) btyp(i) = 2 ! N-sp2
      if (hyb(jj) .eq. 3.and.hyb(ii) .eq. 2.and.ja .eq. 7) btyp(i) = 2 ! N-sp2
      if (hyb(ii) .eq. 1.or.hyb(jj) .eq. 1) btyp(i) = 3 ! sp-X i.e. no torsion
      if ((param%group(ia) .eq. 7.or.ia .eq. 1).and.hyb(ii) .eq. 1) then
        btyp(i) = 3 ! linear halogen i.e. no torsion
        bridge = .true.
      end if
      if ((param%group(ja) .eq. 7.or.ja .eq. 1).and.hyb(jj) .eq. 1) then
        btyp(i) = 3 ! linear halogen i.e. no torsion
        bridge = .true.
      end if
      if (hyb(ii) .eq. 5.or.hyb(jj) .eq. 5) btyp(i) = 4 ! hypervalent
      if (imetal(ii) .gt. 0.or.imetal(jj) .gt. 0) btyp(i) = 5 ! metal
      if (imetal(ii) .eq. 2.and.imetal(jj) .eq. 2) btyp(i) = 7 ! TM metal-metal
      if (imetal(jj) .eq. 2.and.itag(ii) .eq. -1.and.piadr(ii) .gt. 0) btyp(i) = 6 ! eta
      if (imetal(ii) .eq. 2.and.itag(jj) .eq. -1.and.piadr(jj) .gt. 0) btyp(i) = 6 ! eta
      bbtyp = btyp(i)
! normal bond
      if (bbtyp .lt. 5) then
        hybi = max(hyb(ii),hyb(jj))
        hybj = min(hyb(ii),hyb(jj))
        if (hybi .eq. 5.or.hybj .eq. 5) then
          bstrength = gen%bstren(4)                                       ! base value hypervalent
        else
          bstrength = gen%bsmat(hybi,hybj)                                ! base value normal hyb
        end if
        if (hybi .eq. 3.and.hybj .eq. 2.and.(ia .eq. 7.or.ja .eq. 7)) &
 &                                      bstrength = gen%bstren(2)*1.04   ! N-sp2

        if (bridge) then
          if (param%group(ia) .eq. 7) bstrength = gen%bstren(1)*0.50d0 ! bridging X
          if (param%group(ja) .eq. 7) bstrength = gen%bstren(1)*0.50d0 ! bridging X
          if (ia .eq. 1.or.ia .eq. 9) bstrength = gen%bstren(1)*0.30d0 ! bridging H/F
          if (ja .eq. 1.or.ja .eq. 9) bstrength = gen%bstren(1)*0.30d0 ! bridging H/F
        end if
        if (bbtyp .eq. 4) shift = gen%hyper_shift          ! hypervalent
        if (ia .eq. 1.or.ja .eq. 1) shift = gen%rabshifth            ! XH
        if (ia .eq. 9.and.ja .eq. 9) shift = 0.22                 ! f2
        if (hyb(ii) .eq. 3.and.hyb(jj) .eq. 0) shift = shift-0.022         ! X-sp3
        if (hyb(ii) .eq. 0.and.hyb(jj) .eq. 3) shift = shift-0.022         ! X-sp3
        if (hyb(ii) .eq. 1.and.hyb(jj) .eq. 0) shift = shift+0.14          ! X-sp
        if (hyb(ii) .eq. 0.and.hyb(jj) .eq. 1) shift = shift+0.14          ! X-sp
        if ((ia .eq. 1.and.ja .eq. 6)) then
          call ringsatom(nat,jj,cring,sring,ringsj)
          if (ringsj .eq. 3) fxh = 1.05    ! 3-ring CH
          if (ctype(nat,at,topo%nb,piadr,jj) .eq. 1) fxh = 0.95    ! aldehyd CH
        end if
        if ((ia .eq. 6.and.ja .eq. 1)) then
          call ringsatom(nat,ii,cring,sring,ringsi)
          if (ringsi .eq. 3) fxh = 1.05    ! 3-ring CH
          if (ctype(nat,at,topo%nb,piadr,ii) .eq. 1) fxh = 0.95    ! aldehyd CH
        end if
        if ((ia .eq. 1.and.ja .eq. 5)) fxh = 1.10    ! BH
        if ((ja .eq. 1.and.ia .eq. 5)) fxh = 1.10    !
        if ((ia .eq. 1.and.ja .eq. 7)) fxh = 1.06    ! NH
        if ((ja .eq. 1.and.ia .eq. 7)) fxh = 1.06    !
        if ((ia .eq. 1.and.ja .eq. 8)) fxh = 0.93    ! OH
        if ((ja .eq. 1.and.ia .eq. 8)) fxh = 0.93    !
        if (bbtyp .eq. 3.and.ia .eq. 6.and.ja .eq. 8) bstrength = gen%bstren(3)*0.90d0 ! makes CO right and M-CO reasonable
        if (bbtyp .eq. 3.and.ia .eq. 8.and.ja .eq. 6) bstrength = gen%bstren(3)*0.90d0 !
!           modify locally for triple bonds
        if (bbtyp .eq. 3.and.(hyb(ii) .eq. 0.or.hyb(jj) .eq. 0)) bbtyp = 1 ! sp-sp3
        if (bbtyp .eq. 3.and.(hyb(ii) .eq. 3.or.hyb(jj) .eq. 3)) bbtyp = 1 ! sp-sp3
        if (bbtyp .eq. 3.and.(hyb(ii) .eq. 2.or.hyb(jj) .eq. 2)) bbtyp = 2 ! sp-sp2
!           Pi stuff
        if (pibo(i) .gt. 0) then
          shift = gen%hueckelp*(gen%bzref-pibo(i)) ! ref value = no correction is benzene, P=2/3
          if (bbtyp .ne. 3.and.pibo(i) .gt. 0.1) then
            btyp(i) = 2
            bbtyp = 2
          end if
          fpi = 1.0d0-gen%hueckelp2*(gen%bzref2-pibo(i)) ! deepness
        end if
        if (ia .gt. 10.and.ja .gt. 10) then
          fcn = fcn/(1.0d0+0.007*dble(topo%nb(20,ii))**2)
          fcn = fcn/(1.0d0+0.007*dble(topo%nb(20,jj))**2)
        end if
        qafac = topo%qa(ii)*topo%qa(jj)*70.0d0
        fqq = 1.0d0+gen%qfacbm0*exp(-15.d0*qafac)/(1.0d0+exp(-15.d0*qafac))
! metal involed
      else
        shift = 0
        bstrength = gen%bstren(bbtyp)
        if (bbtyp .eq. 7) then ! TM-TM
          if (itabrow6(ia) .gt. 4.and.itabrow6(ja) .gt. 4) bstrength = gen%bstren(8) ! 4/5d-4/5d
          if (itabrow6(ia) .eq. 4.and.itabrow6(ja) .gt. 4) bstrength = gen%bstren(9) ! 3d-4/5d
          if (itabrow6(ja) .eq. 4.and.itabrow6(ia) .gt. 4) bstrength = gen%bstren(9) ! 3d-4/5d
          dum = 2.0d0*mchar(ii)+2.0d0*mchar(jj)
          dum = min(dum,0.5d0)  ! limit the "metallic" correction
          bstrength = bstrength*(1.0d0-dum)
        end if
        mtyp1 = 0  ! no metal
        mtyp2 = 0
        if (param%group(ia) .eq. 1) mtyp1 = 1  ! Li...
        if (param%group(ia) .eq. 2) mtyp1 = 2  ! Be...
        if (param%group(ia) .gt. 2.and.imetal(ii) .eq. 1) mtyp1 = 3  ! main group
        if (imetal(ii) .eq. 2) mtyp1 = 4  ! TM
        if (param%group(ja) .eq. 1) mtyp2 = 1  ! Li...
        if (param%group(ja) .eq. 2) mtyp2 = 2  ! Be...
        if (param%group(ja) .gt. 2.and.imetal(jj) .eq. 1) mtyp2 = 3  ! main group
        if (imetal(jj) .eq. 2) mtyp2 = 4  ! TM
        qafac = topo%qa(ii)*topo%qa(jj)*25.0d0
        dum = exp(-15.d0*qafac)/(1.0d0+exp(-15.d0*qafac))
        fqq = 1.0d0+dum*(gen%qfacbm(mtyp1)+gen%qfacbm(mtyp2))*0.5   ! metal charge corr.
        if (imetal(ii) .eq. 2.and.ja .gt. 10) fheavy = 0.65d0 ! heavy gen. ligand
        if (imetal(jj) .eq. 2.and.ia .gt. 10) fheavy = 0.65d0
        if (imetal(ii) .eq. 2.and.ja .eq. 15) fheavy = 1.60d0 ! P ligand
        if (imetal(jj) .eq. 2.and.ia .eq. 15) fheavy = 1.60d0
        if (imetal(ii) .eq. 2.and.param%group(ja) .eq. 6) fheavy = 0.85d0 ! chalcogen ligand
        if (imetal(jj) .eq. 2.and.param%group(ia) .eq. 6) fheavy = 0.85d0
        if (imetal(ii) .eq. 2.and.param%group(ja) .eq. 7) fheavy = 1.30d0 ! halogen ligand
        if (imetal(jj) .eq. 2.and.param%group(ia) .eq. 7) fheavy = 1.30d0
        if (imetal(ii) .eq. 2.and.ja .eq. 1.and.itabrow6(ia) .le. 5) fxh = 0.80d0 ! hydrogen 3d/4d
        if (imetal(jj) .eq. 2.and.ia .eq. 1.and.itabrow6(ja) .le. 5) fxh = 0.80d0 ! hydrogen 3d/4d
        if (imetal(ii) .eq. 2.and.ja .eq. 1.and.itabrow6(ia) .gt. 5) fxh = 1.00d0 ! hydrogen 5d
        if (imetal(jj) .eq. 2.and.ia .eq. 1.and.itabrow6(ja) .gt. 5) fxh = 1.00d0 ! hydrogen 5d
        if (imetal(ii) .eq. 1.and.ja .eq. 1) fxh = 1.20d0
        if (imetal(jj) .eq. 1.and.ia .eq. 1) fxh = 1.20d0
        if (imetal(jj) .eq. 2.and.hyb(ii) .eq. 1) then !CO/CN/NC...
          if (ia .eq. 6) then
            fpi = 1.5d0
            shift = -0.45d0
          end if
          if (ia .eq. 7.and.topo%nb(20,ii) .ne. 1) then
            fpi = 0.4d0
            shift = 0.47d0
          end if
        end if
        if (imetal(ii) .eq. 2.and.hyb(jj) .eq. 1) then !CO/CN/NC...
          if (ja .eq. 6) then
            fpi = 1.5d0
            shift = -0.45d0
          end if
          if (ja .eq. 7.and.topo%nb(20,jj) .ne. 1) then
            fpi = 0.4d0
            shift = 0.47d0
          end if
        end if
        if (imetal(ii) .eq. 2) shift = shift+gen%metal2_shift   ! metal shift TM
        if (imetal(jj) .eq. 2) shift = shift+gen%metal2_shift   !
        if (imetal(ii) .eq. 1.and.param%group(ia) .le. 2) shift = shift+gen%metal1_shift   ! metal shift group 1+2
        if (imetal(jj) .eq. 1.and.param%group(ja) .le. 2) shift = shift+gen%metal1_shift   !
        if (mtyp1 .eq. 3) shift = shift+gen%metal3_shift   ! metal shift MG
        if (mtyp2 .eq. 3) shift = shift+gen%metal3_shift   !
        if (bbtyp .eq. 6.and.param%metal(ia) .eq. 2) shift = shift+gen%eta_shift*topo%nb(20,ii)! eta coordinated
        if (bbtyp .eq. 6.and.param%metal(ja) .eq. 2) shift = shift+gen%eta_shift*topo%nb(20,jj)! eta coordinated
        if (mtyp1 .gt. 0.and.mtyp1 .lt. 3) fcn = fcn/(1.0d0+0.100*dble(topo%nb(20,ii))**2)
        if (mtyp2 .gt. 0.and.mtyp2 .lt. 3) fcn = fcn/(1.0d0+0.100*dble(topo%nb(20,jj))**2)
        if (mtyp1 .eq. 3) fcn = fcn/(1.0d0+0.030*dble(topo%nb(20,ii))**2)
        if (mtyp2 .eq. 3) fcn = fcn/(1.0d0+0.030*dble(topo%nb(20,jj))**2)
        if (mtyp1 .eq. 4) fcn = fcn/(1.0d0+0.036*dble(topo%nb(20,ii))**2)
        if (mtyp2 .eq. 4) fcn = fcn/(1.0d0+0.036*dble(topo%nb(20,jj))**2)
        if (mtyp1 .eq. 4.or.mtyp2 .eq. 4) then
          fsrb2 = -gen%srb2*0.22! weaker, inverse EN dep. for TM metals
        else
          fsrb2 = gen%srb2*0.28! "normal" for other metals
        end if
      end if

      if (ia .gt. 10.and.ja .gt. 10) then  ! both atoms are heavy
        shift = shift+gen%hshift3
        if (ia .gt. 18) shift = shift+gen%hshift4
        if (ja .gt. 18) shift = shift+gen%hshift4
        if (ia .gt. 36) shift = shift+gen%hshift5
        if (ja .gt. 36) shift = shift+gen%hshift5
      end if

! shift
      topo%vbond(1,i) = gen%rabshift+shift   ! value for all bonds + special part

! RINGS prefactor
      if (rings .gt. 0) ringf = 1.0d0+gen%fringbo*(6.0d0-dble(rings))**2  ! max ring size is 6

! steepness
      topo%vbond(2,i) = gen%srb1*(1.0d0+fsrb2*(param%en(ia)-param%en(ja))**2+gen%srb3*bstrength)

! tot prefactor        atoms              spec     typ       qterm    heavy-M  pi   XH(3ring,OH...) CN for M
      topo%vbond(3,i) = -param%bond(ia)*param%bond(ja)*ringf*bstrength*fqq*fheavy*fpi*fxh*fcn
!        write(myunit,*) bond(ia),bond(ja),ringf,bstrength,fqq,fheavy,fpi,fxh

! output
      r0 = (rtmp(ij)+topo%vbond(1,i))*0.529167
      if (pr2) write (myunit,'(2a3,2i5,2x,2i5,2x,6f8.3)') &
  &   pse(at(ii)),pse(at(jj)),ii,jj,bbtyp,rings,0.529167*rab(ij),r0,pibo(i),fqq,topo%vbond(3,i),topo%vbond(2,i)
    end do

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!     scale FC if bond is part of hydrogen bridge
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!      do i=1,topo%nbond
!         ii=topo%blist(1,i)
!         jj=topo%blist(2,i)
!         ia=at(ii)
!         ja=at(jj)
!         do j=1,topo%nathbAB
!            hbA=topo%hbatABl(2,j)
!            !O-H case:
!            if (ia.eq.8.and.ja.eq.1.or.ia.eq.1.and.ja.eq.8) then
!               if (ii.eq.hbA.or.jj.eq.hbA) then
!                  topo%vbond(2,i) = topo%vbond(2,i) * 1.00
!                  !topo%vbond(1,i) = topo%vbond(1,i) * 1.00
!               end if
!            !N-H case
!          else if (ia.eq.7.and.ja.eq.1.or.ia.eq.1.and.ja.eq.7) then
!               if (ii.eq.hbA.or.jj.eq.hbA) then
!                  topo%vbond(2,i) = topo%vbond(2,i) * 1.00
!                  !topo%vbond(1,i) = topo%vbond(1,i) * 1.00
!               end if
!            end if
!         end do
!      end do

    deallocate (rtmp)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!     scale FC if bond is part of hydrogen bridge
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    !Set up fix hblist just like for the HB term
    call bond_hbset0(nat,at,xyz,sqrab,bond_hbn,topo,hbthr1,hbthr2)
    allocate (bond_hbl(3,bond_hbn))
    allocate (topo%nr_hb(topo%nbond),source=0)
    call bond_hbset(nat,at,xyz,sqrab,bond_hbn,bond_hbl,topo,hbthr1,hbthr2)

    !Set up AH, B and nr. of B list
    call bond_hb_AHB_set0(nat,at,topo%nbond,bond_hbn,bond_hbl,AHB_nr,topo)
    allocate (lin_AHB(0:AHB_nr),source=0)
    call bond_hb_AHB_set1(nat,at,topo%nbond,bond_hbn,bond_hbl,AHB_nr,lin_AHB,topo%bond_hb_nr,topo%b_max,topo)
    allocate (topo%bond_hb_AH(2,topo%bond_hb_nr),source=0)
    allocate (topo%bond_hb_B(topo%b_max,topo%bond_hb_nr),source=0)
    allocate (topo%bond_hb_Bn(topo%bond_hb_nr),source=0)
    call bond_hb_AHB_set(nat,at,topo%nbond,bond_hbn,bond_hbl,AHB_nr,lin_AHB,topo)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!               bend
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    topo%nangl = 0
    do i = 1,nat
      nn = topo%nb(20,i)                 ! take full set to include M-X-Y
      if (nn .le. 1) cycle
      if (topo%nb(20,i) .gt. 6) cycle     ! no highly coordinated atom
      ati = at(i)
      do j = 1,nn
        do k = 1,j-1
          jj = topo%nb(j,i)
          kk = topo%nb(k,i)
          atj = at(jj)
          atk = at(kk)
          fijk = param%angl(ati)*param%angl2(atj)*param%angl2(atk)
          if (fijk .lt. gen%fcthr) cycle     ! too small
          topo%nangl = topo%nangl+1
        end do
      end do
    end do

    if (pr) write (myunit,'(1x,"#angl    :",3x,i0)') topo%nangl
    if (pr2) then
      write (myunit,*)
      write (myunit,*) 'angle atoms        phi0    phi      FC  pi rings'
    end if

    topo%nangl_alloc = topo%nangl
    allocate (topo%alist(3,topo%nangl),source=0)
    allocate (topo%vangl(2,topo%nangl),source=0.0d0)
    topo%nangl = 0
    do i = 1,nat
      nn = topo%nb(20,i)
      if (nn .le. 1) cycle
      if (topo%nb(20,i) .gt. 6) cycle
      ii = i
      ati = at(i)
      do j = 1,nn
        do k = 1,j-1
          jj = topo%nb(j,i)
          kk = topo%nb(k,i)
          atj = at(jj)
          atk = at(kk)
          fijk = param%angl(ati)*param%angl2(atj)*param%angl2(atk)
          if (fijk .lt. gen%fcthr) cycle     ! too small
          call bangl(xyz,jj,i,kk,phi)
          if (param%metal(ati) .gt. 0.and.phi*180./pi .lt. 60.) cycle ! skip eta cases even if CN < 6 (e.g. CaCp+)
          feta = 1.0d0
          if (imetal(ii) .eq. 2.and.itag(jj) .eq. -1.and.piadr(jj) .gt. 0) feta = 0.3d0       ! eta coord.
          if (imetal(ii) .eq. 2.and.itag(kk) .eq. -1.and.piadr(kk) .gt. 0) feta = feta*0.3d0  !
          nh = 0
          if (atj .eq. 1) nh = nh+1
          if (atk .eq. 1) nh = nh+1
          nnn = 0
          if (atj .eq. 7) nnn = nnn+1
          if (atk .eq. 7) nnn = nnn+1
          no = 0
          if (atj .eq. 8) no = no+1
          if (atk .eq. 8) no = no+1
          nheav = 0
          if (atj .gt. 14) nheav = nheav+1
          if (atk .gt. 14) nheav = nheav+1
          nsi = 0
          if (atj .eq. 14) nsi = nsi+1
          if (atk .eq. 14) nsi = nsi+1
          nc = 0
          if (atj .eq. 6) nc = nc+1
          if (atk .eq. 6) nc = nc+1
          nmet = 0
          if (param%metal(atj) .ne. 0) nmet = nmet+1
          if (param%metal(atk) .ne. 0) nmet = nmet+1
          npi = 0
          if (piadr(jj) .ne. 0) npi = npi+1
          if (piadr(kk) .ne. 0) npi = npi+1
          topo%nangl = topo%nangl+1
          topo%alist(1,topo%nangl) = ii
          topo%alist(2,topo%nangl) = jj
          topo%alist(3,topo%nangl) = kk
          call ringsbend(nat,ii,jj,kk,cring,sring,rings)
          triple = (hyb(ii) .eq. 1.or.hyb(jj) .eq. 1).or. &
&                (hyb(ii) .eq. 1.or.hyb(kk) .eq. 1)
          if (imetal(ii) .eq. 0.and.imetal(jj) .eq. 0.and.imetal(kk) .eq. 0) then
            fqq = 1.0d0-(topo%qa(ii)*topo%qa(jj)+topo%qa(ii)*topo%qa(kk))*gen%qfacBEN      ! weaken it
          else
            fqq = 1.0d0-(topo%qa(ii)*topo%qa(jj)+topo%qa(ii)*topo%qa(kk))*gen%qfacBEN*2.5
          end if
          f2 = 1.0d0
          fn = 1.0d0

!-------------------------
! definitions come here
!-------------------------

!!!!!!!!!!
! DEFAULT
!!!!!!!!!!
          r0 = 100.0

          if (hyb(i) .eq. 1) r0 = 180.
          if (hyb(i) .eq. 2) r0 = 120.
          if (hyb(i) .eq. 3) r0 = 109.5
          if (hyb(i) .eq. 3.and.at(i) .gt. 10) then
            if (nn .le. 3) r0 = gen%aheavy3    ! heavy maingroup three coordinated
            if (nn .ge. 4) r0 = gen%aheavy4    ! heavy maingroup four  coordinated
            if (nn .eq. 4.and.param%group(ati) .eq. 5) r0 = 109.5      ! four coordinated group 5
            if (nn .eq. 4.and.param%group(ati) .eq. 4.and.ati .gt. 49) r0 = 109.5      ! four coordinated Sn, Pb
            if (param%group(ati) .eq. 4) r0 = r0-nh*5.   ! smaller angles for XHn Si...
            if (param%group(ati) .eq. 5) r0 = r0-nh*5.   ! smaller angles for XHn P..
            if (param%group(ati) .eq. 6) r0 = r0-nh*5.   ! smaller angles for XHn S..
          end if
          if (hyb(i) .eq. 5) then
            r0 = 90.
            f2 = 0.11       ! not very important
            if (phi*180./pi .gt. gen%linthr) r0 = 180.       ! hypervalent coordination can be linear GEODEP
          end if
!!!!!!!!!!
! B
!!!!!!!!!!
          if (ati .eq. 5) then
            if (hyb(i) .eq. 3) r0 = 115.
            if (hyb(i) .eq. 2) r0 = 115.
          end if
!!!!!!!!!!
! C cases
!!!!!!!!!!
          if (ati .eq. 6) then
            if (hyb(i) .eq. 3.and.nh .eq. 2) r0 = 108.6  ! CHH
            if (hyb(i) .eq. 3.and.no .eq. 1) r0 = 108.5  ! COR
            if (hyb(i) .eq. 2.and.no .eq. 2) r0 = 122.   ! COO
            if (hyb(i) .eq. 2.and.no .eq. 1) f2 = 0.7    ! C=O
            if (hyb(i) .eq. 1.and.no .eq. 2) then
              triple = .false.   ! CO2
              f2 = 2.0
            end if
            if (hyb(i) .eq. 3.and.nn .gt. 4) then
              if (phi*180./pi .gt. gen%linthr) r0 = 180.       ! hypervalent coordination can be linear GEODEP
            end if
          end if
!!!!!!!!!!
! O cases
!!!!!!!!!!
          if (ati .eq. 8.and.nn .eq. 2) then
            r0 = 104.5
!                   H2O
            if (nh .eq. 2) then
              r0 = 100. ! compensate ES of the Hs
              f2 = 1.20 ! H2O is better with 1.2-1.3 but H2O in fit behaves differently
            end if
            r0 = r0+7.*nsi   ! O angles widen with Si attached
            r0 = r0+14.*nmet  ! O angles widen with M attached
            if (npi .eq. 2) then
              r0 = 109. ! e.g. Ph-O-Ph
            end if
            if (nmet .gt. 0.and.phi*180./pi .gt. gen%linthr) then
              r0 = 180. ! metal coordination can be linear GEODEP
              f2 = 0.3
            end if
          end if
!!!!!!!!!!
! N cases
!!!!!!!!!!
          if (ati .eq. 7.and.nn .eq. 2) then
            f2 = 1.4
            r0 = 115.
            if (rings .ne. 0) r0 = 105.
            if (at(kk) .eq. 8.or.at(jj) .eq. 8) r0 = 103.
            if (at(kk) .eq. 9.or.at(jj) .eq. 9) r0 = 102.
            if (hyb(i) .eq. 1) r0 = 180.   ! NC or NNN
            if (imetal(jj) .eq. 2.and.hyb(i) .eq. 1.and.at(kk) .eq. 7) r0 = 135.   ! NN on M
            if (imetal(kk) .eq. 2.and.hyb(i) .eq. 1.and.at(jj) .eq. 7) r0 = 135.   ! NN on M
          end if
! NR3
          if (ati .eq. 7.and.hyb(i) .eq. 3) then
!                 in pi system
            if (npi .gt. 0) then
              if (amide(nat,at,hyb,topo%nb,piadr,i)) then
                r0 = 115.
                f2 = 1.2d0
              else
                sumppi = pbo(lin(ii,jj))+pbo(lin(ii,kk))
                r0 = 113.
                f2 = 1.d0-sumppi*0.7d0 ! must be -!
              end if
            else
              r0 = 104. ! sat. pyr. N, steep around 106
              f2 = 0.40 ! 1.0 is better for NH3
              f2 = f2+nh*0.19
              f2 = f2+no*0.25
              f2 = f2+nc*0.01
            end if
          end if
!!!!!!!!!!
! RING < 5
!!!!!!!!!!
          if (rings .eq. 3) r0 = 82. ! 60 gives too little strain
          if (rings .eq. 4) r0 = 96.
          if (rings .eq. 5.and.ati .eq. 6) r0 = 109.
!!!!!!!!!!
! specials
!!!!!!!!!!
! R-X in 3-rings e.g. cyclopropene
          if (rings .eq. 0) then
            call ringsatom(nat,i,cring,sring,idum)
            if (idum .eq. 3) then
              call ringsatom(nat,jj,cring,sring,ringsj)
              call ringsatom(nat,kk,cring,sring,ringsk)
              if (ringsj+ringsk .eq. 102) r0 = r0+4.d0
            end if
          end if

! triple bonds
          if (triple) then
            f2 = 0.60d0  ! complex 7 in S30L makes artificial torsions if this is 0.4 which is
            ! slightly better for the phenylmethylethyne bending pot.
            if (atj .eq. 7.or.atk .eq. 7) f2 = 1.00d0
            if ((imetal(jj) .eq. 2.or.imetal(kk) .eq. 2).and.phi*180./pi .gt. gen%linthr) then
              if (ati .eq. 6.and.atj .eq. 6) f2 = 3.   ! M-CC
              if (ati .eq. 6.and.atk .eq. 6) f2 = 3.   ! M-CC
              if (ati .eq. 6.and.atj .eq. 7) f2 = 3.   ! M-CN
              if (ati .eq. 6.and.atk .eq. 7) f2 = 3.   ! M-CN
              if (ati .eq. 6.and.param%group(atj) .eq. 6) f2 = 14.  ! M-CO or CS
              if (ati .eq. 6.and.param%group(atk) .eq. 6) f2 = 14.  ! M-CO or CS
              if (ati .eq. 7.and.atj .eq. 7) f2 = 10.  ! M-NN
              if (ati .eq. 7.and.atj .eq. 6) f2 = 10.  ! M-NC
              if (ati .eq. 7.and.atk .eq. 6) f2 = 10.  ! M-NC
              if (ati .eq. 7.and.atj .eq. 8) then; r0 = 180.; f2 = 12.; end if  ! M-NO
              if (ati .eq. 7.and.atk .eq. 8) then; r0 = 180.; f2 = 12.; end if  ! M-NO
            end if
          end if
! carbene analogous
          if (param%group(ati) .eq. 4.and.nn .eq. 2.and.itag(i) .eq. 1) then
            if (ati .eq. 6) r0 = 145.
            if (ati .gt. 6) r0 = 90.
          end if
! SO3X
          if (param%group(ati) .eq. 6.and.nn .eq. 4.and.no .ge. 1) r0 = 115.
! halogens CN=2
          if (param%group(ati) .eq. 7.and.hyb(i) .eq. 1) then
            if (ati .eq. 9) r0 = 90.
            if (ati .eq. 17) r0 = 90.
            if (ati .eq. 35) r0 = 90.
            if (ati .eq. 53) r0 = 90.
            if (ati .gt. 9.and.phi*180./pi .gt. gen%linthr) r0 = 180. ! change to linear if linear coordinated, GEODEP
            f2 = 0.6/dble(ati)**0.15
          end if
! PB or Sn can be pyramidal
          if (hyb(i) .eq. 3.and.param%group(ati) .eq. 4.and.ati .gt. 32.and.topo%qa(i) .gt. 0.4) then
            if (phi*180./pi .gt. 140.) then
              r0 = 180. ! change to linear
            end if
            if (phi*180./pi .lt. 100.) then
              r0 = 90.
            end if
            f2 = 1.0
          end if
! METAL
          if (imetal(ii) .gt. 0) then
            if (hyb(i) .eq. 0) then
              r0 = 90.
              f2 = 1.35  ! important difference to other bends, big effect 1.15,1.25,1.35
            end if
            if (hyb(i) .eq. 1) r0 = 180.
            if (hyb(i) .eq. 2) r0 = 120.
            if (hyb(i) .eq. 3) r0 = 109.5
            if (phi*180./pi .gt. gen%linthr) r0 = 180. ! change to linear
          end if

          fn = 1.0d0-2.36d0/dble(nn)**2

!----------------------
! end of definitions
!----------------------
          topo%vangl(1,topo%nangl) = r0*pi/180.
          fbsmall = (1.0d0-gen%fbs1*exp(-0.64*(topo%vangl(1,topo%nangl)-pi)**2))

!                          central*neigbor charge spec. met.  small angle corr.
          topo%vangl(2,topo%nangl) = fijk*fqq*f2*fn*fbsmall*feta
!              write(myunit,*) param%angl(ati),param%angl2(atj),param%angl2(atk), param%angl(ati)*param%angl2(atj)*param%angl2(atk), fqq,f2,fn,fbsmall
          if (pr2) write (myunit,'(3i5,2x,3f8.3,l2,i4)') ii,jj,kk,r0,phi*180./pi,topo%vangl(2,topo%nangl),picon,rings
        end do
      end do
    end do

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!              torsion
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    topo%ntors = sum(piadr)+nat
    do m = 1,topo%nbond
      ii = topo%blist(1,m)
      jj = topo%blist(2,m)
      if (btyp(m) .eq. 3.or.btyp(m) .eq. 6) cycle ! no sp-sp or metal eta
      if (param%tors(at(ii)) .lt. 0.or.param%tors(at(jj)) .lt. 0) cycle ! no negative values
      if (param%tors(at(ii))*param%tors(at(jj)) .lt. 1.d-3) cycle ! no small values
      if (param%metal(at(ii)) .gt. 1.and.topo%nb(20,ii) .gt. 4) cycle ! no HC metals
      if (param%metal(at(jj)) .gt. 1.and.topo%nb(20,jj) .gt. 4) cycle !
      topo%ntors = topo%ntors+topo%nb(20,ii)*topo%nb(20,jj)*2 ! upper limit
    end do
    maxtors = topo%ntors
    if (pr2) write (myunit,*) 'torsion atoms        nrot   rings    phi0    phi      FC'

    topo%ntors_alloc = topo%ntors
    allocate (topo%tlist(5,topo%ntors),source=0)
    allocate (topo%vtors(2,topo%ntors),source=0.0d0)
    topo%ntors = 0
    do m = 1,topo%nbond
      ii = topo%blist(1,m)
      jj = topo%blist(2,m)
      if (btyp(m) .eq. 3.or.btyp(m) .eq. 6) cycle    ! metal eta or triple
      fij = param%tors(at(ii))*param%tors(at(jj))             ! atom contribution, central bond
      if (fij .lt. gen%fcthr) cycle
      if (param%tors(at(ii)) .lt. 0.or.param%tors(at(jj)) .lt. 0) cycle ! no negative values
      if (param%metal(at(ii)) .gt. 1.and.topo%nb(20,ii) .gt. 4) cycle ! no HC metals
      if (param%metal(at(jj)) .gt. 1.and.topo%nb(20,jj) .gt. 4) cycle !
      fqq = 1.0d0+abs(topo%qa(ii)*topo%qa(jj))*gen%qfacTOR      ! weaken it for e.g. CF-CF and similar
      call ringsbond(nat,ii,jj,cring,sring,rings) ! i and j in same ring
      lring = .false.
      ccij = .false.
      if (rings .gt. 0) lring = .true.
      sp3ij = hyb(ii) .eq. 3.and.hyb(jj) .eq. 3
      if (at(ii) .eq. 6.and.at(jj) .eq. 6) ccij = .true.
      nhi = 1
      nhj = 1
      do ineig = 1,topo%nb(20,ii)
        if (at(topo%nb(ineig,ii)) .eq. 1) nhi = nhi+1
      end do
      do jneig = 1,topo%nb(20,jj)
        if (at(topo%nb(jneig,jj)) .eq. 1) nhj = nhj+1
      end do
      fij = fij*(dble(nhi)*dble(nhj))**0.07 ! n H term
      ! amides and alpha carbons in peptides/proteins
      if (alphaCO(nat,at,hyb,topo%nb,piadr,ii,jj)) fij = fij*1.3d0
      if (amide(nat,at,hyb,topo%nb,piadr,ii).and.hyb(jj) .eq. 3.and.at(jj) .eq. 6) fij = fij*1.3d0
      if (amide(nat,at,hyb,topo%nb,piadr,jj).and.hyb(ii) .eq. 3.and.at(ii) .eq. 6) fij = fij*1.3d0
      ! hypervalent
      if (btyp(m) .eq. 4) fij = fij*0.2d0
!        loop over neighbors of ij
      do ineig = 1,topo%nb(20,ii)
        kk = topo%nb(ineig,ii)
        if (kk .eq. jj) cycle
        do jneig = 1,topo%nb(20,jj)
          ll = topo%nb(jneig,jj)
          if (ll .eq. ii) cycle
          if (ll .eq. kk) cycle
          if (chktors(nat,xyz,ii,jj,kk,ll)) cycle  ! near 180
          fkl = param%tors2(at(kk))*param%tors2(at(ll))       ! outer kl term
          if (at(kk) .eq. 7.and.piadr(kk) .eq. 0) fkl = param%tors2(at(kk))*param%tors2(at(ll))*0.5
          if (at(ll) .eq. 7.and.piadr(ll) .eq. 0) fkl = param%tors2(at(kk))*param%tors2(at(ll))*0.5
          if (fkl .lt. gen%fcthr) cycle
          if (param%tors(at(kk)) .lt. 0.or.param%tors(at(ll)) .lt. 0) cycle ! no negative values
          f1 = gen%torsf(1)
          f2 = 0.0d0
          fkl = fkl*(dble(topo%nb(20,kk))*dble(topo%nb(20,ll)))**(-0.14)  ! CN term

!-----------------------
! definitions come here
!-----------------------
          if (lring) then
            if (rings .gt. 3) then
              call ringstors(nat,ii,jj,kk,ll,cring,sring,rings4) ! smallest ring in which i,j,k,l are
            else
              rings4 = 3 ! the 3-ring is special
            end if
! RING CASE
            nrot = 1
            if (btyp(m) .eq. 2) nrot = 2 ! max at 90 for pi and symmetric at 0,-180,180
            phi = 0  ! cis
            if (btyp(m) .eq. 1.and.rings4 .gt. 0) then
              call ringstorl(nat,ii,jj,kk,ll,cring,sring,ringl)  ! largest ring in which i,j,k,l are
              notpicon = piadr(kk) .eq. 0.and.piadr(ll) .eq. 0                      ! do it only for sat. rings
              if (rings4 .eq. 3.and.notpicon) then; nrot = 1; phi = 0.d0; f1 = gen%fr3; end if
              if (rings4 .eq. 4.and.ringl .eq. rings4.and.notpicon) then; nrot = 6; phi = 30.d0; f1 = gen%fr4; end if
              if (rings4 .eq. 5.and.ringl .eq. rings4.and.notpicon) then; nrot = 6; phi = 30.d0; f1 = gen%fr5; end if
              if (rings4 .eq. 6.and.ringl .eq. rings4.and.notpicon) then; nrot = 3; phi = 60.d0; f1 = gen%fr6; end if
            end if
            if (rings4 .eq. 0.and.btyp(m) .eq. 1.and. &
                topo%nb(20,kk) .eq. 1.and.topo%nb(20,ll) .eq. 1) then; nrot = 6; phi = 30.d0; f1 = 0.30; end if
            if (btyp(m) .eq. 2.and.rings .eq. 5.and.at(ii)*at(jj) .eq. 42) then
              if (amide(nat,at,hyb,topo%nb,piadr,ii).or.amide(nat,at,hyb,topo%nb,piadr,jj)) f1 = 5.  ! improving CB7
            end if
          else
! ACYCLIC
            phi = 180.d0 ! trans
            nrot = 1
            if (hyb(ii) .eq. 3.and.hyb(jj) .eq. 3) nrot = 3 ! Me case
            if (btyp(m) .eq. 2) nrot = 2 ! max at 90 for pi and symmetric at 0,-180,180
            if (piadr(ii) .gt. 0.and.(piadr(jj) .eq. 0.and.hyb(jj) .eq. 3)) then  ! pi-sp3
              f1 = 0.5d0
              if (at(ii) .eq. 7) f1 = 0.2d0 ! important for CB7 conf.
              phi = 180.d0
              nrot = 3
            end if
            if (piadr(jj) .gt. 0.and.(piadr(ii) .eq. 0.and.hyb(ii) .eq. 3)) then
              f1 = 0.5d0
              if (at(jj) .eq. 7) f1 = 0.2d0 ! important for CB7 conf.
              phi = 180.d0
              nrot = 3
            end if
          end if
! SP3 specials
          if (hyb(ii) .eq. 3.and.hyb(jj) .eq. 3) then
! N-N, P-P ...
            if (param%group(at(ii)) .eq. 5.and.param%group(at(jj)) .eq. 5) then
              nrot = 3
              phi = 60.d0
              f1 = 3.0d0
            end if
! 5-6
            if ((param%group(at(ii)) .eq. 5.and.param%group(at(jj)) .eq. 6).or. &
  &            (param%group(at(ii)) .eq. 6.and.param%group(at(jj)) .eq. 5)) then
              nrot = 2
              phi = 90.d0
              f1 = 1.0d0
              if (at(ii) .ge. 15.and.at(jj) .ge. 15) f1 = 20.0d0
            end if
! O-O, S-S ...
            if (param%group(at(ii)) .eq. 6.and.param%group(at(jj)) .eq. 6) then
              nrot = 2
              phi = 90.d0
              f1 = 5.0d0
              if (at(ii) .ge. 16.and.at(jj) .ge. 16) f1 = 25.0d0 ! better for h2s2
            end if
          end if
! pi system
          if (pibo(m) .gt. 0) then
            f2 = pibo(m)*exp(-2.5d0*(1.24d0-pibo(m))**14)  ! decrease to very small values for P < 0.3
            ! values of 2.5 instead of 2.4 give larger tangles
            ! the parameter 1.24 is very sensitive ie 1.25 yield 5 deg more in 1,3cB
            if (piadr(kk) .eq. 0.and.at(kk) .gt. 10) f2 = f2*1.3! the pi BO becomes more significant if heavies are attached
            if (piadr(ll) .eq. 0.and.at(ll) .gt. 10) f2 = f2*1.3
            f1 = f1*0.55
          end if

          if (hyb(kk) .eq. 5.or.hyb(ll) .eq. 5) fkl = fkl*1.5 ! hypervalent corr.
!--------------------
! end of definitions
!-------------------

! total FC            sigma       pi             charge central outer kl
          fctot = (f1+10.d0*gen%torsf(2)*f2)*fqq*fij*fkl

          if (fctot .gt. gen%fcthr) then ! avoid tiny potentials
            topo%ntors = topo%ntors+1
            if (topo%ntors .gt. maxtors) then
              if (pr) write(myunit,'("internal (torsion setup) error ",a)')source  
              io = 1 
              return
            end if
            topo%tlist(1,topo%ntors) = ll
            topo%tlist(2,topo%ntors) = ii
            topo%tlist(3,topo%ntors) = jj
            topo%tlist(4,topo%ntors) = kk
            topo%tlist(5,topo%ntors) = nrot
            topo%vtors(1,topo%ntors) = phi*pi/180.0d0
            topo%vtors(2,topo%ntors) = fctot
!                 printout
            phi = valijklff(nat,xyz,ll,ii,jj,kk)
            if (pr2) write (myunit,'(4i5,2x,i2,5x,i2,4x,3f8.3)') &
&            ii,jj,kk,ll,topo%tlist(5,topo%ntors),rings,topo%vtors(1,topo%ntors)*180./pi,phi*180./pi,topo%vtors(2,topo%ntors)
          end if

! extra rot=1 torsion potential for sp3-sp3 to get gauche conf energies well
          sp3kl = hyb(kk) .eq. 3.and.hyb(ll) .eq. 3
          if (sp3kl.and.sp3ij.and.(.not.lring).and.btyp(m) .lt. 5) then
            topo%ntors = topo%ntors+1
            if (topo%ntors .gt. maxtors) then
              if(pr) write(myunit,'("internal (torsion setup) error ",a)')source
              io = 1 
              return
            end if
            ff = gen%torsf(6)
            if (at(ii) .eq. 7.or.at(jj) .eq. 7) ff = gen%torsf(7)
            if (at(ii) .eq. 8.or.at(jj) .eq. 8) ff = gen%torsf(8)
            topo%tlist(1,topo%ntors) = ll
            topo%tlist(2,topo%ntors) = ii
            topo%tlist(3,topo%ntors) = jj
            topo%tlist(4,topo%ntors) = kk
            topo%tlist(5,topo%ntors) = 1
            topo%vtors(1,topo%ntors) = pi
            topo%vtors(2,topo%ntors) = ff*fij*fkl*fqq
            if (pr2) write (myunit,'(4i5,2x,i2,5x,i2,4x,3f8.3)') &
&            ii,jj,kk,ll,topo%tlist(5,topo%ntors),rings,topo%vtors(1,topo%ntors)*180./pi,phi*180./pi,topo%vtors(2,topo%ntors)
          end if

        end do ! neighbors ij
      end do
    end do ! bond loop

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! out-of-plane, improper (three-fold coordinated central pi atom i or an N)
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    if (pr2) write (myunit,*) 'out-of-plane atoms          phi0    phi      FC'
    do i = 1,nat
      if (topo%nb(20,i) .ne. 3) cycle
      if (piadr(i) .eq. 0) then
        if (at(i) .ne. 7) cycle
      end if
      topo%ntors = topo%ntors+1
      jj = topo%nb(1,i)
      kk = topo%nb(2,i)
      ll = topo%nb(3,i)
!        sort atoms according to distance to central atom such that the same inversion angle def. always results
      sdum3(1) = rab(lin(i,jj))
      sdum3(2) = rab(lin(i,kk))
      sdum3(3) = rab(lin(i,ll))
      ind3(1) = jj
      ind3(2) = kk
      ind3(3) = ll
      call ssort(3,sdum3,ind3)
      jj = ind3(1)
      kk = ind3(2)
      ll = ind3(3)
      topo%tlist(1,topo%ntors) = i
      topo%tlist(2,topo%ntors) = jj
      topo%tlist(3,topo%ntors) = kk
      topo%tlist(4,topo%ntors) = ll
      if (piadr(i) .eq. 0.and.at(i) .eq. 7) then  ! sat N case
        r0 = 80.0d0
        ff = 0.60d0
        topo%tlist(5,topo%ntors) = -1
        topo%vtors(1,topo%ntors) = r0*pi/180. ! double min at +/- phi0
        topo%vtors(2,topo%ntors) = 0.0d0
        do m = 1,topo%nb(20,i)
          idum = topo%nb(m,i)
          topo%vtors(2,topo%ntors) = topo%vtors(2,topo%ntors)+ff*sqrt(param%repz(at(idum)))  ! NX3 has higher inv barr. than NH3
        end do
      else
        ncarbo = 0
        nf = 0
        do m = 1,topo%nb(20,i)
          idum = topo%nb(m,i)
          if (at(idum) .eq. 8.or.at(idum) .eq. 16) ncarbo = ncarbo+1
          if (param%group(at(idum)) .eq. 7) nf = nf+1
        end do
        fqq = 1.0d0+topo%qa(i)*5.0d0
        topo%tlist(5,topo%ntors) = 0         ! phi0=0 case (pi)
        topo%vtors(1,topo%ntors) = 0.0d0     !  "      "
        sumppi = pbo(lin(i,jj))+pbo(lin(i,kk))+pbo(lin(i,ll))
        f2 = 1.0d0-sumppi*gen%torsf(5)
!> base val  piBO  charge term
        topo%vtors(2,topo%ntors) = gen%torsf(3)*f2*fqq
!> carbonyl corr.
        if (at(i) .eq. 5.and.ncarbo .gt. 0) topo%vtors(2,topo%ntors) = topo%vtors(2,topo%ntors)*38.
        if (at(i) .eq. 6.and.ncarbo .gt. 0) topo%vtors(2,topo%ntors) = topo%vtors(2,topo%ntors)*38.
        if (at(i) .eq. 6.and.nf .gt. 0.and.ncarbo .eq. 0) topo%vtors(2,topo%ntors) = topo%vtors(2,topo%ntors)*10.
        if (at(i) .eq. 7.and.ncarbo .gt. 0) topo%vtors(2,topo%ntors) = topo%vtors(2,topo%ntors)*10./f2 ! no pi dep
      end if
!        printout
      phi = omega(nat,xyz,i,jj,kk,ll)
      if (pr2) write (myunit,'(4i5,7x,3f8.3)') i,jj,kk,ll,topo%vtors(1,topo%ntors)*180./pi,phi*180./pi,topo%vtors(2,topo%ntors)
    end do

    if(pr)then
    write (myunit,'(1x,"#tors    :",3x,i0)') topo%ntors
    write (myunit,'(1x,"#nmol    :",3x,i0)') topo%nfrag
    endif


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! check if triple bonded carbon is present (for torsion term)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      nn=0
      do i=1, nat
        if (at(i).eq.6.and.topo%nb(20,i).eq.2) then
          do j=1, 2
            nbi=topo%nb(j,i)
            if (at(nbi).eq.6.and.topo%nb(20,nbi).eq.2) then
              nn = nn + 1
            endif
          enddo
        endif
      enddo
      if (nn.ne.0) then
        ! fix double counting
        nn = nn/2
        allocate(topo%sTorsl(6, nn), source=0)
        call specialTorsList(nn, nat, at, xyz, topo, hyb, topo%sTorsl)
      endif

!> all done

    topo%maxsystem = 5000
    call fragmentize(nat,at,xyz,topo%maxsystem,500,rab,topo%nb, &
       & topo%ispinsyst,topo%nspinsyst,topo%nsystem)

    if(pr) write (myunit,'(1x,"#optfrag :",3x,i0)') topo%nfrag

    if (pr2) then
      write (myunit,*)
      write (myunit,*) 'GFN-FF setup done.'
      write (myunit,*)
    end if

  end subroutine gfnff_ini

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!> zeta(g_a,gam(ia)*g_c,refq(ii,ia)+iz,q(i)+iz)

!> charge scaling function
    pure elemental function zeta(at,q)
      implicit none
      integer,intent(in) :: at
      real(wp),intent(in) :: q

      real(wp)           :: zeta,qmod
      real(wp),parameter :: zeff(86) = (/ &
      &   1,2,  & ! H-He
      &   3,4,5,6,7,8,9,10,  & ! Li-Ne
      &  11,12,13,14,15,16,17,18,  & ! Na-Ar
      &  19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,  & ! K-Kr
      &   9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,  & ! Rb-Xe
      &   9,10,11,30,31,32,33,34,35,36,37,38,39,40,41,42,43,  & ! Cs-Lu
      &  12,13,14,15,16,17,18,19,20,21,22,23,24,25,26/)  ! Hf-Rn
!! Semiempirical Evaluation of the GlobalHardness of the Atoms of 103
!! Elements of the Periodic Table Using the Most Probable Radii as
!! their Size Descriptors DULAL C. GHOSH, NAZMUL ISLAM 2009 in
!! Wiley InterScience (www.inte"rscience.wiley.com).
!! DOI 10.1002/qua.22202
!! values in the paper multiplied by two because
!! (ii:ii)=(IP-EA)=d^2 E/dN^2 but the hardness
!! definition they use is 1/2d^2 E/dN^2 (in Eh)
      real(wp),parameter :: c(1:86) = (/ &
     &0.47259288_wp,0.92203391_wp,0.17452888_wp,0.25700733_wp,0.33949086_wp,0.42195412_wp, & ! H-C
     &0.50438193_wp,0.58691863_wp,0.66931351_wp,0.75191607_wp,0.17964105_wp,0.22157276_wp, & ! N-Mg
     &0.26348578_wp,0.30539645_wp,0.34734014_wp,0.38924725_wp,0.43115670_wp,0.47308269_wp, & ! Al-Ar
     &0.17105469_wp,0.20276244_wp,0.21007322_wp,0.21739647_wp,0.22471039_wp,0.23201501_wp, & ! Ca-Cr
     &0.23933969_wp,0.24665638_wp,0.25398255_wp,0.26128863_wp,0.26859476_wp,0.27592565_wp, & ! Mn-Zn
     &0.30762999_wp,0.33931580_wp,0.37235985_wp,0.40273549_wp,0.43445776_wp,0.46611708_wp, & ! Ga-Kr
     &0.15585079_wp,0.18649324_wp,0.19356210_wp,0.20063311_wp,0.20770522_wp,0.21477254_wp, & ! Rb-Mo
     &0.22184614_wp,0.22891872_wp,0.23598621_wp,0.24305612_wp,0.25013018_wp,0.25719937_wp, & ! Tc-Cd
     &0.28784780_wp,0.31848673_wp,0.34912431_wp,0.37976593_wp,0.41040808_wp,0.44105777_wp, & ! In-Xe
     &0.05019332_wp,0.06762570_wp,0.08504445_wp,0.10247736_wp,0.11991105_wp,0.13732772_wp, & ! Cs-Nd
     &0.15476297_wp,0.17218265_wp,0.18961288_wp,0.20704760_wp,0.22446752_wp,0.24189645_wp, & ! Pm-Dy
     &0.25932503_wp,0.27676094_wp,0.29418231_wp,0.31159587_wp,0.32902274_wp,0.34592298_wp, & ! Ho-Hf
     &0.36388048_wp,0.38130586_wp,0.39877476_wp,0.41614298_wp,0.43364510_wp,0.45104014_wp, & ! Ta-Pt
     &0.46848986_wp,0.48584550_wp,0.12526730_wp,0.14268677_wp,0.16011615_wp,0.17755889_wp, & ! Au-Po
     &0.19497557_wp,0.21240778_wp/)

      intrinsic :: exp

      qmod = zeff(at)+q
      if (qmod .lt. 0._wp) then
        zeta = exp(3.0d0)
      else
        zeta = exp(3.0d0*(1._wp-exp(c(at)*(1._wp-zeff(at)/qmod))))
      end if

    end function zeta

!========================================================================================!

  integer function iTabRow6(i)
    implicit none
    INTEGER :: i

    iTabRow6 = 0
    If (i .gt. 0.and.i .le. 2) Then
      iTabRow6 = 1
    Else If (i .gt. 2.and.i .le. 10) Then
      iTabRow6 = 2
    Else If (i .gt. 10.and.i .le. 18) Then
      iTabRow6 = 3
    Else If (i .gt. 18.and.i .le. 36) Then
      iTabRow6 = 4
    Else If (i .gt. 36.and.i .le. 54) Then
      iTabRow6 = 5
    Else If (i .gt. 54) Then
      iTabRow6 = 6
    End If

    Return
  end function iTabRow6

!========================================================================================!



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! special treatment for rotation around carbon triple bonds
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! requested for obtaining diphenylacetylene torsion potential
! also applied for e.g. divinylacetylene

! Check for triple bonded carbon (Ci and Cnbi) and setup list for calculating
!  torsion potential using dehidral angle between C1 C2 C3 C4
! C--C1                C--C
!      \              /
!       C2--Ci-Cnbi--C3
!      /             \
! C-- C               C4--C
!
! using C1=ii, C2=jj, C3=kk, C4=ll
subroutine specialTorsList(nst, nat, at, xyz, topo, hyb, sTorsList)
  use gfnff_data_types,only:TGFFTopology 
  integer, intent(in) :: nst
  integer,intent(in) :: nat
  integer,intent(in) :: at(nat)
  real(wp),intent(in) :: xyz(3,nat)
  type(TGFFTopology), intent(in) :: topo
  integer,intent(in) :: hyb(nat)
  integer, intent(inout) :: sTorsList(6, nst)
  integer :: i,j,k,ii,jj,kk,ll,idx,nbi
  logical :: iiok, llok
  idx=0
  do i=1, nat
    ! carbon with two neighbors bonded to other carbon* with two neighbors
    if (at(i).eq.6.and.topo%nb(20,i).eq.2) then
      JLOOP : do j=1, 2
        nbi=topo%nb(j,i)
        if (at(nbi).eq.6.and.topo%nb(20,nbi).eq.2) then  ! *other carbon
          ! check carbon triple bond distance
          if (NORM2(xyz(1:3,i)-xyz(1:3,nbi)).le.2.37) then
            ! at this point we know that i and nbi are carbons bonded through triple bond
            ! check C2 and C3
            jj = 0
            do k=1, 2  ! C2 is other nb of Ci
              if (topo%nb(k,i).ne.nbi.and.at(topo%nb(k,i)).eq.6) then
                jj=topo%nb(k,i)
              endif
            enddo
            kk = 0
            do k=1, 2  ! C3 is other nb of Cnbi
              if (topo%nb(k,nbi).ne.i.and.at(topo%nb(k,nbi)).eq.6) then
                kk=topo%nb(k,nbi)
              endif
            enddo
            if(jj == 0 .or. kk == 0) cycle JLOOP
            ! check C1 through C4 are sp2 carbon
            if (hyb(jj).eq.2.and.hyb(kk).eq.2 &
            &   .and.at(jj).eq.6.and.at(kk).eq.6) then
              iiok=.false.
              llok=.false.
              ! which of the two valid neighbors is picked as C1 depends
              !  on atom sorting in input file !!! The last one in file.
              do k=1, topo%nb(20,jj)
                if (hyb(k).eq.2.and.at(k).eq.6.and.topo%nb(20,k).eq.3.and. &
                   & topo%nb(k,jj).ne.i) then
                  ii=topo%nb(k,jj)
                  iiok=.true.
                endif
              enddo
              ! which of the two valid neighbors is picked as C4 depends
              !  on atom sorting in input file !!! The last one in file.
              do k=1, topo%nb(20,kk)
                if (hyb(k).eq.2.and.at(k).eq.6.and.topo%nb(20,k).eq.3.and. &
                   & topo%nb(k,kk).ne.nbi) then
                  ll=topo%nb(k,kk)
                  llok=.true.
                endif
              enddo
              if (nbi.gt.i.and.iiok.and.llok) then ! to avoid double counting
                idx = idx + 1
                sTorsList(1, idx) = ii  ! C1
                sTorsList(2, idx) = jj  ! C2
                sTorsList(3, idx) = i   ! Ci
                sTorsList(4, idx) = nbi ! Cnbi
                sTorsList(5, idx) = kk  ! C3
                sTorsList(6, idx) = ll  ! C4
              endif
            endif ! C1-C4 are sp2 carbon
          endif  ! CC distance
        endif  ! other carbon
      enddo JLOOP
    endif ! is carbon with nnb=2
  enddo
end subroutine specialTorsList

!========================================================================================!
end module gfnff_ini_mod

!================================================================================!
! This file is part of gfnff.
!
! Copyright (C) 2023 Philipp Pracht
!
! gfnff is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfnff is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfnff. If not, see <https://www.gnu.org/licenses/>.
!==============================================================================!

!> module gfnff_gbsa
!> An interface to GBSA and ALPB calculations for gfnff
!>
!> NOTE: The GBSA for GFN-FF technically does not exist.
!>       We are using the improved ALPB model instead.
module gfnff_gbsa
  use iso_fortran_env,only:wp => real64,stdout => output_unit
#ifdef WITH_GBSA
  use solvation_solv_input, only : TSolvInput
  use solvation_solv_state, only : solutionState
  use solvation_solv_kernel, only : gbKernel
  use solvation_solv_model, only: TSolvModel, init, newBornModel, info
  use solvation_solv_gbsa, only: TBorn
#endif
  implicit none
  private

#ifndef WITH_GBSA
  !> TBorn placeholder if compiled without GBSA support
  type :: TBorn
    integer :: dummy
  end type TBorn
#endif

  public :: TBorn, gfnff_gbsa_init, gfnff_solvation, gfnff_gbsa_print

!========================================================================================!
!========================================================================================!
contains  !> MODULE PROCEDURES START HERE
!========================================================================================!
!========================================================================================!

subroutine gfnff_gbsa_init(nat,at,solv,gbsa)
!> set up the GBSA (i.e., ALPB) parametrization
   implicit none
   !> INPUT
   integer,intent(in)          :: nat      !> number of atoms
   integer,intent(in)          :: at(nat)  !> atom types
   character(len=*),intent(in) :: solv     !> which solvent to use
   !> OUTPUT
   type(TBorn),intent(out)     :: gbsa     !> gbsa type returned 
   !> LOCAL
#ifdef WITH_GBSA
   type(TSolvInput) :: input
   type(TSolvModel) :: model

   input = TSolvInput(solvent=trim(solv), alpb=.true., kernel=gbKernel%p16)
   call init(model, input, 0)
   !call info(model,stdout)
   call newBornModel(model, gbsa, at)
#else
   gbsa%dummy = 0
#endif

   return
end subroutine gfnff_gbsa_init

subroutine gfnff_gbsa_print(gbsa,iunit)
   implicit none
   integer :: iunit
   type(TBorn),intent(in)     :: gbsa     !> gbsa type
#ifdef WITH_GBSA
   call gbsa%info(iunit)
#endif
end subroutine gfnff_gbsa_print

!========================================================================================!

subroutine gfnff_solvation(nat,at,xyz,qat,gbsa,gsolv,gradient)
!> get energy and gradient contribution from SASA term
   implicit none
   !> INPUT
   integer,intent(in)          :: nat        !> number of atoms
   integer,intent(in)          :: at(nat)    !> atom types 
   real(wp),intent(in)         :: xyz(3,nat) !> coordinats (bohr)
   real(wp),intent(in)         :: qat(nat)   !> charges
   type(TBorn),intent(inout)   :: gbsa       !> gbsa type returned
   !> OUTPUT
   real(wp),intent(out)        :: gsolv      !> solv contribution to E
   real(wp),intent(inout)      :: gradient(3,nat) !> atomic gradient (added to)
   !> LOCAL
   real(wp) :: gborn,ghb,gsasa,gshift
#ifdef WITH_GBSA
   call gbsa%update(at, xyz)
   call gbsa%addGradient(at,xyz,qat,qat,gradient)
   call gbsa%getEnergyParts(qat,qat,gborn,ghb,gsasa, &
   & gshift)
   gsolv = gsasa+gborn+ghb+gshift
#else
   gsolv = 0.0_wp
#endif
end subroutine gfnff_solvation
!========================================================================================!
end module gfnff_gbsa

!================================================================================!
! This file is part of gfnff.
!
! Copyright (C) 2023 Philipp Pracht
!
! gfnff is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfnff is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfnff. If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------!
!> The original (unmodified) source code can be found under the GNU LGPL 3.0 license
!> Copyright (C) 2019-2020 Sebastian Ehlert, Sebastian Spicher, Stefan Grimme
!> at https://github.com/grimme-lab/xtb
!================================================================================!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!in gfnff_ini:
!      integer, parameter :: maxsystem = 50
!      integer :: ispinsyst  (10*n,maxsystem)
!      integer :: nspinsyst  (maxsystem)
!      integer :: nsystem
!      call fragmentize(n,at,xyz,maxsystem, 400, rab, nb, ispinsyst, nspinsyst, nsystem)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
module gfnff_fraghess
  use iso_fortran_env,only:wp => real64,sp => real32
  !$ use omp_lib
  use gfnff_helpers,only:mrecgff,lin
  implicit none
  public

  ! interface
  !   function shortest_distance(nspin, start, goal, neighbours, input_distances, visited, precessor)
  !      implicit none
  !      real(wp)             :: shortest_distance
  !      integer, intent(in)  :: nspin
  !      integer, intent(in)  :: start
  !      integer, intent(in)  :: goal
  !      integer, intent(in)  :: neighbours(20, nspin)
  !      real(wp), intent(in) :: input_distances(nspin, nspin)
  !      logical, intent(out) :: visited(nspin)
  !      integer, intent(out) :: precessor(nspin)
  !      integer  :: current
  !      integer  :: neighbour
  !      integer  :: i_neighbours
  !      integer  :: bonds
  !      real(wp) :: alt_dist
  !      real(wp) :: distance(nspin)
  !    end function shortest_distance
  !    subroutine eigsort4(lab,ew,u)
  !       implicit none
  !       integer  :: ii,k, j, i
  !       real(sp) :: pp, hilf
  !       integer  :: lab
  !       real(sp) :: ew(lab)
  !       real(sp) :: u(lab,lab)
  !    end subroutine eigsort4
  !  end interface

!========================================================================================!
!========================================================================================!
contains  !> MODULE PROCEDURES START HERE
!========================================================================================!
!========================================================================================!

  subroutine fragmentize(nspin,at,xyz,maxsystem,maxmagnat,jab,neigh,ispinsyst,nspinsyst,nsystem)
    implicit none

    !Dummy Arguments:
    integer,intent(in)  :: nspin                              ! # of atoms in the whole system
    integer,intent(in)  :: maxsystem                          ! maximum # of fragments
    integer,intent(in)  :: maxmagnat                          ! maximum # of atoms per fragment
    integer,intent(in)  :: neigh(20,nspin)                   ! neighbour list
    integer,intent(in)  :: at(nspin)                          ! atom nunber
    real(wp),intent(in)  :: xyz(3,nspin)                       ! xyz coordinates
    real(wp),intent(in)  :: jab(nspin*(nspin+1)/2)           ! distances between pairs A and B
    integer,allocatable,intent(out) :: ispinsyst(:,:)         ! array with list of atoms of each fragment
    integer,allocatable,intent(out) :: nspinsyst(:)           ! array with # of atoms for each fragment
    integer,intent(out) :: nsystem                            ! # of fragments
    real(sp)  :: rmaxab(nspin,nspin)

    !Stack
    integer  :: i,ati
    integer  :: current
    integer  :: ass
    integer  :: k
    integer  :: j,atj
    integer  :: fragcount
    integer  :: nfrag_ini
    integer  :: nci_ini
    integer  :: eq_frag
    integer  :: maxdistatoms(2)
    integer  :: max_linkatoms(2)
    integer  :: assigned_to_frag(nspin)
    integer  :: precessor(nspin)
    integer  :: path(nspin)
    integer  :: fragvec(nspin)
    integer  :: nbox
    integer  :: nci_frag_size
    real(wp) :: grid(3,maxsystem)
    real(wp) :: magdist(nspin,nspin)
    real(wp) :: maxdist
    real(wp) :: cur_dist
    real(wp) :: max_link
    real(wp) :: box_xyz(3),vec(3)
    real(wp) :: frag_cma(3,maxsystem)
    logical  :: equal(maxsystem)
    logical  :: visited(nspin)
    logical  :: assigned(nspin,nspin)

    integer,allocatable  :: ifrag_ini(:)

    allocate (ispinsyst(nspin,maxsystem),source=0)
    allocate (nspinsyst(maxsystem),source=0)

    if (nspin .lt. 500) then
      nsystem = 1
      return
    end if

!       open (55, file="fragment.out")

    nci_frag_size = 50
    fragcount = 0
    fragvec = 0
    eq_frag = 0
    frag_cma = 0
    grid = 0
    equal = .false.

    call mrecgff(nspin,neigh,fragcount,fragvec)

    nsystem = maxval(fragvec)

    !Use NCI-Fragmentation from mrec:
    do i = 1,nspin
      nspinsyst(fragvec(i)) = nspinsyst(fragvec(i))+1
      ispinsyst(nspinsyst(fragvec(i)),fragvec(i)) = i
    end do ! End Loop over  i from 1 to nspin

    !Calculate COM for each NCI fragment
    do i = 1,nsystem
      nfrag_ini = nspinsyst(i)
      if (nfrag_ini .lt. nci_frag_size) then
        allocate (ifrag_ini(nfrag_ini),source=0)
        ifrag_ini = ispinsyst(1:nfrag_ini,i)
        call com(nfrag_ini,at(ifrag_ini),xyz(:,ifrag_ini),frag_cma(:,i))
        deallocate (ifrag_ini)
      end if
    end do

    !Determine box size
    do i = 1,3
      box_xyz(i) = maxval(frag_cma(i,:))-minval(frag_cma(i,:))
    end do

    !Determine number of sub boxes
    nbox = ceiling((real(nspin)/real(maxmagnat))**(1.0d0/3.0d0))

    !Determine position of nci frag on grid
    do i = 1,nsystem
      nfrag_ini = nspinsyst(i)
      if (nfrag_ini .lt. nci_frag_size) then
        do j = 1,3
          grid(j,i) = nbox*(frag_cma(j,i)-minval(frag_cma(j,:)))/box_xyz(j)
          if (grid(j,i) .eq. 0) grid(j,i) = grid(j,i)+1.0d0
          grid(j,i) = ceiling(grid(j,i))
        end do
      end if
    end do

    !Sum over all nci fragments on same grid position
    nci_ini = nsystem
    do i = 1,nci_ini !nsystem
      eq_frag = 0
      !nfrag_ini=nspinsyst(i)
      do j = i+1,nci_ini
        nfrag_ini = nspinsyst(j)
        vec(:) = grid(:,i)-grid(:,j)
        if (norm2(grid(:,i)) .ne. 0.and.norm2(vec) .eq. 0.and..not.equal(j)) then
          eq_frag = eq_frag+1
          do k = 1,nfrag_ini
            ispinsyst(nspinsyst(i)+k,i) = ispinsyst(k,j)
          end do
          nspinsyst(i) = nspinsyst(i)+nspinsyst(j)
          equal(j) = .true.
        end if
      end do
      nsystem = nsystem-eq_frag
    end do

    !overwrite ispinsyst/nspinsyst
    do i = 1,nsystem
      do j = 1,nci_ini
        if (.not.equal(j)) then
          nspinsyst(i) = nspinsyst(j)
          ispinsyst(:,i) = ispinsyst(:,j)
          equal(j) = .true.
          exit
        end if
      end do
    end do

    nspinsyst(nsystem+1:maxsystem) = 0
    ispinsyst(:,nsystem+1:maxsystem) = 0

    do i = 1,nsystem !loop über separierte systeme
      do j = 1,nspinsyst(i) !loop über atom1 im system
        do k = j,nspinsyst(i)
          ati = ispinsyst(j,i)
          atj = ispinsyst(k,i)
          rmaxab(atj,ati) = jab(lin(atj,ati))/1.2
          rmaxab(ati,atj) = rmaxab(atj,ati)
        end do
      end do
    end do

    magdist = rmaxab

    !Find Sub-Systems with nspinsyst > maxmagnat
    ass = maxloc(nspinsyst,1)
    do while (nspinsyst(ass) > maxmagnat)

      !Set Spins in this list as available for algorithm
      assigned = .false.
      do i = 1,nspinsyst(ass)
        do j = 1,nspinsyst(ass)
          assigned(ispinsyst(i,ass),ispinsyst(j,ass)) = .true.
        end do ! End Loop over  j from 1 to nspinsyst(ass)
      end do ! End Loop over  i from 1 to nspin

      !Find largest distance:
      maxdist = maxval(rmaxab,mask=assigned)
      maxdistatoms = maxloc(rmaxab,mask=assigned)
      !        write( *, * ) "maxdistatoms", maxdistatoms

      !If a Path is found between A and B
      if (maxdist < huge(1.0_wp)) then

        !get shortest Path from A to B
        cur_dist = shortest_distance(nspin,maxdistatoms(1),maxdistatoms(2),neigh,magdist,visited,precessor)
        current = maxdistatoms(2)

        !loop while A and B are still connected
        do while (cur_dist < huge(1.0_wp))

          !find weakest link
          max_link = 0
          max_linkatoms = 0
          i = 1
          path = 0

          do while (precessor(current) /= 0)
            path(i) = current
            current = precessor(current)
            i = i+1
          end do ! End loop: while precessor(current) /= 0
          path(i) = maxdistatoms(1)
          i = i+1
          max_linkatoms(1) = path(i/2)
          max_linkatoms(2) = path((i/2)+1)

          !Split weakest link, set distance to infinity
          magdist(max_linkatoms(1),max_linkatoms(2)) = huge(1.0_wp)
          magdist(max_linkatoms(2),max_linkatoms(1)) = huge(1.0_wp)

          !Get next-shortest Path:
          cur_dist = shortest_distance(nspin,maxdistatoms(1),maxdistatoms(2),neigh,magdist,visited,precessor)
          current = maxdistatoms(2)
        end do ! cur_dist < huge(1.0_wp)

        !A and B are now Seperated:
        rmaxab(maxdistatoms(1),maxdistatoms(2)) = huge(1.0_sp)
        rmaxab(maxdistatoms(2),maxdistatoms(1)) = huge(1.0_sp)
      end if ! End if: while maxdist < huge(1.0d0)

      !Split into subsystems:
      !Overwrite old spinsystem:

      cur_dist = shortest_distance(nspin,maxdistatoms(1),maxdistatoms(2),neigh,magdist,visited,precessor)
      nspinsyst(ass) = count(visited)
      ispinsyst(:,ass) = 0
      k = 1
      do i = 1,nspin
        if (visited(i)) then
          ispinsyst(k,ass) = i
          k = k+1
        end if
      end do ! End Loop over  i from 1 to count(visited)

      !add new spinsystem
      cur_dist = shortest_distance(nspin,maxdistatoms(2),maxdistatoms(1),neigh,magdist,visited,precessor)
      nsystem = nsystem+1
      nspinsyst(nsystem) = count(visited)
      k = 1
      do i = 1,nspin
        if (visited(i)) then
          ispinsyst(k,nsystem) = i
          k = k+1
        end if
      end do ! End Loop over  i from 1 to count(visited)
      ass = maxloc(nspinsyst,1)

    end do ! End loop: while nspinsyst(ass) > maxmagnat

!        write fragment.out file for visualization
!        do i = 1, nsystem !loop über separierte systeme
!           write (55, *) "System ", i, "mit atomen", nspinsyst(i)
!           do j = 1, nspinsyst(i)
!              write (55, *) ispinsyst(j, i)
!           end do
!        end do
!        close (55)

  end subroutine fragmentize

  subroutine frag_hess_diag(nat,hess,eig_calc,ispinsyst,nspinsyst,nsystem)
    !---------------------------------------------------------------------------------------------
    ! Purpose:
    ! Subroutine performs diagonalization of fragmented hessian.
    ! fragmentize must be called beforehand, fragments are available via this module.
    !
    ! How does it work?
    ! This subroutine uses masked arrays: an array (hess_mask) consists only of logicals and has
    ! the same size as the hessian matrix of the entire system. For all entries of the hessian
    ! matrix that belong to one fragment, the corresponding position in the masked array is set
    ! true. Using the intrinsic "pack and unpack" functions in combination with mask, the hessian
    ! entries for only one fragment are written into a smaller array (mini_hess) which is faster
    ! diagonalized due to the reduzed size (# of atoms in fragment < # of atoms in the entire system).
    !
    ! Input:
    ! nat      - Number of atoms of the entire system
    ! hess     - (Lindh) Hessian of the entire system
    !
    ! Output:
    ! hess     - diagonalized hessian (eigenvectors), overwritten
    ! eig_calc - diagonalized hessian (eigenvalues)
    !---------------------------------------------------------------------------------------------
    implicit none
    !Dummy Arguments
    integer,intent(in)     :: nat                          ! # of atoms
    real(sp),intent(inout)  :: hess(3*nat,3*nat)            ! input hessian
    real(sp),intent(out)    :: eig_calc(3*nat)              ! eigenvectors od entire system
    integer,intent(in) :: ispinsyst(:,:)         ! array with list of atoms of each fragment
    integer,intent(in) :: nspinsyst(:)           ! array with # of atoms for each fragment
    integer,intent(in) :: nsystem                            ! # of fragments
    !Stack
    integer                  :: isystem
    integer                  :: i,j,ii,jj,k
    integer                  :: nat3                         ! # of atoms in the system * 3
    integer                  :: nat_cur                      ! # of atoms in fragment
    integer                  :: nat3_cur                     ! nat in fragments * 3
    integer                  :: info                         ! for ssyev
    integer                  :: lwork                        ! for ssyev
    logical                  :: hess_mask(3*nat,3*nat)       ! masked hessian array
    real(sp)                 :: ev_calc(3*nat,3*nat)         ! eigenvectors of entire system
    real(sp),allocatable    :: mini_hess(:,:)               ! eigenvectors of fragment
    real(sp),allocatable    :: eig(:)                       ! eigenvalues of fragment
    real(sp),allocatable    :: aux(:)                       ! for ssyev

    ev_calc = 0.0e0_sp
    eig_calc = 0.0e0_sp
    nat3 = 3*nat

    !$omp parallel default(none) &
    !$omp private(isystem,i,ii,j,jj,nat_cur,nat3_cur,mini_hess,hess_mask,eig,lwork,aux,info) &
    !$omp shared(nsystem,ev_calc,eig_calc,hess,nspinsyst,ispinsyst)
    !$omp do reduction(+:ev_calc,eig_calc)
    do isystem = 1,nsystem
      hess_mask = .false.
      do i = 1,nspinsyst(isystem)
        do j = 1,i

          nat_cur = nspinsyst(isystem)
          nat3_cur = 3*nat_cur
          ii = 3*ispinsyst(i,isystem)
          jj = 3*ispinsyst(j,isystem)
          hess_mask(ii-2:ii,jj-2:jj) = .true.
          hess_mask(jj-2:jj,ii-2:ii) = .true.

        end do
      end do

      allocate (mini_hess(nat3_cur,nat3_cur),source=0.0e0_sp)
      allocate (eig(nat3_cur),source=0.0e0_sp)

      mini_hess = reshape(pack(hess,mask=hess_mask),shape(mini_hess))
      lwork = 1+6*nat3_cur+2*nat3_cur**2
      allocate (aux(lwork))
      call ssyev('V','U',nat3_cur,mini_hess,nat3_cur,eig,aux,lwork,info)
      deallocate (aux)
!!$omp critical
      ev_calc = unpack(reshape(mini_hess, [nat3_cur*nat3_cur]),mask=hess_mask,field=ev_calc)
      eig_calc = unpack(eig,mask=any(hess_mask,1),field=eig_calc)
!!$omp end critical

      deallocate (mini_hess,eig)

    end do
    !$omp end do
    !$omp end parallel

    do i = 1,nat3
      ev_calc(:,i) = ev_calc(:,i)-(sum(ev_calc(:,i))/nat3)
    end do

    hess = ev_calc

    call eigsort4(nat3,hess,eig_calc)

  end subroutine frag_hess_diag

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!calculates the shortest path between two atoms
!start and goal are integers, determining the index in xyz
!https://de.wikipedia.org/wiki/Dijkstra-Algorithmus
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  real(wp) function shortest_distance(nspin,start,goal,neighbours,input_distances,visited,precessor)
    implicit none
    !Dummy Arguments:
    integer,intent(in)  :: nspin
    integer,intent(in)  :: start
    integer,intent(in)  :: goal
    integer,intent(in)  :: neighbours(20,nspin)
    real(wp),intent(in) :: input_distances(nspin,nspin)
    logical,intent(out) :: visited(nspin)
    integer,intent(out) :: precessor(nspin)

    !Stack:
    integer  :: current
    integer  :: neighbour
    integer  :: i_neighbours
    integer  :: bonds
    real(wp) :: alt_dist
    real(wp) :: distance(nspin)

    !logical:: visited(nspin)

    bonds = 0
    precessor = 0
    distance = huge(distance)
    distance(start) = 0
    visited = .false.
    do while (.not.all(visited)) !as long there are unvisited nodes
      current = minloc(distance,1,.not.visited)

      !Abort if Fragments are not connected:
      if (distance(current) == huge(distance)) then
        shortest_distance = huge(distance)
        return
      end if ! distance(current) == huge(distance)

      visited(current) = .true.
      if (current == goal) then
        shortest_distance = distance(goal)
        !route to target found
        do while (precessor(current) /= 0)
          bonds = bonds+1
          current = precessor(current)
        end do ! End loop: while precessor(current) /= 0
        exit
      else
        !loop over all neighbours of current atom
        do i_neighbours = 1,neighbours(20,current)
          neighbour = neighbours(i_neighbours,current)
          if (.not.visited(neighbour)) then
            !distanzupdate
            alt_dist = distance(current)+input_distances(current,neighbour)
            !write( *, * ) alt_dist, distance(current),
            if ((alt_dist < distance(neighbour))) then
              distance(neighbour) = alt_dist
              precessor(neighbour) = current
            end if ! (alt_dist < distance(neighbour))
          end if !(visited(neighbour))
        end do ! End Loop over  i_neighbours from 1 to all_Atoms(current)%n_neighbours
      end if
    end do ! End loop: while sum(visited) /= 0
    !initialize
    shortest_distance = distance(goal)
  end function shortest_distance

  subroutine eigsort4(lab,u,ew)
    implicit none
    integer  :: ii,k,j,i
    real(sp) :: pp,hilf

    integer,intent(in)    :: lab
    real(sp),intent(inout) :: ew(lab)
    real(sp),intent(inout) :: u(lab,lab)

    do ii = 2,lab
      i = ii-1
      k = i
      pp = ew(i)
      do j = ii,lab
        if (ew(j) .gt. pp) cycle
        k = j
        pp = ew(j)
      end do
      if (k .eq. i) cycle
      ew(k) = ew(i)
      ew(i) = pp
      do j = 1,lab
        hilf = u(j,i)
        u(j,i) = u(j,k)
        u(j,k) = hilf
      end do
    end do

  end subroutine eigsort4

  pure subroutine com(n,at,xyz,sum3)
    implicit none
    !Dummy
    integer,intent(in)   :: n
    integer,intent(in)   :: at(n)
    real(wp),intent(in)  :: xyz(3,n)
    real(wp),intent(out) :: sum3(3)
    !Stack
    integer               :: i
    real(wp)              :: sumw
    real(wp)              :: sumwx,sumwy,sumwz

    sumw = 0
    sumwx = 0.d0
    sumwy = 0.d0
    sumwz = 0.d0

    do i = 1,n
      sumw = sumw+1
      sumwx = sumwx+xyz(1,i)
      sumwy = sumwy+xyz(2,i)
      sumwz = sumwz+xyz(3,i)
    end do

    sum3(1) = sumwx/sumw
    sum3(2) = sumwy/sumw
    sum3(3) = sumwz/sumw

  end subroutine com

!========================================================================================!
end module gfnff_fraghess

!================================================================================!
! This file is part of gfnff.
!
! Copyright (C) 2023 Philipp Pracht
!
! gfnff is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfnff is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfnff. If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------!
!> The original (unmodified) source code can be found under the GNU LGPL 3.0 license
!> Copyright (C) 2019-2020 Sebastian Ehlert, Sebastian Spicher, Stefan Grimme
!> at https://github.com/grimme-lab/xtb
!================================================================================!
module gfnff_setup_mod
  use iso_fortran_env,only:wp => real64,stdout => output_unit
  use gfnff_ini_mod,only:gfnff_ini
  use gfnff_data_types,only:TGFFData,TGFFTopology,TGFFGenerator
  implicit none
  private
  public :: gfnff_setup,gfnff_input

!========================================================================================!
!========================================================================================!
contains   !> MODULE PROCEDURES START HERE
!========================================================================================!
!========================================================================================!

  subroutine gfnff_setup(nat,at,xyz,ichrg,pr,restart,write_topo, &
  &                      gen,param,topo,accuracy,version,io,verbose,iunit)
    use gfnff_restart
    use gfnff_param,only:ini,gfnff_set_param
    implicit none
    character(len=*),parameter :: source = 'gfnff_setup'
!> Dummy
    integer,intent(in)  :: nat
    integer,intent(in)  :: at(nat)
    real(wp),intent(in) :: xyz(3,nat)
    integer,intent(in)  :: ichrg

    type(TGFFTopology),intent(inout) :: topo
    type(TGFFGenerator),intent(inout) :: gen
    type(TGFFData),intent(inout) :: param
    integer,intent(in) :: version
    logical,intent(in) :: restart
    logical,intent(in) :: pr          !> printout flag
    logical,intent(in) :: write_topo
    real(wp),intent(in) :: accuracy
    integer,intent(out) :: io
    logical,intent(in),optional :: verbose !> extended prinout
    integer,intent(in),optional :: iunit

!> Stack
    integer :: newichrg,myunit
    logical :: ex,success,exitRun

!> initialize
    io = 0
    if(present(iunit))then
      myunit = iunit
    else
      myunit = stdout
    endif

    newichrg = ichrg
    call gfnff_input(nat,at,xyz,newichrg,topo)

    call gfnff_set_param(nat,gen,param)
    param%dispscale = 1.0_wp
    if (restart) then
      inquire (file=topo%filename,exist=ex)
      if (ex) then
        call read_restart_gff(topo%filename,nat,version,success,.true.,topo)
        if (success) then
          if(pr) write (myunit,'(/,"> GFN-FF topology read successfully from file ",a," !")') &
          & topo%filename  
          return
        else
          write (myunit,'("**ERROR** Could not read topology file. ",a)') source
          exitRun = .true.
          if (exitRun) then
            return
          end if
        end if
      end if
    end if

    call gfnff_ini(pr,ini,nat,at,xyz,ichrg,gen,param,topo,accuracy,io,verbose=verbose, iunit=myunit)
    if (io /= 0) then
      write (myunit,'("Failed to generate topology ",a)') source
      return
    end if

    if (write_topo) then
      call write_restart_gff('gfnff_topo',nat,version,topo)
      call write_gfnff_adjacency('gfnff_adjacency',topo)
    end if

  end subroutine gfnff_setup
!========================================================================================!

  subroutine gfnff_input(nat,at,xyz,ichrg,topo)
    use gfnff_param
    implicit none
    ! Dummy
    integer,intent(in)  :: nat
    integer,intent(in)  :: at(nat)
    real(wp),intent(in) :: xyz(3,nat)
    integer,intent(inout)  :: ichrg
    type(TGFFTopology),intent(inout) :: topo
    ! Stack
    integer           :: i,j,k
    integer           :: ni
    integer           :: ns
    integer           :: nf
    integer           :: ich
    integer           :: iatom
    integer           :: iresidue
    integer           :: ifrag
    integer           :: ibond
    integer           :: bond_ij(3)
    real(wp)          :: r
    real(wp)          :: dum1
    real(wp)          :: floats(10)
    logical           :: ex
    character(len=80) :: atmp
    character(len=80) :: s(10)
    integer,allocatable :: rn(:)

    if (.not.allocated(topo%nb)) allocate (topo%nb(20,nat),source=0)
    if (.not.allocated(topo%qfrag)) allocate (topo%qfrag(nat),source=0.0d0)
    if (.not.allocated(topo%fraglist)) allocate (topo%fraglist(nat),source=0)

!> We actually do not want to read .CHRG if we have multiple instances of GFN-FF running at once
!> E.g. within an ONIOM setup.
!> Could REALLLY mess things up.....

    ini = .true.
!    inquire (file='.CHRG',exist=ex)
!    if (ex) then
!      open (newunit=ich,file='.CHRG')
!      read (ich,'(a)') atmp
!      close (ich)
!      !call readline(atmp,floats,s,ns,nf)
!      dum1 = -huge(dum1)/2.0_wp
!      floats(:) = dum1
!      read (atmp,*) floats(1:10)
!      nf = 0
!      do i = 1,10
!        if (floats(i) .gt. dum1) nf = nf+1
!      end do
!      topo%qfrag(1:nf) = floats(1:nf)
!      ichrg = int(sum(topo%qfrag(1:nf)))
!      topo%qfrag(nf+1:nat) = 9999
!    else
      topo%qfrag(1) = ichrg
      topo%qfrag(2:nat) = 0
!    end if

  end subroutine gfnff_input
!========================================================================================!

  subroutine write_gfnff_adjacency(fname,topo)
    implicit none
    character(len=*),intent(in) :: fname
    integer :: ifile ! file handle
    type(TGFFTopology) :: topo
    integer :: i,j

    open (newunit=ifile,file=fname)
    ! looping over topology neighboring list
    if (ifile .ne. -1) then
      write (ifile,'(a)') '# indices of neighbouring atoms (max seven)'
      do i = 1,size(topo%nb,2)
        write (ifile,'(*(i0:, 1x))') (topo%nb(j,i),j=1,topo%nb(size(topo%nb,1),i))
      end do
    end if
    close (ifile)
  end subroutine write_gfnff_adjacency

!========================================================================================!
end module gfnff_setup_mod

!================================================================================!
! This file is part of gfnff.
!
! Copyright (C) 2023 Philipp Pracht
!
! gfnff is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfnff is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfnff. If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------!
!> The original (unmodified) source code can be found under the GNU LGPL 3.0 license
!> Copyright (C) 2019-2020 Sebastian Ehlert, Sebastian Spicher, Stefan Grimme
!> at https://github.com/grimme-lab/xtb
!================================================================================!
module gfnff_cn
  use iso_fortran_env,only:wp => real64
  use gfnff_data_types,only:TGFFData
  implicit none
  private
  public :: gfnff_dlogcoord

!========================================================================================!
!========================================================================================!
contains  !> MODULE PROCEDURES START HERE
!========================================================================================!
!========================================================================================!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! CN routines
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!> logCN derivative saved in dlogCN array
  subroutine gfnff_dlogcoord(n,at,xyz,rab,logCN,dlogCN,thr2,param)
    implicit none
    type(TGFFData),intent(in) :: param
    integer,intent(in)  :: n
    integer,intent(in)  :: at(n)
    real(wp),intent(in)  :: xyz(3,n)
    real(wp),intent(in)  :: rab(n*(n+1)/2)
    real(wp),intent(out) :: logCN(n)
    real(wp),intent(out) :: dlogCN(3,n,n)
    real(wp),intent(in)  :: thr2
    real(wp)             :: cn(n)
    !> counter
    integer  :: i,j,ij,ii
    !> distances
    real(wp) :: r
    real(wp) :: r0
    real(wp) :: dr
    real(wp),dimension(3) :: rij
    !> treshold
    real(wp) :: thr
    !> cn parameter
    real(wp) :: erfCN
    real(wp) :: dlogdcni
    real(wp) :: dlogdcnj
    real(wp) :: derivative
    !> local parameter
    real(wp),parameter :: kn = -7.5_wp
    !> initialize vaiiables
    cn = 0.0_wp
    logCN = 0.0_wp
    dlogCN = 0.0_wp
    dlogdcni = 0.0_wp
    dlogdcnj = 0.0_wp
    derivative = 0.0_wp
    r = 0.0_wp
    r0 = 0.0_wp
    rij = 0.0_wp
    thr = sqrt(thr2)
    !> create error function CN
    do i = 2,n
      ii = i*(i-1)/2
      do j = 1,i-1
        ij = ii+j
        r = rab(ij)
        if (r .gt. thr) cycle
        r0 = (param%rcov(at(i))+param%rcov(at(j)))
        dr = (r-r0)/r0
        !> hier kommt die CN funktion hin
!           erfCN = create_expCN(16.0d0,r,r0)
        erfCN = 0.5_wp*(1.0_wp+erf(kn*dr))
        cn(i) = cn(i)+erfCN
        cn(j) = cn(j)+erfCN
      end do
    end do
    !> create cutted logarithm CN + derivatives
    do i = 1,n
      ii = i*(i-1)/2
      logCN(i) = create_logCN(cn(i),param)
      !> get dlogCN/dCNi
      dlogdcni = create_dlogCN(cn(i),param)
      do j = 1,i-1
        ij = ii+j
        !> get dlogCN/dCNj
        dlogdcnj = create_dlogCN(cn(j),param)
        r = rab(ij)
        if (r .gt. thr) cycle
        r0 = (param%rcov(at(i))+param%rcov(at(j)))
        !> get derfCN/dRij
        derivative = create_derfCN(kn,r,r0)
!           derivative = create_dexpCN(16.0d0,r,r0)
        rij = derivative*(xyz(:,j)-xyz(:,i))/r
        !> project rij gradient onto cartesians
        dlogCN(:,j,j) = dlogdcnj*rij+dlogCN(:,j,j)
        dlogCN(:,i,j) = -dlogdcnj*rij
        dlogCN(:,j,i) = dlogdcni*rij
        dlogCN(:,i,i) = -dlogdcni*rij+dlogCN(:,i,i)
      end do
    end do

  contains

    pure elemental function create_logCN(cn,param) result(count)
      type(TGFFData),intent(in) :: param
      real(wp),intent(in) :: cn
      real(wp) :: count
      count = log(1+exp(param%cnmax))-log(1+exp(param%cnmax-cn))
    end function create_logCN

    pure elemental function create_dlogCN(cn,param) result(count)
      type(TGFFData),intent(in) :: param
      real(wp),intent(in) :: cn
      real(wp) :: count
      count = exp(param%cnmax)/(exp(param%cnmax)+exp(cn))
    end function create_dlogCN

    pure elemental function create_erfCN(k,r,r0) result(count)
      real(wp),intent(in) :: k
      real(wp),intent(in) :: r
      real(wp),intent(in) :: r0
      real(wp) :: count
      real(wp) :: dr
      dr = (r-r0)/r0
      count = 0.5_wp*(1.0_wp+erf(kn*dr))
    end function create_erfCN

    pure elemental function create_derfCN(k,r,r0) result(count)
      real(wp),intent(in) :: k
      real(wp),intent(in) :: r
      real(wp),intent(in) :: r0
      real(wp),parameter :: sqrtpi = 1.77245385091_wp
      real(wp) :: count
      real(wp) :: dr
      dr = (r-r0)/r0
      count = k/sqrtpi*exp(-k**2*dr*dr)/r0
    end function create_derfCN

    pure elemental function create_expCN(k,r,r0) result(count)
      real(wp),intent(in) :: k
      real(wp),intent(in) :: r
      real(wp),intent(in) :: r0
      real(wp) :: count
      count = 1.0_wp/(1.0_wp+exp(-k*(r0/r-1.0_wp)))
    end function create_expCN

    pure elemental function create_dexpCN(k,r,r0) result(count)
      real(wp),intent(in) :: k
      real(wp),intent(in) :: r
      real(wp),intent(in) :: r0
      real(wp) :: count
      real(wp) :: expterm
      expterm = exp(-k*(r0/r-1._wp))
      count = (-k*r0*expterm)/(r**2*((expterm+1._wp)**2))
    end function create_dexpCN

  end subroutine gfnff_dlogcoord

end module gfnff_cn

module gfnff
    use gfnff_interface
    implicit none

contains


subroutine gfnff_sp(nat, ichrg, numbers, posotions, status, energy, grad)
    integer,intent(in) :: nat, ichrg
    integer,intent(in) :: numbers(nat)
    double precision,intent(in) :: posotions(3, nat)      ! Bohr
    !f2py depend(posotions) :: nat=shape(posotions,1)
    !f2py depend(numbers) :: nat=size(numbers)

    integer :: io
    integer,intent(out) :: status
    double precision,intent(out) :: energy          ! Hartree
    double precision,intent(out) :: grad(3, nat)    ! Hartree / Bohr
    logical, parameter :: pr = .false.
    type(gfnff_data) :: calculator

    !> calculation
    call calculator%init(nat,numbers,posotions,print=pr,verbose=pr,ichrg=ichrg,iostat=io)
    if (io == 0) then
        ! Topology setup successful
        status = 0
    else
        ! Topology setup exited with errors
        status = 1
        error stop
    end if
    call gfnff_singlepoint(nat,numbers,posotions,calculator,energy,grad,pr,iostat=io)
    if (io == 0) then
        ! Singlepoint successful!
        status = 0
    else
        ! Singlepoint exited with errors
        status = 2
        error stop
    end if
end subroutine gfnff_sp


! subroutine gfnff_alpb(nat, ichrg, numbers, posotions, sol, energy, grad, io)
!     integer,intent(in) :: nat
!     integer,intent(in) :: sol
!     integer,intent(in) :: ichrg
!     integer,intent(in) :: numbers(nat)
!     double precision,intent(out) :: energy
!     double precision,intent(out) :: grad(nat, 3)
!     double precision,intent(in) :: posotions(nat, 3)
!     integer,intent(out) :: io

!     !f2py intent(in) :: nat, ichrg, numbers, posotions, io, sol
!     !f2py intent(out) :: energy, grad
!     !f2py depend(nat) :: grad, posotions

!     logical :: pr = .false.
!     type(gfnff_data) :: calculator
!     character(len=:),allocatable :: alpbsolvent
!     alpbsolvent = 'h2o'

!     !> calculation
!     call gfnff_initialize(nat,numbers,posotions,calculator,print=pr,ichrg=ichrg,iostat=io)
!     call gfnff_singlepoint(nat,numbers,posotions,calculator,energy,grad,pr,iostat=io)
! end subroutine gfnff_alpb

end module gfnff

!================================================================================!
! This file is part of gfnff.
!
! Copyright (C) 2023 Philipp Pracht
!
! gfnff is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfnff is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfnff. If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------!
!> The original (unmodified) source code can be found under the GNU LGPL 3.0 license
!> Copyright (C) 2019-2020 Sebastian Ehlert, Sebastian Spicher, Stefan Grimme
!> at https://github.com/grimme-lab/xtb
!================================================================================!
module gfnff_engrad_module
  use iso_fortran_env,only:wp => real64,sp => real32,stdout => output_unit
  use gfnff_ini2
  use gfnff_data_types,only:TGFFData,TGFFNeighbourList,new,TGFFTopology
  use gfnff_gbsa,only:TBorn
  use gfnff_param,only:sqrtZr4r2
  use gfnff_helpers
  use gfnff_math_wrapper
  implicit none
  private
  public :: gfnff_eg,gfnff_results

  type :: gfnff_results
    real(wp) :: e_total = 0.0_wp
    real(wp) :: e_rep = 0.0_wp
    real(wp) :: e_es = 0.0_wp
    real(wp) :: e_disp = 0.0_wp
    real(wp) :: e_xb = 0.0_wp
    real(wp) :: g_born = 0.0_wp
    real(wp) :: g_sasa = 0.0_wp
    real(wp) :: g_hb = 0.0_wp
    real(wp) :: g_shift = 0.0_wp
    real(wp) :: dipole(3) = (/0.0_wp,0.0_wp,0.0_wp/)
    real(wp) :: g_solv = 0.0_wp
    real(wp) :: gnorm = 0.0_wp
    real(wp) :: e_bond = 0.0_wp
    real(wp) :: e_angl = 0.0_wp
    real(wp) :: e_tors = 0.0_wp
    real(wp) :: e_hb = 0.0_wp
    real(wp) :: e_batm = 0.0_wp
    real(wp) :: e_ext = 0.0_wp
  end type gfnff_results

  real(wp),private,parameter :: pi = 3.1415926535897932385_wp
  real(wp),private,parameter :: sqrtpi = 1.77245385091_wp

!========================================================================================!
!========================================================================================!
contains  !> MODULE PROCEDURES START HERE
!========================================================================================!
!========================================================================================!

!---------------------------------------------------
!> GFN-FF
!> energy and analytical gradient for given xyz and
!> charge ichrg
!> requires D3 ini (rcov,r2r4,copyc6) as well as
!> gfnff_ini call
!>
!> the total energy is
!> ees + edisp + erep + ebond + eangl + etors + ehb + exb + ebatm + eext
!>
!> uses EEQ charge and D3 routines
!> basic trigonometry for bending and torsion angles
!> taken slightly modified from QMDFF code
!> repulsion and rabguess from xtb GFN0 part
!>
!> requires setup of
!>     integer,allocatable :: blist(:,:)
!>     integer,allocatable :: alist(:,:)
!>     integer,allocatable :: tlist(:,:)
!>     integer,allocatable ::b3list(:,:)
!>     real(wp),allocatable:: vbond(:,:)
!>     real(wp),allocatable:: vangl(:,:)
!>     real(wp),allocatable:: vtors(:,:)
!>     chi,gam,alp,cnf
!>     repa,repz,alphanb
!> 
!---------------------------------------------------
  subroutine gfnff_eg(pr,n,ichrg,at,xyz,makeq,g,etot,res_gff, &
  &          param,topo,nlist,solvation,update,version,accuracy,io)

    use gfnff_param,only:efield,gffVersion,gfnff_thresholds
    use gfnff_gdisp0
    use gfnff_cn
    use gfnff_rab
    implicit none
    character(len=*),parameter :: source = 'gfnff_eg'
    type(gfnff_results),intent(out) :: res_gff

    type(TGFFData),intent(in) :: param
    type(TGFFTopology),intent(in) :: topo
    type(TGFFNeighbourList),intent(inout) :: nlist

    type(TBorn),allocatable,intent(inout) :: solvation
    logical,intent(in) :: update
    integer,intent(in) :: version
    real(wp),intent(in) :: accuracy
    integer,intent(out) :: io
    integer,intent(in) :: n
    integer,intent(in) :: ichrg
    integer,intent(in) :: at(n)
    real(wp),intent(in) :: xyz(3,n)
    real(wp),intent(inout) :: g(3,n)
    real(wp),intent(inout) :: etot
    logical,intent(in) :: pr
    logical,intent(in) :: makeq

    real(wp) :: edisp,ees,ebond,eangl,etors,erep,ehb,exb,ebatm,eext
    real(wp) :: gsolv,gborn,ghb,gsasa,gshift

    integer  :: i,j,k,l,m,ij,nd3
    integer  :: ati,atj,iat,jat
    integer  :: hbA,hbB
    integer  :: lin
    logical  :: ex,require_update
    integer  :: nhb1,nhb2,nxb
    real(wp) ::  r2,rab,qq0,erff,dd,dum1,r3(3),t8,dum,t22,t39
    real(wp) ::  dx,dy,dz,yy,t4,t5,t6,alpha,t20
    real(wp) ::  repab,t16,t19,t26,t27,xa,ya,za,cosa,de,t28
    real(wp) ::  gammij,eesinf,etmp,phi
    real(wp) ::  rn,dr,g3tmp(3,3),g4tmp(3,4)
    real(wp) :: rij,drij(3,n)

    real(wp),allocatable :: grab0(:,:,:),rab0(:),eeqtmp(:,:)
    real(wp),allocatable :: cn(:),dcn(:,:,:),qtmp(:)
    real(wp),allocatable :: hb_cn(:),hb_dcn(:,:,:)
    real(wp),allocatable :: sqrab(:),srab(:)
    real(wp),allocatable :: g5tmp(:,:)
    integer,allocatable :: d3list(:,:)
    !type(tb_timer) :: timer
    real(wp) :: dispthr,cnthr,repthr,hbthr1,hbthr2

    call gfnff_thresholds(accuracy,dispthr,cnthr,repthr,hbthr1,hbthr2)

    io = 0 !> return status

    g = 0
    exb = 0
    ehb = 0
    erep = 0
    ees = 0
    edisp = 0
    ebond = 0
    eangl = 0
    etors = 0
    ebatm = 0
    eext = 0

    gsolv = 0.0d0
    gsasa = 0.0d0
    gborn = 0.0d0
    ghb = 0.0d0
    gshift = 0.0d0

    allocate (sqrab(n*(n+1)/2),srab(n*(n+1)/2),qtmp(n),g5tmp(3,n), &
   &         eeqtmp(2,n*(n+1)/2),d3list(2,n*(n+1)/2),dcn(3,n,n),cn(n), &
   &         hb_dcn(3,n,n),hb_cn(n))

!      if (pr) call timer%new(10 + count([allocated(solvation)]),.false.)

!      if (pr) call timer%measure(1,'distance/D3 list')
    nd3 = 0
    do i = 1,n
      ij = i*(i-1)/2
      do j = 1,i-1
        k = ij+j
        sqrab(k) = (xyz(1,i)-xyz(1,j))**2+&
 &               (xyz(2,i)-xyz(2,j))**2+&
 &               (xyz(3,i)-xyz(3,j))**2
        if (sqrab(k) .lt. dispthr) then
          nd3 = nd3+1
          d3list(1,nd3) = i
          d3list(2,nd3) = j
        end if
        srab(k) = sqrt(sqrab(k))
      end do
!> The loop above only runs over the off diagonal elements
!> This initializes the unitialized diagonal to zero but does not
!> add it to the dispersion list.
      sqrab(ij+i) = 0.0d0
      srab(ij+i) = 0.0d0
    end do
!      if (pr) call timer%measure(1)

!!!!!!!!!!!!
! Setup HB
!!!!!!!!!!!!

!      if (pr) call timer%measure(10,'HB/XB (incl list setup)')
    if (allocated(nlist%q)) then
      nlist%initialized = size(nlist%q) == n
    end if
    call gfnff_hbset0(n,at,xyz,sqrab,topo,nhb1,nhb2,nxb,hbthr1,hbthr2)
    nlist%initialized = nlist%initialized.and.nhb1 <= nlist%nhb1 &
       & .and.nhb2 <= nlist%nhb2.and.nxb <= nlist%nxb
    require_update = .not.nlist%initialized
    nlist%force_hbond_update = nhb1 .ne. nlist%nhb1 &
                         & .or.nhb2 .ne. nlist%nhb2 &
                         & .or.nxb .ne. nlist%nxb   &
                         & .or. require_update
    if (.not.nlist%initialized) then
      call new(nlist,n,5*nhb1,5*nhb2,3*nxb)
      nlist%hbrefgeo(:,:) = xyz
    end if
    if (update.or.require_update) then
      call gfnff_hbset(n,at,xyz,sqrab,topo,nlist,hbthr1,hbthr2)
    end if
!      if (pr) call timer%measure(10)

!!!!!!!!!!!!!
! Setup
! GBSA
!!!!!!!!!!!!!
#ifdef WITH_GBSA
    if (allocated(solvation)) then
!      call timer%measure(11, "GBSA")
      call solvation%update(at,xyz)
!      call timer%measure(11)
    end if
#endif
!!!!!!!!!!!!!
! REP part
! non-bonded
!!!!!!!!!!!!!

!      if (pr) call timer%measure(2,'non bonded repulsion')
    !$omp parallel do default(none) reduction(+:erep, g) &
    !$omp shared(n, at, xyz, srab, sqrab, repthr, topo, param) &
    !$omp private(iat, jat, m, ij, ati, atj, rab, r2, r3, t8, t16, t19, t26, t27)
    do iat = 1,n
      m = iat*(iat-1)/2
      do jat = 1,iat-1
        ij = m+jat
        r2 = sqrab(ij)
        if (r2 .gt. repthr) cycle ! cut-off
        if (topo%bpair(ij) .eq. 1) cycle ! list avoided because of memory
        ati = at(iat)
        atj = at(jat)
        rab = srab(ij)
        t16 = r2**0.75
        t19 = t16*t16
        t8 = t16*topo%alphanb(ij)
        t26 = exp(-t8)*param%repz(ati)*param%repz(atj)*param%repscaln
        erep = erep+t26/rab !energy
        t27 = t26*(1.5d0*t8+1.0d0)/t19
        r3 = (xyz(:,iat)-xyz(:,jat))*t27
        g(:,iat) = g(:,iat)-r3
        g(:,jat) = g(:,jat)+r3
      end do
    end do
    !$omp end parallel do
!      if (pr) call timer%measure(2)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! just a extremely crude mode for 2D-3D conversion
! i.e. an harmonic potential with estimated Re
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    if (version == gffVersion%harmonic2020) then
      ebond = 0
      !$omp parallel do default(none) reduction(+:ebond, g) &
      !$omp shared(topo, param, xyz, at) private(i, iat, jat, rab, r2, r3, rn, dum)
      do i = 1,topo%nbond
        iat = topo%blist(1,i)
        jat = topo%blist(2,i)
        r3 = xyz(:,iat)-xyz(:,jat)
        rab = sqrt(sum(r3*r3))
        rn = 0.7*(param%rcov(at(iat))+param%rcov(at(jat)))
        r2 = rn-rab
        ebond = ebond+0.1d0*r2**2  ! fixfc = 0.1
        dum = 0.1d0*2.0d0*r2/rab
        g(:,jat) = g(:,jat)+dum*r3
        g(:,iat) = g(:,iat)-dum*r3
      end do
      !$omp end parallel do
      etot = ebond+erep
      return
    end if

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! erf CN and gradient for disp
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!      if (pr) call timer%measure(3,'dCN')
    call gfnff_dlogcoord(n,at,xyz,srab,cn,dcn,cnthr,param) ! new erf used in GFN0
    if (sum(topo%nr_hb) .gt. 0) call dncoord_erf(n,at,xyz,param%rcov,hb_cn,hb_dcn,900.0d0,topo) ! HB erf CN
!      if (pr) call timer%measure(3)

!!!!!!
! EEQ
!!!!!!

!      if (pr) call timer%measure(4,'EEQ energy and q')
    call goed_gfnff(accuracy .gt. 1,n,at,sqrab,srab,&         ! modified version
   &                dfloat(ichrg),eeqtmp,cn,nlist%q,ees,solvation,param,topo,io)  ! without dq/dr
!    if (pr) call timer%measure(4)

!!!!!!!!
!D3(BJ)
!!!!!!!!

!      if (pr) call timer%measure(5,'D3')
    if (nd3 .gt. 0) then
      call d3_gradient(topo%dispm,n,at,xyz,nd3,d3list,topo%zetac6, &
         & param%d3r0,sqrtZr4r2,4.0d0,param%dispscale,cn,dcn,edisp,g)
    end if
    deallocate (d3list)
!      if (pr) call timer%measure(5)

!!!!!!!!
! ES part
!!!!!!!!
!      if (pr) call timer%measure(6,'EEQ gradient')
    !$omp parallel do default(none) reduction (+:g) &
    !$omp shared(topo,nlist,n,sqrab,srab,eeqtmp,xyz,at) &
    !$omp private(i,j,k,ij,r3,r2,rab,gammij,erff,dd)
    do i = 1,n
      k = i*(i-1)/2
      do j = 1,i-1
        ij = k+j
        r2 = sqrab(ij)
        rab = srab(ij)
        gammij = eeqtmp(1,ij)
        erff = eeqtmp(2,ij)
        dd = (2.0d0*gammij*exp(-gammij**2*r2) &
           & /(sqrtpi*r2)-erff/(rab*r2))*nlist%q(i)*nlist%q(j)
        r3 = (xyz(:,i)-xyz(:,j))*dd
        g(:,i) = g(:,i)+r3
        g(:,j) = g(:,j)-r3
      end do
    end do
    !$omp end parallel do
    if (.not.pr) deallocate (eeqtmp)

#ifdef WITH_GBSA
    if (allocated(solvation)) then
!         call timer%measure(11, "GBSA")
      call solvation%addGradient(at,xyz,nlist%q,nlist%q,g)
      call solvation%getEnergyParts(nlist%q,nlist%q,gborn,ghb,gsasa, &
         & gshift)
      gsolv = gsasa+gborn+ghb+gshift
!         call timer%measure(11)
    else
      gborn = 0.0d0
      ghb = 0.0d0
    end if
#endif

    do i = 1,n
      qtmp(i) = nlist%q(i)*param%cnf(at(i))/(2.0d0*sqrt(cn(i))+1.d-16)
    end do

    call gemv(dcn,qtmp,g,alpha=-1.0_wp,beta=1.0_wp)
!      if (pr) call timer%measure(6)

!!!!!!!!!!!!!!!!!!
! SRB bonded part
!!!!!!!!!!!!!!!!!!

!      if (pr) call timer%measure(7,'bonds')
    if (topo%nbond .gt. 0) then
      allocate (grab0(3,n,topo%nbond),rab0(topo%nbond))
      rab0(:) = topo%vbond(1,:) ! shifts
      call gfnffdrab(n,at,xyz,cn,dcn,topo%nbond,topo%blist,rab0,grab0)
      deallocate (dcn)

      !$omp parallel do default(none) reduction(+:g, ebond) &
      !$omp shared(grab0, topo, param, rab0, srab, xyz, at, hb_cn, hb_dcn, n) &
      !$omp private(i, k, iat, jat, ij, rab, rij, drij, t8, dr, dum, yy, &
      !$omp& dx, dy, dz, t4, t5, t6, ati, atj)
      do i = 1,topo%nbond
        iat = topo%blist(1,i)
        jat = topo%blist(2,i)
        ati = at(iat)
        atj = at(jat)
        ij = iat*(iat-1)/2+jat
        rab = srab(ij)
        rij = rab0(i)
        drij = grab0(:,:,i)
        if (topo%nr_hb(i) .ge. 1) then
          call egbond_hb(i,iat,jat,rab,rij,drij,hb_cn,hb_dcn,n,at,xyz,ebond,g,param,topo)
        else
          call egbond(i,iat,jat,rab,rij,drij,n,at,xyz,ebond,g,topo)
        end if
      end do
      !$omp end parallel do

      deallocate (hb_dcn)

!!!!!!!!!!!!!!!!!!
! bonded REP
!!!!!!!!!!!!!!!!!!

      !$omp parallel do default(none) reduction(+:erep, g) &
      !$omp shared(topo, param, at, sqrab, srab, xyz) &
      !$omp private(i, iat, jat, ij, xa, ya, za, dx, dy, dz, r2, rab, ati, atj, &
      !$omp& alpha, repab, t16, t19, t26, t27)
      do i = 1,topo%nbond
        iat = topo%blist(1,i)
        jat = topo%blist(2,i)
        ij = iat*(iat-1)/2+jat
        xa = xyz(1,iat)
        ya = xyz(2,iat)
        za = xyz(3,iat)
        dx = xa-xyz(1,jat)
        dy = ya-xyz(2,jat)
        dz = za-xyz(3,jat)
        r2 = sqrab(ij)
        rab = srab(ij)
        ati = at(iat)
        atj = at(jat)
        alpha = sqrt(param%repa(ati)*param%repa(atj))
        repab = param%repz(ati)*param%repz(atj)*param%repscalb
        t16 = r2**0.75d0
        t19 = t16*t16
        t26 = exp(-alpha*t16)*repab
        erep = erep+t26/rab !energy
        t27 = t26*(1.5d0*alpha*t16+1.0d0)/t19
        g(1,iat) = g(1,iat)-dx*t27
        g(2,iat) = g(2,iat)-dy*t27
        g(3,iat) = g(3,iat)-dz*t27
        g(1,jat) = g(1,jat)+dx*t27
        g(2,jat) = g(2,jat)+dy*t27
        g(3,jat) = g(3,jat)+dz*t27
      end do
      !$omp end parallel do
    end if
!      if (pr) call timer%measure(7)

!!!!!!!!!!!!!!!!!!
! bend
!!!!!!!!!!!!!!!!!!

!      if (pr) call timer%measure(8,'bend and torsion')
    if (topo%nangl .gt. 0) then
      !$omp parallel do default(none) reduction (+:eangl, g) &
      !$omp shared(n, at, xyz, topo, param) &
      !$omp private(m, j, i, k, etmp, g3tmp)
      do m = 1,topo%nangl
        j = topo%alist(1,m)
        i = topo%alist(2,m)
        k = topo%alist(3,m)
        call egbend(m,j,i,k,n,at,xyz,etmp,g3tmp,param,topo)
        g(1:3,j) = g(1:3,j)+g3tmp(1:3,1)
        g(1:3,i) = g(1:3,i)+g3tmp(1:3,2)
        g(1:3,k) = g(1:3,k)+g3tmp(1:3,3)
        eangl = eangl+etmp
      end do
      !$omp end parallel do
    end if

!!!!!!!!!!!!!!!!!!
! torsion
!!!!!!!!!!!!!!!!!!

    if (topo%ntors .gt. 0) then
      !$omp parallel do default(none) reduction(+:etors, g) &
      !$omp shared(param, topo, n, at, xyz) &
      !$omp private(m, i, j, k, l, etmp, g4tmp)
      do m = 1,topo%ntors
        i = topo%tlist(1,m)
        j = topo%tlist(2,m)
        k = topo%tlist(3,m)
        l = topo%tlist(4,m)
        call egtors(m,i,j,k,l,n,at,xyz,etmp,g4tmp,param,topo)
        g(1:3,i) = g(1:3,i)+g4tmp(1:3,1)
        g(1:3,j) = g(1:3,j)+g4tmp(1:3,2)
        g(1:3,k) = g(1:3,k)+g4tmp(1:3,3)
        g(1:3,l) = g(1:3,l)+g4tmp(1:3,4)
        etors = etors+etmp
      end do
      !$omp end parallel do
    end if
!      if (pr) call timer%measure(8)


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! triple bonded carbon torsion potential
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   if (allocated(topo%sTorsl)) then
      m = size(topo%sTorsl(1,:))
      if (m.ne.0) then
         do i=1, m
               call sTors_eg(m, n, xyz, topo, etmp, g5tmp)
               etors = etors + etmp
               g = g + g5tmp
         enddo
      endif
   endif

!!!!!!!!!!!!!!!!!!
! BONDED ATM
!!!!!!!!!!!!!!!!!!

!      if (pr) call timer%measure(9,'bonded ATM')
    if (topo%nbatm .gt. 0) then
      !$omp parallel do default(none) reduction(+:ebatm, g) &
      !$omp shared(n, at, xyz, srab, sqrab, topo, param) &
      !$omp private(i, j, k, l, etmp, g3tmp)
      do i = 1,topo%nbatm
        j = topo%b3list(1,i)
        k = topo%b3list(2,i)
        l = topo%b3list(3,i)
        call batmgfnff_eg(n,j,k,l,at,xyz,topo%qa,sqrab,srab,etmp,g3tmp,param)
        g(1:3,j) = g(1:3,j)+g3tmp(1:3,1)
        g(1:3,k) = g(1:3,k)+g3tmp(1:3,2)
        g(1:3,l) = g(1:3,l)+g3tmp(1:3,3)
        ebatm = ebatm+etmp
      end do
      !$omp end parallel do
    end if
!      if (pr) call timer%measure(9)

!!!!!!!!!!!!!!!!!!
! EHB
!!!!!!!!!!!!!!!!!!

!      if (pr) call timer%measure(10,'HB/XB (incl list setup)')

    if (nlist%nhb1 .gt. 0) then
      !$omp parallel do default(none) reduction(+:ehb, g) &
      !$omp shared(topo, nlist, param, n, at, xyz, sqrab, srab) &
      !$omp private(i, j, k, l, etmp, g3tmp)
      do i = 1,nlist%nhb1
        j = nlist%hblist1(1,i)
        k = nlist%hblist1(2,i)
        l = nlist%hblist1(3,i)
        call abhgfnff_eg1(n,j,k,l,at,xyz,topo%qa,sqrab,srab,etmp,g3tmp,param,topo)
        g(1:3,j) = g(1:3,j)+g3tmp(1:3,1)
        g(1:3,k) = g(1:3,k)+g3tmp(1:3,2)
        g(1:3,l) = g(1:3,l)+g3tmp(1:3,3)
        ehb = ehb+etmp
      end do
      !$omp end parallel do
    end if

    if (nlist%nhb2 .gt. 0) then
      !$omp parallel do default(none) reduction(+:ehb, g) &
      !$omp shared(topo, nlist, param, n, at, xyz, sqrab, srab) &
      !$omp private(i, j, k, l, etmp, g5tmp)
      do i = 1,nlist%nhb2
        j = nlist%hblist2(1,i)
        k = nlist%hblist2(2,i)
        l = nlist%hblist2(3,i)
        !Carbonyl case R-C=O...H_A
        if (at(k) .eq. 8.and.topo%nb(20,k) .eq. 1.and.at(topo%nb(1,k)) .eq. 6) then
          call abhgfnff_eg3(n,j,k,l,at,xyz,topo%qa,sqrab,srab, &
             & etmp,g5tmp,param,topo)
          !Nitro case R-N=O...H_A
        else if (at(k) .eq. 8.and.topo%nb(20,k) .eq. 1.and.at(topo%nb(1,k)) .eq. 7) then
          call abhgfnff_eg3(n,j,k,l,at,xyz,topo%qa,sqrab,srab, &
             & etmp,g5tmp,param,topo)
          !N hetero aromat
        else if (at(k) .eq. 7.and.topo%nb(20,k) .eq. 2) then
          call abhgfnff_eg2_rnr(n,j,k,l,at,xyz,topo%qa,sqrab,srab, &
             & etmp,g5tmp,param,topo)
        else
          !Default
          call abhgfnff_eg2new(n,j,k,l,at,xyz,topo%qa,sqrab,srab, &
             & etmp,g5tmp,param,topo)
        end if
        g = g+g5tmp
        ehb = ehb+etmp
      end do
      !$omp end parallel do
    end if

!!!!!!!!!!!!!!!!!!
! EXB
!!!!!!!!!!!!!!!!!!

    if (nlist%nxb .gt. 0) then
      !$omp parallel do default(none) reduction(+:exb, g) &
      !$omp shared(topo, nlist, param, n, at, xyz) &
      !$omp private(i, j, k, l, etmp, g3tmp)
      do i = 1,nlist%nxb
        j = nlist%hblist3(1,i)
        k = nlist%hblist3(2,i)
        l = nlist%hblist3(3,i)
        call rbxgfnff_eg(n,j,k,l,at,xyz,topo%qa,etmp,g3tmp,param)
        g(1:3,j) = g(1:3,j)+g3tmp(1:3,1)
        g(1:3,k) = g(1:3,k)+g3tmp(1:3,2)
        g(1:3,l) = g(1:3,l)+g3tmp(1:3,3)
        exb = exb+etmp
      end do
      !$omp end parallel do
    end if
!     if (pr) call timer%measure(10)

!!!!!!!!!!!!!!!!!!
! external stuff
!!!!!!!!!!!!!!!!!!

    if (sum(abs(efield)) .gt. 1d-6) then
      do i = 1,n
        r3(:) = -nlist%q(i)*efield(:)
        g(:,i) = g(:,i)+r3(:)
        eext = eext+r3(1)*(xyz(1,i)-topo%xyze0(1,i))+&
 &                  r3(2)*(xyz(2,i)-topo%xyze0(2,i))+&
 &                  r3(3)*(xyz(3,i)-topo%xyze0(3,i))
      end do
    end if

!!!!!!!!!!!!!!!!!!!!!!!!!!
! total energy summation
!!!!!!!!!!!!!!!!!!!!!!!!!!
    etot = ees+edisp+erep+ebond &
   &       +eangl+etors+ehb+exb+ebatm+eext &
   &       +gsolv

!!!!!!!!!!!!!!!!!!
! printout
!!!!!!!!!!!!!!!!!!
    if (pr) then
!        call timer%write(6,'E+G')
      if (abs(sum(nlist%q)-ichrg) .gt. 1.d-1) then ! check EEQ only once
        write (stdout,*) nlist%q
        write (stdout,*) sum(nlist%q),ichrg
        write (stdout,'("EEQ charge constrain error ",a)') source
        io = 1
        return
      end if
      r3 = 0
      do i = 1,n
        r3(:) = r3(:)+nlist%q(i)*xyz(:,i)
      end do

!> just for fit De calc
      sqrab = 1.d+12
      srab = 1.d+6
      cn = 0
!> asymtotically for R=inf, Etot is the SIE contaminted EES
!> which is computed here to get the atomization energy De,n,at(n)
      call goed_gfnff(.true.,n,at,sqrab,srab,dfloat(ichrg),eeqtmp,cn,qtmp,eesinf,solvation,param,topo,io)
      de = -(etot-eesinf)
    end if
!> write resusts to res type
    res_gff%e_total = etot
    res_gff%gnorm = sqrt(sum(g**2))
    res_gff%e_bond = ebond
    res_gff%e_angl = eangl
    res_gff%e_tors = etors
    res_gff%e_es = ees
    res_gff%e_rep = erep
    res_gff%e_disp = edisp
    res_gff%e_hb = ehb
    res_gff%e_xb = exb
    res_gff%e_batm = ebatm
    res_gff%e_ext = eext
    res_gff%g_hb = ghb
    res_gff%g_born = gborn
    res_gff%g_solv = gsolv
    res_gff%g_shift = gshift
    res_gff%g_sasa = gsasa
    call gemv(xyz,nlist%q,res_gff%dipole)

  end subroutine gfnff_eg

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  subroutine egbond(i,iat,jat,rab,rij,drij,n,at,xyz,e,g,topo)
    implicit none
    !Dummy
    type(TGFFTopology),intent(in) :: topo
    integer,intent(in)   :: i
    integer,intent(in)   :: n
    integer,intent(in)   :: iat
    integer,intent(in)   :: jat
    integer,intent(in)   :: at(n)
    real(wp),intent(in)    :: rab
    real(wp),intent(in)    :: rij
    real(wp),intent(in)    :: drij(3,n)
    real(wp),intent(in)    :: xyz(3,n)
    real(wp),intent(inout) :: e
    real(wp),intent(inout) :: g(3,n)
    !Stack
    integer j,k
    real(wp) :: dr,dum
    real(wp) :: dx,dy,dz
    real(wp) :: yy
    real(wp) :: t4,t5,t6,t8

    t8 = topo%vbond(2,i)
    dr = rab-rij
    dum = topo%vbond(3,i)*exp(-t8*dr**2)
    e = e+dum                      ! bond energy
    yy = 2.0d0*t8*dr*dum
    dx = xyz(1,iat)-xyz(1,jat)
    dy = xyz(2,iat)-xyz(2,jat)
    dz = xyz(3,iat)-xyz(3,jat)
    t4 = -yy*(dx/rab-drij(1,iat))
    t5 = -yy*(dy/rab-drij(2,iat))
    t6 = -yy*(dz/rab-drij(3,iat))
    g(1,iat) = g(1,iat)+t4-drij(1,iat)*yy ! to avoid if in loop below
    g(2,iat) = g(2,iat)+t5-drij(2,iat)*yy
    g(3,iat) = g(3,iat)+t6-drij(3,iat)*yy
    t4 = -yy*(-dx/rab-drij(1,jat))
    t5 = -yy*(-dy/rab-drij(2,jat))
    t6 = -yy*(-dz/rab-drij(3,jat))
    g(1,jat) = g(1,jat)+t4-drij(1,jat)*yy ! to avoid if in loop below
    g(2,jat) = g(2,jat)+t5-drij(2,jat)*yy
    g(3,jat) = g(3,jat)+t6-drij(3,jat)*yy
    do k = 1,n !3B gradient
      g(:,k) = g(:,k)+drij(:,k)*yy
    end do

  end subroutine egbond

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  subroutine egbond_hb(i,iat,jat,rab,rij,drij,hb_cn,hb_dcn,n,at,xyz,e,g,param,topo)
    implicit none
    !Dummy
    type(TGFFData),intent(in) :: param
    type(TGFFTopology),intent(in) :: topo
    integer,intent(in)   :: i
    integer,intent(in)   :: n
    integer,intent(in)   :: iat
    integer,intent(in)   :: jat
    integer,intent(in)   :: at(n)
    real(wp),intent(in)    :: rab
    real(wp),intent(in)    :: rij
    real(wp),intent(in)    :: drij(3,n)
    real(wp),intent(in)    :: xyz(3,n)
    real(wp),intent(in)    :: hb_cn(n)
    real(wp),intent(in)    :: hb_dcn(3,n,n)
    real(wp),intent(inout) :: e
    real(wp),intent(inout) :: g(3,n)
    !Stack
    integer j,k
    integer jA,jH
    integer hbH,hbB,hbA
    real(wp) :: dr,dum
    real(wp) :: dx,dy,dz
    real(wp) :: yy,zz
    real(wp) :: t1,t4,t5,t6,t8

    if (at(iat) .eq. 1) then
      hbH = iat
      hbA = jat
    else if (at(jat) .eq. 1) then
      hbH = jat
      hbA = iat
    else
!      write (stdout,'(10x,"No H-atom found in this bond ",i0,1x,i0)') iat,jat
      return
    end if

    t1 = 1.0-param%vbond_scale
    t8 = (-t1*hb_cn(hbH)+1.0)*topo%vbond(2,i)
    dr = rab-rij
    dum = topo%vbond(3,i)*exp(-t8*dr**2)
    e = e+dum                      ! bond energy
    yy = 2.0d0*t8*dr*dum
    dx = xyz(1,iat)-xyz(1,jat)
    dy = xyz(2,iat)-xyz(2,jat)
    dz = xyz(3,iat)-xyz(3,jat)
    t4 = -yy*(dx/rab-drij(1,iat))
    t5 = -yy*(dy/rab-drij(2,iat))
    t6 = -yy*(dz/rab-drij(3,iat))
    g(1,iat) = g(1,iat)+t4-drij(1,iat)*yy ! to avoid if in loop below
    g(2,iat) = g(2,iat)+t5-drij(2,iat)*yy
    g(3,iat) = g(3,iat)+t6-drij(3,iat)*yy
    t4 = -yy*(-dx/rab-drij(1,jat))
    t5 = -yy*(-dy/rab-drij(2,jat))
    t6 = -yy*(-dz/rab-drij(3,jat))
    g(1,jat) = g(1,jat)+t4-drij(1,jat)*yy ! to avoid if in loop below
    g(2,jat) = g(2,jat)+t5-drij(2,jat)*yy
    g(3,jat) = g(3,jat)+t6-drij(3,jat)*yy
    do k = 1,n !3B gradient
      g(:,k) = g(:,k)+drij(:,k)*yy
    end do
    zz = dum*topo%vbond(2,i)*dr**2*t1
    do j = 1,topo%bond_hb_nr !CN gradient
      jH = topo%bond_hb_AH(2,j)
      jA = topo%bond_hb_AH(1,j)
      if (jH .eq. hbH.and.jA .eq. hbA) then
        g(:,hbH) = g(:,hbH)+hb_dcn(:,hbH,hbH)*zz
        do k = 1,topo%bond_hb_Bn(j)
          hbB = topo%bond_hb_B(k,j)
          g(:,hbB) = g(:,hbB)-hb_dcn(:,hbB,hbH)*zz
        end do
      end if
    end do

  end subroutine egbond_hb

  subroutine dncoord_erf(nat,at,xyz,rcov,cn,dcn,thr,topo)
    implicit none
    !Dummy
    type(TGFFTopology),intent(in) :: topo
    integer,intent(in)   :: nat
    integer,intent(in)   :: at(nat)
    real(wp),intent(in)  :: xyz(3,nat)
    real(wp),intent(in)  :: rcov(:)
    real(wp),intent(out) :: cn(nat)
    real(wp),intent(out) :: dcn(3,nat,nat)
    real(wp),intent(in),optional :: thr
    real(wp) :: cn_thr
    !Stack
    integer  :: i,j
    integer  :: lin,linAH
    integer  :: iat,jat
    integer  :: iA,jA,jH
    integer  :: ati,atj
    real(wp) :: r,r2,rij(3)
    real(wp) :: rcovij
    real(wp) :: dtmp,tmp
    real(wp),parameter :: hlfosqrtpi = 1.0_wp/1.77245385091_wp
    real(wp),parameter :: kn = 27.5_wp
    real(wp),parameter :: rcov_scal = 1.78

    cn = 0._wp
    dcn = 0._wp

    do i = 1,topo%bond_hb_nr
      iat = topo%bond_hb_AH(2,i)
      ati = at(iat)
      iA = topo%bond_hb_AH(1,i)
      do j = 1,topo%bond_hb_Bn(i)
        jat = topo%bond_hb_B(j,i)
        atj = at(jat)
        rij = xyz(:,jat)-xyz(:,iat)
        r2 = sum(rij**2)
        if (r2 .gt. thr) cycle
        r = sqrt(r2)
        rcovij = rcov_scal*(rcov(ati)+rcov(atj))
        tmp = 0.5_wp*(1.0_wp+erf(-kn*(r-rcovij)/rcovij))
        dtmp = -hlfosqrtpi*kn*exp(-kn**2*(r-rcovij)**2/rcovij**2)/rcovij
        cn(iat) = cn(iat)+tmp
        cn(jat) = cn(jat)+tmp
        dcn(:,jat,jat) = dtmp*rij/r+dcn(:,jat,jat)
        dcn(:,iat,jat) = dtmp*rij/r
        dcn(:,jat,iat) = -dtmp*rij/r
        dcn(:,iat,iat) = -dtmp*rij/r+dcn(:,iat,iat)
      end do
    end do

  end subroutine dncoord_erf

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  subroutine egbend(m,j,i,k,n,at,xyz,e,g,param,topo)
    implicit none
    type(TGFFData),intent(in) :: param
    type(TGFFTopology),intent(in) :: topo
    integer m,n,at(n)
    integer i,j,k
    real(wp) :: xyz(3,n),g(3,3),e

    real(wp) ::  c0,kijk,va(3),vb(3),vc(3),cosa
    real(wp) ::  dt,ea,dedb(3),dedc(3),rmul2,rmul1,deddt
    real(wp) ::  term1(3),term2(3),rab2,vab(3),vcb(3),rp
    real(wp) ::  rcb2,damp,dampij,damp2ij,dampjk,damp2jk
    real(wp) ::  theta,deda(3),vp(3),et,dij,c1
    real(wp) ::  term3(3),x1sin,x1cos,e1,dphi1,vdc(3)
    real(wp) ::  ddd(3),ddc(3),ddb(3),dda(3),rjl,phi
    real(wp) ::  rij,rijk,phi0,rkl,rjk,dampkl,damp2kl
    real(wp) ::  dampjl,damp2jl,rn

    c0 = topo%vangl(1,m)
    kijk = topo%vangl(2,m)
    va(1:3) = xyz(1:3,i)
    vb(1:3) = xyz(1:3,j)
    vc(1:3) = xyz(1:3,k)
    call vsub(va,vb,vab,3)
    call vsub(vc,vb,vcb,3)
    rab2 = vab(1)*vab(1)+vab(2)*vab(2)+vab(3)*vab(3)
    rcb2 = vcb(1)*vcb(1)+vcb(2)*vcb(2)+vcb(3)*vcb(3)
    call crprod(vcb,vab,vp)
    rp = vlen(vp)+1.d-14
    call impsc(vab,vcb,cosa)
    cosa = dble(min(1.0d0,max(-1.0d0,cosa)))
    theta = dacos(cosa)

    call gfnffdampa(at(i),at(j),rab2,dampij,damp2ij,param)
    call gfnffdampa(at(k),at(j),rcb2,dampjk,damp2jk,param)
    damp = dampij*dampjk

    if (pi-c0 .lt. 1.d-6) then ! linear
      dt = theta-c0
      ea = kijk*dt**2
      deddt = 2.d0*kijk*dt
    else
      ea = kijk*(cosa-cos(c0))**2
      deddt = 2.0d0*kijk*sin(theta)*(cos(c0)-cosa)
    end if

    e = ea*damp
    call crprod(vab,vp,deda)
    rmul1 = -deddt/(rab2*rp)
    deda = deda*rmul1
    call crprod(vcb,vp,dedc)
    rmul2 = deddt/(rcb2*rp)
    dedc = dedc*rmul2
    dedb = deda+dedc
    term1(1:3) = ea*damp2ij*dampjk*vab(1:3)
    term2(1:3) = ea*damp2jk*dampij*vcb(1:3)
    g(1:3,1) = -dedb(1:3)*damp-term1(1:3)-term2(1:3)
    g(1:3,2) = deda(1:3)*damp+term1(1:3)
    g(1:3,3) = dedc(1:3)*damp+term2(1:3)

  end subroutine egbend

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  subroutine egbend_nci_mul(j,i,k,c0,fc,n,at,xyz,e,g)
    implicit none
    !Dummy
    integer n,at(n)
    integer i,j,k
    real(wp) ::  c0,fc
    real(wp) ::  xyz(3,n),g(3,3),e
    !Stack
    real(wp) ::  kijk,va(3),vb(3),vc(3),cosa
    real(wp) ::  dt,ea,dedb(3),dedc(3),rmul2,rmul1,deddt
    real(wp) ::  term1(3),term2(3),rab2,vab(3),vcb(3),rp
    real(wp) ::  rcb2,damp,dampij,damp2ij,dampjk,damp2jk
    real(wp) ::  theta,deda(3),vp(3),et,dij,c1
    real(wp) ::  term3(3),x1sin,x1cos,e1,dphi1,vdc(3)
    real(wp) ::  ddd(3),ddc(3),ddb(3),dda(3),rjl,phi
    real(wp) ::  rij,rijk,phi0,rkl,rjk,dampkl,damp2kl
    real(wp) ::  dampjl,damp2jl,rn

    kijk = fc/(cos(0.0d0)-cos(c0))**2
    va(1:3) = xyz(1:3,i)
    vb(1:3) = xyz(1:3,j)
    vc(1:3) = xyz(1:3,k)
    call vsub(va,vb,vab,3)
    call vsub(vc,vb,vcb,3)
    rab2 = vab(1)*vab(1)+vab(2)*vab(2)+vab(3)*vab(3)
    rcb2 = vcb(1)*vcb(1)+vcb(2)*vcb(2)+vcb(3)*vcb(3)
    call crprod(vcb,vab,vp)
    rp = vlen(vp)+1.d-14
    call impsc(vab,vcb,cosa)
    cosa = dble(min(1.0d0,max(-1.0d0,cosa)))
    theta = dacos(cosa)

    if (pi-c0 .lt. 1.d-6) then     ! linear
      dt = theta-c0
      ea = kijk*dt**2
      deddt = 2.d0*kijk*dt
    else
      ea = kijk*(cosa-cos(c0))**2  ! not linear
      deddt = 2.0d0*kijk*sin(theta)*(cos(c0)-cosa)
    end if

    e = (1.0d0-ea)
    call crprod(vab,vp,deda)
    rmul1 = -deddt/(rab2*rp)
    deda = deda*rmul1
    call crprod(vcb,vp,dedc)
    rmul2 = deddt/(rcb2*rp)
    dedc = dedc*rmul2
    dedb = deda+dedc
    g(1:3,1) = dedb(1:3)
    g(1:3,2) = -deda(1:3)
    g(1:3,3) = -dedc(1:3)

  end subroutine egbend_nci_mul

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  subroutine egbend_nci(j,i,k,c0,kijk,n,at,xyz,e,g,param)
    implicit none
    !Dummy
    type(TGFFData),intent(in) :: param
    integer n,at(n)
    integer i,j,k
    real(wp) :: c0,kijk
    real(wp) :: xyz(3,n),g(3,3),e
    !Stack
    real(wp) ::  va(3),vb(3),vc(3),cosa
    real(wp) ::  dt,ea,dedb(3),dedc(3),rmul2,rmul1,deddt
    real(wp) ::  term1(3),term2(3),rab2,vab(3),vcb(3),rp
    real(wp) ::  rcb2,damp,dampij,damp2ij,dampjk,damp2jk
    real(wp) ::  theta,deda(3),vp(3),et,dij,c1
    real(wp) ::  term3(3),x1sin,x1cos,e1,dphi1,vdc(3)
    real(wp) ::  ddd(3),ddc(3),ddb(3),dda(3),rjl,phi
    real(wp) ::  rij,rijk,phi0,rkl,rjk,dampkl,damp2kl
    real(wp) ::  dampjl,damp2jl,rn

    va(1:3) = xyz(1:3,i)
    vb(1:3) = xyz(1:3,j)
    vc(1:3) = xyz(1:3,k)
    call vsub(va,vb,vab,3)
    call vsub(vc,vb,vcb,3)
    rab2 = vab(1)*vab(1)+vab(2)*vab(2)+vab(3)*vab(3)
    rcb2 = vcb(1)*vcb(1)+vcb(2)*vcb(2)+vcb(3)*vcb(3)
    call crprod(vcb,vab,vp)
    rp = vlen(vp)+1.d-14
    call impsc(vab,vcb,cosa)
    cosa = dble(min(1.0d0,max(-1.0d0,cosa)))
    theta = dacos(cosa)

    call gfnffdampa_nci(at(i),at(j),rab2,dampij,damp2ij,param)
    call gfnffdampa_nci(at(k),at(j),rcb2,dampjk,damp2jk,param)
    damp = dampij*dampjk

    if (pi-c0 .lt. 1.d-6) then ! linear
      dt = theta-c0
      ea = kijk*dt**2
      deddt = 2.d0*kijk*dt
    else
      ea = kijk*(cosa-cos(c0))**2
      deddt = 2.0d0*kijk*sin(theta)*(cos(c0)-cosa)
    end if

    e = ea*damp
    call crprod(vab,vp,deda)
    rmul1 = -deddt/(rab2*rp)
    deda = deda*rmul1
    call crprod(vcb,vp,dedc)
    rmul2 = deddt/(rcb2*rp)
    dedc = dedc*rmul2
    dedb = deda+dedc
    term1(1:3) = ea*damp2ij*dampjk*vab(1:3)
    term2(1:3) = ea*damp2jk*dampij*vcb(1:3)
    g(1:3,1) = -dedb(1:3)*damp-term1(1:3)-term2(1:3)
    g(1:3,2) = deda(1:3)*damp+term1(1:3)
    g(1:3,3) = dedc(1:3)*damp+term2(1:3)

  end subroutine egbend_nci

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  subroutine egtors(m,i,j,k,l,n,at,xyz,e,g,param,topo)
    implicit none
    type(TGFFData),intent(in) :: param
    type(TGFFTopology),intent(in) :: topo
    integer m,n,at(n)
    integer i,j,k,l
    real(wp) :: xyz(3,n),g(3,4),e

    real(wp) ::  c0,kijk,va(3),vb(3),vc(3),cosa
    real(wp) ::  dt,ea,dedb(3),dedc(3),rmul2,rmul1,deddt
    real(wp) ::  term1(3),term2(3),rab2,vab(3),vcb(3),rp
    real(wp) ::  rcb2,damp,dampij,damp2ij,dampjk,damp2jk
    real(wp) ::  theta,deda(3),vp(3),et,dij,c1
    real(wp) ::  term3(3),x1sin,x1cos,e1,dphi1,vdc(3)
    real(wp) ::  ddd(3),ddc(3),ddb(3),dda(3),rjl,phi
    real(wp) ::  rij,rijk,phi0,rkl,rjk,dampkl,damp2kl
    real(wp) ::  dampjl,damp2jl,rn

    rn = dble(topo%tlist(5,m))
    phi0 = topo%vtors(1,m)
    if (topo%tlist(5,m) .gt. 0) then
      vab(1:3) = xyz(1:3,i)-xyz(1:3,j)
      vcb(1:3) = xyz(1:3,j)-xyz(1:3,k)
      vdc(1:3) = xyz(1:3,k)-xyz(1:3,l)
      rij = vab(1)*vab(1)+vab(2)*vab(2)+vab(3)*vab(3)
      rjk = vcb(1)*vcb(1)+vcb(2)*vcb(2)+vcb(3)*vcb(3)
      rkl = vdc(1)*vdc(1)+vdc(2)*vdc(2)+vdc(3)*vdc(3)
      call gfnffdampt(at(i),at(j),rij,dampij,damp2ij,param)
      call gfnffdampt(at(k),at(j),rjk,dampjk,damp2jk,param)
      call gfnffdampt(at(k),at(l),rkl,dampkl,damp2kl,param)
      damp = dampjk*dampij*dampkl
      phi = valijklff(n,xyz,i,j,k,l)
      call dphidr(n,xyz,i,j,k,l,phi,dda,ddb,ddc,ddd)
      dphi1 = phi-phi0
      c1 = rn*dphi1+pi
      x1cos = cos(c1)
      x1sin = sin(c1)
      et = (1.+x1cos)*topo%vtors(2,m)
      dij = -rn*x1sin*topo%vtors(2,m)*damp
      term1(1:3) = et*damp2ij*dampjk*dampkl*vab(1:3)
      term2(1:3) = et*damp2jk*dampij*dampkl*vcb(1:3)
      term3(1:3) = et*damp2kl*dampij*dampjk*vdc(1:3)
      g(1:3,1) = dij*dda(1:3)+term1
      g(1:3,2) = dij*ddb(1:3)-term1+term2
      g(1:3,3) = dij*ddc(1:3)+term3-term2
      g(1:3,4) = dij*ddd(1:3)-term3
      e = et*damp
    else
      vab(1:3) = xyz(1:3,j)-xyz(1:3,i)
      vcb(1:3) = xyz(1:3,j)-xyz(1:3,k)
      vdc(1:3) = xyz(1:3,j)-xyz(1:3,l)
      rij = vab(1)*vab(1)+vab(2)*vab(2)+vab(3)*vab(3)
      rjk = vcb(1)*vcb(1)+vcb(2)*vcb(2)+vcb(3)*vcb(3)
      rjl = vdc(1)*vdc(1)+vdc(2)*vdc(2)+vdc(3)*vdc(3)
      call gfnffdampt(at(i),at(j),rij,dampij,damp2ij,param)
      call gfnffdampt(at(k),at(j),rjk,dampjk,damp2jk,param)
      call gfnffdampt(at(j),at(l),rjl,dampjl,damp2jl,param)
      damp = dampjk*dampij*dampjl
      phi = omega(n,xyz,i,j,k,l)
      call domegadr(n,xyz,i,j,k,l,phi,dda,ddb,ddc,ddd)
      if (topo%tlist(5,m) .eq. 0) then  ! phi0=0 case
        dphi1 = phi-phi0
        c1 = dphi1+pi
        x1cos = cos(c1)
        x1sin = sin(c1)
        et = (1.+x1cos)*topo%vtors(2,m)
        dij = -x1sin*topo%vtors(2,m)*damp
      else                     ! double min at phi0,-phi0
        et = topo%vtors(2,m)*(cos(phi)-cos(phi0))**2
        dij = 2.*topo%vtors(2,m)*sin(phi)*(cos(phi0)-cos(phi))*damp
      end if
      term1(1:3) = et*damp2ij*dampjk*dampjl*vab(1:3)
      term2(1:3) = et*damp2jk*dampij*dampjl*vcb(1:3)
      term3(1:3) = et*damp2jl*dampij*dampjk*vdc(1:3)
      g(1:3,1) = dij*dda(1:3)-term1
      g(1:3,2) = dij*ddb(1:3)+term1+term2+term3
      g(1:3,3) = dij*ddc(1:3)-term2
      g(1:3,4) = dij*ddd(1:3)-term3
      e = et*damp
    end if

  end subroutine egtors

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  !torsion without distance damping!!! damping is inherint in the HB term
  subroutine egtors_nci_mul(i,j,k,l,rn,phi0,tshift,n,at,xyz,e,g)
    implicit none
    !Dummy
    integer n,at(n)
    integer i,j,k,l
    integer rn
    real(wp) :: phi0,tshift
    real(wp) :: xyz(3,n),g(3,4),e
    !Stack
    real(wp) ::  c0,fc,kijk,va(3),vb(3),vc(3),cosa
    real(wp) ::  dt,ea,dedb(3),dedc(3),rmul2,rmul1,deddt
    real(wp) ::  term1(3),term2(3),rab2,vab(3),vcb(3),rp
    real(wp) ::  rcb2,damp,dampij,damp2ij,dampjk,damp2jk
    real(wp) ::  theta,deda(3),vp(3),et,dij,c1
    real(wp) ::  term3(3),x1sin,x1cos,e1,dphi1,vdc(3)
    real(wp) ::  ddd(3),ddc(3),ddb(3),dda(3),rjl,phi
    real(wp) ::  rij,rijk,rkl,rjk,dampkl,damp2kl
    real(wp) ::  dampjl,damp2jl

    fc = (1.0d0-tshift)/2.0d0
    vab(1:3) = xyz(1:3,i)-xyz(1:3,j)
    vcb(1:3) = xyz(1:3,j)-xyz(1:3,k)
    vdc(1:3) = xyz(1:3,k)-xyz(1:3,l)
    rij = vab(1)*vab(1)+vab(2)*vab(2)+vab(3)*vab(3)
    rjk = vcb(1)*vcb(1)+vcb(2)*vcb(2)+vcb(3)*vcb(3)
    rkl = vdc(1)*vdc(1)+vdc(2)*vdc(2)+vdc(3)*vdc(3)
    phi = valijklff(n,xyz,i,j,k,l)
    call dphidr(n,xyz,i,j,k,l,phi,dda,ddb,ddc,ddd)
    dphi1 = phi-phi0
    c1 = rn*dphi1+pi
    x1cos = cos(c1)
    x1sin = sin(c1)
    et = (1.+x1cos)*fc+tshift
    dij = -rn*x1sin*fc
    g(1:3,1) = dij*dda(1:3)
    g(1:3,2) = dij*ddb(1:3)
    g(1:3,3) = dij*ddc(1:3)
    g(1:3,4) = dij*ddd(1:3)
    e = et !*damp
  end subroutine egtors_nci_mul

      !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  subroutine egtors_nci(i,j,k,l,rn,phi0,fc,n,at,xyz,e,g,param)
    implicit none
    !Dummy
    type(TGFFData),intent(in) :: param
    integer n,at(n)
    integer i,j,k,l
    integer rn
    real(wp) :: phi0,fc
    real(wp) :: xyz(3,n),g(3,4),e
    !Stack
    real(wp) ::  c0,kijk,va(3),vb(3),vc(3),cosa
    real(wp) ::  dt,ea,dedb(3),dedc(3),rmul2,rmul1,deddt
    real(wp) ::  term1(3),term2(3),rab2,vab(3),vcb(3),rp
    real(wp) ::  rcb2,damp,dampij,damp2ij,dampjk,damp2jk
    real(wp) ::  theta,deda(3),vp(3),et,dij,c1
    real(wp) ::  term3(3),x1sin,x1cos,e1,dphi1,vdc(3)
    real(wp) ::  ddd(3),ddc(3),ddb(3),dda(3),rjl,phi
    real(wp) ::  rij,rijk,rkl,rjk,dampkl,damp2kl
    real(wp) ::  dampjl,damp2jl

    vab(1:3) = xyz(1:3,i)-xyz(1:3,j)
    vcb(1:3) = xyz(1:3,j)-xyz(1:3,k)
    vdc(1:3) = xyz(1:3,k)-xyz(1:3,l)
    rij = vab(1)*vab(1)+vab(2)*vab(2)+vab(3)*vab(3)
    rjk = vcb(1)*vcb(1)+vcb(2)*vcb(2)+vcb(3)*vcb(3)
    rkl = vdc(1)*vdc(1)+vdc(2)*vdc(2)+vdc(3)*vdc(3)
    call gfnffdampt_nci(at(i),at(j),rij,dampij,damp2ij,param)
    call gfnffdampt_nci(at(k),at(j),rjk,dampjk,damp2jk,param)
    call gfnffdampt_nci(at(k),at(l),rkl,dampkl,damp2kl,param)
    damp = dampjk*dampij*dampkl
    phi = valijklff(n,xyz,i,j,k,l)
    call dphidr(n,xyz,i,j,k,l,phi,dda,ddb,ddc,ddd)
    dphi1 = phi-phi0
    c1 = rn*dphi1+pi
    x1cos = cos(c1)
    x1sin = sin(c1)
    et = (1.+x1cos)*fc
    dij = -rn*x1sin*fc*damp
    term1(1:3) = et*damp2ij*dampjk*dampkl*vab(1:3)
    term2(1:3) = et*damp2jk*dampij*dampkl*vcb(1:3)
    term3(1:3) = et*damp2kl*dampij*dampjk*vdc(1:3)
    g(1:3,1) = dij*dda(1:3)+term1
    g(1:3,2) = dij*ddb(1:3)-term1+term2
    g(1:3,3) = dij*ddc(1:3)+term3-term2
    g(1:3,4) = dij*ddd(1:3)-term3
    e = et*damp
  end subroutine egtors_nci

!cccccccccccccccccccccccccccccccccccccccccccccc
! damping of bend and torsion for long
! bond distances to allow proper dissociation
!cccccccccccccccccccccccccccccccccccccccccccccc

  subroutine gfnffdampa(ati,atj,r2,damp,ddamp,param)
    implicit none
    type(TGFFData),intent(in) :: param
    integer ati,atj
    real(wp) :: r2,damp,ddamp,rr,rcut
    rcut = param%atcuta*(param%rcov(ati)+param%rcov(atj))**2
    rr = (r2/rcut)**2
    damp = 1.0d0/(1.0d0+rr)
    ddamp = -2.d0*2*rr/(r2*(1.0d0+rr)**2)
  end subroutine gfnffdampa

  subroutine gfnffdampt(ati,atj,r2,damp,ddamp,param)
    implicit none
    type(TGFFData),intent(in) :: param
    integer ati,atj
    real(wp) :: r2,damp,ddamp,rr,rcut
    rcut = param%atcutt*(param%rcov(ati)+param%rcov(atj))**2
    rr = (r2/rcut)**2
    damp = 1.0d0/(1.0d0+rr)
    ddamp = -2.d0*2*rr/(r2*(1.0d0+rr)**2)
  end subroutine gfnffdampt

  subroutine gfnffdampa_nci(ati,atj,r2,damp,ddamp,param)
    implicit none
    type(TGFFData),intent(in) :: param
    integer ati,atj
    real(wp) :: r2,damp,ddamp,rr,rcut
    rcut = param%atcuta_nci*(param%rcov(ati)+param%rcov(atj))**2
    rr = (r2/rcut)**2
    damp = 1.0d0/(1.0d0+rr)
    ddamp = -2.d0*2*rr/(r2*(1.0d0+rr)**2)
  end subroutine gfnffdampa_nci

  subroutine gfnffdampt_nci(ati,atj,r2,damp,ddamp,param)
    implicit none
    type(TGFFData),intent(in) :: param
    integer ati,atj
    real(wp) :: r2,damp,ddamp,rr,rcut
    rcut = param%atcutt_nci*(param%rcov(ati)+param%rcov(atj))**2
    rr = (r2/rcut)**2
    damp = 1.0d0/(1.0d0+rr)
    ddamp = -2.d0*2*rr/(r2*(1.0d0+rr)**2)
  end subroutine gfnffdampt_nci

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Ref.: S. Alireza Ghasemi, Albert Hofstetter, Santanu Saha, and Stefan Goedecker
!       PHYSICAL REVIEW B 92, 045131 (2015)
!       Interatomic potentials for ionic systems with density functional accuracy
!       based on charge densities obtained by a neural network
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  subroutine goed_gfnff(single,n,at,sqrab,r,chrg,eeqtmp,cn,q,es,gbsa,param,topo,io)
    implicit none
    character(len=*),parameter :: source = 'gfnff_eg_goed'
    type(TGFFData),intent(in) :: param
    type(TGFFTopology),intent(in) :: topo
    logical,intent(in)  :: single     !> real*4 flag for solver
    integer,intent(in)  :: n          !> number of atoms
    integer,intent(in)  :: at(n)      !> ordinal numbers
    real(wp),intent(in)  :: sqrab(n*(n+1)/2)   !> squared dist
    real(wp),intent(in)  :: r(n*(n+1)/2)       !> dist
    real(wp),intent(in)  :: chrg       !> total charge on system
    real(wp),intent(in)  :: cn(n)      !> CN
    real(wp),intent(out) :: q(n)       !> output charges
    real(wp),intent(out) :: es         !> ES energy
    real(wp),intent(out) :: eeqtmp(2,n*(n+1)/2)   !> intermediates
    type(TBorn),allocatable,intent(in) :: gbsa    !> solvation object
    integer,intent(out) :: io   !> return status
    !> LOCAL
    integer :: m,i,j,k,ii,ij
    integer :: io1,io2
    integer,allocatable :: ipiv(:)
    real(wp) :: gammij,tsqrt2pi,r2,tmp
    real(wp),allocatable :: A(:,:),x(:)
    real(sp),allocatable :: A4(:,:),x4(:)
!>  parameter
    parameter(tsqrt2pi=0.797884560802866_wp)
    logical :: exitRun

    io = 0  !> return status

!> # atoms + chrg constrain + frag constrain
    m = n+topo%nfrag

    allocate (A(m,m),x(m))
!>  setup RHS
    do i = 1,n
      x(i) = topo%chieeq(i)+param%cnf(at(i))*sqrt(cn(i))
    end do

    A = 0
!> setup A matrix
    !$omp parallel default(none) &
    !$omp shared(topo,n,sqrab,r,eeqtmp,A,at) &
    !$omp private(i,j,k,ij,gammij,tmp)
    !$omp do schedule(dynamic)
    do i = 1,n
      A(i,i) = tsqrt2pi/sqrt(topo%alpeeq(i))+topo%gameeq(i) ! J of i
      k = i*(i-1)/2
      do j = 1,i-1
        ij = k+j
        gammij = 1./sqrt(topo%alpeeq(i)+topo%alpeeq(j)) ! squared above
        tmp = erf(gammij*r(ij))
        eeqtmp(1,ij) = gammij
        eeqtmp(2,ij) = tmp
        A(j,i) = tmp/r(ij)
        A(i,j) = A(j,i)
      end do
    end do
    !$omp enddo
    !$omp end parallel

!> fragment charge constrain
    do i = 1,topo%nfrag
      x(n+i) = topo%qfrag(i)
      do j = 1,n
        if (topo%fraglist(j) .eq. i) then
          A(n+i,j) = 1
          A(j,n+i) = 1
        end if
      end do
    end do

#ifdef WITH_GBSA
    if (allocated(gbsa)) then
      A(:n,:n) = A(:n,:n)+gbsa%bornMat(:,:)
    end if
#endif

    allocate (ipiv(m))

    if (single) then
      allocate (A4(m,m),x4(m))
      A4 = A
      x4 = x
      deallocate (A,x)
      call ssytrf_wrap(a4,ipiv,io1)
      call sytrs_wrap(a4,x4,ipiv,io2)
      q(1:n) = x4(1:n)
      deallocate (A4,x4)
    else
      call dsytrf_wrap(a,ipiv,io1)
      call sytrs_wrap(a,x,ipiv,io2)
      q(1:n) = x(1:n)
      deallocate (A,x)
    end if

    exitRun = (io1 /= 0).or.(io2 /= 0)
    if (exitRun) then
      write (stdout,'("Solving linear equations failed ",a)') source
      return
    end if

    if (n .eq. 1) q(1) = chrg

!> energy
    es = 0.0_wp
    do i = 1,n
      ii = i*(i-1)/2
      do j = 1,i-1
        ij = ii+j
        tmp = eeqtmp(2,ij)
        es = es+q(i)*q(j)*tmp/r(ij)
      end do
      es = es-q(i)*(topo%chieeq(i)+param%cnf(at(i))*sqrt(cn(i))) &
     &        +q(i)*q(i)*0.5d0*(topo%gameeq(i)+tsqrt2pi/sqrt(topo%alpeeq(i)))
    end do

  end subroutine goed_gfnff

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! HB energy and analytical gradient
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!> subroutine for case 1: A...H...B
  subroutine abhgfnff_eg1(n,A,B,H,at,xyz,q,sqrab,srab,energy,gdr,param,topo)
    implicit none
    type(TGFFData),intent(in) :: param
    type(TGFFTopology),intent(in) :: topo
    integer A,B,H,n,at(n)
    real(wp) :: xyz(3,n),energy,gdr(3,3)
    real(wp) :: q(n)
    real(wp) :: sqrab(n*(n+1)/2)   ! squared dist
    real(wp) :: srab(n*(n+1)/2)    ! dist

    real(wp) :: outl,dampl,damps,rdamp,damp,dd24a,dd24b
    real(wp) :: ratio1,ratio2,ratio3
    real(wp) :: xm,ym,zm
    real(wp) :: rab,rah,rbh,rab2,rah2,rbh2,rah4,rbh4
    real(wp) :: drah(3),drbh(3),drab(3),drm(3)
    real(wp) :: dg(3),dga(3),dgb(3),dgh(3)
    real(wp) :: ga(3),gb(3),gh(3)
    real(wp) :: gi,denom,ratio,tmp,qhoutl,radab,rahprbh
    real(wp) :: ex1a,ex2a,ex1b,ex2b,ex1h,ex2h,expo
    real(wp) :: bas,aci
    real(wp) :: eabh
    real(wp) :: aterm,rterm,dterm,sterm
    real(wp) :: qa,qb,qh
    real(wp) :: ca(2),cb(2)
    real(wp) :: gqa,gqb,gqh
    real(wp) :: caa,cbb
    real(wp) :: shortcut

    integer i,j,ij,lina
    lina(i,j) = min(i,j)+max(i,j)*(max(i,j)-1)/2

    gdr = 0
    energy = 0

    call hbonds(A,B,ca,cb,param,topo)

!     A-B distance
    ij = lina(A,B)
    rab2 = sqrab(ij)
    rab = srab(ij)

!     A-H distance
    ij = lina(A,H)
    rah2 = sqrab(ij)
    rah = srab(ij)

!     B-H distance
    ij = lina(B,H)
    rbh2 = sqrab(ij)
    rbh = srab(ij)

    rahprbh = rah+rbh+1.d-12
    radab = param%rad(at(A))+param%rad(at(B))

!     out-of-line damp
    expo = (param%hbacut/radab)*(rahprbh/rab-1.d0)
    if (expo .gt. 15.0d0) return ! avoid overflow
    ratio2 = exp(expo)
    outl = 2.d0/(1.d0+ratio2)

!     long damping
    ratio1 = (rab2/param%hblongcut)**param%hbalp
    dampl = 1.d0/(1.d0+ratio1)

!     short damping
    shortcut = param%hbscut*radab
    ratio3 = (shortcut/rab2)**param%hbalp
    damps = 1.d0/(1.d0+ratio3)

    damp = damps*dampl
    rdamp = damp/rab2/rab

!     hydrogen charge scaled term
    ex1h = exp(param%hbst*q(H))
    ex2h = ex1h+param%hbsf
    qh = ex1h/ex2h

!     hydrogen charge scaled term
    ex1a = exp(-param%hbst*q(A))
    ex2a = ex1a+param%hbsf
    qa = ex1a/ex2a

!     hydrogen charge scaled term
    ex1b = exp(-param%hbst*q(B))
    ex2b = ex1b+param%hbsf
    qb = ex1b/ex2b

!     donor-acceptor term
    rah4 = rah2*rah2
    rbh4 = rbh2*rbh2
    denom = 1.d0/(rah4+rbh4)

    caa = qa*ca(1)
    cbb = qb*cb(1)
    qhoutl = qh*outl

    bas = (caa*rah4+cbb*rbh4)*denom
    aci = (cb(2)*rah4+ca(2)*rbh4)*denom

!     energy
    rterm = -aci*rdamp*qhoutl
    energy = bas*rterm

!     gradient
    drah(1:3) = xyz(1:3,A)-xyz(1:3,H)
    drbh(1:3) = xyz(1:3,B)-xyz(1:3,H)
    drab(1:3) = xyz(1:3,A)-xyz(1:3,B)

    aterm = -aci*bas*rdamp*qh
    sterm = -rdamp*bas*qhoutl
    dterm = -aci*bas*qhoutl

    tmp = denom*denom*4.0d0
    dd24a = rah2*rbh4*tmp
    dd24b = rbh2*rah4*tmp

!     donor-acceptor part: bas
    gi = (caa-cbb)*dd24a*rterm
    ga(1:3) = gi*drah(1:3)
    gi = (cbb-caa)*dd24b*rterm
    gb(1:3) = gi*drbh(1:3)
    gh(1:3) = -ga(1:3)-gb(1:3)

!     donor-acceptor part: aci
    gi = (cb(2)-ca(2))*dd24a
    dga(1:3) = gi*drah(1:3)*sterm
    ga(1:3) = ga(1:3)+dga(1:3)

    gi = (ca(2)-cb(2))*dd24b
    dgb(1:3) = gi*drbh(1:3)*sterm
    gb(1:3) = gb(1:3)+dgb(1:3)

    dgh(1:3) = -dga(1:3)-dgb(1:3)
    gh(1:3) = gh(1:3)+dgh(1:3)

!     damping part rab
    gi = rdamp*(-(2.d0*param%hbalp*ratio1/(1+ratio1))+(2.d0*param%hbalp*ratio3/(1+ratio3))-3.d0)/rab2
    dg(1:3) = gi*drab(1:3)*dterm
    ga(1:3) = ga(1:3)+dg(1:3)
    gb(1:3) = gb(1:3)-dg(1:3)

!     out of line term: rab
    gi = aterm*2.d0*ratio2*expo*rahprbh/(1+ratio2)**2/(rahprbh-rab)/rab2
    dg(1:3) = gi*drab(1:3)
    ga(1:3) = ga(1:3)+dg(1:3)
    gb(1:3) = gb(1:3)-dg(1:3)

!     out of line term: rah,rbh
    tmp = -2.d0*aterm*ratio2*expo/(1+ratio2)**2/(rahprbh-rab)
    dga(1:3) = drah(1:3)*tmp/rah
    ga(1:3) = ga(1:3)+dga(1:3)
    dgb(1:3) = drbh(1:3)*tmp/rbh
    gb(1:3) = gb(1:3)+dgb(1:3)
    dgh(1:3) = -dga(1:3)-dgb(1:3)
    gh(1:3) = gh(1:3)+dgh(1:3)

!     move gradients into place
    gdr(1:3,1) = ga(1:3)
    gdr(1:3,2) = gb(1:3)
    gdr(1:3,3) = gh(1:3)

  end subroutine abhgfnff_eg1

!subroutine for case 2: A-H...B including orientation of neighbors at B
  subroutine abhgfnff_eg2new(n,A,B,H,at,xyz,q,sqrab,srab,energy,gdr,param,topo)
    implicit none
    type(TGFFData),intent(in) :: param
    type(TGFFTopology),intent(in) :: topo
    integer A,B,H,n,at(n)
    real(wp) :: xyz(3,n),energy,gdr(3,n)
    real(wp) :: q(n)
    real(wp) :: sqrab(n*(n+1)/2)   ! squared dist
    real(wp) :: srab(n*(n+1)/2)    ! dist

    real(wp) :: outl,dampl,damps,rdamp,damp
    real(wp) :: ddamp,rabdamp,rbhdamp
    real(wp) :: ratio1,ratio2,ratio2_nb(topo%nb(20,B)),ratio3
    real(wp) :: xm,ym,zm
    real(wp) :: rab,rah,rbh,rab2,rah2,rbh2,rah4,rbh4
    real(wp) :: ranb(topo%nb(20,B)),ranb2(topo%nb(20,B)),rbnb(topo%nb(20,B)),rbnb2(topo%nb(20,B))
    real(wp) :: drah(3),drbh(3),drab(3),drm(3)
    real(wp) :: dranb(3,topo%nb(20,B)),drbnb(3,topo%nb(20,B))
    real(wp) :: dg(3),dga(3),dgb(3),dgh(3),dgnb(3)
    real(wp) :: ga(3),gb(3),gh(3),gnb(3,topo%nb(20,B))
    real(wp) :: denom,ratio,qhoutl,radab
    real(wp) :: gi,gi_nb(topo%nb(20,B))
    real(wp) :: tmp1,tmp2(topo%nb(20,B))
    real(wp) :: rahprbh,ranbprbnb(topo%nb(20,B))
    real(wp) :: ex1a,ex2a,ex1b,ex2b,ex1h,ex2h,expo,expo_nb(topo%nb(20,B))
    real(wp) :: eabh
    real(wp) :: aterm,dterm,nbterm
    real(wp) :: qa,qb,qh
    real(wp) :: ca(2),cb(2)
    real(wp) :: gqa,gqb,gqh
    real(wp) :: shortcut
    real(wp) :: const
    real(wp) :: outl_nb(topo%nb(20,B)),outl_nb_tot
    real(wp) :: hbnbcut_save
    logical mask_nb(topo%nb(20,B))

!     proportion between Rbh und Rab distance dependencies
    real(wp) :: p_bh
    real(wp) :: p_ab

    integer i,j,ij,lina,nbb
    lina(i,j) = min(i,j)+max(i,j)*(max(i,j)-1)/2

    p_bh = 1.d0+param%hbabmix
    p_ab = -param%hbabmix

    gdr = 0
    energy = 0

    call hbonds(A,B,ca,cb,param,topo)

    nbb = topo%nb(20,B)
!     Neighbours of B
    do i = 1,nbb
!        compute distances
      dranb(1:3,i) = xyz(1:3,A)-xyz(1:3,topo%nb(i,B))
      drbnb(1:3,i) = xyz(1:3,B)-xyz(1:3,topo%nb(i,B))
!        A-nb(B) distance
      ranb2(i) = sum(dranb(1:3,i)**2)
      ranb(i) = sqrt(ranb2(i))
!        B-nb(B) distance
      rbnb2(i) = sum(drbnb(1:3,i)**2)
      rbnb(i) = sqrt(rbnb2(i))
    end do

!     A-B distance
    ij = lina(A,B)
    rab2 = sqrab(ij)
    rab = srab(ij)

!     A-H distance
    ij = lina(A,H)
    rah2 = sqrab(ij)
    rah = srab(ij)

!     B-H distance
    ij = lina(B,H)
    rbh2 = sqrab(ij)
    rbh = srab(ij)

    rahprbh = rah+rbh+1.d-12
    radab = param%rad(at(A))+param%rad(at(B))

!     out-of-line damp: A-H...B
    expo = (param%hbacut/radab)*(rahprbh/rab-1.d0)
    if (expo .gt. 15.0d0) return ! avoid overflow
    ratio2 = exp(expo)
    outl = 2.d0/(1.d0+ratio2)

!     out-of-line damp: A...nb(B)-B
    if (at(B) .eq. 7.and.topo%nb(20,B) .eq. 1) then
      hbnbcut_save = 2.0
    else
      hbnbcut_save = param%hbnbcut
    end if
    do i = 1,nbb
      ranbprbnb(i) = ranb(i)+rbnb(i)+1.d-12
      expo_nb(i) = (hbnbcut_save/radab)*(ranbprbnb(i)/rab-1.d0)
      ratio2_nb(i) = exp(-expo_nb(i))**(1.0)
      outl_nb(i) = (2.d0/(1.d0+ratio2_nb(i)))-1.0d0
    end do
    outl_nb_tot = product(outl_nb)

!     long damping
    ratio1 = (rab2/param%hblongcut)**param%hbalp
    dampl = 1.d0/(1.d0+ratio1)

!     short damping
    shortcut = param%hbscut*radab
    ratio3 = (shortcut/rab2)**param%hbalp
    damps = 1.d0/(1.d0+ratio3)

    damp = damps*dampl
    ddamp = (-2.d0*param%hbalp*ratio1/(1.d0+ratio1))+(2.d0*param%hbalp*ratio3/(1.d0+ratio3))
    rbhdamp = damp*((p_bh/rbh2/rbh))
    rabdamp = damp*((p_ab/rab2/rab))
    rdamp = rbhdamp+rabdamp

!     hydrogen charge scaled term
    ex1h = exp(param%hbst*q(H))
    ex2h = ex1h+param%hbsf
    qh = ex1h/ex2h

!     hydrogen charge scaled term
    ex1a = exp(-param%hbst*q(A))
    ex2a = ex1a+param%hbsf
    qa = ex1a/ex2a

!     hydrogen charge scaled term
    ex1b = exp(-param%hbst*q(B))
    ex2b = ex1b+param%hbsf
    qb = ex1b/ex2b

    qhoutl = qh*outl*outl_nb_tot

!     constant values, no gradient
    const = ca(2)*qa*cb(1)*qb*param%xhaci_globabh

!     energy
    energy = -rdamp*qhoutl*const

!     gradient
    drah(1:3) = xyz(1:3,A)-xyz(1:3,H)
    drbh(1:3) = xyz(1:3,B)-xyz(1:3,H)
    drab(1:3) = xyz(1:3,A)-xyz(1:3,B)

    aterm = -rdamp*qh*outl_nb_tot*const
    nbterm = -rdamp*qh*outl*const
    dterm = -qhoutl*const

!------------------------------------------------------------------------------
!     damping part: rab
    gi = ((rabdamp+rbhdamp)*ddamp-3.d0*rabdamp)/rab2
    gi = gi*dterm
    dg(1:3) = gi*drab(1:3)
    ga(1:3) = dg(1:3)
    gb(1:3) = -dg(1:3)

!------------------------------------------------------------------------------
!     damping part: rbh
    gi = -3.d0*rbhdamp/rbh2
    gi = gi*dterm
    dg(1:3) = gi*drbh(1:3)
    gb(1:3) = gb(1:3)+dg(1:3)
    gh(1:3) = -dg(1:3)

!------------------------------------------------------------------------------
!     angular A-H...B term
!------------------------------------------------------------------------------
!     out of line term: rab
    tmp1 = -2.d0*aterm*ratio2*expo/(1+ratio2)**2/(rahprbh-rab)
    gi = -tmp1*rahprbh/rab2
    dg(1:3) = gi*drab(1:3)
    ga(1:3) = ga(1:3)+dg(1:3)
    gb(1:3) = gb(1:3)-dg(1:3)

!     out of line term: rah,rbh
    gi = tmp1/rah
    dga(1:3) = gi*drah(1:3)
    ga(1:3) = ga(1:3)+dga(1:3)
    gi = tmp1/rbh
    dgb(1:3) = gi*drbh(1:3)
    gb(1:3) = gb(1:3)+dgb(1:3)
    dgh(1:3) = -dga(1:3)-dgb(1:3)
    gh(1:3) = gh(1:3)+dgh(1:3)

!------------------------------------------------------------------------------
!     angular A...nb(B)-B term
!------------------------------------------------------------------------------
!     out of line term: rab
    mask_nb = .true.
    do i = 1,nbb
      mask_nb(i) = .false.
      tmp2(i) = 2.d0*nbterm*product(outl_nb,mask_nb)*ratio2_nb(i)*expo_nb(i)/&
               & (1+ratio2_nb(i))**2/(ranbprbnb(i)-rab)
      gi_nb(i) = -tmp2(i)*ranbprbnb(i)/rab2
      dg(1:3) = gi_nb(i)*drab(1:3)
      ga(1:3) = ga(1:3)+dg(1:3)
      gb(1:3) = gb(1:3)-dg(1:3)
      mask_nb = .true.
    end do

!     out of line term: ranb,rbnb
    do i = 1,nbb
      gi_nb(i) = tmp2(i)/ranb(i)
      dga(1:3) = gi_nb(i)*dranb(1:3,i)
      ga(1:3) = ga(1:3)+dga(1:3)
      gi_nb(i) = tmp2(i)/rbnb(i)
      dgb(1:3) = gi_nb(i)*drbnb(1:3,i)
      gb(1:3) = gb(1:3)+dgb(1:3)
      dgnb(1:3) = -dga(1:3)-dgb(1:3)
      gnb(1:3,i) = dgnb(1:3)
    end do

!------------------------------------------------------------------------------
    if (nbb .lt. 1) then
      gdr(1:3,A) = gdr(1:3,A)+ga(1:3)
      gdr(1:3,B) = gdr(1:3,B)+gb(1:3)
      gdr(1:3,H) = gdr(1:3,H)+gh(1:3)
      return
    end if

!------------------------------------------------------------------------------
!     move gradients into place
    gdr(1:3,A) = gdr(1:3,A)+ga(1:3)
    gdr(1:3,B) = gdr(1:3,B)+gb(1:3)
    gdr(1:3,H) = gdr(1:3,H)+gh(1:3)
    do i = 1,nbb
      gdr(1:3,topo%nb(i,B)) = gdr(1:3,topo%nb(i,B))+gnb(1:3,i)
    end do

  end subroutine abhgfnff_eg2new

!> subroutine for case 2: A-H...B including LP position
  subroutine abhgfnff_eg2_rnr(n,A,B,H,at,xyz,q,sqrab,srab,energy,gdr,param,topo)
    implicit none
    type(TGFFData),intent(in) :: param
    type(TGFFTopology),intent(in) :: topo
    integer A,B,H,n,at(n)
    real(wp) :: xyz(3,n),energy,gdr(3,n)
    real(wp) :: q(n)
    real(wp) :: sqrab(n*(n+1)/2)   !> squared dist
    real(wp) :: srab(n*(n+1)/2)    !> dist

    real(wp) :: outl,dampl,damps,rdamp,damp
    real(wp) :: ddamp,rabdamp,rbhdamp
    real(wp) :: ratio1,ratio2,ratio2_lp,ratio2_nb(topo%nb(20,B)),ratio3
    real(wp) :: xm,ym,zm
    real(wp) :: rab,rah,rbh,rab2,rah2,rbh2,rah4,rbh4
    real(wp) :: ranb(topo%nb(20,B)),ranb2(topo%nb(20,B)),rbnb(topo%nb(20,B)),rbnb2(topo%nb(20,B))
    real(wp) :: drah(3),drbh(3),drab(3),drm(3),dralp(3),drblp(3)
    real(wp) :: dranb(3,topo%nb(20,B)),drbnb(3,topo%nb(20,B))
    real(wp) :: dg(3),dga(3),dgb(3),dgh(3),dgnb(3)
    real(wp) :: ga(3),gb(3),gh(3),gnb(3,topo%nb(20,B)),gnb_lp(3),glp(3)
    real(wp) :: denom,ratio,qhoutl,radab
    real(wp) :: gi,gi_nb(topo%nb(20,B))
    real(wp) :: tmp1,tmp2(topo%nb(20,B)),tmp3
    real(wp) :: rahprbh,ranbprbnb(topo%nb(20,B))
    real(wp) :: ex1a,ex2a,ex1b,ex2b,ex1h,ex2h,expo,expo_lp,expo_nb(topo%nb(20,B))
    real(wp) :: eabh
    real(wp) :: aterm,dterm,nbterm,lpterm
    real(wp) :: qa,qb,qh
    real(wp) :: ca(2),cb(2)
    real(wp) :: gqa,gqb,gqh
    real(wp) :: shortcut
    real(wp) :: const
    real(wp) :: outl_nb(topo%nb(20,B)),outl_nb_tot,outl_lp
    real(wp) :: vector(3),vnorm
    real(wp) :: gii(3,3)
    real(wp) :: unit_vec(3)
    real(wp) :: drnb(3,topo%nb(20,B))
    real(wp) :: lp(3)   !> lonepair position
    real(wp) :: lp_dist !> distance parameter between B and lonepair
    real(wp) :: ralp,ralp2,rblp,rblp2,ralpprblp
    logical mask_nb(topo%nb(20,B))

!> proportion between Rbh und Rab distance dependencies
    real(wp) :: p_bh
    real(wp) :: p_ab
!> lone-pair out-of-line damping
    real(wp) :: hblpcut

    integer i,j,ij,lina,nbb
    lina(i,j) = min(i,j)+max(i,j)*(max(i,j)-1)/2

    p_bh = 1.d0+param%hbabmix
    p_ab = -param%hbabmix

    gdr = 0
    energy = 0
    vector = 0
    lp_dist = 0.50-0.018*param%repz(at(B))
    hblpcut = 56

    call hbonds(A,B,ca,cb,param,topo)

    nbb = topo%nb(20,B)
!> Neighbours of B
    do i = 1,nbb
!> compute distances
      dranb(1:3,i) = xyz(1:3,A)-xyz(1:3,topo%nb(i,B))
      drbnb(1:3,i) = xyz(1:3,B)-xyz(1:3,topo%nb(i,B))
!> A-nb(B) distance
      ranb2(i) = sum(dranb(1:3,i)**2)
      ranb(i) = sqrt(ranb2(i))
!> B-nb(B) distance
      rbnb2(i) = sum(drbnb(1:3,i)**2)
      rbnb(i) = sqrt(rbnb2(i))
    end do

!> Neighbours of B
    do i = 1,nbb
      drnb(1:3,i) = xyz(1:3,topo%nb(i,B))-xyz(1:3,B)
      vector = vector+drnb(1:3,i)
    end do

    vnorm = norm2(vector)
!> lonepair coordinates
    if (vnorm .gt. 1.d-10) then
      lp = xyz(1:3,B)-lp_dist*(vector/vnorm)
    else
      lp = xyz(1:3,B)
      nbb = 0
    end if

!> A-B distance
    ij = lina(A,B)
    rab2 = sqrab(ij)
    rab = srab(ij)

!> A-H distance
    ij = lina(A,H)
    rah2 = sqrab(ij)
    rah = srab(ij)

!> B-H distance
    ij = lina(B,H)
    rbh2 = sqrab(ij)
    rbh = srab(ij)

    rahprbh = rah+rbh+1.d-12
    radab = param%rad(at(A))+param%rad(at(B))

!> out-of-line damp: A-H...B
    expo = (param%hbacut/radab)*(rahprbh/rab-1.d0)
    if (expo .gt. 15.0d0) return ! avoid overflow
    ratio2 = exp(expo)
    outl = 2.d0/(1.d0+ratio2)

!> out-of-line damp: A...LP-B
    rblp2 = sum((xyz(1:3,B)-lp(1:3))**2)
    rblp = sqrt(rblp2)
    ralp2 = sum((xyz(1:3,A)-lp(1:3))**2)
    ralp = sqrt(ralp2)
    ralpprblp = ralp+rblp+1.d-12
    expo_lp = (hblpcut/radab)*(ralpprblp/rab-1.d0)
    ratio2_lp = exp(expo_lp)
    outl_lp = 2.d0/(1.d0+ratio2_lp)

!> out-of-line damp: A...nb(B)-B
    do i = 1,nbb
      ranbprbnb(i) = ranb(i)+rbnb(i)+1.d-12
      expo_nb(i) = (param%hbnbcut/radab)*(ranbprbnb(i)/rab-1.d0)
      ratio2_nb(i) = exp(-expo_nb(i))**(1.0)
      outl_nb(i) = (2.d0/(1.d0+ratio2_nb(i)))-1.0d0
    end do
    outl_nb_tot = product(outl_nb)

!> long range damping
    ratio1 = (rab2/param%hblongcut)**param%hbalp
    dampl = 1.d0/(1.d0+ratio1)

!> short range damping
    shortcut = param%hbscut*radab
    ratio3 = (shortcut/rab2)**param%hbalp
    damps = 1.d0/(1.d0+ratio3)

    damp = damps*dampl
    ddamp = (-2.d0*param%hbalp*ratio1/(1.d0+ratio1))+(2.d0*param%hbalp*ratio3/(1.d0+ratio3))
    rbhdamp = damp*((p_bh/rbh2/rbh))
    rabdamp = damp*((p_ab/rab2/rab))
    rdamp = rbhdamp+rabdamp

!> hydrogen charge scaled term
    ex1h = exp(param%hbst*q(H))
    ex2h = ex1h+param%hbsf
    qh = ex1h/ex2h

!> hydrogen charge scaled term
    ex1a = exp(-param%hbst*q(A))
    ex2a = ex1a+param%hbsf
    qa = ex1a/ex2a

!> hydrogen charge scaled term
    ex1b = exp(-param%hbst*q(B))
    ex2b = ex1b+param%hbsf
    qb = ex1b/ex2b

    qhoutl = qh*outl*outl_nb_tot*outl_lp

!> constant values, no gradient
    const = ca(2)*qa*cb(1)*qb*param%xhaci_globabh

!> energy
    energy = -rdamp*qhoutl*const

!> gradient
    drah(1:3) = xyz(1:3,A)-xyz(1:3,H)
    drbh(1:3) = xyz(1:3,B)-xyz(1:3,H)
    drab(1:3) = xyz(1:3,A)-xyz(1:3,B)
    dralp(1:3) = xyz(1:3,A)-lp(1:3)
    drblp(1:3) = xyz(1:3,B)-lp(1:3)

    aterm = -rdamp*qh*outl_nb_tot*outl_lp*const
    nbterm = -rdamp*qh*outl*outl_lp*const
    lpterm = -rdamp*qh*outl*outl_nb_tot*const
    dterm = -qhoutl*const

!------------------------------------------------------------------------------
!> damping part: rab
    gi = ((rabdamp+rbhdamp)*ddamp-3.d0*rabdamp)/rab2
    gi = gi*dterm
    dg(1:3) = gi*drab(1:3)
    ga(1:3) = dg(1:3)
    gb(1:3) = -dg(1:3)

!------------------------------------------------------------------------------
!> damping part: rbh
    gi = -3.d0*rbhdamp/rbh2
    gi = gi*dterm
    dg(1:3) = gi*drbh(1:3)
    gb(1:3) = gb(1:3)+dg(1:3)
    gh(1:3) = -dg(1:3)

!------------------------------------------------------------------------------
!> angular A-H...B term
!------------------------------------------------------------------------------
!> out of line term: rab
    tmp1 = -2.d0*aterm*ratio2*expo/(1+ratio2)**2/(rahprbh-rab)
    gi = -tmp1*rahprbh/rab2
    dg(1:3) = gi*drab(1:3)
    ga(1:3) = ga(1:3)+dg(1:3)
    gb(1:3) = gb(1:3)-dg(1:3)

!> out of line term: rah,rbh
    gi = tmp1/rah
    dga(1:3) = gi*drah(1:3)
    ga(1:3) = ga(1:3)+dga(1:3)
    gi = tmp1/rbh
    dgb(1:3) = gi*drbh(1:3)
    gb(1:3) = gb(1:3)+dgb(1:3)
    dgh(1:3) = -dga(1:3)-dgb(1:3)
    gh(1:3) = gh(1:3)+dgh(1:3)

!------------------------------------------------------------------------------
!> angular A...LP-B term
!------------------------------------------------------------------------------
!> out of line term: rab
    tmp3 = -2.d0*lpterm*ratio2_lp*expo_lp/(1+ratio2_lp)**2/(ralpprblp-rab)
    gi = -tmp3*ralpprblp/rab2
    dg(1:3) = gi*drab(1:3)
    ga(1:3) = ga(1:3)+dg(1:3)
    gb(1:3) = gb(1:3)-dg(1:3)

!> out of line term: ralp,rblp
    gi = tmp3/ralp
    dga(1:3) = gi*dralp(1:3)
    ga(1:3) = ga(1:3)+dga(1:3)
    gi = tmp3/(rblp+1.0d-12)
    dgb(1:3) = gi*drblp(1:3)
    gb(1:3) = gb(1:3)-dga(1:3)
    glp(1:3) = -dga(1:3)!-dgb(1:3)

!> neighbor part: LP
    unit_vec = 0
    do i = 1,3
      unit_vec(i) = -1
      gii(1:3,i) = -lp_dist*dble(nbb)*(unit_vec/vnorm+(vector*vector(i)/sum(vector**2)**(1.5d0)))
      unit_vec = 0
    end do
    gnb_lp = matmul(gii,glp)

!------------------------------------------------------------------------------
!> angular A...nb(B)-B term
!------------------------------------------------------------------------------
!> out of line term: rab
    mask_nb = .true.
    do i = 1,nbb
      mask_nb(i) = .false.
      tmp2(i) = 2.d0*nbterm*product(outl_nb,mask_nb)*ratio2_nb(i)*expo_nb(i)/&
               & (1+ratio2_nb(i))**2/(ranbprbnb(i)-rab)
      gi_nb(i) = -tmp2(i)*ranbprbnb(i)/rab2
      dg(1:3) = gi_nb(i)*drab(1:3)
      ga(1:3) = ga(1:3)+dg(1:3)
      gb(1:3) = gb(1:3)-dg(1:3)
      mask_nb = .true.
    end do

!> out of line term: ranb,rbnb
    do i = 1,nbb
      gi_nb(i) = tmp2(i)/ranb(i)
      dga(1:3) = gi_nb(i)*dranb(1:3,i)
      ga(1:3) = ga(1:3)+dga(1:3)
      gi_nb(i) = tmp2(i)/rbnb(i)
      dgb(1:3) = gi_nb(i)*drbnb(1:3,i)
      gb(1:3) = gb(1:3)+dgb(1:3)
      dgnb(1:3) = -dga(1:3)-dgb(1:3)
      gnb(1:3,i) = dgnb(1:3)
    end do

!------------------------------------------------------------------------------
    if (nbb .lt. 1) then
      gdr(1:3,A) = gdr(1:3,A)+ga(1:3)
      gdr(1:3,B) = gdr(1:3,B)+gb(1:3)
      gdr(1:3,H) = gdr(1:3,H)+gh(1:3)
      return
    end if

!------------------------------------------------------------------------------
!> move gradients into place
    gdr(1:3,A) = gdr(1:3,A)+ga(1:3)
    gdr(1:3,B) = gdr(1:3,B)+gb(1:3)+gnb_lp(1:3)
    gdr(1:3,H) = gdr(1:3,H)+gh(1:3)
    do i = 1,nbb
      gdr(1:3,topo%nb(i,B)) = gdr(1:3,topo%nb(i,B))+gnb(1:3,i)-gnb_lp(1:3)/dble(nbb)
    end do

  end subroutine abhgfnff_eg2_rnr

!> subroutine for case 3: A-H...B, B is 0=C including two in plane LPs at B
!> this is the multiplicative version of incorporationg etors and ebend
!> equal to abhgfnff_eg2_new multiplied by etors and eangl
  subroutine abhgfnff_eg3(n,A,B,H,at,xyz,q,sqrab,srab,energy,gdr,param,topo)
    implicit none
    type(TGFFData),intent(in) :: param
    type(TGFFTopology),intent(in) :: topo
    integer A,B,H,n,at(n)
    real(wp) :: xyz(3,n),energy,gdr(3,n)
    real(wp) :: q(n)
    real(wp) :: sqrab(n*(n+1)/2)   ! squared dist
    real(wp) :: srab(n*(n+1)/2)    ! dist

    real(wp) :: outl,dampl,damps,rdamp,damp
    real(wp) :: ddamp,rabdamp,rbhdamp
    real(wp) :: ratio1,ratio2,ratio2_nb(topo%nb(20,B)),ratio3
    real(wp) :: xm,ym,zm
    real(wp) :: rab,rah,rbh,rab2,rah2,rbh2,rah4,rbh4
    real(wp) :: ranb(topo%nb(20,B)),ranb2(topo%nb(20,B)),rbnb(topo%nb(20,B)),rbnb2(topo%nb(20,B))
    real(wp) :: drah(3),drbh(3),drab(3),drm(3)
    real(wp) :: dranb(3,topo%nb(20,B)),drbnb(3,topo%nb(20,B))
    real(wp) :: dg(3),dga(3),dgb(3),dgh(3),dgnb(3)
    real(wp) :: ga(3),gb(3),gh(3),gnb(3,topo%nb(20,B))
    real(wp) :: phi,phi0,r0,t0,fc,tshift,bshift
    real(wp) :: eangl,etors,gangl(3,n),gtors(3,n)
    real(wp) :: etmp(20),g3tmp(3,3),g4tmp(3,4,20)
    real(wp) :: ratio,qhoutl,radab
    real(wp) :: gi,gi_nb(topo%nb(20,B))
    real(wp) :: tmp1,tmp2(topo%nb(20,B))
    real(wp) :: rahprbh,ranbprbnb(topo%nb(20,B))
    real(wp) :: ex1a,ex2a,ex1b,ex2b,ex1h,ex2h,expo,expo_nb(topo%nb(20,B))
    real(wp) :: eabh
    real(wp) :: aterm,dterm,nbterm,bterm,tterm
    real(wp) :: qa,qb,qh
    real(wp) :: ca(2),cb(2)
    real(wp) :: gqa,gqb,gqh
    real(wp) :: shortcut
    real(wp) :: tlist(5,topo%nb(20,topo%nb(1,B)))
    real(wp) :: vtors(2,topo%nb(20,topo%nb(1,B)))
    real(wp) :: const
    real(wp) :: outl_nb(topo%nb(20,B)),outl_nb_tot
    logical mask_nb(topo%nb(20,B)),t_mask(20)

!> proportion between Rbh und Rab distance dependencies
    real(wp) :: p_bh
    real(wp) :: p_ab

    integer C,D
    integer i,j,ii,jj,kk,ll,ij,lina
    integer nbb,nbc
    integer ntors,rn

    lina(i,j) = min(i,j)+max(i,j)*(max(i,j)-1)/2

    p_bh = 1.d0+param%hbabmix
    p_ab = -param%hbabmix

    gdr = 0
    energy = 0
    etors = 0
    gtors = 0
    eangl = 0
    gangl = 0

    call hbonds(A,B,ca,cb,param,topo)

!> Determine all neighbors for torsion term
!>   A
!>    \         tors:
!>     H        ll
!>      :        \
!>       O        jj
!>       ||       |
!>       C        kk
!>      / \       \
!>     R1  R2      ii
!------------------------------------------
    nbb = topo%nb(20,B)
    C = topo%nb(nbb,B)
    nbc = topo%nb(20,C)
    ntors = nbc-nbb

    nbb = topo%nb(20,B)
!> Neighbours of B
    do i = 1,nbb
!> compute distances
      dranb(1:3,i) = xyz(1:3,A)-xyz(1:3,topo%nb(i,B))
      drbnb(1:3,i) = xyz(1:3,B)-xyz(1:3,topo%nb(i,B))
!> A-nb(B) distance
      ranb2(i) = sum(dranb(1:3,i)**2)
      ranb(i) = sqrt(ranb2(i))
!> B-nb(B) distance
      rbnb2(i) = sum(drbnb(1:3,i)**2)
      rbnb(i) = sqrt(rbnb2(i))
    end do

!> A-B distance
    ij = lina(A,B)
    rab2 = sqrab(ij)
    rab = srab(ij)

!> A-H distance
    ij = lina(A,H)
    rah2 = sqrab(ij)
    rah = srab(ij)

!> B-H distance
    ij = lina(B,H)
    rbh2 = sqrab(ij)
    rbh = srab(ij)

    rahprbh = rah+rbh+1.d-12
    radab = param%rad(at(A))+param%rad(at(B))

!> out-of-line damp: A-H...B
    expo = (param%hbacut/radab)*(rahprbh/rab-1.d0)
    if (expo .gt. 15.0d0) return ! avoid overflow
    ratio2 = exp(expo)
    outl = 2.d0/(1.d0+ratio2)

!> out-of-line damp: A...nb(B)-B
    do i = 1,nbb
      ranbprbnb(i) = ranb(i)+rbnb(i)+1.d-12
      expo_nb(i) = (param%hbnbcut/radab)*(ranbprbnb(i)/rab-1.d0)
      ratio2_nb(i) = exp(-expo_nb(i))
      outl_nb(i) = (2.d0/(1.d0+ratio2_nb(i)))-1.0d0
    end do
    outl_nb_tot = product(outl_nb)

!> long range damping
    ratio1 = (rab2/param%hblongcut)**param%hbalp
    dampl = 1.d0/(1.d0+ratio1)

!> short range damping
    shortcut = param%hbscut*radab
    ratio3 = (shortcut/rab2)**6
    damps = 1.d0/(1.d0+ratio3)

    damp = damps*dampl
    ddamp = (-2.d0*param%hbalp*ratio1/(1.d0+ratio1))+(2.d0*param%hbalp*ratio3/(1.d0+ratio3))
    rbhdamp = damp*((p_bh/rbh2/rbh))
    rabdamp = damp*((p_ab/rab2/rab))
    rdamp = rbhdamp+rabdamp

!> Set up torsion paramter
    j = 0
    do i = 1,nbc
      if (topo%nb(i,C) == B) cycle
      j = j+1
      tlist(1,j) = topo%nb(i,C)
      tlist(2,j) = B
      tlist(3,j) = C
      tlist(4,j) = H
      tlist(5,j) = 2
      t0 = 180
      phi0 = t0*pi/180.
      vtors(1,j) = phi0-(pi/2.0)
      vtors(2,j) = param%tors_hb
    end do

!> Calculate etors
    do i = 1,ntors
      ii = tlist(1,i)
      jj = tlist(2,i)
      kk = tlist(3,i)
      ll = tlist(4,i)
      rn = tlist(5,i)
      phi0 = vtors(1,i)
      tshift = vtors(2,i)
      phi = valijklff(n,xyz,ii,jj,kk,ll)
      call egtors_nci_mul(ii,jj,kk,ll,rn,phi0,tshift,n,at,xyz,etmp(i),g4tmp(:,:,i))
    end do
    etors = product(etmp(1:ntors))

!> Calculate gtors
    t_mask = .true.
    do i = 1,ntors
      t_mask(i) = .false.
      ii = tlist(1,i)
      jj = tlist(2,i)
      kk = tlist(3,i)
      ll = tlist(4,i)
      gtors(1:3,ii) = gtors(1:3,ii)+g4tmp(1:3,1,i)*product(etmp(1:ntors),t_mask(1:ntors))
      gtors(1:3,jj) = gtors(1:3,jj)+g4tmp(1:3,2,i)*product(etmp(1:ntors),t_mask(1:ntors))
      gtors(1:3,kk) = gtors(1:3,kk)+g4tmp(1:3,3,i)*product(etmp(1:ntors),t_mask(1:ntors))
      gtors(1:3,ll) = gtors(1:3,ll)+g4tmp(1:3,4,i)*product(etmp(1:ntors),t_mask(1:ntors))
      t_mask = .true.
    end do

!> Calculate eangl + gangl
    r0 = 120
    phi0 = r0*pi/180.
    bshift = param%bend_hb
    fc = 1.0d0-bshift
    call bangl(xyz,kk,jj,ll,phi)
    call egbend_nci_mul(jj,kk,ll,phi0,fc,n,at,xyz,eangl,g3tmp)
    gangl(1:3,jj) = gangl(1:3,jj)+g3tmp(1:3,1)
    gangl(1:3,kk) = gangl(1:3,kk)+g3tmp(1:3,2)
    gangl(1:3,ll) = gangl(1:3,ll)+g3tmp(1:3,3)

!> hydrogen charge scaled term
    ex1h = exp(param%hbst*q(H))
    ex2h = ex1h+param%hbsf
    qh = ex1h/ex2h

!> hydrogen charge scaled term
    ex1a = exp(-param%hbst*q(A))
    ex2a = ex1a+param%hbsf
    qa = ex1a/ex2a

!> hydrogen charge scaled term
    ex1b = exp(-param%hbst*q(B))
    ex2b = ex1b+param%hbsf
    qb = ex1b/ex2b

    qhoutl = qh*outl*outl_nb_tot

!> constant values, no gradient
    const = ca(2)*qa*cb(1)*qb*param%xhaci_coh

!> energy
    energy = -rdamp*qhoutl*eangl*etors*const

!> gradient
    drah(1:3) = xyz(1:3,A)-xyz(1:3,H)
    drbh(1:3) = xyz(1:3,B)-xyz(1:3,H)
    drab(1:3) = xyz(1:3,A)-xyz(1:3,B)

    aterm = -rdamp*qh*outl_nb_tot*eangl*etors*const
    nbterm = -rdamp*qh*outl*eangl*etors*const
    dterm = -qhoutl*eangl*etors*const
    tterm = -rdamp*qhoutl*eangl*const
    bterm = -rdamp*qhoutl*etors*const

!------------------------------------------------------------------------------
!> damping part: rab
    gi = ((rabdamp+rbhdamp)*ddamp-3.d0*rabdamp)/rab2
    gi = gi*dterm
    dg(1:3) = gi*drab(1:3)
    ga(1:3) = dg(1:3)
    gb(1:3) = -dg(1:3)

!------------------------------------------------------------------------------
!> damping part: rbh
    gi = -3.d0*rbhdamp/rbh2
    gi = gi*dterm
    dg(1:3) = gi*drbh(1:3)
    gb(1:3) = gb(1:3)+dg(1:3)
    gh(1:3) = -dg(1:3)

!------------------------------------------------------------------------------
!> angular A-H...B term
!------------------------------------------------------------------------------
!> out of line term: rab
    tmp1 = -2.d0*aterm*ratio2*expo/(1+ratio2)**2/(rahprbh-rab)
    gi = -tmp1*rahprbh/rab2
    dg(1:3) = gi*drab(1:3)
    ga(1:3) = ga(1:3)+dg(1:3)
    gb(1:3) = gb(1:3)-dg(1:3)

!> out of line term: rah,rbh
    gi = tmp1/rah
    dga(1:3) = gi*drah(1:3)
    ga(1:3) = ga(1:3)+dga(1:3)
    gi = tmp1/rbh
    dgb(1:3) = gi*drbh(1:3)
    gb(1:3) = gb(1:3)+dgb(1:3)
    dgh(1:3) = -dga(1:3)-dgb(1:3)
    gh(1:3) = gh(1:3)+dgh(1:3)

!------------------------------------------------------------------------------
!> angular A...nb(B)-B term
!------------------------------------------------------------------------------
!> out of line term: rab
    mask_nb = .true.
    do i = 1,nbb
      mask_nb(i) = .false.
      tmp2(i) = 2.d0*nbterm*product(outl_nb,mask_nb)*ratio2_nb(i)*expo_nb(i)/&
               & (1+ratio2_nb(i))**2/(ranbprbnb(i)-rab)
      gi_nb(i) = -tmp2(i)*ranbprbnb(i)/rab2
      dg(1:3) = gi_nb(i)*drab(1:3)
      ga(1:3) = ga(1:3)+dg(1:3)
      gb(1:3) = gb(1:3)-dg(1:3)
      mask_nb = .true.
    end do

!> out of line term: ranb,rbnb
    do i = 1,nbb
      gi_nb(i) = tmp2(i)/ranb(i)
      dga(1:3) = gi_nb(i)*dranb(1:3,i)
      ga(1:3) = ga(1:3)+dga(1:3)
      gi_nb(i) = tmp2(i)/rbnb(i)
      dgb(1:3) = gi_nb(i)*drbnb(1:3,i)
      gb(1:3) = gb(1:3)+dgb(1:3)
      dgnb(1:3) = -dga(1:3)-dgb(1:3)
      gnb(1:3,i) = dgnb(1:3)
    end do

!------------------------------------------------------------------------------
    if (nbb .lt. 1) then
      gdr(1:3,A) = gdr(1:3,A)+ga(1:3)
      gdr(1:3,B) = gdr(1:3,B)+gb(1:3)
      gdr(1:3,H) = gdr(1:3,H)+gh(1:3)
      return
    end if

!------------------------------------------------------------------------------
!> torsion term H...B=C<R1,R2
!------------------------------------------------------------------------------
    do i = 1,ntors
      ii = tlist(1,i)
      gdr(1:3,ii) = gdr(1:3,ii)+gtors(1:3,ii)*tterm
    end do
    gdr(1:3,jj) = gdr(1:3,jj)+gtors(1:3,jj)*tterm
    gdr(1:3,kk) = gdr(1:3,kk)+gtors(1:3,kk)*tterm
    gdr(1:3,ll) = gdr(1:3,ll)+gtors(1:3,ll)*tterm

!------------------------------------------------------------------------------
!> angle term H...B=C
!------------------------------------------------------------------------------
    gdr(1:3,jj) = gdr(1:3,jj)+gangl(1:3,jj)*bterm
    gdr(1:3,kk) = gdr(1:3,kk)+gangl(1:3,kk)*bterm
    gdr(1:3,ll) = gdr(1:3,ll)+gangl(1:3,ll)*bterm

!------------------------------------------------------------------------------
!> move gradients into place
    gdr(1:3,A) = gdr(1:3,A)+ga(1:3)
    gdr(1:3,B) = gdr(1:3,B)+gb(1:3)
    gdr(1:3,H) = gdr(1:3,H)+gh(1:3)
    do i = 1,nbb
      gdr(1:3,topo%nb(i,B)) = gdr(1:3,topo%nb(i,B))+gnb(1:3,i)
    end do

  end subroutine abhgfnff_eg3

!> subroutine for case 3: A-H...B, B is 0=C including two in plane LPs at B
!> this is the multiplicative version of incorporationg etors and ebend without neighbor LP
  subroutine abhgfnff_eg3_mul(n,A,B,H,at,xyz,q,sqrab,srab,energy,gdr,param,topo)
    implicit none
    type(TGFFData),intent(in) :: param
    type(TGFFTopology),intent(in) :: topo
    integer A,B,H,C,D,n,at(n)
    real(wp) :: xyz(3,n),energy,gdr(3,n)
    real(wp) :: q(n)
    real(wp) :: sqrab(n*(n+1)/2)   ! squared dist
    real(wp) :: srab(n*(n+1)/2)    ! dist

    real(wp) :: outl,dampl,damps,rdamp,damp
    real(wp) :: ddamp,rabdamp,rbhdamp
    real(wp) :: ratio1,ratio2,ratio2_nb(topo%nb(20,B)),ratio3
    real(wp) :: xm,ym,zm
    real(wp) :: rab,rah,rbh,rab2,rah2,rbh2,rah4,rbh4
    real(wp) :: ranb(topo%nb(20,B)),ranb2(topo%nb(20,B)),rbnb(topo%nb(20,B)),rbnb2(topo%nb(20,B))
    real(wp) :: drah(3),drbh(3),drab(3),drm(3)
    real(wp) :: dranb(3,topo%nb(20,B)),drbnb(3,topo%nb(20,B))
    real(wp) :: dg(3),dga(3),dgb(3),dgh(3),dgnb(3)
    real(wp) :: ga(3),gb(3),gh(3),gnb(3,topo%nb(20,B))
    real(wp) :: phi,phi0,r0,fc,tshift,bshift
    real(wp) :: eangl,etors,gangl(3,n),gtors(3,n)
    real(wp) :: etmp,g3tmp(3,3),g4tmp(3,4)
    real(wp) :: denom,ratio,qhoutl,radab
    real(wp) :: gi,gi_nb(topo%nb(20,B))
    real(wp) :: tmp1,tmp2(topo%nb(20,B))
    real(wp) :: rahprbh,ranbprbnb(topo%nb(20,B))
    real(wp) :: ex1a,ex2a,ex1b,ex2b,ex1h,ex2h,expo,expo_nb(topo%nb(20,B))
    real(wp) :: eabh
    real(wp) :: aterm,dterm,bterm,tterm
    real(wp) :: qa,qb,qh
    real(wp) :: ca(2),cb(2)
    real(wp) :: gqa,gqb,gqh
    real(wp) :: shortcut
    real(wp) :: const
    real(wp) :: tlist(5,topo%nb(20,topo%nb(1,B)))
    real(wp) :: vtors(2,topo%nb(20,topo%nb(1,B)))
    logical mask_nb(topo%nb(20,B))

!> proportion between Rbh und Rab distance dependencies
    real(wp) :: p_bh
    real(wp) :: p_ab

    integer i,j,ii,jj,kk,ll,ij,lina
    integer nbb,nbc
    integer ntors,rn

    lina(i,j) = min(i,j)+max(i,j)*(max(i,j)-1)/2

    p_bh = 1.d0+param%hbabmix
    p_ab = -param%hbabmix

    gdr = 0
    energy = 0
    etors = 0
    gtors = 0
    eangl = 0
    gangl = 0

    call hbonds(A,B,ca,cb,param,topo)

!> Determine all neighbors for torsion term
!>   A
!>    \         tors:
!>     H        ll
!>      :        \
!>       O        jj
!>       ||       |
!>       C        kk
!>      / \       \
!>     R1  R2      ii
!------------------------------------------
    nbb = topo%nb(20,B)
    C = topo%nb(nbb,B)
    nbc = topo%nb(20,C)
    ntors = nbc-nbb

!> A-B distance
    ij = lina(A,B)
    rab2 = sqrab(ij)
    rab = srab(ij)

!> A-H distance
    ij = lina(A,H)
    rah2 = sqrab(ij)
    rah = srab(ij)

!> B-H distance
    ij = lina(B,H)
    rbh2 = sqrab(ij)
    rbh = srab(ij)

    rahprbh = rah+rbh+1.d-12
    radab = param%rad(at(A))+param%rad(at(B))

!> out-of-line damp: A-H...B
    expo = (param%hbacut/radab)*(rahprbh/rab-1.d0)
    if (expo .gt. 15.0d0) return ! avoid overflow
    ratio2 = exp(expo)
    outl = 2.d0/(1.d0+ratio2)

!> long range damping
    ratio1 = (rab2/param%hblongcut)**param%hbalp
    dampl = 1.d0/(1.d0+ratio1)

!> short range damping
    shortcut = param%hbscut*radab
    ratio3 = (shortcut/rab2)**param%hbalp
    damps = 1.d0/(1.d0+ratio3)

    damp = damps*dampl
    ddamp = (-2.d0*param%hbalp*ratio1/(1.d0+ratio1))+(2.d0*param%hbalp*ratio3/(1.d0+ratio3))
    rbhdamp = damp*((p_bh/rbh2/rbh))
    rabdamp = damp*((p_ab/rab2/rab))
    rdamp = rbhdamp+rabdamp

!> Set up torsion paramter
    j = 0
    do i = 1,nbc
      if (topo%nb(i,C) == B) cycle
      j = j+1
      tlist(1,j) = topo%nb(i,C)
      tlist(2,j) = B
      tlist(3,j) = C
      tlist(4,j) = H
      tlist(5,j) = 2
      vtors(1,j) = pi/2.0
      vtors(2,j) = 0.70
    end do

!> Calculate etors
    do i = 1,ntors
      ii = tlist(1,i)
      jj = tlist(2,i)
      kk = tlist(3,i)
      ll = tlist(4,i)
      rn = tlist(5,i)
      phi0 = vtors(1,i)
      tshift = vtors(2,i)
      phi = valijklff(n,xyz,ii,jj,kk,ll)
      call egtors_nci_mul(ii,jj,kk,ll,rn,phi0,tshift,n,at,xyz,etmp,g4tmp)
      gtors(1:3,ii) = gtors(1:3,ii)+g4tmp(1:3,1)
      gtors(1:3,jj) = gtors(1:3,jj)+g4tmp(1:3,2)
      gtors(1:3,kk) = gtors(1:3,kk)+g4tmp(1:3,3)
      gtors(1:3,ll) = gtors(1:3,ll)+g4tmp(1:3,4)
      etors = etors+etmp
    end do
    etors = etors/ntors

    r0 = 120
    phi0 = r0*pi/180.
    bshift = 0.1
    fc = 1.0d0-bshift
    call bangl(xyz,kk,jj,ll,phi)
    call egbend_nci_mul(jj,kk,ll,phi0,fc,n,at,xyz,etmp,g3tmp)
    gangl(1:3,jj) = gangl(1:3,jj)+g3tmp(1:3,1)
    gangl(1:3,kk) = gangl(1:3,kk)+g3tmp(1:3,2)
    gangl(1:3,ll) = gangl(1:3,ll)+g3tmp(1:3,3)
    eangl = eangl+etmp

!> hydrogen charge scaled term
    ex1h = exp(param%hbst*q(H))
    ex2h = ex1h+param%hbsf
    qh = ex1h/ex2h

!> hydrogen charge scaled term
    ex1a = exp(-param%hbst*q(A))
    ex2a = ex1a+param%hbsf
    qa = ex1a/ex2a

!> hydrogen charge scaled term
    ex1b = exp(-param%hbst*q(B))
    ex2b = ex1b+param%hbsf
    qb = ex1b/ex2b

!> max distance to neighbors excluded, would lead to linear C=O-H
    qhoutl = qh*outl

!> constant values, no gradient
    const = ca(2)*qa*cb(1)*qb*param%xhaci_globabh

!> energy
    energy = -rdamp*qhoutl*const*eangl*etors

!> gradient
    drah(1:3) = xyz(1:3,A)-xyz(1:3,H)
    drbh(1:3) = xyz(1:3,B)-xyz(1:3,H)
    drab(1:3) = xyz(1:3,A)-xyz(1:3,B)

    aterm = -rdamp*qh*etors*eangl*const
    dterm = -qhoutl*etors*eangl*const
    tterm = -rdamp*qhoutl*eangl*const/ntors
    bterm = -rdamp*qhoutl*etors*const

!------------------------------------------------------------------------------
!> damping part: rab
    gi = ((rabdamp+rbhdamp)*ddamp-3.d0*rabdamp)/rab2
    gi = gi*dterm
    dg(1:3) = gi*drab(1:3)
    ga(1:3) = dg(1:3)
    gb(1:3) = -dg(1:3)

!------------------------------------------------------------------------------
!>  damping part: rbh
    gi = -3.d0*rbhdamp/rbh2
    gi = gi*dterm
    dg(1:3) = gi*drbh(1:3)
    gb(1:3) = gb(1:3)+dg(1:3)
    gh(1:3) = -dg(1:3)

!------------------------------------------------------------------------------
!> angular A-H...B term
!------------------------------------------------------------------------------
!> out of line term: rab
    tmp1 = -2.d0*aterm*ratio2*expo/(1+ratio2)**2/(rahprbh-rab)
    gi = -tmp1*rahprbh/rab2
    dg(1:3) = gi*drab(1:3)
    ga(1:3) = ga(1:3)+dg(1:3)
    gb(1:3) = gb(1:3)-dg(1:3)

!> out of line term: rah,rbh
    gi = tmp1/rah
    dga(1:3) = gi*drah(1:3)
    ga(1:3) = ga(1:3)+dga(1:3)
    gi = tmp1/rbh
    dgb(1:3) = gi*drbh(1:3)
    gb(1:3) = gb(1:3)+dgb(1:3)
    dgh(1:3) = -dga(1:3)-dgb(1:3)
    gh(1:3) = gh(1:3)+dgh(1:3)

!------------------------------------------------------------------------------
!> torsion term H...B=C<R1,R2
!------------------------------------------------------------------------------
    do i = 1,ntors
      ii = tlist(1,i)
      gdr(1:3,ii) = gdr(1:3,ii)+gtors(1:3,ii)*tterm
    end do
    gdr(1:3,jj) = gdr(1:3,jj)+gtors(1:3,jj)*tterm
    gdr(1:3,kk) = gdr(1:3,kk)+gtors(1:3,kk)*tterm
    gdr(1:3,ll) = gdr(1:3,ll)+gtors(1:3,ll)*tterm

!------------------------------------------------------------------------------
!> angle term H...B=C
!------------------------------------------------------------------------------
    gdr(1:3,jj) = gdr(1:3,jj)+gangl(1:3,jj)*bterm
    gdr(1:3,kk) = gdr(1:3,kk)+gangl(1:3,kk)*bterm
    gdr(1:3,ll) = gdr(1:3,ll)+gangl(1:3,ll)*bterm

!------------------------------------------------------------------------------
!> move gradients into place
    gdr(1:3,A) = gdr(1:3,A)+ga(1:3)
    gdr(1:3,B) = gdr(1:3,B)+gb(1:3)
    gdr(1:3,H) = gdr(1:3,H)+gh(1:3)

  end subroutine abhgfnff_eg3_mul

!> subroutine for case 3: A-H...B, B is 0=C including two in plane LPs at B
!> this is the additive version of incorporationg etors and ebend
!> This subroutine is currently unused
  subroutine abhgfnff_eg3_add(n,A,B,H,at,xyz,q,sqrab,srab,energy,gdr,param,topo)
    implicit none
    type(TGFFData),intent(in) :: param
    type(TGFFTopology),intent(in) :: topo
    integer A,B,H,C,D,n,at(n)
    real(wp) :: xyz(3,n),energy,gdr(3,n)
    real(wp) :: q(n)
    real(wp) :: sqrab(n*(n+1)/2)   ! squared dist
    real(wp) :: srab(n*(n+1)/2)    ! dist

    real(wp) :: outl,dampl,damps,rdamp,damp
    real(wp) :: ddamp,rabdamp,rbhdamp
    real(wp) :: ratio1,ratio2,ratio2_nb(topo%nb(20,B)),ratio3
    real(wp) :: xm,ym,zm
    real(wp) :: rab,rah,rbh,rab2,rah2,rbh2,rah4,rbh4
    real(wp) :: ranb(topo%nb(20,B)),ranb2(topo%nb(20,B)),rbnb(topo%nb(20,B)),rbnb2(topo%nb(20,B))
    real(wp) :: drah(3),drbh(3),drab(3),drm(3)
    real(wp) :: dranb(3,topo%nb(20,B)),drbnb(3,topo%nb(20,B))
    real(wp) :: dg(3),dga(3),dgb(3),dgh(3),dgnb(3)
    real(wp) :: ga(3),gb(3),gh(3),gnb(3,topo%nb(20,B))
    real(wp) :: phi,phi0,r0,fc
    real(wp) :: eangl,etors
    real(wp) :: etmp,g3tmp(3,3),g4tmp(3,4)
    real(wp) :: denom,ratio,qhoutl,radab
    real(wp) :: gi,gi_nb(topo%nb(20,B))
    real(wp) :: tmp1,tmp2(topo%nb(20,B))
    real(wp) :: rahprbh,ranbprbnb(topo%nb(20,B))
    real(wp) :: ex1a,ex2a,ex1b,ex2b,ex1h,ex2h,expo,expo_nb(topo%nb(20,B))
    real(wp) :: eabh
    real(wp) :: aterm,dterm,nbterm
    real(wp) :: qa,qb,qh
    real(wp) :: ca(2),cb(2)
    real(wp) :: gqa,gqb,gqh
    real(wp) :: shortcut
    real(wp) :: const
    real(wp) :: outl_nb(topo%nb(20,B)),outl_nb_tot
    real(wp) :: tlist(5,topo%nb(20,topo%nb(1,B)))
    real(wp) :: vtors(2,topo%nb(20,topo%nb(1,B)))
    logical mask_nb(topo%nb(20,B))

!> proportion between Rbh und Rab distance dependencies
    real(wp) :: p_bh
    real(wp) :: p_ab

    integer i,j,ii,jj,kk,ll,ij,lina
    integer nbb,nbc
    integer ntors,rn

    lina(i,j) = min(i,j)+max(i,j)*(max(i,j)-1)/2

    p_bh = 1.d0+param%hbabmix
    p_ab = -param%hbabmix

    gdr = 0
    energy = 0
    etors = 0
    eangl = 0

    call hbonds(A,B,ca,cb,param,topo)

!> Determine all neighbors for torsion term
!>   A
!>    \         tors:
!>     H        ll
!>      :        \
!>       O        jj
!>       ||       |
!>       C        kk
!>      / \       \
!>     R1  R2      ii
!------------------------------------------
    nbb = topo%nb(20,B)
    C = topo%nb(nbb,B)
    nbc = topo%nb(20,C)
    ntors = nbc-nbb

!> A-B distance
    ij = lina(A,B)
    rab2 = sqrab(ij)
    rab = srab(ij)

!> A-H distance
    ij = lina(A,H)
    rah2 = sqrab(ij)
    rah = srab(ij)

!> B-H distance
    ij = lina(B,H)
    rbh2 = sqrab(ij)
    rbh = srab(ij)

    rahprbh = rah+rbh+1.d-12
    radab = param%rad(at(A))+param%rad(at(B))

!> out-of-line damp: A-H...B
    expo = (param%hbacut/radab)*(rahprbh/rab-1.d0)
    if (expo .gt. 15.0d0) return ! avoid overflow
    ratio2 = exp(expo)
    outl = 2.d0/(1.d0+ratio2)

!> long range damping
    ratio1 = (rab2/param%hblongcut)**param%hbalp
    dampl = 1.d0/(1.d0+ratio1)

!> short range damping
    shortcut = param%hbscut*radab
    ratio3 = (shortcut/rab2)**param%hbalp
    damps = 1.d0/(1.d0+ratio3)

    damp = damps*dampl
    ddamp = (-2.d0*param%hbalp*ratio1/(1.d0+ratio1))+(2.d0*param%hbalp*ratio3/(1.d0+ratio3))
    rbhdamp = damp*((p_bh/rbh2/rbh))
    rabdamp = damp*((p_ab/rab2/rab))
    rdamp = rbhdamp+rabdamp

!> Set up torsion paramter
    j = 0
    do i = 1,nbc
      if (topo%nb(i,C) == B) cycle
      j = j+1
      tlist(1,j) = topo%nb(i,C)
      tlist(2,j) = B
      tlist(3,j) = C
      tlist(4,j) = H
      tlist(5,j) = 2
      vtors(1,j) = pi
      vtors(2,j) = 0.30
    end do

!> Calculate etors
    do i = 1,ntors
      ii = tlist(1,i)
      jj = tlist(2,i)
      kk = tlist(3,i)
      ll = tlist(4,i)
      rn = tlist(5,i)
      phi0 = vtors(1,i)
      fc = vtors(2,i)
      phi = valijklff(n,xyz,ii,jj,kk,ll)
      call egtors_nci(ii,jj,kk,ll,rn,phi0,fc,n,at,xyz,etmp,g4tmp,param)
      gdr(1:3,ii) = gdr(1:3,ii)+g4tmp(1:3,1)
      gdr(1:3,jj) = gdr(1:3,jj)+g4tmp(1:3,2)
      gdr(1:3,kk) = gdr(1:3,kk)+g4tmp(1:3,3)
      gdr(1:3,ll) = gdr(1:3,ll)+g4tmp(1:3,4)
      etors = etors+etmp
    end do

!> Calculate eangl + gangl
    write (stdout,*) 'angle atoms          phi0   phi      FC'
    r0 = 120
    phi0 = r0*pi/180.
    fc = 0.20
    call bangl(xyz,kk,jj,ll,phi)
    write (stdout,'(3i5,2x,3f8.3)') &
    &   jj,kk,ll,phi0*180./pi,phi*180./pi,fc
    call egbend_nci(jj,kk,ll,phi0,fc,n,at,xyz,etmp,g3tmp,param)
    gdr(1:3,jj) = gdr(1:3,jj)+g3tmp(1:3,1)
    gdr(1:3,kk) = gdr(1:3,kk)+g3tmp(1:3,2)
    gdr(1:3,ll) = gdr(1:3,ll)+g3tmp(1:3,3)
    eangl = eangl+etmp

!> hydrogen charge scaled term
    ex1h = exp(param%hbst*q(H))
    ex2h = ex1h+param%hbsf
    qh = ex1h/ex2h

!> hydrogen charge scaled term
    ex1a = exp(-param%hbst*q(A))
    ex2a = ex1a+param%hbsf
    qa = ex1a/ex2a

!> hydrogen charge scaled term
    ex1b = exp(-param%hbst*q(B))
    ex2b = ex1b+param%hbsf
    qb = ex1b/ex2b

!> max distance to neighbors excluded, would lead to linear C=O-H
    qhoutl = qh*outl

!> constant values, no gradient
    const = ca(2)*qa*cb(1)*qb*param%xhaci_globabh

!> energy
    energy = -rdamp*qhoutl*const+etors+eangl

!> gradient
    drah(1:3) = xyz(1:3,A)-xyz(1:3,H)
    drbh(1:3) = xyz(1:3,B)-xyz(1:3,H)
    drab(1:3) = xyz(1:3,A)-xyz(1:3,B)

    aterm = -rdamp*qh*const
    dterm = -qhoutl*const

!------------------------------------------------------------------------------
!> damping part: rab
    gi = ((rabdamp+rbhdamp)*ddamp-3.d0*rabdamp)/rab2
    gi = gi*dterm
    dg(1:3) = gi*drab(1:3)
    ga(1:3) = dg(1:3)
    gb(1:3) = -dg(1:3)

!------------------------------------------------------------------------------
!> damping part: rbh
    gi = -3.d0*rbhdamp/rbh2
    gi = gi*dterm
    dg(1:3) = gi*drbh(1:3)
    gb(1:3) = gb(1:3)+dg(1:3)
    gh(1:3) = -dg(1:3)

!------------------------------------------------------------------------------
!> angular A-H...B term
!------------------------------------------------------------------------------
!> out of line term: rab
    tmp1 = -2.d0*aterm*ratio2*expo/(1+ratio2)**2/(rahprbh-rab)
    gi = -tmp1*rahprbh/rab2
    dg(1:3) = gi*drab(1:3)
    ga(1:3) = ga(1:3)+dg(1:3)
    gb(1:3) = gb(1:3)-dg(1:3)

!> out of line term: rah,rbh
    gi = tmp1/rah
    dga(1:3) = gi*drah(1:3)
    ga(1:3) = ga(1:3)+dga(1:3)
    gi = tmp1/rbh
    dgb(1:3) = gi*drbh(1:3)
    gb(1:3) = gb(1:3)+dgb(1:3)
    dgh(1:3) = -dga(1:3)-dgb(1:3)
    gh(1:3) = gh(1:3)+dgh(1:3)

!------------------------------------------------------------------------------
!> move gradients into place
    gdr(1:3,A) = gdr(1:3,A)+ga(1:3)
    gdr(1:3,B) = gdr(1:3,B)+gb(1:3)
    gdr(1:3,H) = gdr(1:3,H)+gh(1:3)

  end subroutine abhgfnff_eg3_add

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! XB energy and analytical gradient
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

  subroutine rbxgfnff_eg(n,A,B,X,at,xyz,q,energy,gdr,param)
    implicit none
    type(TGFFData),intent(in) :: param
    integer               :: A,B,X,n,at(n)
    real(wp)                :: xyz(3,n)
    real(wp),intent(inout)  :: energy,gdr(3,3)
    real(wp)                :: q(n)

    real(wp) :: outl,dampl,damps,rdamp,damp
    real(wp) :: ratio1,ratio2,ratio3
    real(wp) :: rab,rax,rbx,rab2,rax2,rbx2,rax4,rbx4
    real(wp) :: drax(3),drbx(3),drab(3),drm(3)
    real(wp) :: dg(3),dga(3),dgb(3),dgx(3)
    real(wp) :: gi,ga(3),gb(3),gx(3)
    real(wp) :: ex1_a,ex2_a,ex1_b,ex2_b,ex1_x,ex2_x,expo
    real(wp) :: aterm,dterm
    real(wp) :: qa,qb,qx
    real(wp) :: cx,cb
    real(wp) :: gqa,gqb,gqx
    real(wp) :: shortcut,const

    integer i,j

    gdr = 0
    energy = 0

    cb = 1.!param%xhbas(at(B))
    cx = param%xbaci(at(X))

!> compute distances
    drax(1:3) = xyz(1:3,A)-xyz(1:3,X)
    drbx(1:3) = xyz(1:3,B)-xyz(1:3,X)
    drab(1:3) = xyz(1:3,A)-xyz(1:3,B)

!> A-B distance
    rab2 = sum(drab**2)
    rab = sqrt(rab2)

!> A-X distance
    rax2 = sum(drax**2)
    rax = sqrt(rax2)+1.d-12

!> B-X distance
    rbx2 = sum(drbx**2)
    rbx = sqrt(rbx2)+1.d-12

!> out-of-line damp
    expo = param%xbacut*((rax+rbx)/rab-1.d0)
    if (expo .gt. 15.0d0) return ! avoid overflow
    ratio2 = exp(expo)
    outl = 2.d0/(1.d0+ratio2)

!> long damping
    ratio1 = (rbx2/param%hblongcut_xb)**param%hbalp
    dampl = 1.d0/(1.d0+ratio1)

!> short damping
    shortcut = param%xbscut*(param%rad(at(A))+param%rad(at(B)))
    ratio3 = (shortcut/rbx2)**param%hbalp
    damps = 1.d0/(1.d0+ratio3)

    damp = damps*dampl
    rdamp = damp/rbx2/rbx ! **2

!> halogen charge scaled term
    ex1_x = exp(param%xbst*q(X))
    ex2_x = ex1_x+param%xbsf
    qx = ex1_x/ex2_x

!> donor charge scaled term
    ex1_b = exp(-param%xbst*q(B))
    ex2_b = ex1_b+param%xbsf
    qb = ex1_b/ex2_b

!> constant values, no gradient
    const = cb*qb*cx*qx

!> r^3 only sligxtly better than r^4
    aterm = -rdamp*const
    dterm = -outl*const
    energy = -rdamp*outl*const

!> damping part rab
    gi = rdamp*(-(2.d0*param%hbalp*ratio1/(1.d0+ratio1))+(2.d0*param%hbalp*ratio3&
   &     /(1.d0+ratio3))-3.d0)/rbx2   ! 4,5,6 instead of 3.
    gi = gi*dterm
    dg(1:3) = gi*drbx(1:3)
    gb(1:3) = dg(1:3)
    gx(1:3) = -dg(1:3)

!> out of line term: rab
    gi = 2.d0*ratio2*expo*(rax+rbx)/(1.d0+ratio2)**2/(rax+rbx-rab)/rab2
    gi = gi*aterm
    dg(1:3) = gi*drab(1:3)
    ga(1:3) = +dg(1:3)
    gb(1:3) = gb(1:3)-dg(1:3)

!> out of line term: rax,rbx
    gi = -2.d0*ratio2*expo/(1.d0+ratio2)**2/(rax+rbx-rab)/rax
    gi = gi*aterm
    dga(1:3) = gi*drax(1:3)
    ga(1:3) = ga(1:3)+dga(1:3)
    gi = -2.d0*ratio2*expo/(1.d0+ratio2)**2/(rax+rbx-rab)/rbx
    gi = gi*aterm
    dgb(1:3) = gi*drbx(1:3)
    gb(1:3) = gb(1:3)+dgb(1:3)
    dgx(1:3) = -dga(1:3)-dgb(1:3)
    gx(1:3) = gx(1:3)+dgx(1:3)

!> move gradients into place
    gdr(1:3,1) = ga(1:3)
    gdr(1:3,2) = gb(1:3)
    gdr(1:3,3) = gx(1:3)

    return
  end subroutine rbxgfnff_eg

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! taken from D3 ATM code
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  subroutine batmgfnff_eg(n,iat,jat,kat,at,xyz,q,sqrab,srab,energy,g,param)
    implicit none
    type(TGFFData),intent(in) :: param
    integer,intent(in) :: iat,jat,kat,n,at(n)
    real(wp),intent(in) :: xyz(3,n),q(n)
    real(wp),intent(out) :: energy,g(3,3)
    real(wp),intent(in) :: sqrab(n*(n+1)/2)   ! squared dist
    real(wp),intent(in) :: srab(n*(n+1)/2)   ! dist

    real(wp) :: r2ij,r2jk,r2ik,c9,mijk,imjk,ijmk,rijk3,ang,angr9,rav3
    real(wp) :: rij(3),rik(3),rjk(3),drij,drik,drjk,dang,ff,fi,fj,fk,fqq
    parameter(fqq=3.0d0)
    integer linij,linik,linjk,lina,i,j
    lina(i,j) = min(i,j)+max(i,j)*(max(i,j)-1)/2

    fi = (1.d0-fqq*q(iat))
    fi = min(max(fi,-4.0d0),4.0d0)
    fj = (1.d0-fqq*q(jat))
    fj = min(max(fj,-4.0d0),4.0d0)
    fk = (1.d0-fqq*q(kat))
    fk = min(max(fk,-4.0d0),4.0d0)
!> charge term
    ff = fi*fj*fk
!> strength of interaction
    c9 = ff*param%zb3atm(at(iat))*param%zb3atm(at(jat))*param%zb3atm(at(kat))
    linij = lina(iat,jat)
    linik = lina(iat,kat)
    linjk = lina(jat,kat)
    r2ij = sqrab(linij)
    r2jk = sqrab(linjk)
    r2ik = sqrab(linik)
    mijk = -r2ij+r2jk+r2ik
    imjk = r2ij-r2jk+r2ik
    ijmk = r2ij+r2jk-r2ik
    rijk3 = r2ij*r2jk*r2ik
    rav3 = rijk3**1.5 ! R^9
    ang = 0.375d0*ijmk*imjk*mijk/rijk3
    angr9 = (ang+1.0d0)/rav3
    energy = c9*angr9 ! energy

!> derivatives of each part w.r.t. r_ij,jk,ik
    dang = -0.375d0*(r2ij**3+r2ij**2*(r2jk+r2ik) &
&             +r2ij*(3.0d0*r2jk**2+2.0*r2jk*r2ik+3.0*r2ik**2) &
&             -5.0*(r2jk-r2ik)**2*(r2jk+r2ik)) &
&             /(srab(linij)*rijk3*rav3)
    drij = -dang*c9
    dang = -0.375d0*(r2jk**3+r2jk**2*(r2ik+r2ij) &
&             +r2jk*(3.0d0*r2ik**2+2.0*r2ik*r2ij+3.0*r2ij**2) &
&             -5.0*(r2ik-r2ij)**2*(r2ik+r2ij)) &
&             /(srab(linjk)*rijk3*rav3)
    drjk = -dang*c9
    dang = -0.375d0*(r2ik**3+r2ik**2*(r2jk+r2ij) &
&             +r2ik*(3.0d0*r2jk**2+2.0*r2jk*r2ij+3.0*r2ij**2) &
&             -5.0*(r2jk-r2ij)**2*(r2jk+r2ij)) &
&             /(srab(linik)*rijk3*rav3)
    drik = -dang*c9

    rij = xyz(:,jat)-xyz(:,iat)
    rik = xyz(:,kat)-xyz(:,iat)
    rjk = xyz(:,kat)-xyz(:,jat)
    g(:,1) = drij*rij/srab(linij)
    g(:,1) = g(:,1)+drik*rik/srab(linik)
    g(:,2) = drjk*rjk/srab(linjk)
    g(:,2) = g(:,2)-drij*rij/srab(linij)
    g(:,3) = -drik*rik/srab(linik)
    g(:,3) = g(:,3)-drjk*rjk/srab(linjk)

  end subroutine batmgfnff_eg

!========================================================================================!
!> torsion term for rotation around triple bonded carbon
subroutine sTors_eg(m, n, xyz, topo, energy, dg)
   integer, intent(in) :: m
   integer, intent(in) :: n
   real(wp), intent(in) :: xyz(3,n)
   type(TGFFTopology), intent(in) :: topo
   real(wp), intent(out) :: energy
   real(wp), intent(out) :: dg(3,n)
   integer :: c1,c2,c3,c4
   integer :: i

   !> torsion angle between C1-C4
   real(wp) :: phi
   real(wp) :: erefhalf
   real(wp) :: dp1(3),dp2(3),dp3(3),dp4(3)

   energy = 0.0_wp
   dg(:,:) = 0.0_wp

   if ( .not. any(topo%sTorsl(:,m) .eq. 0)) then

      c1 = topo%sTorsl(1,m)
      c2 = topo%sTorsl(2,m)
      c3 = topo%sTorsl(5,m)
      c4 = topo%sTorsl(6,m)

      ! dihedral angle in radians!
      phi=valijklff(n,xyz,c1,c2,c3,c4)
      call dphidr(n,xyz,c1,c2,c3,c4,phi,dp1,dp2,dp3,dp4)

      ! reference energy for torsion of 90° !
      ! calculated with DLPNO-CCSD(T) CBS on diphenylacetylene !
      erefhalf = 3.75_wp*1.0e-4_wp  ! approx 1.97 kJ/mol !
      energy = -erefhalf*cos(2.0_wp*phi) + erefhalf
      do i=1, 3
         dg(i, c1) = dg(i, c1) + erefhalf*2.0_wp*sin(2.0_wp*phi)*dp1(i)
         dg(i, c2) = dg(i, c2) + erefhalf*2.0_wp*sin(2.0_wp*phi)*dp2(i)
         dg(i, c3) = dg(i, c3) + erefhalf*2.0_wp*sin(2.0_wp*phi)*dp3(i)
         dg(i, c4) = dg(i, c4) + erefhalf*2.0_wp*sin(2.0_wp*phi)*dp4(i)
      enddo
   endif

end subroutine sTors_eg



!========================================================================================!
end module gfnff_engrad_module

!================================================================================!
! This file is part of gfnff.
!
! Copyright (C) 2023 Philipp Pracht
!
! gfnff is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfnff is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfnff. If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------!
!> The original (unmodified) source code can be found under the GNU LGPL 3.0 license
!> Copyright (C) 2019-2020 Sebastian Ehlert, Sebastian Spicher, Stefan Grimme
!> at https://github.com/grimme-lab/xtb
!================================================================================!
!> A collection of helper routines needed by gfnff
module gfnff_helpers
  use iso_fortran_env,only:wp => real64
  implicit none
  private

  !> public from this module
  public :: lin
  public :: mrecgff
  public :: getring36,ssort
  public :: vlen,vsub,valijklff
  public :: omega,domegadr,dphidr,bangl,impsc

  public :: crprod
  interface crprod
    module procedure crossprod
  end interface crprod

  public :: readl

!========================================================================================!
!========================================================================================!
contains !> MODULE PROCEDURES START HERE
!========================================================================================!
!========================================================================================!

  subroutine mrecgff(nat,nb,molcount,molvec)
    ! molcount: number of total fragments (increased during search)
    ! nat: overall number of atoms
    ! molvec: assignment vector of atom to fragment
    implicit none
    integer :: nat,molvec(nat),i,j,molcount,nb(20,nat)
    real(wp),allocatable :: bond(:,:)
    logical,allocatable :: taken(:)

    allocate (taken(nat),bond(nat,nat))
    bond = 0
    do i = 1,nat
      do j = 1,nb(20,i)
        bond(i,nb(j,i)) = 1
        bond(nb(j,i),i) = 1
      end do
    end do
    molvec = 0
    molcount = 1
    taken = .false.
    do i = 1,nat
      if (.not.taken(i)) then
        molvec(i) = molcount
        taken(i) = .true.
        call mrecgff2(nb,i,taken,nat,bond,molvec,molcount)
        molcount = molcount+1
      end if
    end do
    molcount = molcount-1
  end subroutine mrecgff
  recursive subroutine mrecgff2(nb,i,taken,nat,bond,molvec,molcnt)
    implicit none
    integer :: i,nat,molcnt,molvec(nat),j,icn,k,nb(20,nat)
    real(wp) :: bond(nat,nat)
    logical :: taken(nat)

    icn = nb(20,i)
    do k = 1,icn
      j = maxloc(bond(:,i),1)
      bond(j,i) = 0
      if (i .eq. j) cycle
      if (.not.taken(j)) then
        molvec(j) = molcnt
        taken(j) = .true.
        call mrecgff2(nb,j,taken,nat,bond,molvec,molcnt)
      end if
    end do
  end subroutine mrecgff2

!========================================================================================!
  subroutine getring36(n,at,nbin,a0_in,cout,irout)
    implicit none
    integer :: cout(10,20),irout(20)  ! output: atomlist, ringsize, # of rings in irout(20)
    integer :: at(n)
    integer :: n,nbin(20,n),a0,i,nb(20,n),a0_in
    integer :: i1,i2,i3,i4,i5,i6,i7,i8,i9,i10
    integer :: n0,n1,n2,n3,n4,n5,n6,n7,n8,n9,n10
    integer :: a1,a2,a3,a4,a5,a6,a7,a8,a9,a10
    integer :: list(n),m,mm,nn,c(10),cdum(10,600),iring
    integer :: adum1(0:n),adum2(0:n),kk,j,idum(600),same(600),k
    real(wp) :: w(n),av,sd

    if (n .le. 2) return

    nn = nbin(20,a0_in)

    cdum = 0
    kk = 0
    do m = 1,nn
!     if(nb(m,a0_in).eq.1) cycle
      nb = nbin
      do i = 1,n
        if (nb(20,i) .eq. 1) nb(20,i) = 0
      end do

      do mm = 1,nn
        w(mm) = dble(mm)
        list(mm) = mm
      end do
      w(m) = 0.0d0
      call ssort(nn,w,list)
      do mm = 1,nn
        nb(mm,a0_in) = nbin(list(mm),a0_in)
      end do

      iring = 0
      c = 0

      a0 = a0_in
      n0 = nb(20,a0)

      do i1 = 1,n0
        a1 = nb(i1,a0)
        if (a1 .eq. a0) cycle
        n1 = nb(20,a1)
        do i2 = 1,n1
          a2 = nb(i2,a1)
          if (a2 .eq. a1) cycle
          n2 = nb(20,a2)
          do i3 = 1,n2
            a3 = nb(i3,a2)
            n3 = nb(20,a3)
            if (a3 .eq. a2) cycle
            c(1) = a1
            c(2) = a2
            c(3) = a3
            if (a3 .eq. a0.and.chkrng(n,3,c)) then
              iring = 3
              kk = kk+1
              cdum(1:iring,kk) = c(1:iring)
              idum(kk) = iring
            end if
            do i4 = 1,n3
              a4 = nb(i4,a3)
              n4 = nb(20,a4)
              if (a4 .eq. a3) cycle
              c(4) = a4
              if (a4 .eq. a0.and.chkrng(n,4,c)) then
                iring = 4
                kk = kk+1
                cdum(1:iring,kk) = c(1:iring)
                idum(kk) = iring
              end if
              do i5 = 1,n4
                a5 = nb(i5,a4)
                n5 = nb(20,a5)
                if (a5 .eq. a4) cycle
                c(5) = a5
                if (a5 .eq. a0.and.chkrng(n,5,c)) then
                  iring = 5
                  kk = kk+1
                  cdum(1:iring,kk) = c(1:iring)
                  idum(kk) = iring
                end if
                do i6 = 1,n5
                  a6 = nb(i6,a5)
                  n6 = nb(20,a6)
                  if (a6 .eq. a5) cycle
                  c(6) = a6
                  if (a6 .eq. a0.and.chkrng(n,6,c)) then
                    iring = 6
                    kk = kk+1
                    cdum(1:iring,kk) = c(1:iring)
                    idum(kk) = iring
                  end if
                end do
              end do
            end do
          end do
        end do
      end do
    end do

! compare
    same = 0
    do i = 1,kk
      do j = i+1,kk
        if (idum(i) .ne. idum(j)) cycle ! different ring size
        if (same(j) .eq. 1) cycle ! already double
        adum1 = 0
        adum2 = 0
        do m = 1,10
          i1 = cdum(m,i)
          i2 = cdum(m,j)
          adum1(i1) = 1
          adum2(i2) = 1
        end do
        if (sum(abs(adum1-adum2)) .ne. 0) then
          same(j) = 0
        else
          same(j) = 1
        end if
      end do
    end do

    m = 0
    do i = 1,kk
      if (same(i) .eq. 0) then
        m = m+1
        if (m .gt. 20) exit !stop 'too many rings'
        irout(m) = idum(i)     ! number of atoms in ring m
        nn = idum(i)
        cout(1:nn,m) = cdum(1:nn,i)
        i2 = 0
        do k = 1,nn            ! determine if its a hetereo
          i1 = at(cdum(k,i))
          i2 = i2+i1
        end do
        av = dble(i2)/dble(nn)
        sd = 0
        cout(m,19) = 0
        do k = 1,nn
          i1 = at(cdum(k,i))
          sd = sd+(av-dble(i1))**2
        end do
        if (sd .gt. 1.d-6) cout(m,19) = idint(1000.*sqrt(sd)/dble(nn))
      end if
    end do
    irout(20) = m  ! number of rings for this atom

    return
  end subroutine getring36

  logical function chkrng(nn,n,c)
    implicit none
    integer n,idum(nn),nn,c(10),i,j
    chkrng = .true.
    idum = 0
    do i = 1,n
      idum(c(i)) = idum(c(i))+1
    end do
    j = 0
    do i = 1,nn
      if (idum(i) .eq. 1) j = j+1
    end do
    if (j .ne. n) chkrng = .false.
  end function chkrng

  subroutine ssort(n,edum,ind)
    implicit none
    integer :: n,ii,k,j,m,i,sc1
    real(wp) :: edum(n),pp
    integer :: ind(n)

    do ii = 2,n
      i = ii-1
      k = i
      pp = edum(i)
      do j = ii,n
        if (edum(j) .gt. pp) exit
        k = j
        pp = edum(j)
      end do
      if (k .eq. i) exit
      edum(k) = edum(i)
      edum(i) = pp
      sc1 = ind(i)
      ind(i) = ind(k)
      ind(k) = sc1
    end do
  end subroutine ssort
!========================================================================================!

  subroutine vsub(a,b,c,n)
    implicit none
    integer n
    real(wp) :: a(n),b(n),c(n)
    integer :: i
    do i = 1,n
      c(i) = a(i)-b(i)
    end do
    return
  end subroutine vsub

!========================================================================================!

  real(wp) function vlen(a)
    implicit none !double precision (a-h,o-z)
    real(wp) :: a(3)
    real(wp) :: tot

    tot = a(1)*a(1)+a(2)*a(2)+a(3)*a(3)
    vlen = 0.0d0
    if (tot .gt. 0.0d0) vlen = dsqrt(tot)

    return
  end function vlen

!========================================================================================!

  real(wp) function valijklff(natoms,xyz,i,j,k,l)
    implicit none
    integer :: ic,i,j,k,l,natoms
    real(wp) :: xyz(3,natoms)
    real(wp) :: ra(3),rb(3),rc(3),na(3),nb(3)
    real(wp) :: rab,rbc,thab,thbc
    real(wp) :: nan,nbn,rcn,snanb,deter

    real(wp),parameter :: eps = 1.0d-14
    real(wp),parameter :: pi = 3.1415926535897932384626433832795029d0

    !>-- get torsion coordinate
    do ic = 1,3
      ra(ic) = xyz(ic,j)-xyz(ic,i)
      rb(ic) = xyz(ic,k)-xyz(ic,j)
      rc(ic) = xyz(ic,l)-xyz(ic,k)
    end do

    !>-- determinante of rb,ra,rc
    deter = ra(1)*(rb(2)*rc(3)-rb(3)*rc(2))  &
   &      -ra(2)*(rb(1)*rc(3)-rb(3)*rc(1)) &
   &      +ra(3)*(rb(1)*rc(2)-rb(2)*rc(1))

    thab = valijk(natoms,xyz,i,k,j)
    thbc = valijk(natoms,xyz,j,l,k)
    call crossprod(ra,rb,na)
    call crossprod(rb,rc,nb)
    nan = vecnorm(na,3,1)
    nbn = vecnorm(nb,3,1)

    snanb = 0.0d0
    do ic = 1,3
      snanb = snanb+na(ic)*nb(ic)
    end do
    if (abs(abs(snanb)-1.d0) .lt. eps) then
      snanb = sign(1.d0,snanb)
    end if

    valijklff = acos(snanb)
  end function valijklff

  real(wp) Function valijk(nat,xyz,j,k,i)
    implicit none
    integer :: nat,j,k,i,ic
    real(wp) :: ra(3),rb(3),rab,eps
    real(wp) :: xyz(3,nat),ran,rbn
    parameter(eps=1.d-14)

    do ic = 1,3
      ra(ic) = xyz(ic,j)-xyz(ic,i)
      rb(ic) = xyz(ic,k)-xyz(ic,i)
    end do

    ran = vecnorm(ra,3,1)
    rbn = vecnorm(rb,3,1)
    rab = 0.d0
    do ic = 1,3
      rab = rab+ra(ic)*rb(ic)
    end do

    if (abs(abs(rab)-1.d0) .lt. eps) then
      rab = sign(1.d0,rab)
    end if
    valijk = acos(rab)

  End Function valijk

  subroutine crossprod(ra,rb,rab)
    implicit none
    real(wp) :: ra(3),rb(3),rab(3)
    rab(1) = ra(2)*rb(3)-ra(3)*rb(2)
    rab(2) = ra(3)*rb(1)-ra(1)*rb(3)
    rab(3) = ra(1)*rb(2)-ra(2)*rb(1)
  end Subroutine crossprod

  real(wp) Function vecnorm(r,n,inorm)
    implicit none
    integer :: i,n,inorm
    real(wp) :: r(n),or,sp,rn
    sp = 0.0_wp
    do i = 1,n
      sp = sp+r(i)*r(i)
    end do
    rn = sqrt(sp)
    if (inorm .gt. 0) then
      if (abs(rn) .gt. 1.d-14) then
        or = 1.0_wp/rn
        do i = 1,n
          r(i) = or*r(i)
        end do
      end if
    end if
    vecnorm = rn
  end function vecnorm

!========================================================================================!

  pure elemental integer function lin(i1,i2)
    integer,intent(in) :: i1,i2
    integer :: idum1,idum2
    idum1 = max(i1,i2)
    idum2 = min(i1,i2)
    lin = idum2+idum1*(idum1-1)/2
    return
  end function lin

!========================================================================================!

  real(wp) Function omega(nat,xyz,i,j,k,l)
    !>   Calculates the inversion angle
    implicit none
    integer :: ic,nat,i,j,k,l

    real(wp) :: xyz(3,nat)
    real(wp) :: rd(3),re(3),rn(3),rv(3),rnv
    real(wp) :: rkjn,rljn,rnn,rvn

    do ic = 1,3
      re(ic) = xyz(ic,i)-xyz(ic,j)
      rd(ic) = xyz(ic,k)-xyz(ic,j)
      rv(ic) = xyz(ic,l)-xyz(ic,i)
    end do
    call crossprod(re,rd,rn)
    rnn = vecnorm(rn,3,1)
    rvn = vecnorm(rv,3,1)

    rnv = rn(1)*rv(1)+rn(2)*rv(2)+rn(3)*rv(3)
    omega = asin(rnv)

  End Function omega

  Subroutine domegadr(nat,xyz,i,j,k,l,omega, &
  &          domegadri,domegadrj,domegadrk,domegadrl)
    !> inversion derivatives
    implicit none
    integer  :: ic,i,j,k,l,nat
    real(wp) :: omega,sinomega
    real(wp) :: xyz(3,nat),onenner,rnn,rvn
    real(wp) :: rn(3),rv(3),rd(3),re(3),rdme(3),rve(3)
    real(wp) :: rne(3),rdv(3),rdn(3)
    real(wp) :: rvdme(3),rndme(3),nenner
    real(wp) :: domegadri(3),domegadrj(3),domegadrk(3),domegadrl(3),eps
    parameter(eps=1.d-14)

    sinomega = sin(omega)

    do ic = 1,3
      rv(ic) = xyz(ic,l)-xyz(ic,i)
      rd(ic) = xyz(ic,k)-xyz(ic,j)
      re(ic) = xyz(ic,i)-xyz(ic,j)

      rdme(ic) = rd(ic)-re(ic)
    end do

    call crossprod(re,rd,rn)
    rvn = vecnorm(rv,3,0)
    rnn = vecnorm(rn,3,0)

    call crossprod(rv,re,rve)
    call crossprod(rn,re,rne)
    call crossprod(rd,rv,rdv)
    call crossprod(rd,rn,rdn)
    call crossprod(rv,rdme,rvdme)
    call crossprod(rn,rdme,rndme)

    nenner = rnn*rvn*cos(omega)
    if (abs(nenner) .gt. eps) then
      onenner = 1.d0/nenner
      do ic = 1,3
! ... domega/dri
        domegadri(ic) = onenner*(rdv(ic)-rn(ic)- &
                                 sinomega*(rvn/rnn*rdn(ic)-rnn/rvn*rv(ic)))

! ... domega/drj
        domegadrj(ic) = onenner*(rvdme(ic)-sinomega*rvn/rnn*rndme(ic))

! ... domega/drk
        domegadrk(ic) = onenner*(rve(ic)-sinomega*rvn/rnn*rne(ic))

! ... domega/drl
        domegadrl(ic) = onenner*(rn(ic)-sinomega*rnn/rvn*rv(ic))
      end do
    else
      do ic = 1,3
        domegadri(ic) = 0.d0
        domegadrj(ic) = 0.d0
        domegadrk(ic) = 0.d0
        domegadrl(ic) = 0.d0
      end do
    end if

  End Subroutine domegadr

!========================================================================================!

  Subroutine dphidr(nat,xyz,i,j,k,l,phi, &
  &                dphidri,dphidrj,dphidrk,dphidrl)
    !> the torsion derivatives

    implicit none
    integer :: ic,i,j,k,l,nat
    real(wp) :: sinphi,cosphi,onenner,thab,thbc
    real(wp) :: ra(3),rb(3),rc(3),rab(3),rac(3),rbc(3),rbb(3)
    real(wp) :: raa(3),rba(3),rapba(3),rapbb(3),rbpca(3),rbpcb(3)
    real(wp) :: rapb(3),rbpc(3),na(3),nb(3),nan,nbn
    real(wp) :: dphidri(3),dphidrj(3),dphidrk(3),dphidrl(3)
    real(wp) :: xyz(3,nat),phi,nenner,eps,vz

    parameter(eps=1.d-14)

    cosphi = cos(phi)
    sinphi = sin(phi)
    do ic = 1,3
      ra(ic) = xyz(ic,j)-xyz(ic,i)
      rb(ic) = xyz(ic,k)-xyz(ic,j)
      rc(ic) = xyz(ic,l)-xyz(ic,k)

      rapb(ic) = ra(ic)+rb(ic)
      rbpc(ic) = rb(ic)+rc(ic)
    end do

    call crossprod(ra,rb,na)
    call crossprod(rb,rc,nb)
    nan = vecnorm(na,3,0)
    nbn = vecnorm(nb,3,0)

    nenner = nan*nbn*sinphi
    if (abs(nenner) .lt. eps) then
      dphidri = 0
      dphidrj = 0
      dphidrk = 0
      dphidrl = 0
      onenner = 1.0d0/(nan*nbn)
    else
      onenner = 1.d0/nenner
    end if
    call crossprod(na,rb,rab)
    call crossprod(nb,ra,rba)
    call crossprod(na,rc,rac)
    call crossprod(nb,rb,rbb)
    call crossprod(nb,rc,rbc)
    call crossprod(na,ra,raa)

    call crossprod(rapb,na,rapba)
    call crossprod(rapb,nb,rapbb)
    call crossprod(rbpc,na,rbpca)
    call crossprod(rbpc,nb,rbpcb)

! ... dphidri
    do ic = 1,3
      dphidri(ic) = onenner*(cosphi*nbn/nan*rab(ic)-rbb(ic))

! ... dphidrj
      dphidrj(ic) = onenner*(cosphi*(nbn/nan*rapba(ic) &
                                     +nan/nbn*rbc(ic)) &
                             -(rac(ic)+rapbb(ic)))
! ... dphidrk
      dphidrk(ic) = onenner*(cosphi*(nbn/nan*raa(ic) &
                                     +nan/nbn*rbpcb(ic)) &
                             -(rba(ic)+rbpca(ic)))
! ... dphidrl
      dphidrl(ic) = onenner*(cosphi*nan/nbn*rbb(ic)-rab(ic))
    end do

  End Subroutine dphidr

!========================================================================================!

  pure subroutine bangl(xyz,i,j,k,angle)
    implicit none
    real(wp),intent(in)  :: xyz(3,*)
    real(wp),intent(out) :: angle
    integer,intent(in)  :: i,j,k

    real(wp) d2ij,d2jk,d2ik,xy,temp

    d2ij = sum((xyz(:,i)-xyz(:,j))**2)
    d2jk = sum((xyz(:,j)-xyz(:,k))**2)
    d2ik = sum((xyz(:,i)-xyz(:,k))**2)
    xy = sqrt(d2ij*d2jk)
    temp = 0.5d0*(d2ij+d2jk-d2ik)/xy
    if (temp .gt. 1.0d0) temp = 1.0d0
    if (temp .lt. -1.0d0) temp = -1.0d0
    angle = acos(temp)

  end subroutine bangl

!========================================================================================!

  pure subroutine impsc(a,b,c)
    implicit none
    real(wp),intent(in)  :: a(3),b(3)
    real(wp),intent(out) :: c
    integer  :: i
    real(wp) :: rimp,al,bl

    rimp = 0.0d0

    do i = 1,3
      rimp = rimp+a(i)*b(i)
    end do

    al = norm2(a)
    bl = norm2(b)

    if (al .gt. 0.0d0.and.bl .gt. 0.0d0) then
      c = rimp/(al*bl)
    else
      c = 0.0d0
    end if

    return
  end subroutine impsc

!========================================================================================!
  subroutine readl(a1,x,n)
    character(len=*) ::  a1
    real(wp) :: x(:)
    integer,intent(out) :: n
    n = size(x,1) !will be overwrotten in getfloats
    call getfloats(a1,x,n)
  end subroutine readl
!========================================================================================!
!cuts the at blanks and tabstops and returns all floats and strings in order of occurence
  subroutine getfloats(line,floats,cf)
    implicit none
    real(wp),intent(inout) :: floats(*)
    character(len=*),intent(in) :: line
    integer,intent(inout) :: cf
    real(wp) :: num
    character(len=128) :: str,stmp
    character(len=80) strings(3)
    character(len=1) digit
    integer :: i,ty,cs,cfmax

    cfmax = cf !on input cf is the dimension of floats()
    stmp = ''
    cs = 0
    cf = 0
    strings(:) = ''
    do i = 1,len(trim(line))
      digit = line(i:i)
      if (digit .ne. ' '.and.digit .ne. char(9)) then  !should exclude tabstops and blanks, 9 is ascii code for tab
        stmp = trim(stmp)//trim(digit)
      elseif (stmp .ne. '') then
        call checktype(stmp,num,str,ty)      !get type of string, 0=number, 1=character
        if (ty .eq. 0) then
          cf = cf+1
          if (cf .le. cfmax) floats(cf) = num
        elseif (ty .eq. 1) then
          cs = cs+1
          !   strings(cs)=trim(str)
        else
          write (*,*) 'Problem in checktype, must abort'
          exit
        end if
        stmp = ''
      end if
      if (i .eq. len(trim(line))) then  !special case: end of line
        call checktype(stmp,num,str,ty)
        if (ty .eq. 0) then
          cf = cf+1
          if (cf .le. cfmax) floats(cf) = num
        elseif (ty .eq. 1) then
          cs = cs+1
          !   strings(cs)=trim(str)
        else
          write (*,*) 'Problem in checktype, must abort'
          exit
        end if
        stmp = ''
      end if
    end do
  contains
    subroutine checktype(field,num,str,ty)
      implicit none
      character(len=*) :: field,str
      real(wp) :: num
      integer :: e,ty
      logical :: is_num
      ty = 99
      str = ''
      is_num = .false.
      read (field,'(F10.5)',IOSTAT=e) num !cast string on real and get error code; 0 means success.
      if (e .eq. 0) is_num = .true.
      if (is_num) then
        if (index(field,'.') .ne. 0) then  !check for integer/real
          read (field,'(F30.16)') num
          ty = 0
        else                       !if integer, add .0 to string; otherwise cast to real does not work
          str = trim(field)//'.0'
          read (str,'(F30.16)') num
          str = ''
          ty = 0
        end if
      else
        str = trim(field)
        ty = 1
      end if
    end subroutine checktype
  end subroutine getfloats
!========================================================================================!
end module gfnff_helpers
